import React, { Component } from 'react';
import styled, { css, keyframes } from 'styled-components';
import ReactDOM from 'react-dom';

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function commonjsRequire () {
	throw new Error('Dynamic requires are not currently supported by rollup-plugin-commonjs');
}

function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x.default : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var reactIs_production_min = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports,"__esModule",{value:!0});
var b="function"===typeof Symbol&&Symbol.for,c=b?Symbol.for("react.element"):60103,d=b?Symbol.for("react.portal"):60106,e=b?Symbol.for("react.fragment"):60107,f=b?Symbol.for("react.strict_mode"):60108,g=b?Symbol.for("react.profiler"):60114,h=b?Symbol.for("react.provider"):60109,k=b?Symbol.for("react.context"):60110,l=b?Symbol.for("react.async_mode"):60111,m=b?Symbol.for("react.concurrent_mode"):60111,n=b?Symbol.for("react.forward_ref"):60112,p=b?Symbol.for("react.suspense"):60113,q=b?Symbol.for("react.memo"):
60115,r=b?Symbol.for("react.lazy"):60116;function t(a){if("object"===typeof a&&null!==a){var u=a.$$typeof;switch(u){case c:switch(a=a.type,a){case l:case m:case e:case g:case f:case p:return a;default:switch(a=a&&a.$$typeof,a){case k:case n:case h:return a;default:return u}}case r:case q:case d:return u}}}function v(a){return t(a)===m}exports.typeOf=t;exports.AsyncMode=l;exports.ConcurrentMode=m;exports.ContextConsumer=k;exports.ContextProvider=h;exports.Element=c;exports.ForwardRef=n;
exports.Fragment=e;exports.Lazy=r;exports.Memo=q;exports.Portal=d;exports.Profiler=g;exports.StrictMode=f;exports.Suspense=p;exports.isValidElementType=function(a){return "string"===typeof a||"function"===typeof a||a===e||a===m||a===g||a===f||a===p||"object"===typeof a&&null!==a&&(a.$$typeof===r||a.$$typeof===q||a.$$typeof===h||a.$$typeof===k||a.$$typeof===n)};exports.isAsyncMode=function(a){return v(a)||t(a)===l};exports.isConcurrentMode=v;exports.isContextConsumer=function(a){return t(a)===k};
exports.isContextProvider=function(a){return t(a)===h};exports.isElement=function(a){return "object"===typeof a&&null!==a&&a.$$typeof===c};exports.isForwardRef=function(a){return t(a)===n};exports.isFragment=function(a){return t(a)===e};exports.isLazy=function(a){return t(a)===r};exports.isMemo=function(a){return t(a)===q};exports.isPortal=function(a){return t(a)===d};exports.isProfiler=function(a){return t(a)===g};exports.isStrictMode=function(a){return t(a)===f};
exports.isSuspense=function(a){return t(a)===p};
});
unwrapExports(reactIs_production_min);
var reactIs_production_min_1 = reactIs_production_min.typeOf;
var reactIs_production_min_2 = reactIs_production_min.AsyncMode;
var reactIs_production_min_3 = reactIs_production_min.ConcurrentMode;
var reactIs_production_min_4 = reactIs_production_min.ContextConsumer;
var reactIs_production_min_5 = reactIs_production_min.ContextProvider;
var reactIs_production_min_6 = reactIs_production_min.Element;
var reactIs_production_min_7 = reactIs_production_min.ForwardRef;
var reactIs_production_min_8 = reactIs_production_min.Fragment;
var reactIs_production_min_9 = reactIs_production_min.Lazy;
var reactIs_production_min_10 = reactIs_production_min.Memo;
var reactIs_production_min_11 = reactIs_production_min.Portal;
var reactIs_production_min_12 = reactIs_production_min.Profiler;
var reactIs_production_min_13 = reactIs_production_min.StrictMode;
var reactIs_production_min_14 = reactIs_production_min.Suspense;
var reactIs_production_min_15 = reactIs_production_min.isValidElementType;
var reactIs_production_min_16 = reactIs_production_min.isAsyncMode;
var reactIs_production_min_17 = reactIs_production_min.isConcurrentMode;
var reactIs_production_min_18 = reactIs_production_min.isContextConsumer;
var reactIs_production_min_19 = reactIs_production_min.isContextProvider;
var reactIs_production_min_20 = reactIs_production_min.isElement;
var reactIs_production_min_21 = reactIs_production_min.isForwardRef;
var reactIs_production_min_22 = reactIs_production_min.isFragment;
var reactIs_production_min_23 = reactIs_production_min.isLazy;
var reactIs_production_min_24 = reactIs_production_min.isMemo;
var reactIs_production_min_25 = reactIs_production_min.isPortal;
var reactIs_production_min_26 = reactIs_production_min.isProfiler;
var reactIs_production_min_27 = reactIs_production_min.isStrictMode;
var reactIs_production_min_28 = reactIs_production_min.isSuspense;

var reactIs_development = createCommonjsModule(function (module, exports) {
});
unwrapExports(reactIs_development);
var reactIs_development_1 = reactIs_development.typeOf;
var reactIs_development_2 = reactIs_development.AsyncMode;
var reactIs_development_3 = reactIs_development.ConcurrentMode;
var reactIs_development_4 = reactIs_development.ContextConsumer;
var reactIs_development_5 = reactIs_development.ContextProvider;
var reactIs_development_6 = reactIs_development.Element;
var reactIs_development_7 = reactIs_development.ForwardRef;
var reactIs_development_8 = reactIs_development.Fragment;
var reactIs_development_9 = reactIs_development.Lazy;
var reactIs_development_10 = reactIs_development.Memo;
var reactIs_development_11 = reactIs_development.Portal;
var reactIs_development_12 = reactIs_development.Profiler;
var reactIs_development_13 = reactIs_development.StrictMode;
var reactIs_development_14 = reactIs_development.Suspense;
var reactIs_development_15 = reactIs_development.isValidElementType;
var reactIs_development_16 = reactIs_development.isAsyncMode;
var reactIs_development_17 = reactIs_development.isConcurrentMode;
var reactIs_development_18 = reactIs_development.isContextConsumer;
var reactIs_development_19 = reactIs_development.isContextProvider;
var reactIs_development_20 = reactIs_development.isElement;
var reactIs_development_21 = reactIs_development.isForwardRef;
var reactIs_development_22 = reactIs_development.isFragment;
var reactIs_development_23 = reactIs_development.isLazy;
var reactIs_development_24 = reactIs_development.isMemo;
var reactIs_development_25 = reactIs_development.isPortal;
var reactIs_development_26 = reactIs_development.isProfiler;
var reactIs_development_27 = reactIs_development.isStrictMode;
var reactIs_development_28 = reactIs_development.isSuspense;

var reactIs = createCommonjsModule(function (module) {
{
  module.exports = reactIs_production_min;
}
});
var reactIs_1 = reactIs.isElement;
var reactIs_2 = reactIs.isValidElementType;
var reactIs_3 = reactIs.ForwardRef;

/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;
function toObject(val) {
	if (val === null || val === undefined) {
		throw new TypeError('Object.assign cannot be called with null or undefined');
	}
	return Object(val);
}
function shouldUseNative() {
	try {
		if (!Object.assign) {
			return false;
		}
		var test1 = new String('abc');
		test1[5] = 'de';
		if (Object.getOwnPropertyNames(test1)[0] === '5') {
			return false;
		}
		var test2 = {};
		for (var i = 0; i < 10; i++) {
			test2['_' + String.fromCharCode(i)] = i;
		}
		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
			return test2[n];
		});
		if (order2.join('') !== '0123456789') {
			return false;
		}
		var test3 = {};
		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
			test3[letter] = letter;
		});
		if (Object.keys(Object.assign({}, test3)).join('') !==
				'abcdefghijklmnopqrst') {
			return false;
		}
		return true;
	} catch (err) {
		return false;
	}
}
var objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
	var from;
	var to = toObject(target);
	var symbols;
	for (var s = 1; s < arguments.length; s++) {
		from = Object(arguments[s]);
		for (var key in from) {
			if (hasOwnProperty.call(from, key)) {
				to[key] = from[key];
			}
		}
		if (getOwnPropertySymbols) {
			symbols = getOwnPropertySymbols(from);
			for (var i = 0; i < symbols.length; i++) {
				if (propIsEnumerable.call(from, symbols[i])) {
					to[symbols[i]] = from[symbols[i]];
				}
			}
		}
	}
	return to;
};

var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';
var ReactPropTypesSecret_1 = ReactPropTypesSecret;

var has = Function.call.bind(Object.prototype.hasOwnProperty);

function emptyFunction() {}
function emptyFunctionWithReset() {}
emptyFunctionWithReset.resetWarningCache = emptyFunction;
var factoryWithThrowingShims = function() {
  function shim(props, propName, componentName, location, propFullName, secret) {
    if (secret === ReactPropTypesSecret_1) {
      return;
    }
    var err = new Error(
      'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
      'Use PropTypes.checkPropTypes() to call them. ' +
      'Read more at http://fb.me/use-check-prop-types'
    );
    err.name = 'Invariant Violation';
    throw err;
  }  shim.isRequired = shim;
  function getShim() {
    return shim;
  }  var ReactPropTypes = {
    array: shim,
    bool: shim,
    func: shim,
    number: shim,
    object: shim,
    string: shim,
    symbol: shim,
    any: shim,
    arrayOf: getShim,
    element: shim,
    elementType: shim,
    instanceOf: getShim,
    node: shim,
    objectOf: getShim,
    oneOf: getShim,
    oneOfType: getShim,
    shape: getShim,
    exact: getShim,
    checkPropTypes: emptyFunctionWithReset,
    resetWarningCache: emptyFunction
  };
  ReactPropTypes.PropTypes = ReactPropTypes;
  return ReactPropTypes;
};

var propTypes = createCommonjsModule(function (module) {
{
  module.exports = factoryWithThrowingShims();
}
});

var classnames = createCommonjsModule(function (module) {
/*!
  Copyright (c) 2017 Jed Watson.
  Licensed under the MIT License (MIT), see
  http://jedwatson.github.io/classnames
*/
(function () {
	var hasOwn = {}.hasOwnProperty;
	function classNames () {
		var classes = [];
		for (var i = 0; i < arguments.length; i++) {
			var arg = arguments[i];
			if (!arg) continue;
			var argType = typeof arg;
			if (argType === 'string' || argType === 'number') {
				classes.push(arg);
			} else if (Array.isArray(arg) && arg.length) {
				var inner = classNames.apply(null, arg);
				if (inner) {
					classes.push(inner);
				}
			} else if (argType === 'object') {
				for (var key in arg) {
					if (hasOwn.call(arg, key) && arg[key]) {
						classes.push(key);
					}
				}
			}
		}
		return classes.join(' ');
	}
	if (module.exports) {
		classNames.default = classNames;
		module.exports = classNames;
	} else {
		window.classNames = classNames;
	}
}());
});

var LARGE_ARRAY_SIZE = 200;
var HASH_UNDEFINED = '__lodash_hash_undefined__';
var INFINITY = 1 / 0,
    MAX_SAFE_INTEGER = 9007199254740991;
var argsTag = '[object Arguments]',
    funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    symbolTag = '[object Symbol]';
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
var reIsHostCtor = /^\[object .+?Constructor\]$/;
var reIsUint = /^(?:0|[1-9]\d*)$/;
var freeGlobal = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;
var root = freeGlobal || freeSelf || Function('return this')();
function apply(func, thisArg, args) {
  switch (args.length) {
    case 0: return func.call(thisArg);
    case 1: return func.call(thisArg, args[0]);
    case 2: return func.call(thisArg, args[0], args[1]);
    case 3: return func.call(thisArg, args[0], args[1], args[2]);
  }
  return func.apply(thisArg, args);
}
function arrayIncludes(array, value) {
  var length = array ? array.length : 0;
  return !!length && baseIndexOf(array, value, 0) > -1;
}
function arrayIncludesWith(array, value, comparator) {
  var index = -1,
      length = array ? array.length : 0;
  while (++index < length) {
    if (comparator(value, array[index])) {
      return true;
    }
  }
  return false;
}
function arrayMap(array, iteratee) {
  var index = -1,
      length = array ? array.length : 0,
      result = Array(length);
  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}
function arrayPush(array, values) {
  var index = -1,
      length = values.length,
      offset = array.length;
  while (++index < length) {
    array[offset + index] = values[index];
  }
  return array;
}
function baseFindIndex(array, predicate, fromIndex, fromRight) {
  var length = array.length,
      index = fromIndex + (fromRight ? 1 : -1);
  while ((fromRight ? index-- : ++index < length)) {
    if (predicate(array[index], index, array)) {
      return index;
    }
  }
  return -1;
}
function baseIndexOf(array, value, fromIndex) {
  if (value !== value) {
    return baseFindIndex(array, baseIsNaN, fromIndex);
  }
  var index = fromIndex - 1,
      length = array.length;
  while (++index < length) {
    if (array[index] === value) {
      return index;
    }
  }
  return -1;
}
function baseIsNaN(value) {
  return value !== value;
}
function baseTimes(n, iteratee) {
  var index = -1,
      result = Array(n);
  while (++index < n) {
    result[index] = iteratee(index);
  }
  return result;
}
function baseUnary(func) {
  return function(value) {
    return func(value);
  };
}
function cacheHas(cache, key) {
  return cache.has(key);
}
function getValue(object, key) {
  return object == null ? undefined : object[key];
}
function isHostObject(value) {
  var result = false;
  if (value != null && typeof value.toString != 'function') {
    try {
      result = !!(value + '');
    } catch (e) {}
  }
  return result;
}
function overArg(func, transform) {
  return function(arg) {
    return func(transform(arg));
  };
}
var arrayProto = Array.prototype,
    funcProto = Function.prototype,
    objectProto = Object.prototype;
var coreJsData = root['__core-js_shared__'];
var maskSrcKey = (function() {
  var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
  return uid ? ('Symbol(src)_1.' + uid) : '';
}());
var funcToString = funcProto.toString;
var hasOwnProperty$1 = objectProto.hasOwnProperty;
var objectToString = objectProto.toString;
var reIsNative = RegExp('^' +
  funcToString.call(hasOwnProperty$1).replace(reRegExpChar, '\\$&')
  .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
);
var Symbol$1 = root.Symbol,
    getPrototype = overArg(Object.getPrototypeOf, Object),
    propertyIsEnumerable = objectProto.propertyIsEnumerable,
    splice = arrayProto.splice,
    spreadableSymbol = Symbol$1 ? Symbol$1.isConcatSpreadable : undefined;
var nativeGetSymbols = Object.getOwnPropertySymbols,
    nativeMax = Math.max;
var Map$1 = getNative(root, 'Map'),
    nativeCreate = getNative(Object, 'create');
function Hash(entries) {
  var index = -1,
      length = entries ? entries.length : 0;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
function hashClear() {
  this.__data__ = nativeCreate ? nativeCreate(null) : {};
}
function hashDelete(key) {
  return this.has(key) && delete this.__data__[key];
}
function hashGet(key) {
  var data = this.__data__;
  if (nativeCreate) {
    var result = data[key];
    return result === HASH_UNDEFINED ? undefined : result;
  }
  return hasOwnProperty$1.call(data, key) ? data[key] : undefined;
}
function hashHas(key) {
  var data = this.__data__;
  return nativeCreate ? data[key] !== undefined : hasOwnProperty$1.call(data, key);
}
function hashSet(key, value) {
  var data = this.__data__;
  data[key] = (nativeCreate && value === undefined) ? HASH_UNDEFINED : value;
  return this;
}
Hash.prototype.clear = hashClear;
Hash.prototype['delete'] = hashDelete;
Hash.prototype.get = hashGet;
Hash.prototype.has = hashHas;
Hash.prototype.set = hashSet;
function ListCache(entries) {
  var index = -1,
      length = entries ? entries.length : 0;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
function listCacheClear() {
  this.__data__ = [];
}
function listCacheDelete(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);
  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }
  return true;
}
function listCacheGet(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);
  return index < 0 ? undefined : data[index][1];
}
function listCacheHas(key) {
  return assocIndexOf(this.__data__, key) > -1;
}
function listCacheSet(key, value) {
  var data = this.__data__,
      index = assocIndexOf(data, key);
  if (index < 0) {
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}
ListCache.prototype.clear = listCacheClear;
ListCache.prototype['delete'] = listCacheDelete;
ListCache.prototype.get = listCacheGet;
ListCache.prototype.has = listCacheHas;
ListCache.prototype.set = listCacheSet;
function MapCache(entries) {
  var index = -1,
      length = entries ? entries.length : 0;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
function mapCacheClear() {
  this.__data__ = {
    'hash': new Hash,
    'map': new (Map$1 || ListCache),
    'string': new Hash
  };
}
function mapCacheDelete(key) {
  return getMapData(this, key)['delete'](key);
}
function mapCacheGet(key) {
  return getMapData(this, key).get(key);
}
function mapCacheHas(key) {
  return getMapData(this, key).has(key);
}
function mapCacheSet(key, value) {
  getMapData(this, key).set(key, value);
  return this;
}
MapCache.prototype.clear = mapCacheClear;
MapCache.prototype['delete'] = mapCacheDelete;
MapCache.prototype.get = mapCacheGet;
MapCache.prototype.has = mapCacheHas;
MapCache.prototype.set = mapCacheSet;
function SetCache(values) {
  var index = -1,
      length = values ? values.length : 0;
  this.__data__ = new MapCache;
  while (++index < length) {
    this.add(values[index]);
  }
}
function setCacheAdd(value) {
  this.__data__.set(value, HASH_UNDEFINED);
  return this;
}
function setCacheHas(value) {
  return this.__data__.has(value);
}
SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
SetCache.prototype.has = setCacheHas;
function arrayLikeKeys(value, inherited) {
  var result = (isArray(value) || isArguments(value))
    ? baseTimes(value.length, String)
    : [];
  var length = result.length,
      skipIndexes = !!length;
  for (var key in value) {
    if ((inherited || hasOwnProperty$1.call(value, key)) &&
        !(skipIndexes && (key == 'length' || isIndex(key, length)))) {
      result.push(key);
    }
  }
  return result;
}
function assocIndexOf(array, key) {
  var length = array.length;
  while (length--) {
    if (eq(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}
function baseDifference(array, values, iteratee, comparator) {
  var index = -1,
      includes = arrayIncludes,
      isCommon = true,
      length = array.length,
      result = [],
      valuesLength = values.length;
  if (!length) {
    return result;
  }
  if (iteratee) {
    values = arrayMap(values, baseUnary(iteratee));
  }
  if (comparator) {
    includes = arrayIncludesWith;
    isCommon = false;
  }
  else if (values.length >= LARGE_ARRAY_SIZE) {
    includes = cacheHas;
    isCommon = false;
    values = new SetCache(values);
  }
  outer:
  while (++index < length) {
    var value = array[index],
        computed = iteratee ? iteratee(value) : value;
    value = (comparator || value !== 0) ? value : 0;
    if (isCommon && computed === computed) {
      var valuesIndex = valuesLength;
      while (valuesIndex--) {
        if (values[valuesIndex] === computed) {
          continue outer;
        }
      }
      result.push(value);
    }
    else if (!includes(values, computed, comparator)) {
      result.push(value);
    }
  }
  return result;
}
function baseFlatten(array, depth, predicate, isStrict, result) {
  var index = -1,
      length = array.length;
  predicate || (predicate = isFlattenable);
  result || (result = []);
  while (++index < length) {
    var value = array[index];
    if (depth > 0 && predicate(value)) {
      if (depth > 1) {
        baseFlatten(value, depth - 1, predicate, isStrict, result);
      } else {
        arrayPush(result, value);
      }
    } else if (!isStrict) {
      result[result.length] = value;
    }
  }
  return result;
}
function baseGetAllKeys(object, keysFunc, symbolsFunc) {
  var result = keysFunc(object);
  return isArray(object) ? result : arrayPush(result, symbolsFunc(object));
}
function baseIsNative(value) {
  if (!isObject(value) || isMasked(value)) {
    return false;
  }
  var pattern = (isFunction(value) || isHostObject(value)) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource(value));
}
function baseKeysIn(object) {
  if (!isObject(object)) {
    return nativeKeysIn(object);
  }
  var isProto = isPrototype(object),
      result = [];
  for (var key in object) {
    if (!(key == 'constructor' && (isProto || !hasOwnProperty$1.call(object, key)))) {
      result.push(key);
    }
  }
  return result;
}
function basePick(object, props) {
  object = Object(object);
  return basePickBy(object, props, function(value, key) {
    return key in object;
  });
}
function basePickBy(object, props, predicate) {
  var index = -1,
      length = props.length,
      result = {};
  while (++index < length) {
    var key = props[index],
        value = object[key];
    if (predicate(value, key)) {
      result[key] = value;
    }
  }
  return result;
}
function baseRest(func, start) {
  start = nativeMax(start === undefined ? (func.length - 1) : start, 0);
  return function() {
    var args = arguments,
        index = -1,
        length = nativeMax(args.length - start, 0),
        array = Array(length);
    while (++index < length) {
      array[index] = args[start + index];
    }
    index = -1;
    var otherArgs = Array(start + 1);
    while (++index < start) {
      otherArgs[index] = args[index];
    }
    otherArgs[start] = array;
    return apply(func, this, otherArgs);
  };
}
function getAllKeysIn(object) {
  return baseGetAllKeys(object, keysIn, getSymbolsIn);
}
function getMapData(map, key) {
  var data = map.__data__;
  return isKeyable(key)
    ? data[typeof key == 'string' ? 'string' : 'hash']
    : data.map;
}
function getNative(object, key) {
  var value = getValue(object, key);
  return baseIsNative(value) ? value : undefined;
}
var getSymbols = nativeGetSymbols ? overArg(nativeGetSymbols, Object) : stubArray;
var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object) {
  var result = [];
  while (object) {
    arrayPush(result, getSymbols(object));
    object = getPrototype(object);
  }
  return result;
};
function isFlattenable(value) {
  return isArray(value) || isArguments(value) ||
    !!(spreadableSymbol && value && value[spreadableSymbol]);
}
function isIndex(value, length) {
  length = length == null ? MAX_SAFE_INTEGER : length;
  return !!length &&
    (typeof value == 'number' || reIsUint.test(value)) &&
    (value > -1 && value % 1 == 0 && value < length);
}
function isKeyable(value) {
  var type = typeof value;
  return (type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean')
    ? (value !== '__proto__')
    : (value === null);
}
function isMasked(func) {
  return !!maskSrcKey && (maskSrcKey in func);
}
function isPrototype(value) {
  var Ctor = value && value.constructor,
      proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto;
  return value === proto;
}
function nativeKeysIn(object) {
  var result = [];
  if (object != null) {
    for (var key in Object(object)) {
      result.push(key);
    }
  }
  return result;
}
function toKey(value) {
  if (typeof value == 'string' || isSymbol(value)) {
    return value;
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}
function toSource(func) {
  if (func != null) {
    try {
      return funcToString.call(func);
    } catch (e) {}
    try {
      return (func + '');
    } catch (e) {}
  }
  return '';
}
function eq(value, other) {
  return value === other || (value !== value && other !== other);
}
function isArguments(value) {
  return isArrayLikeObject(value) && hasOwnProperty$1.call(value, 'callee') &&
    (!propertyIsEnumerable.call(value, 'callee') || objectToString.call(value) == argsTag);
}
var isArray = Array.isArray;
function isArrayLike(value) {
  return value != null && isLength(value.length) && !isFunction(value);
}
function isArrayLikeObject(value) {
  return isObjectLike(value) && isArrayLike(value);
}
function isFunction(value) {
  var tag = isObject(value) ? objectToString.call(value) : '';
  return tag == funcTag || tag == genTag;
}
function isLength(value) {
  return typeof value == 'number' &&
    value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
}
function isObject(value) {
  var type = typeof value;
  return !!value && (type == 'object' || type == 'function');
}
function isObjectLike(value) {
  return !!value && typeof value == 'object';
}
function isSymbol(value) {
  return typeof value == 'symbol' ||
    (isObjectLike(value) && objectToString.call(value) == symbolTag);
}
function keysIn(object) {
  return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
}
var omit = baseRest(function(object, props) {
  if (object == null) {
    return {};
  }
  props = arrayMap(baseFlatten(props, 1), toKey);
  return basePick(object, baseDifference(getAllKeysIn(object), props));
});
function stubArray() {
  return [];
}
var lodash_omit = omit;

function mapToCssModules(className, cssModule) {
  if (!cssModule) return className;
  return className.split(' ').map(function (c) {
    return cssModule[c] || c;
  }).join(' ');
}

var tabFocus_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tabFocus = tabFocus;
exports.default = void 0;
function tabFocus() {
  return "\n    /* WebKit-specific. Other browsers will keep their default outline style. */\n    /* (Initially tried to also force default via 'outline: initial', */\n    /* but that seems to erroneously remove the outline in Firefox altogether.) */\n    outline: 5px auto -webkit-focus-ring-color;\n    outline-offset: -2px;\n  ";
}
var _default = {
  tabFocus: tabFocus
};
exports.default = _default;
});
unwrapExports(tabFocus_1);
var tabFocus_2 = tabFocus_1.tabFocus;

var MixinError_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _wrapNativeSuper(Class) { var _cache = typeof Map === "function" ? new Map() : undefined; _wrapNativeSuper = function _wrapNativeSuper(Class) { if (Class === null || !_isNativeFunction(Class)) return Class; if (typeof Class !== "function") { throw new TypeError("Super expression must either be null or a function"); } if (typeof _cache !== "undefined") { if (_cache.has(Class)) return _cache.get(Class); _cache.set(Class, Wrapper); } function Wrapper() { return _construct(Class, arguments, _getPrototypeOf(this).constructor); } Wrapper.prototype = Object.create(Class.prototype, { constructor: { value: Wrapper, enumerable: false, writable: true, configurable: true } }); return _setPrototypeOf(Wrapper, Class); }; return _wrapNativeSuper(Class); }
function isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
function _construct(Parent, args, Class) { if (isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }
function _isNativeFunction(fn) { return Function.toString.call(fn).indexOf("[native code]") !== -1; }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
var MixinError =
function (_Error) {
  _inherits(MixinError, _Error);
  function MixinError(args) {
    var _this;
    _classCallCheck(this, MixinError);
    _this = _possibleConstructorReturn(this, _getPrototypeOf(MixinError).call(this, args));
    Error.captureStackTrace(_assertThisInitialized(_assertThisInitialized(_this)), MixinError);
    return _this;
  }
  return MixinError;
}(_wrapNativeSuper(Error));
exports.default = MixinError;
module.exports = exports.default;
});
unwrapExports(MixinError_1);

var hover_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hover = hover;
exports.hoverFocus = hoverFocus;
exports.plainHoverFocus = plainHoverFocus;
exports.hoverFocusActive = hoverFocusActive;
exports.default = exports.defaultProps = void 0;
var _MixinError = _interopRequireDefault(MixinError_1);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var defaultProps = {
  '$enable-hover-media-query': false
};
exports.defaultProps = defaultProps;
function hover(content) {
  if (!content) throw new _MixinError.default('content is required');
  return "&:hover, &.hover { ".concat(content, " }");
}
function hoverFocus() {
  var enableHoverMediaQuery = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-hover-media-query'];
  var content = arguments.length > 1 ? arguments[1] : undefined;
  if (enableHoverMediaQuery) {
    return " \n      &:focus, &.focus { ".concat(content, " }\n      ").concat(hover(content), "\n    ");
  }
  return "\n    &:focus,\n    &.focus,\n    &:hover,\n    &.hover {\n      ".concat(content, "\n    }\n  ");
}
function plainHoverFocus() {
  var enableHoverMediaQuery = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-hover-media-query'];
  var content = arguments.length > 1 ? arguments[1] : undefined;
  if (enableHoverMediaQuery) {
    return "\n      &, \n      &:focus, \n      &.focus {\n        ".concat(content, "\n      }\n      ").concat(hover(content), "\n    ");
  }
  return " \n    &, \n    &:focus, \n    &.focus, \n    &:hover, \n    &.hover {\n      ".concat(content, "\n    }\n  ");
}
function hoverFocusActive() {
  var enableHoverMediaQuery = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-hover-media-query'];
  var content = arguments.length > 1 ? arguments[1] : undefined;
  if (enableHoverMediaQuery) {
    return "\n      &:focus,\n      &.focus,\n      &:active,\n      &.active {\n        ".concat(content, "\n      }\n      ").concat(hover(content), "\n    ");
  }
  return "\n    &:focus, \n    &.focus, \n    &:active, \n    &.active,\n    &:hover,\n    &.hover {\n     ".concat(content, "\n    }\n  ");
}
hover.focus = hoverFocus;
hover.plainFocus = plainHoverFocus;
hover.activeFocus = hoverFocusActive;
var _default = {
  defaultProps: defaultProps,
  hover: hover,
  hoverFocus: hoverFocus,
  plainHoverFocus: plainHoverFocus,
  hoverFocusActive: hoverFocusActive
};
exports.default = _default;
});
unwrapExports(hover_1);
var hover_2 = hover_1.hover;
var hover_3 = hover_1.hoverFocus;
var hover_4 = hover_1.plainHoverFocus;
var hover_5 = hover_1.hoverFocusActive;
var hover_6 = hover_1.defaultProps;

var a_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.a = a;
exports.default = exports.defaultProps = void 0;
var defaultProps = {
  '$link-color': '#0275d8',
  '$link-decoration': 'none',
  '$link-hover-color': '#014C8D',
  '$link-hover-decoration': 'underline',
  '$enable-hover-media-query': false
};
exports.defaultProps = defaultProps;
function a() {
  var $linkColor = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$link-color'];
  var $linkDecoration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$link-decoration'];
  var $linkHoverColor = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$link-hover-color'];
  var $linkHoverDecoration = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : defaultProps['$link-hover-decoration'];
  var $enableHoverMediaQuery = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : defaultProps['$enable-hover-media-query'];
  return "\n    color: ".concat($linkColor, ";\n    text-decoration: ").concat($linkDecoration, ";\n    background-color: transparent;\n    -webkit-text-decoration-skip: objects;\n  \n    ").concat((0, hover_1.hoverFocus)($enableHoverMediaQuery, "\n      color: ".concat($linkHoverColor, ";\n      text-decoration: ").concat($linkHoverDecoration, ";\n    ")), "\n    \n    &:focus {\n      ").concat((0, tabFocus_1.tabFocus)(), "\n    }\n\n    a:not([href]):not([tabindex]) {\n      color: inherit;\n      text-decoration: none;\n      \n      ").concat((0, hover_1.hoverFocus)($enableHoverMediaQuery, "\n        color: inherit;\n        text-decoration: none;\n      "), "\n\n      &:focus {\n        outline: 0;\n      }\n    }\n  ");
}
var _default = {
  defaultProps: defaultProps,
  a: a
};
exports.default = _default;
});
unwrapExports(a_1);
var a_2 = a_1.a;
var a_3 = a_1.defaultProps;

var defaultProps = {
  tag: 'a',
  theme: {
    '$link-color': '#0275d8',
    '$link-decoration': 'none',
    '$link-hover-color': '#014C8D',
    '$link-hover-decoration': 'underline',
    '$enable-hover-media-query': false
  }
};
var propTypes$1 = {
  className: propTypes.string,
  tag: propTypes.any,
  theme: propTypes.shape({
    '$link-color': propTypes.string,
    '$link-decoration': propTypes.string,
    '$link-hover-color': propTypes.string,
    '$link-hover-decoration': propTypes.string,
    '$enable-hover-media-query': propTypes.bool
  }),
  color: propTypes.oneOf(['white', 'muted', 'gray-dark', 'primary', 'success', 'info', 'warning', 'danger']),
  cssModule: propTypes.object
};
var AUnstyled =
function (_React$Component) {
  _inherits(AUnstyled, _React$Component);
  function AUnstyled() {
    var _getPrototypeOf2;
    var _this;
    _classCallCheck(this, AUnstyled);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(AUnstyled)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _defineProperty(_assertThisInitialized(_this), "state", {
      focus: false
    });
    return _this;
  }
  _createClass(AUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          color = _omit.color,
          Tag = _omit.tag,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "color", "tag"]);
      var focus = this.state.focus;
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, _defineProperty({
          focus: focus
        }, "text-".concat(color), color)), cssModule)
      }, attributes));
    }
  }]);
  return AUnstyled;
}(React.Component);
_defineProperty(AUnstyled, "propTypes", propTypes$1);
_defineProperty(AUnstyled, "defaultProps", defaultProps);
var A = styled(AUnstyled).withConfig({
  displayName: "A",
  componentId: "sc-70cat-0"
})(["", ""], function (props) {
  return "\n    ".concat(a_2(props.theme['$link-color'], props.theme['$link-decoration'], props.theme['$link-hover-color'], props.theme['$link-hover-decoration'], props.theme['$enable-hover-media-query']), "\n  ");
});
A.defaultProps = defaultProps;
A.propTypes = propTypes$1;

var defaultProps$1 = {
  theme: {}
};
function composeLink(RouterLink) {
  var Link =
  function (_React$Component) {
    _inherits(Link, _React$Component);
    function Link() {
      _classCallCheck(this, Link);
      return _possibleConstructorReturn(this, _getPrototypeOf(Link).apply(this, arguments));
    }
    _createClass(Link, [{
      key: "render",
      value: function render() {
        var _omit = lodash_omit(this.props, ['theme']),
            className = _omit.className,
            to = _omit.to,
            attributes = _objectWithoutProperties(_omit, ["className", "to"]);
        return React.createElement(RouterLink, _extends({
          className: className,
          to: to
        }, attributes));
      }
    }]);
    return Link;
  }(React.Component);
  _defineProperty(Link, "propTypes", {
    className: propTypes.string,
    to: propTypes.string.isRequired,
    theme: propTypes.object
  });
  Link = styled(Link).withConfig({
    displayName: "composeLink__Link",
    componentId: "rslfo4-0"
  })(["", ""], function (props) {
    return "\n      ".concat(a_2(props.theme['$link-color'], props.theme['$link-decoration'], props.theme['$link-hover-color'], props.theme['$link-hover-decoration'], props.theme['$enable-hover-media-query']), "\n    ");
  });
  Link.defaultProps = defaultProps$1;
  return Link;
}

var defaultProps$2 = {
  tag: 'abbr',
  initialism: false
};
var propTypes$2 = {
  className: propTypes.string,
  tag: propTypes.any,
  title: propTypes.string.isRequired,
  initialism: propTypes.bool,
  cssModule: propTypes.object
};
var AbbrUnstyled =
function (_React$Component) {
  _inherits(AbbrUnstyled, _React$Component);
  function AbbrUnstyled() {
    _classCallCheck(this, AbbrUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(AbbrUnstyled).apply(this, arguments));
  }
  _createClass(AbbrUnstyled, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          initialism = _this$props.initialism,
          title = _this$props.title,
          Tag = _this$props.tag,
          cssModule = _this$props.cssModule,
          attributes = _objectWithoutProperties(_this$props, ["className", "initialism", "title", "tag", "cssModule"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, {
          initialism: initialism
        }), cssModule),
        title: title
      }, attributes));
    }
  }]);
  return AbbrUnstyled;
}(React.Component);
_defineProperty(AbbrUnstyled, "propTypes", propTypes$2);
_defineProperty(AbbrUnstyled, "defaultProps", defaultProps$2);
var Abbr = styled(AbbrUnstyled).withConfig({
  displayName: "Abbr",
  componentId: "sc-1y0a322-0"
})(["&[title]{text-decoration:underline dotted;cursor:help;border-bottom:0;}&.initialism{font-size:90%;text-transform:uppercase;}"]);
Abbr.defaultProps = defaultProps$2;
Abbr.propTypes = propTypes$2;

var Address = styled.address.withConfig({
  displayName: "Address",
  componentId: "sc-1bdqtqe-0"
})(["margin-bottom:1rem;font-style:normal;line-height:inherit;"]);

function _classCallCheck$1(r,e){if(!(r instanceof e))throw new TypeError("Cannot call a class as a function")}var classCallCheck=_classCallCheck$1;function _defineProperty$1(r,e,n){return e in r?Object.defineProperty(r,e,{value:n,enumerable:!0,configurable:!0,writable:!0}):r[e]=n,r}var defineProperty=_defineProperty$1;function createCommonjsModule$1(r,e){return r(e={exports:{}},e.exports),e.exports}var colorName={aliceblue:[240,248,255],antiquewhite:[250,235,215],aqua:[0,255,255],aquamarine:[127,255,212],azure:[240,255,255],beige:[245,245,220],bisque:[255,228,196],black:[0,0,0],blanchedalmond:[255,235,205],blue:[0,0,255],blueviolet:[138,43,226],brown:[165,42,42],burlywood:[222,184,135],cadetblue:[95,158,160],chartreuse:[127,255,0],chocolate:[210,105,30],coral:[255,127,80],cornflowerblue:[100,149,237],cornsilk:[255,248,220],crimson:[220,20,60],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgoldenrod:[184,134,11],darkgray:[169,169,169],darkgreen:[0,100,0],darkgrey:[169,169,169],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkseagreen:[143,188,143],darkslateblue:[72,61,139],darkslategray:[47,79,79],darkslategrey:[47,79,79],darkturquoise:[0,206,209],darkviolet:[148,0,211],deeppink:[255,20,147],deepskyblue:[0,191,255],dimgray:[105,105,105],dimgrey:[105,105,105],dodgerblue:[30,144,255],firebrick:[178,34,34],floralwhite:[255,250,240],forestgreen:[34,139,34],fuchsia:[255,0,255],gainsboro:[220,220,220],ghostwhite:[248,248,255],gold:[255,215,0],goldenrod:[218,165,32],gray:[128,128,128],green:[0,128,0],greenyellow:[173,255,47],grey:[128,128,128],honeydew:[240,255,240],hotpink:[255,105,180],indianred:[205,92,92],indigo:[75,0,130],ivory:[255,255,240],khaki:[240,230,140],lavender:[230,230,250],lavenderblush:[255,240,245],lawngreen:[124,252,0],lemonchiffon:[255,250,205],lightblue:[173,216,230],lightcoral:[240,128,128],lightcyan:[224,255,255],lightgoldenrodyellow:[250,250,210],lightgray:[211,211,211],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightsalmon:[255,160,122],lightseagreen:[32,178,170],lightskyblue:[135,206,250],lightslategray:[119,136,153],lightslategrey:[119,136,153],lightsteelblue:[176,196,222],lightyellow:[255,255,224],lime:[0,255,0],limegreen:[50,205,50],linen:[250,240,230],magenta:[255,0,255],maroon:[128,0,0],mediumaquamarine:[102,205,170],mediumblue:[0,0,205],mediumorchid:[186,85,211],mediumpurple:[147,112,219],mediumseagreen:[60,179,113],mediumslateblue:[123,104,238],mediumspringgreen:[0,250,154],mediumturquoise:[72,209,204],mediumvioletred:[199,21,133],midnightblue:[25,25,112],mintcream:[245,255,250],mistyrose:[255,228,225],moccasin:[255,228,181],navajowhite:[255,222,173],navy:[0,0,128],oldlace:[253,245,230],olive:[128,128,0],olivedrab:[107,142,35],orange:[255,165,0],orangered:[255,69,0],orchid:[218,112,214],palegoldenrod:[238,232,170],palegreen:[152,251,152],paleturquoise:[175,238,238],palevioletred:[219,112,147],papayawhip:[255,239,213],peachpuff:[255,218,185],peru:[205,133,63],pink:[255,192,203],plum:[221,160,221],powderblue:[176,224,230],purple:[128,0,128],rebeccapurple:[102,51,153],red:[255,0,0],rosybrown:[188,143,143],royalblue:[65,105,225],saddlebrown:[139,69,19],salmon:[250,128,114],sandybrown:[244,164,96],seagreen:[46,139,87],seashell:[255,245,238],sienna:[160,82,45],silver:[192,192,192],skyblue:[135,206,235],slateblue:[106,90,205],slategray:[112,128,144],slategrey:[112,128,144],snow:[255,250,250],springgreen:[0,255,127],steelblue:[70,130,180],tan:[210,180,140],teal:[0,128,128],thistle:[216,191,216],tomato:[255,99,71],turquoise:[64,224,208],violet:[238,130,238],wheat:[245,222,179],white:[255,255,255],whitesmoke:[245,245,245],yellow:[255,255,0],yellowgreen:[154,205,50]},isArrayish=function(r){return !(!r||"string"==typeof r)&&(r instanceof Array||Array.isArray(r)||r.length>=0&&(r.splice instanceof Function||Object.getOwnPropertyDescriptor(r,r.length-1)&&"String"!==r.constructor.name))},simpleSwizzle=createCommonjsModule$1(function(r){var e=Array.prototype.concat,n=Array.prototype.slice,t=r.exports=function(r){for(var t=[],o=0,a=r.length;o<a;o++){var i=r[o];isArrayish(i)?t=e.call(t,n.call(i)):t.push(i);}return t};t.wrap=function(r){return function(){return r(t(arguments))}};}),colorString=createCommonjsModule$1(function(r){var e={};for(var n in colorName)colorName.hasOwnProperty(n)&&(e[colorName[n]]=n);var t=r.exports={to:{},get:{}};function o(r,e,n){return Math.min(Math.max(e,r),n)}function a(r){var e=r.toString(16).toUpperCase();return e.length<2?"0"+e:e}t.get=function(r){var e,n;switch(r.substring(0,3).toLowerCase()){case"hsl":e=t.get.hsl(r),n="hsl";break;case"hwb":e=t.get.hwb(r),n="hwb";break;default:e=t.get.rgb(r),n="rgb";}return e?{model:n,value:e}:null},t.get.rgb=function(r){if(!r)return null;var e,n,t,a=[0,0,0,1];if(e=r.match(/^#([a-f0-9]{6})([a-f0-9]{2})?$/i)){for(t=e[2],e=e[1],n=0;n<3;n++){var i=2*n;a[n]=parseInt(e.slice(i,i+2),16);}t&&(a[3]=Math.round(parseInt(t,16)/255*100)/100);}else if(e=r.match(/^#([a-f0-9]{3,4})$/i)){for(t=(e=e[1])[3],n=0;n<3;n++)a[n]=parseInt(e[n]+e[n],16);t&&(a[3]=Math.round(parseInt(t+t,16)/255*100)/100);}else if(e=r.match(/^rgba?\(\s*([+-]?\d+)\s*,\s*([+-]?\d+)\s*,\s*([+-]?\d+)\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)$/)){for(n=0;n<3;n++)a[n]=parseInt(e[n+1],0);e[4]&&(a[3]=parseFloat(e[4]));}else{if(!(e=r.match(/^rgba?\(\s*([+-]?[\d\.]+)\%\s*,\s*([+-]?[\d\.]+)\%\s*,\s*([+-]?[\d\.]+)\%\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)$/)))return (e=r.match(/(\D+)/))?"transparent"===e[1]?[0,0,0,0]:(a=colorName[e[1]])?(a[3]=1,a):null:null;for(n=0;n<3;n++)a[n]=Math.round(2.55*parseFloat(e[n+1]));e[4]&&(a[3]=parseFloat(e[4]));}for(n=0;n<3;n++)a[n]=o(a[n],0,255);return a[3]=o(a[3],0,1),a},t.get.hsl=function(r){if(!r)return null;var e=r.match(/^hsla?\(\s*([+-]?(?:\d*\.)?\d+)(?:deg)?\s*,\s*([+-]?[\d\.]+)%\s*,\s*([+-]?[\d\.]+)%\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)$/);if(e){var n=parseFloat(e[4]);return [(parseFloat(e[1])+360)%360,o(parseFloat(e[2]),0,100),o(parseFloat(e[3]),0,100),o(isNaN(n)?1:n,0,1)]}return null},t.get.hwb=function(r){if(!r)return null;var e=r.match(/^hwb\(\s*([+-]?\d*[\.]?\d+)(?:deg)?\s*,\s*([+-]?[\d\.]+)%\s*,\s*([+-]?[\d\.]+)%\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)$/);if(e){var n=parseFloat(e[4]);return [(parseFloat(e[1])%360+360)%360,o(parseFloat(e[2]),0,100),o(parseFloat(e[3]),0,100),o(isNaN(n)?1:n,0,1)]}return null},t.to.hex=function(){var r=simpleSwizzle(arguments);return "#"+a(r[0])+a(r[1])+a(r[2])+(r[3]<1?a(Math.round(255*r[3])):"")},t.to.rgb=function(){var r=simpleSwizzle(arguments);return r.length<4||1===r[3]?"rgb("+Math.round(r[0])+", "+Math.round(r[1])+", "+Math.round(r[2])+")":"rgba("+Math.round(r[0])+", "+Math.round(r[1])+", "+Math.round(r[2])+", "+r[3]+")"},t.to.rgb.percent=function(){var r=simpleSwizzle(arguments),e=Math.round(r[0]/255*100),n=Math.round(r[1]/255*100),t=Math.round(r[2]/255*100);return r.length<4||1===r[3]?"rgb("+e+"%, "+n+"%, "+t+"%)":"rgba("+e+"%, "+n+"%, "+t+"%, "+r[3]+")"},t.to.hsl=function(){var r=simpleSwizzle(arguments);return r.length<4||1===r[3]?"hsl("+r[0]+", "+r[1]+"%, "+r[2]+"%)":"hsla("+r[0]+", "+r[1]+"%, "+r[2]+"%, "+r[3]+")"},t.to.hwb=function(){var r=simpleSwizzle(arguments),e="";return r.length>=4&&1!==r[3]&&(e=", "+r[3]),"hwb("+r[0]+", "+r[1]+"%, "+r[2]+"%"+e+")"},t.to.keyword=function(r){return e[r.slice(0,3)]};}),colorString_1=colorString.to,colorString_2=colorString.get,conversions=createCommonjsModule$1(function(r){var e={};for(var n in colorName)colorName.hasOwnProperty(n)&&(e[colorName[n]]=n);var t=r.exports={rgb:{channels:3,labels:"rgb"},hsl:{channels:3,labels:"hsl"},hsv:{channels:3,labels:"hsv"},hwb:{channels:3,labels:"hwb"},cmyk:{channels:4,labels:"cmyk"},xyz:{channels:3,labels:"xyz"},lab:{channels:3,labels:"lab"},lch:{channels:3,labels:"lch"},hex:{channels:1,labels:["hex"]},keyword:{channels:1,labels:["keyword"]},ansi16:{channels:1,labels:["ansi16"]},ansi256:{channels:1,labels:["ansi256"]},hcg:{channels:3,labels:["h","c","g"]},apple:{channels:3,labels:["r16","g16","b16"]},gray:{channels:1,labels:["gray"]}};for(var o in t)if(t.hasOwnProperty(o)){if(!("channels"in t[o]))throw new Error("missing channels property: "+o);if(!("labels"in t[o]))throw new Error("missing channel labels property: "+o);if(t[o].labels.length!==t[o].channels)throw new Error("channel and label counts mismatch: "+o);var a=t[o].channels,i=t[o].labels;delete t[o].channels,delete t[o].labels,Object.defineProperty(t[o],"channels",{value:a}),Object.defineProperty(t[o],"labels",{value:i});}t.rgb.hsl=function(r){var e,n,t=r[0]/255,o=r[1]/255,a=r[2]/255,i=Math.min(t,o,a),s=Math.max(t,o,a),l=s-i;return s===i?e=0:t===s?e=(o-a)/l:o===s?e=2+(a-t)/l:a===s&&(e=4+(t-o)/l),(e=Math.min(60*e,360))<0&&(e+=360),n=(i+s)/2,[e,100*(s===i?0:n<=.5?l/(s+i):l/(2-s-i)),100*n]},t.rgb.hsv=function(r){var e,n,t,o,a,i=r[0]/255,s=r[1]/255,l=r[2]/255,c=Math.max(i,s,l),h=c-Math.min(i,s,l),u=function(r){return (c-r)/6/h+.5};return 0===h?o=a=0:(a=h/c,e=u(i),n=u(s),t=u(l),i===c?o=t-n:s===c?o=1/3+e-t:l===c&&(o=2/3+n-e),o<0?o+=1:o>1&&(o-=1)),[360*o,100*a,100*c]},t.rgb.hwb=function(r){var e=r[0],n=r[1],o=r[2];return [t.rgb.hsl(r)[0],100*(1/255*Math.min(e,Math.min(n,o))),100*(o=1-1/255*Math.max(e,Math.max(n,o)))]},t.rgb.cmyk=function(r){var e,n=r[0]/255,t=r[1]/255,o=r[2]/255;return [100*((1-n-(e=Math.min(1-n,1-t,1-o)))/(1-e)||0),100*((1-t-e)/(1-e)||0),100*((1-o-e)/(1-e)||0),100*e]},t.rgb.keyword=function(r){var n=e[r];if(n)return n;var t,o,a,i=1/0;for(var s in colorName)if(colorName.hasOwnProperty(s)){var l=colorName[s],c=(o=r,a=l,Math.pow(o[0]-a[0],2)+Math.pow(o[1]-a[1],2)+Math.pow(o[2]-a[2],2));c<i&&(i=c,t=s);}return t},t.keyword.rgb=function(r){return colorName[r]},t.rgb.xyz=function(r){var e=r[0]/255,n=r[1]/255,t=r[2]/255;return [100*(.4124*(e=e>.04045?Math.pow((e+.055)/1.055,2.4):e/12.92)+.3576*(n=n>.04045?Math.pow((n+.055)/1.055,2.4):n/12.92)+.1805*(t=t>.04045?Math.pow((t+.055)/1.055,2.4):t/12.92)),100*(.2126*e+.7152*n+.0722*t),100*(.0193*e+.1192*n+.9505*t)]},t.rgb.lab=function(r){var e=t.rgb.xyz(r),n=e[0],o=e[1],a=e[2];return o/=100,a/=108.883,n=(n/=95.047)>.008856?Math.pow(n,1/3):7.787*n+16/116,[116*(o=o>.008856?Math.pow(o,1/3):7.787*o+16/116)-16,500*(n-o),200*(o-(a=a>.008856?Math.pow(a,1/3):7.787*a+16/116))]},t.hsl.rgb=function(r){var e,n,t,o,a,i=r[0]/360,s=r[1]/100,l=r[2]/100;if(0===s)return [a=255*l,a,a];e=2*l-(n=l<.5?l*(1+s):l+s-l*s),o=[0,0,0];for(var c=0;c<3;c++)(t=i+1/3*-(c-1))<0&&t++,t>1&&t--,a=6*t<1?e+6*(n-e)*t:2*t<1?n:3*t<2?e+(n-e)*(2/3-t)*6:e,o[c]=255*a;return o},t.hsl.hsv=function(r){var e=r[0],n=r[1]/100,t=r[2]/100,o=n,a=Math.max(t,.01);return n*=(t*=2)<=1?t:2-t,o*=a<=1?a:2-a,[e,100*(0===t?2*o/(a+o):2*n/(t+n)),100*((t+n)/2)]},t.hsv.rgb=function(r){var e=r[0]/60,n=r[1]/100,t=r[2]/100,o=Math.floor(e)%6,a=e-Math.floor(e),i=255*t*(1-n),s=255*t*(1-n*a),l=255*t*(1-n*(1-a));switch(t*=255,o){case 0:return [t,l,i];case 1:return [s,t,i];case 2:return [i,t,l];case 3:return [i,s,t];case 4:return [l,i,t];case 5:return [t,i,s]}},t.hsv.hsl=function(r){var e,n,t,o=r[0],a=r[1]/100,i=r[2]/100,s=Math.max(i,.01);return t=(2-a)*i,n=a*s,[o,100*(n=(n/=(e=(2-a)*s)<=1?e:2-e)||0),100*(t/=2)]},t.hwb.rgb=function(r){var e,n,t,o,a,i,s,l=r[0]/360,c=r[1]/100,h=r[2]/100,u=c+h;switch(u>1&&(c/=u,h/=u),t=6*l-(e=Math.floor(6*l)),0!=(1&e)&&(t=1-t),o=c+t*((n=1-h)-c),e){default:case 6:case 0:a=n,i=o,s=c;break;case 1:a=o,i=n,s=c;break;case 2:a=c,i=n,s=o;break;case 3:a=c,i=o,s=n;break;case 4:a=o,i=c,s=n;break;case 5:a=n,i=c,s=o;}return [255*a,255*i,255*s]},t.cmyk.rgb=function(r){var e=r[0]/100,n=r[1]/100,t=r[2]/100,o=r[3]/100;return [255*(1-Math.min(1,e*(1-o)+o)),255*(1-Math.min(1,n*(1-o)+o)),255*(1-Math.min(1,t*(1-o)+o))]},t.xyz.rgb=function(r){var e,n,t,o=r[0]/100,a=r[1]/100,i=r[2]/100;return n=-.9689*o+1.8758*a+.0415*i,t=.0557*o+-.204*a+1.057*i,e=(e=3.2406*o+-1.5372*a+-.4986*i)>.0031308?1.055*Math.pow(e,1/2.4)-.055:12.92*e,n=n>.0031308?1.055*Math.pow(n,1/2.4)-.055:12.92*n,t=t>.0031308?1.055*Math.pow(t,1/2.4)-.055:12.92*t,[255*(e=Math.min(Math.max(0,e),1)),255*(n=Math.min(Math.max(0,n),1)),255*(t=Math.min(Math.max(0,t),1))]},t.xyz.lab=function(r){var e=r[0],n=r[1],t=r[2];return n/=100,t/=108.883,e=(e/=95.047)>.008856?Math.pow(e,1/3):7.787*e+16/116,[116*(n=n>.008856?Math.pow(n,1/3):7.787*n+16/116)-16,500*(e-n),200*(n-(t=t>.008856?Math.pow(t,1/3):7.787*t+16/116))]},t.lab.xyz=function(r){var e,n,t,o=r[0];e=r[1]/500+(n=(o+16)/116),t=n-r[2]/200;var a=Math.pow(n,3),i=Math.pow(e,3),s=Math.pow(t,3);return n=a>.008856?a:(n-16/116)/7.787,e=i>.008856?i:(e-16/116)/7.787,t=s>.008856?s:(t-16/116)/7.787,[e*=95.047,n*=100,t*=108.883]},t.lab.lch=function(r){var e,n=r[0],t=r[1],o=r[2];return (e=360*Math.atan2(o,t)/2/Math.PI)<0&&(e+=360),[n,Math.sqrt(t*t+o*o),e]},t.lch.lab=function(r){var e,n=r[0],t=r[1];return e=r[2]/360*2*Math.PI,[n,t*Math.cos(e),t*Math.sin(e)]},t.rgb.ansi16=function(r){var e=r[0],n=r[1],o=r[2],a=1 in arguments?arguments[1]:t.rgb.hsv(r)[2];if(0===(a=Math.round(a/50)))return 30;var i=30+(Math.round(o/255)<<2|Math.round(n/255)<<1|Math.round(e/255));return 2===a&&(i+=60),i},t.hsv.ansi16=function(r){return t.rgb.ansi16(t.hsv.rgb(r),r[2])},t.rgb.ansi256=function(r){var e=r[0],n=r[1],t=r[2];return e===n&&n===t?e<8?16:e>248?231:Math.round((e-8)/247*24)+232:16+36*Math.round(e/255*5)+6*Math.round(n/255*5)+Math.round(t/255*5)},t.ansi16.rgb=function(r){var e=r%10;if(0===e||7===e)return r>50&&(e+=3.5),[e=e/10.5*255,e,e];var n=.5*(1+~~(r>50));return [(1&e)*n*255,(e>>1&1)*n*255,(e>>2&1)*n*255]},t.ansi256.rgb=function(r){if(r>=232){var e=10*(r-232)+8;return [e,e,e]}var n;return r-=16,[Math.floor(r/36)/5*255,Math.floor((n=r%36)/6)/5*255,n%6/5*255]},t.rgb.hex=function(r){var e=(((255&Math.round(r[0]))<<16)+((255&Math.round(r[1]))<<8)+(255&Math.round(r[2]))).toString(16).toUpperCase();return "000000".substring(e.length)+e},t.hex.rgb=function(r){var e=r.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);if(!e)return [0,0,0];var n=e[0];3===e[0].length&&(n=n.split("").map(function(r){return r+r}).join(""));var t=parseInt(n,16);return [t>>16&255,t>>8&255,255&t]},t.rgb.hcg=function(r){var e,n=r[0]/255,t=r[1]/255,o=r[2]/255,a=Math.max(Math.max(n,t),o),i=Math.min(Math.min(n,t),o),s=a-i;return e=s<=0?0:a===n?(t-o)/s%6:a===t?2+(o-n)/s:4+(n-t)/s+4,e/=6,[360*(e%=1),100*s,100*(s<1?i/(1-s):0)]},t.hsl.hcg=function(r){var e=r[1]/100,n=r[2]/100,t=1,o=0;return (t=n<.5?2*e*n:2*e*(1-n))<1&&(o=(n-.5*t)/(1-t)),[r[0],100*t,100*o]},t.hsv.hcg=function(r){var e=r[1]/100,n=r[2]/100,t=e*n,o=0;return t<1&&(o=(n-t)/(1-t)),[r[0],100*t,100*o]},t.hcg.rgb=function(r){var e=r[0]/360,n=r[1]/100,t=r[2]/100;if(0===n)return [255*t,255*t,255*t];var o,a=[0,0,0],i=e%1*6,s=i%1,l=1-s;switch(Math.floor(i)){case 0:a[0]=1,a[1]=s,a[2]=0;break;case 1:a[0]=l,a[1]=1,a[2]=0;break;case 2:a[0]=0,a[1]=1,a[2]=s;break;case 3:a[0]=0,a[1]=l,a[2]=1;break;case 4:a[0]=s,a[1]=0,a[2]=1;break;default:a[0]=1,a[1]=0,a[2]=l;}return o=(1-n)*t,[255*(n*a[0]+o),255*(n*a[1]+o),255*(n*a[2]+o)]},t.hcg.hsv=function(r){var e=r[1]/100,n=e+r[2]/100*(1-e),t=0;return n>0&&(t=e/n),[r[0],100*t,100*n]},t.hcg.hsl=function(r){var e=r[1]/100,n=r[2]/100*(1-e)+.5*e,t=0;return n>0&&n<.5?t=e/(2*n):n>=.5&&n<1&&(t=e/(2*(1-n))),[r[0],100*t,100*n]},t.hcg.hwb=function(r){var e=r[1]/100,n=e+r[2]/100*(1-e);return [r[0],100*(n-e),100*(1-n)]},t.hwb.hcg=function(r){var e=r[1]/100,n=1-r[2]/100,t=n-e,o=0;return t<1&&(o=(n-t)/(1-t)),[r[0],100*t,100*o]},t.apple.rgb=function(r){return [r[0]/65535*255,r[1]/65535*255,r[2]/65535*255]},t.rgb.apple=function(r){return [r[0]/255*65535,r[1]/255*65535,r[2]/255*65535]},t.gray.rgb=function(r){return [r[0]/100*255,r[0]/100*255,r[0]/100*255]},t.gray.hsl=t.gray.hsv=function(r){return [0,0,r[0]]},t.gray.hwb=function(r){return [0,100,r[0]]},t.gray.cmyk=function(r){return [0,0,0,r[0]]},t.gray.lab=function(r){return [r[0],0,0]},t.gray.hex=function(r){var e=255&Math.round(r[0]/100*255),n=((e<<16)+(e<<8)+e).toString(16).toUpperCase();return "000000".substring(n.length)+n},t.rgb.gray=function(r){return [(r[0]+r[1]+r[2])/3/255*100]};}),conversions_1=conversions.rgb,conversions_2=conversions.hsl,conversions_3=conversions.hsv,conversions_4=conversions.hwb,conversions_5=conversions.cmyk,conversions_6=conversions.xyz,conversions_7=conversions.lab,conversions_8=conversions.lch,conversions_9=conversions.hex,conversions_10=conversions.keyword,conversions_11=conversions.ansi16,conversions_12=conversions.ansi256,conversions_13=conversions.hcg,conversions_14=conversions.apple,conversions_15=conversions.gray;function buildGraph(){for(var r={},e=Object.keys(conversions),n=e.length,t=0;t<n;t++)r[e[t]]={distance:-1,parent:null};return r}function deriveBFS(r){var e=buildGraph(),n=[r];for(e[r].distance=0;n.length;)for(var t=n.pop(),o=Object.keys(conversions[t]),a=o.length,i=0;i<a;i++){var s=o[i],l=e[s];-1===l.distance&&(l.distance=e[t].distance+1,l.parent=t,n.unshift(s));}return e}function link(r,e){return function(n){return e(r(n))}}function wrapConversion(r,e){for(var n=[e[r].parent,r],t=conversions[e[r].parent][r],o=e[r].parent;e[o].parent;)n.unshift(e[o].parent),t=link(conversions[e[o].parent][o],t),o=e[o].parent;return t.conversion=n,t}var route=function(r){for(var e=deriveBFS(r),n={},t=Object.keys(e),o=t.length,a=0;a<o;a++){var i=t[a];null!==e[i].parent&&(n[i]=wrapConversion(i,e));}return n},convert={},models=Object.keys(conversions);function wrapRaw(r){var e=function(e){return null==e?e:(arguments.length>1&&(e=Array.prototype.slice.call(arguments)),r(e))};return "conversion"in r&&(e.conversion=r.conversion),e}function wrapRounded(r){var e=function(e){if(null==e)return e;arguments.length>1&&(e=Array.prototype.slice.call(arguments));var n=r(e);if("object"==typeof n)for(var t=n.length,o=0;o<t;o++)n[o]=Math.round(n[o]);return n};return "conversion"in r&&(e.conversion=r.conversion),e}models.forEach(function(r){convert[r]={},Object.defineProperty(convert[r],"channels",{value:conversions[r].channels}),Object.defineProperty(convert[r],"labels",{value:conversions[r].labels});var e=route(r);Object.keys(e).forEach(function(n){var t=e[n];convert[r][n]=wrapRounded(t),convert[r][n].raw=wrapRaw(t);});});var colorConvert=convert,_slice=[].slice,skippedModels=["keyword","gray","hex"],hashedModelKeys={};Object.keys(colorConvert).forEach(function(r){hashedModelKeys[_slice.call(colorConvert[r].labels).sort().join("")]=r;});var limiters={};function Color(r,e){if(!(this instanceof Color))return new Color(r,e);if(e&&e in skippedModels&&(e=null),e&&!(e in colorConvert))throw new Error("Unknown model: "+e);var n,t;if(void 0===r)this.model="rgb",this.color=[0,0,0],this.valpha=1;else if(r instanceof Color)this.model=r.model,this.color=r.color.slice(),this.valpha=r.valpha;else if("string"==typeof r){var o=colorString.get(r);if(null===o)throw new Error("Unable to parse color from string: "+r);this.model=o.model,t=colorConvert[this.model].channels,this.color=o.value.slice(0,t),this.valpha="number"==typeof o.value[t]?o.value[t]:1;}else if(r.length){this.model=e||"rgb",t=colorConvert[this.model].channels;var a=_slice.call(r,0,t);this.color=zeroArray(a,t),this.valpha="number"==typeof r[t]?r[t]:1;}else if("number"==typeof r)r&=16777215,this.model="rgb",this.color=[r>>16&255,r>>8&255,255&r],this.valpha=1;else{this.valpha=1;var i=Object.keys(r);"alpha"in r&&(i.splice(i.indexOf("alpha"),1),this.valpha="number"==typeof r.alpha?r.alpha:0);var s=i.sort().join("");if(!(s in hashedModelKeys))throw new Error("Unable to parse color from object: "+JSON.stringify(r));this.model=hashedModelKeys[s];var l=colorConvert[this.model].labels,c=[];for(n=0;n<l.length;n++)c.push(r[l[n]]);this.color=zeroArray(c);}if(limiters[this.model])for(t=colorConvert[this.model].channels,n=0;n<t;n++){var h=limiters[this.model][n];h&&(this.color[n]=h(this.color[n]));}this.valpha=Math.max(0,Math.min(1,this.valpha)),Object.freeze&&Object.freeze(this);}function roundTo(r,e){return Number(r.toFixed(e))}function roundToPlace(r){return function(e){return roundTo(e,r)}}function getset(r,e,n){return (r=Array.isArray(r)?r:[r]).forEach(function(r){(limiters[r]||(limiters[r]=[]))[e]=n;}),r=r[0],function(t){var o;return arguments.length?(n&&(t=n(t)),(o=this[r]()).color[e]=t,o):(o=this[r]().color[e],n&&(o=n(o)),o)}}function maxfn(r){return function(e){return Math.max(0,Math.min(r,e))}}function assertArray(r){return Array.isArray(r)?r:[r]}function zeroArray(r,e){for(var n=0;n<e;n++)"number"!=typeof r[n]&&(r[n]=0);return r}Color.prototype={toString:function(){return this.string()},toJSON:function(){return this[this.model]()},string:function(r){var e=this.model in colorString.to?this:this.rgb(),n=1===(e=e.round("number"==typeof r?r:1)).valpha?e.color:e.color.concat(this.valpha);return colorString.to[e.model](n)},percentString:function(r){var e=this.rgb().round("number"==typeof r?r:1),n=1===e.valpha?e.color:e.color.concat(this.valpha);return colorString.to.rgb.percent(n)},array:function(){return 1===this.valpha?this.color.slice():this.color.concat(this.valpha)},object:function(){for(var r={},e=colorConvert[this.model].channels,n=colorConvert[this.model].labels,t=0;t<e;t++)r[n[t]]=this.color[t];return 1!==this.valpha&&(r.alpha=this.valpha),r},unitArray:function(){var r=this.rgb().color;return r[0]/=255,r[1]/=255,r[2]/=255,1!==this.valpha&&r.push(this.valpha),r},unitObject:function(){var r=this.rgb().object();return r.r/=255,r.g/=255,r.b/=255,1!==this.valpha&&(r.alpha=this.valpha),r},round:function(r){return r=Math.max(r||0,0),new Color(this.color.map(roundToPlace(r)).concat(this.valpha),this.model)},alpha:function(r){return arguments.length?new Color(this.color.concat(Math.max(0,Math.min(1,r))),this.model):this.valpha},red:getset("rgb",0,maxfn(255)),green:getset("rgb",1,maxfn(255)),blue:getset("rgb",2,maxfn(255)),hue:getset(["hsl","hsv","hsl","hwb","hcg"],0,function(r){return (r%360+360)%360}),saturationl:getset("hsl",1,maxfn(100)),lightness:getset("hsl",2,maxfn(100)),saturationv:getset("hsv",1,maxfn(100)),value:getset("hsv",2,maxfn(100)),chroma:getset("hcg",1,maxfn(100)),gray:getset("hcg",2,maxfn(100)),white:getset("hwb",1,maxfn(100)),wblack:getset("hwb",2,maxfn(100)),cyan:getset("cmyk",0,maxfn(100)),magenta:getset("cmyk",1,maxfn(100)),yellow:getset("cmyk",2,maxfn(100)),black:getset("cmyk",3,maxfn(100)),x:getset("xyz",0,maxfn(100)),y:getset("xyz",1,maxfn(100)),z:getset("xyz",2,maxfn(100)),l:getset("lab",0,maxfn(100)),a:getset("lab",1),b:getset("lab",2),keyword:function(r){return arguments.length?new Color(r):colorConvert[this.model].keyword(this.color)},hex:function(r){return arguments.length?new Color(r):colorString.to.hex(this.rgb().round().color)},rgbNumber:function(){var r=this.rgb().color;return (255&r[0])<<16|(255&r[1])<<8|255&r[2]},luminosity:function(){for(var r=this.rgb().color,e=[],n=0;n<r.length;n++){var t=r[n]/255;e[n]=t<=.03928?t/12.92:Math.pow((t+.055)/1.055,2.4);}return .2126*e[0]+.7152*e[1]+.0722*e[2]},contrast:function(r){var e=this.luminosity(),n=r.luminosity();return e>n?(e+.05)/(n+.05):(n+.05)/(e+.05)},level:function(r){var e=this.contrast(r);return e>=7.1?"AAA":e>=4.5?"AA":""},isDark:function(){var r=this.rgb().color;return (299*r[0]+587*r[1]+114*r[2])/1e3<128},isLight:function(){return !this.isDark()},negate:function(){for(var r=this.rgb(),e=0;e<3;e++)r.color[e]=255-r.color[e];return r},lighten:function(r){var e=this.hsl();return e.color[2]+=e.color[2]*r,e},darken:function(r){var e=this.hsl();return e.color[2]-=e.color[2]*r,e},saturate:function(r){var e=this.hsl();return e.color[1]+=e.color[1]*r,e},desaturate:function(r){var e=this.hsl();return e.color[1]-=e.color[1]*r,e},whiten:function(r){var e=this.hwb();return e.color[1]+=e.color[1]*r,e},blacken:function(r){var e=this.hwb();return e.color[2]+=e.color[2]*r,e},grayscale:function(){var r=this.rgb().color,e=.3*r[0]+.59*r[1]+.11*r[2];return Color.rgb(e,e,e)},fade:function(r){return this.alpha(this.valpha-this.valpha*r)},opaquer:function(r){return this.alpha(this.valpha+this.valpha*r)},rotate:function(r){var e=this.hsl(),n=e.color[0];return n=(n=(n+r)%360)<0?360+n:n,e.color[0]=n,e},mix:function(r,e){var n=r.rgb(),t=this.rgb(),o=void 0===e?.5:e,a=2*o-1,i=n.alpha()-t.alpha(),s=((a*i==-1?a:(a+i)/(1+a*i))+1)/2,l=1-s;return Color.rgb(s*n.red()+l*t.red(),s*n.green()+l*t.green(),s*n.blue()+l*t.blue(),n.alpha()*o+t.alpha()*(1-o))}},Object.keys(colorConvert).forEach(function(r){if(-1===skippedModels.indexOf(r)){var e=colorConvert[r].channels;Color.prototype[r]=function(){if(this.model===r)return new Color(this);if(arguments.length)return new Color(arguments,r);var n="number"==typeof arguments[e]?e:this.valpha;return new Color(assertArray(colorConvert[this.model][r].raw(this.color)).concat(n),r)},Color[r]=function(n){return "number"==typeof n&&(n=zeroArray(_slice.call(arguments),e)),new Color(n,r)};}});var color=Color,ColorMock=function r(e){var n=this;classCallCheck(this,r),defineProperty(this,"hsl",function(){return n}),defineProperty(this,"isLight",function(){return !1}),defineProperty(this,"isDark",function(){return !1}),defineProperty(this,"negate",function(){return n}),defineProperty(this,"lighten",function(){return n}),defineProperty(this,"darken",function(){return n}),defineProperty(this,"alpha",function(){return n}),defineProperty(this,"saturate",function(){return n}),defineProperty(this,"desaturate",function(){return n}),defineProperty(this,"grayscale",function(){return n}),defineProperty(this,"whiten",function(){return n}),defineProperty(this,"blacken",function(){return n}),defineProperty(this,"fade",function(){return n}),defineProperty(this,"opaquer",function(){return n}),defineProperty(this,"rotate",function(){return n}),defineProperty(this,"contrast",function(){return 10}),defineProperty(this,"luminosity",function(){return .5}),defineProperty(this,"mix",function(){return n}),defineProperty(this,"blue",function(){return n.toString()}),defineProperty(this,"green",function(){return n.toString()}),defineProperty(this,"red",function(){return n.toString()}),defineProperty(this,"hex",function(){return n.toString()}),defineProperty(this,"rgbNumber",function(){return n.toString()}),defineProperty(this,"rgb",function(){return n.toString()}),defineProperty(this,"toString",function(){return n.color}),this.color=e;};function ColorWrapper(r){return "string"==typeof r&&-1!==r.indexOf("linear-gradient")?new ColorMock(r):color(r)}

var alert = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.alertVariant = alertVariant;
exports.default = void 0;
var _color = _interopRequireDefault(ColorWrapper);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function alertVariant(background, border, bodyColor) {
  return "\n    background-color: ".concat(background, ";\n    border-color: ").concat(border, ";\n    color: ").concat(bodyColor, ";\n  \n    hr {\n      border-top-color: ").concat((0, _color.default)(border).darken(0.5).toString(), ";\n    }\n    .alert-link {\n      color: ").concat((0, _color.default)(bodyColor).darken(0.1).toString(), ";\n    }\n  ");
}
var _default = {
  alertVariant: alertVariant
};
exports.default = _default;
});
unwrapExports(alert);
var alert_1 = alert.alertVariant;

var borderRadius_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.borderRadius = borderRadius;
exports.borderTopRadius = borderTopRadius;
exports.borderRightRadius = borderRightRadius;
exports.borderBottomRadius = borderBottomRadius;
exports.borderLeftRadius = borderLeftRadius;
exports.default = exports.defaultProps = void 0;
var defaultProps = {
  '$border-radius': '.25rem',
  '$enable-rounded': true
};
exports.defaultProps = defaultProps;
function borderRadius() {
  var enableRounded = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-rounded'];
  var radius = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$border-radius'];
  if (enableRounded) {
    return "\n      border-radius: ".concat(radius, ";\n    ");
  }
  return '';
}
function borderTopRadius() {
  var enableRounded = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-rounded'];
  var radius = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$border-radius'];
  if (enableRounded) {
    return "\n      border-top-right-radius: ".concat(radius, ";\n      border-top-left-radius: ").concat(radius, ";\n    ");
  }
  return '';
}
function borderRightRadius() {
  var enableRounded = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-rounded'];
  var radius = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$border-radius'];
  if (enableRounded) {
    return "\n      border-bottom-right-radius: ".concat(radius, ";\n      border-top-right-radius: ").concat(radius, ";\n    ");
  }
  return '';
}
function borderBottomRadius() {
  var enableRounded = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-rounded'];
  var radius = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$border-radius'];
  if (enableRounded) {
    return "\n      border-bottom-right-radius: ".concat(radius, ";\n      border-bottom-left-radius: ").concat(radius, ";\n    ");
  }
  return '';
}
function borderLeftRadius() {
  var enableRounded = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-rounded'];
  var radius = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$border-radius'];
  if (enableRounded) {
    return "\n      border-bottom-left-radius: ".concat(radius, ";\n      border-top-left-radius: ").concat(radius, ";\n    ");
  }
  return '';
}
var _default = {
  defaultProps: defaultProps,
  all: borderRadius,
  top: borderTopRadius,
  right: borderRightRadius,
  bottom: borderBottomRadius,
  left: borderLeftRadius
};
exports.default = _default;
});
unwrapExports(borderRadius_1);
var borderRadius_2 = borderRadius_1.borderRadius;
var borderRadius_3 = borderRadius_1.borderTopRadius;
var borderRadius_4 = borderRadius_1.borderRightRadius;
var borderRadius_5 = borderRadius_1.borderBottomRadius;
var borderRadius_6 = borderRadius_1.borderLeftRadius;
var borderRadius_7 = borderRadius_1.defaultProps;

var tools = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getTetherAttachments = getTetherAttachments;
exports.getScrollbarWidth = getScrollbarWidth;
exports.setScrollbarWidth = setScrollbarWidth;
exports.isBodyOverflowing = isBodyOverflowing;
exports.getOriginalBodyPadding = getOriginalBodyPadding;
exports.conditionallyUpdateScrollbar = conditionallyUpdateScrollbar;
exports.toHashCode = toHashCode;
exports.createChainedFunction = createChainedFunction;
exports.pick = pick;
exports.tetherAttachements = void 0;
function getTetherAttachments(placement) {
  switch (placement) {
    case 'top':
    case 'top center':
      return {
        attachment: 'bottom center',
        targetAttachment: 'top center'
      };
    case 'bottom':
    case 'bottom center':
      return {
        attachment: 'top center',
        targetAttachment: 'bottom center'
      };
    case 'left':
    case 'left center':
      return {
        attachment: 'middle right',
        targetAttachment: 'middle left'
      };
    case 'right':
    case 'right center':
      return {
        attachment: 'middle left',
        targetAttachment: 'middle right'
      };
    case 'top left':
      return {
        attachment: 'bottom left',
        targetAttachment: 'top left'
      };
    case 'top right':
      return {
        attachment: 'bottom right',
        targetAttachment: 'top right'
      };
    case 'bottom left':
      return {
        attachment: 'top left',
        targetAttachment: 'bottom left'
      };
    case 'bottom right':
      return {
        attachment: 'top right',
        targetAttachment: 'bottom right'
      };
    case 'right top':
      return {
        attachment: 'top left',
        targetAttachment: 'top right'
      };
    case 'right bottom':
      return {
        attachment: 'bottom left',
        targetAttachment: 'bottom right'
      };
    case 'left top':
      return {
        attachment: 'top right',
        targetAttachment: 'top left'
      };
    case 'left bottom':
      return {
        attachment: 'bottom right',
        targetAttachment: 'bottom left'
      };
    default:
      return {
        attachment: 'top center',
        targetAttachment: 'bottom center'
      };
  }
}
var tetherAttachements = ['top', 'bottom', 'left', 'right', 'top left', 'top center', 'top right', 'right top', 'right middle', 'right bottom', 'bottom right', 'bottom center', 'bottom left', 'left top', 'left middle', 'left bottom'];
exports.tetherAttachements = tetherAttachements;
function getScrollbarWidth() {
  var scrollDiv = document.createElement('div');
  scrollDiv.style.position = 'absolute';
  scrollDiv.style.top = '-9999px';
  scrollDiv.style.width = '50px';
  scrollDiv.style.height = '50px';
  scrollDiv.style.overflow = 'scroll';
  document.body.appendChild(scrollDiv);
  var scrollbarWidth = scrollDiv.offsetWidth - scrollDiv.clientWidth;
  document.body.removeChild(scrollDiv);
  return scrollbarWidth;
}
function setScrollbarWidth(padding) {
  document.body.style.paddingRight = padding > 0 ? "".concat(padding, "px") : null;
}
function isBodyOverflowing() {
  return document.body.clientWidth < window.innerWidth;
}
function getOriginalBodyPadding() {
  return parseInt(window.getComputedStyle(document.body, null).getPropertyValue('padding-right') || 0, 10);
}
function conditionallyUpdateScrollbar() {
  var scrollbarWidth = getScrollbarWidth();
  var fixedContent = document.querySelectorAll('.navbar-fixed-top, .navbar-fixed-bottom, .is-fixed')[0];
  var bodyPadding = fixedContent ? parseInt(fixedContent.style.paddingRight || 0, 10) : 0;
  if (isBodyOverflowing()) {
    setScrollbarWidth(bodyPadding + scrollbarWidth);
  }
}
function toHashCode(str) {
  var hash = 0;
  if (str.length === 0) {
    return hash;
  }
  for (var i = 0; i < str.length; i += 1) {
    var char = str.charCodeAt(i);
    hash = (hash << 5) - hash + char;
    hash = hash & hash;
  }
  return hash;
}
function createChainedFunction() {
  for (var _len = arguments.length, funcs = new Array(_len), _key = 0; _key < _len; _key++) {
    funcs[_key] = arguments[_key];
  }
  return funcs.filter(function (func) {
    return func != null;
  }).reduce(function (acc, func) {
    return function chainedFunction() {
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }
      acc.apply(this, args);
      func.apply(this, args);
    };
  }, function () {});
}
function pick(obj, keys) {
  var pickKeys = Array.isArray(keys) ? keys : [keys];
  var length = pickKeys.length;
  var key;
  var result = {};
  while (length > 0) {
    length -= 1;
    key = pickKeys[length];
    result[key] = obj[key];
  }
  return result;
}
});
unwrapExports(tools);
var tools_1 = tools.getTetherAttachments;
var tools_2 = tools.getScrollbarWidth;
var tools_3 = tools.setScrollbarWidth;
var tools_4 = tools.isBodyOverflowing;
var tools_5 = tools.getOriginalBodyPadding;
var tools_6 = tools.conditionallyUpdateScrollbar;
var tools_7 = tools.toHashCode;
var tools_8 = tools.createChainedFunction;
var tools_9 = tools.pick;
var tools_10 = tools.tetherAttachements;

function componentWillMount() {
  var state = this.constructor.getDerivedStateFromProps(this.props, this.state);
  if (state !== null && state !== undefined) {
    this.setState(state);
  }
}
function componentWillReceiveProps(nextProps) {
  function updater(prevState) {
    var state = this.constructor.getDerivedStateFromProps(nextProps, prevState);
    return state !== null && state !== undefined ? state : null;
  }
  this.setState(updater.bind(this));
}
function componentWillUpdate(nextProps, nextState) {
  try {
    var prevProps = this.props;
    var prevState = this.state;
    this.props = nextProps;
    this.state = nextState;
    this.__reactInternalSnapshotFlag = true;
    this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(
      prevProps,
      prevState
    );
  } finally {
    this.props = prevProps;
    this.state = prevState;
  }
}
componentWillMount.__suppressDeprecationWarning = true;
componentWillReceiveProps.__suppressDeprecationWarning = true;
componentWillUpdate.__suppressDeprecationWarning = true;
function polyfill(Component) {
  var prototype = Component.prototype;
  if (!prototype || !prototype.isReactComponent) {
    throw new Error('Can only polyfill class components');
  }
  if (
    typeof Component.getDerivedStateFromProps !== 'function' &&
    typeof prototype.getSnapshotBeforeUpdate !== 'function'
  ) {
    return Component;
  }
  var foundWillMountName = null;
  var foundWillReceivePropsName = null;
  var foundWillUpdateName = null;
  if (typeof prototype.componentWillMount === 'function') {
    foundWillMountName = 'componentWillMount';
  } else if (typeof prototype.UNSAFE_componentWillMount === 'function') {
    foundWillMountName = 'UNSAFE_componentWillMount';
  }
  if (typeof prototype.componentWillReceiveProps === 'function') {
    foundWillReceivePropsName = 'componentWillReceiveProps';
  } else if (typeof prototype.UNSAFE_componentWillReceiveProps === 'function') {
    foundWillReceivePropsName = 'UNSAFE_componentWillReceiveProps';
  }
  if (typeof prototype.componentWillUpdate === 'function') {
    foundWillUpdateName = 'componentWillUpdate';
  } else if (typeof prototype.UNSAFE_componentWillUpdate === 'function') {
    foundWillUpdateName = 'UNSAFE_componentWillUpdate';
  }
  if (
    foundWillMountName !== null ||
    foundWillReceivePropsName !== null ||
    foundWillUpdateName !== null
  ) {
    var componentName = Component.displayName || Component.name;
    var newApiName =
      typeof Component.getDerivedStateFromProps === 'function'
        ? 'getDerivedStateFromProps()'
        : 'getSnapshotBeforeUpdate()';
    throw Error(
      'Unsafe legacy lifecycles will not be called for components using new component APIs.\n\n' +
        componentName +
        ' uses ' +
        newApiName +
        ' but also contains the following legacy lifecycles:' +
        (foundWillMountName !== null ? '\n  ' + foundWillMountName : '') +
        (foundWillReceivePropsName !== null
          ? '\n  ' + foundWillReceivePropsName
          : '') +
        (foundWillUpdateName !== null ? '\n  ' + foundWillUpdateName : '') +
        '\n\nThe above lifecycles should be removed. Learn more about this warning here:\n' +
        'https://fb.me/react-async-component-lifecycle-hooks'
    );
  }
  if (typeof Component.getDerivedStateFromProps === 'function') {
    prototype.componentWillMount = componentWillMount;
    prototype.componentWillReceiveProps = componentWillReceiveProps;
  }
  if (typeof prototype.getSnapshotBeforeUpdate === 'function') {
    if (typeof prototype.componentDidUpdate !== 'function') {
      throw new Error(
        'Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype'
      );
    }
    prototype.componentWillUpdate = componentWillUpdate;
    var componentDidUpdate = prototype.componentDidUpdate;
    prototype.componentDidUpdate = function componentDidUpdatePolyfill(
      prevProps,
      prevState,
      maybeSnapshot
    ) {
      var snapshot = this.__reactInternalSnapshotFlag
        ? this.__reactInternalSnapshot
        : maybeSnapshot;
      componentDidUpdate.call(this, prevProps, prevState, snapshot);
    };
  }
  return Component;
}

var reactLifecyclesCompat_es = /*#__PURE__*/Object.freeze({
  polyfill: polyfill
});

var PropTypes = createCommonjsModule(function (module, exports) {
exports.__esModule = true;
exports.classNamesShape = exports.timeoutsShape = void 0;
var _propTypes = _interopRequireDefault(propTypes);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var timeoutsShape = null;
exports.timeoutsShape = timeoutsShape;
var classNamesShape = null;
exports.classNamesShape = classNamesShape;
});
unwrapExports(PropTypes);
var PropTypes_1 = PropTypes.classNamesShape;
var PropTypes_2 = PropTypes.timeoutsShape;

var Transition_1 = createCommonjsModule(function (module, exports) {
exports.__esModule = true;
exports.default = exports.EXITING = exports.ENTERED = exports.ENTERING = exports.EXITED = exports.UNMOUNTED = void 0;
var PropTypes = _interopRequireWildcard(propTypes);
var _react = _interopRequireDefault(React);
var _reactDom = _interopRequireDefault(ReactDOM);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }
var UNMOUNTED = 'unmounted';
exports.UNMOUNTED = UNMOUNTED;
var EXITED = 'exited';
exports.EXITED = EXITED;
var ENTERING = 'entering';
exports.ENTERING = ENTERING;
var ENTERED = 'entered';
exports.ENTERED = ENTERED;
var EXITING = 'exiting';
exports.EXITING = EXITING;
var Transition =
function (_React$Component) {
  _inheritsLoose(Transition, _React$Component);
  function Transition(props, context) {
    var _this;
    _this = _React$Component.call(this, props, context) || this;
    var parentGroup = context.transitionGroup;
    var appear = parentGroup && !parentGroup.isMounting ? props.enter : props.appear;
    var initialStatus;
    _this.appearStatus = null;
    if (props.in) {
      if (appear) {
        initialStatus = EXITED;
        _this.appearStatus = ENTERING;
      } else {
        initialStatus = ENTERED;
      }
    } else {
      if (props.unmountOnExit || props.mountOnEnter) {
        initialStatus = UNMOUNTED;
      } else {
        initialStatus = EXITED;
      }
    }
    _this.state = {
      status: initialStatus
    };
    _this.nextCallback = null;
    return _this;
  }
  var _proto = Transition.prototype;
  _proto.getChildContext = function getChildContext() {
    return {
      transitionGroup: null
    };
  };
  Transition.getDerivedStateFromProps = function getDerivedStateFromProps(_ref, prevState) {
    var nextIn = _ref.in;
    if (nextIn && prevState.status === UNMOUNTED) {
      return {
        status: EXITED
      };
    }
    return null;
  };
  _proto.componentDidMount = function componentDidMount() {
    this.updateStatus(true, this.appearStatus);
  };
  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    var nextStatus = null;
    if (prevProps !== this.props) {
      var status = this.state.status;
      if (this.props.in) {
        if (status !== ENTERING && status !== ENTERED) {
          nextStatus = ENTERING;
        }
      } else {
        if (status === ENTERING || status === ENTERED) {
          nextStatus = EXITING;
        }
      }
    }
    this.updateStatus(false, nextStatus);
  };
  _proto.componentWillUnmount = function componentWillUnmount() {
    this.cancelNextCallback();
  };
  _proto.getTimeouts = function getTimeouts() {
    var timeout = this.props.timeout;
    var exit, enter, appear;
    exit = enter = appear = timeout;
    if (timeout != null && typeof timeout !== 'number') {
      exit = timeout.exit;
      enter = timeout.enter;
      appear = timeout.appear;
    }
    return {
      exit: exit,
      enter: enter,
      appear: appear
    };
  };
  _proto.updateStatus = function updateStatus(mounting, nextStatus) {
    if (mounting === void 0) {
      mounting = false;
    }
    if (nextStatus !== null) {
      this.cancelNextCallback();
      var node = _reactDom.default.findDOMNode(this);
      if (nextStatus === ENTERING) {
        this.performEnter(node, mounting);
      } else {
        this.performExit(node);
      }
    } else if (this.props.unmountOnExit && this.state.status === EXITED) {
      this.setState({
        status: UNMOUNTED
      });
    }
  };
  _proto.performEnter = function performEnter(node, mounting) {
    var _this2 = this;
    var enter = this.props.enter;
    var appearing = this.context.transitionGroup ? this.context.transitionGroup.isMounting : mounting;
    var timeouts = this.getTimeouts();
    if (!mounting && !enter) {
      this.safeSetState({
        status: ENTERED
      }, function () {
        _this2.props.onEntered(node);
      });
      return;
    }
    this.props.onEnter(node, appearing);
    this.safeSetState({
      status: ENTERING
    }, function () {
      _this2.props.onEntering(node, appearing);
      _this2.onTransitionEnd(node, timeouts.enter, function () {
        _this2.safeSetState({
          status: ENTERED
        }, function () {
          _this2.props.onEntered(node, appearing);
        });
      });
    });
  };
  _proto.performExit = function performExit(node) {
    var _this3 = this;
    var exit = this.props.exit;
    var timeouts = this.getTimeouts();
    if (!exit) {
      this.safeSetState({
        status: EXITED
      }, function () {
        _this3.props.onExited(node);
      });
      return;
    }
    this.props.onExit(node);
    this.safeSetState({
      status: EXITING
    }, function () {
      _this3.props.onExiting(node);
      _this3.onTransitionEnd(node, timeouts.exit, function () {
        _this3.safeSetState({
          status: EXITED
        }, function () {
          _this3.props.onExited(node);
        });
      });
    });
  };
  _proto.cancelNextCallback = function cancelNextCallback() {
    if (this.nextCallback !== null) {
      this.nextCallback.cancel();
      this.nextCallback = null;
    }
  };
  _proto.safeSetState = function safeSetState(nextState, callback) {
    callback = this.setNextCallback(callback);
    this.setState(nextState, callback);
  };
  _proto.setNextCallback = function setNextCallback(callback) {
    var _this4 = this;
    var active = true;
    this.nextCallback = function (event) {
      if (active) {
        active = false;
        _this4.nextCallback = null;
        callback(event);
      }
    };
    this.nextCallback.cancel = function () {
      active = false;
    };
    return this.nextCallback;
  };
  _proto.onTransitionEnd = function onTransitionEnd(node, timeout, handler) {
    this.setNextCallback(handler);
    if (node) {
      if (this.props.addEndListener) {
        this.props.addEndListener(node, this.nextCallback);
      }
      if (timeout != null) {
        setTimeout(this.nextCallback, timeout);
      }
    } else {
      setTimeout(this.nextCallback, 0);
    }
  };
  _proto.render = function render() {
    var status = this.state.status;
    if (status === UNMOUNTED) {
      return null;
    }
    var _this$props = this.props,
        children = _this$props.children,
        childProps = _objectWithoutPropertiesLoose(_this$props, ["children"]);
    delete childProps.in;
    delete childProps.mountOnEnter;
    delete childProps.unmountOnExit;
    delete childProps.appear;
    delete childProps.enter;
    delete childProps.exit;
    delete childProps.timeout;
    delete childProps.addEndListener;
    delete childProps.onEnter;
    delete childProps.onEntering;
    delete childProps.onEntered;
    delete childProps.onExit;
    delete childProps.onExiting;
    delete childProps.onExited;
    if (typeof children === 'function') {
      return children(status, childProps);
    }
    var child = _react.default.Children.only(children);
    return _react.default.cloneElement(child, childProps);
  };
  return Transition;
}(_react.default.Component);
Transition.contextTypes = {
  transitionGroup: PropTypes.object
};
Transition.childContextTypes = {
  transitionGroup: function transitionGroup() {}
};
Transition.propTypes = {};
function noop() {}
Transition.defaultProps = {
  in: false,
  mountOnEnter: false,
  unmountOnExit: false,
  appear: false,
  enter: true,
  exit: true,
  onEnter: noop,
  onEntering: noop,
  onEntered: noop,
  onExit: noop,
  onExiting: noop,
  onExited: noop
};
Transition.UNMOUNTED = 0;
Transition.EXITED = 1;
Transition.ENTERING = 2;
Transition.ENTERED = 3;
Transition.EXITING = 4;
var _default = (0, reactLifecyclesCompat_es.polyfill)(Transition);
exports.default = _default;
});
var Transition = unwrapExports(Transition_1);
var Transition_2 = Transition_1.EXITING;
var Transition_3 = Transition_1.ENTERED;
var Transition_4 = Transition_1.ENTERING;
var Transition_5 = Transition_1.EXITED;
var Transition_6 = Transition_1.UNMOUNTED;

var propTypes$3 = _objectSpread({}, Transition.propTypes, {
  children: propTypes.oneOfType([propTypes.arrayOf(propTypes.node), propTypes.node]),
  tag: propTypes.any,
  baseClass: propTypes.string,
  baseClassActive: propTypes.string,
  className: propTypes.string,
  cssModule: propTypes.object
});
var defaultProps$3 = _objectSpread({}, Transition.defaultProps, {
  tag: 'div',
  baseClass: 'fade',
  baseClassActive: 'show',
  timeout: 150,
  appear: true,
  enter: true,
  exit: true,
  in: true
});
function Fade(props) {
  var Tag = props.tag,
      baseClass = props.baseClass,
      baseClassActive = props.baseClassActive,
      className = props.className,
      cssModule = props.cssModule,
      children = props.children,
      otherProps = _objectWithoutProperties(props, ["tag", "baseClass", "baseClassActive", "className", "cssModule", "children"]);
  var TransitionPropTypeKeys = ['in', 'mountOnEnter', 'unmountOnExit', 'appear', 'enter', 'exit', 'timeout', 'onEnter', 'onEntering', 'onEntered', 'onExit', 'onExiting', 'onExited'];
  var transitionProps = tools_9(otherProps, TransitionPropTypeKeys);
  var childProps = lodash_omit(otherProps, TransitionPropTypeKeys, 'ref');
  return React.createElement(Transition, transitionProps, function (status) {
    var isActive = status === 'entered';
    return React.createElement(Tag, _extends({
      className: mapToCssModules(classnames(className, baseClass, isActive && baseClassActive), cssModule)
    }, childProps), children);
  });
}
Fade.propTypes = propTypes$3;
Fade.defaultProps = defaultProps$3;

var defaultProps$4 = {
  theme: {
    '$close-color': '#000',
    '$close-font-size': '1.5rem',
    '$close-font-weight': '#bold',
    '$close-text-shadow': '0 1px 0 #fff',
    '$enable-hover-media-query': false
  }
};
var propTypes$4 = {
  className: propTypes.string,
  theme: propTypes.shape({
    '$enable-rounded': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool
  }),
  closeLabel: propTypes.string,
  onDismiss: propTypes.func.isRequired,
  'sr-only': propTypes.bool,
  cssModule: propTypes.object
};
var CloseUnstyled =
function (_React$Component) {
  _inherits(CloseUnstyled, _React$Component);
  function CloseUnstyled() {
    _classCallCheck(this, CloseUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(CloseUnstyled).apply(this, arguments));
  }
  _createClass(CloseUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          srOnly = _omit['sr-only'],
          onDismiss = _omit.onDismiss,
          closeLabel = _omit.closeLabel,
          cssModule = _omit.cssModule,
          attributes = _objectWithoutProperties(_omit, ["className", "sr-only", "onDismiss", "closeLabel", "cssModule"]);
      return React.createElement("button", _extends({
        className: mapToCssModules(classnames(className, 'close', {
          'sr-only': srOnly
        }), cssModule),
        type: "button",
        onClick: onDismiss
      }, attributes), closeLabel, React.createElement("span", null, "\xD7"));
    }
  }]);
  return CloseUnstyled;
}(React.Component);
_defineProperty(CloseUnstyled, "propTypes", propTypes$4);
_defineProperty(CloseUnstyled, "defaultProps", defaultProps$4);
var Close = styled(CloseUnstyled).withConfig({
  displayName: "Close",
  componentId: "gim324-0"
})(["", ""], function (props) {
  return "\n    float: right;\n    font-size: ".concat(props.theme['$close-font-size'], ";\n    font-weight: ").concat(props.theme['$close-font-weight'], ";\n    line-height: 1;\n    color: ").concat(props.theme['$close-color'], ";\n    text-shadow: ").concat(props.theme['$close-text-shadow'], ";\n    opacity: .2;\n    \n    &:focus {outline:0;}\n    \n    ").concat(hover_3(props.theme['$enable-hover-media-query'], "\n        color: ".concat(props.theme['$close-color'], ";\n        text-decoration: none;\n        cursor: pointer;\n        opacity: .5;\n      ")), "\n    \n    /* Additional properties for button version\n     iOS requires the button element instead of an anchor tag.\n     If you want the anchor version, it requires 'href=\"#\"'.\n     See https://developer.mozilla.org/en-US/docs/Web/Events/click#Safari_Mobile\n     */\n    \n    /* scss-lint:disable QualifyingElement */\n    &.close {\n      padding: 0;\n      cursor: pointer;\n      background: transparent;\n      border: 0;\n      -webkit-appearance: none;\n    }\n    /* scss-lint:enable QualifyingElement */\n  ");
});
Close.defaultProps = defaultProps$4;
Close.propTypes = propTypes$4;

var defaultProps$5 = {
  color: 'success',
  isOpen: true,
  tag: 'div',
  theme: {
    '$alert-padding-x': '1.25rem',
    '$alert-padding-y': '.75rem',
    '$alert-margin-bottom': '1rem',
    '$alert-border-radius': '.25rem',
    '$alert-link-font-weight': 'bold',
    '$alert-border-width': '1px',
    '$alert-success-bg': '#dff0d8',
    '$alert-success-text': '#3c763d',
    '$alert-success-border': '#3c763d',
    '$alert-info-bg': '#d9edf7',
    '$alert-info-text': '#31708f',
    '$alert-info-border': '#31708f',
    '$alert-warning-bg': '#fcf8e3',
    '$alert-warning-text': '#8a6d3b',
    '$alert-warning-border': '#8a6d3b',
    '$alert-danger-bg': '#f2dede',
    '$alert-danger-text': '#a94442',
    '$alert-danger-border': '#a94442',
    '$enable-rounded': true
  },
  uncontrolled: false,
  autoHideDuration: null,
  transition: _objectSpread({}, defaultProps$3, {
    unmountOnExit: true
  })
};
var propTypes$5 = {
  className: propTypes.string,
  children: propTypes.node,
  color: propTypes.oneOf(['success', 'info', 'warning', 'danger']),
  isOpen: propTypes.bool,
  toggle: propTypes.func,
  onClick: propTypes.func,
  initializeIsOpen: propTypes.func,
  tag: propTypes.any,
  transition: propTypes.shape({
    FadeProptypes: propTypes.object,
    unmountOnExit: propTypes.bool
  }),
  autoHideDuration: propTypes.number,
  theme: propTypes.shape({
    '$alert-padding-x': propTypes.string,
    '$alert-padding-y': propTypes.string,
    '$alert-margin-bottom': propTypes.string,
    '$alert-border-radius': propTypes.string,
    '$alert-link-font-weight': propTypes.string,
    '$alert-border-width': propTypes.string,
    '$alert-success-bg': propTypes.string,
    '$alert-success-text': propTypes.string,
    '$alert-success-border': propTypes.string,
    '$alert-info-bg': propTypes.string,
    '$alert-info-text': propTypes.string,
    '$alert-info-border': propTypes.string,
    '$alert-warning-bg': propTypes.string,
    '$alert-warning-text': propTypes.string,
    '$alert-warning-border': propTypes.string,
    '$alert-danger-bg': propTypes.string,
    '$alert-danger-text': propTypes.string,
    '$alert-danger-border': propTypes.string,
    '$enable-rounded': propTypes.bool
  }),
  uncontrolled: propTypes.bool,
  cssModule: propTypes.object
};
var AlertUnstyled =
function (_React$Component) {
  _inherits(AlertUnstyled, _React$Component);
  function AlertUnstyled() {
    var _getPrototypeOf2;
    var _this;
    _classCallCheck(this, AlertUnstyled);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(AlertUnstyled)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _defineProperty(_assertThisInitialized(_this), "state", {
      uncontrolledOpen: true,
      exited: false
    });
    _defineProperty(_assertThisInitialized(_this), "setAutoHideTimer", function (autoHideDuration) {
      if (!_this.props.autoHideDuration) {
        return;
      }
      clearTimeout(_this.timerAutoHide);
      _this.timerAutoHide = setTimeout(function () {
        if (_this.props.autoHideDuration) {
          _this.toggle();
        }
      }, autoHideDuration || _this.props.autoHideDuration);
    });
    _defineProperty(_assertThisInitialized(_this), "timerAutoHide", null);
    _defineProperty(_assertThisInitialized(_this), "initializeIsOpen", function (props) {
      return _this.setState({
        uncontrolledOpen: props.isOpen
      });
    });
    _defineProperty(_assertThisInitialized(_this), "toggle", function (e) {
      if (_this.props.onClick) {
        _this.props.onClick(e);
      } else {
        _this.setState({
          uncontrolledOpen: false
        });
      }
    });
    _defineProperty(_assertThisInitialized(_this), "handleExited", function () {
      _this.setState({
        exited: true
      });
    });
    return _this;
  }
  _createClass(AlertUnstyled, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      this.initializeIsOpen(this.props);
      if (this.props.uncontrolled) {
        if (this.state.uncontrolledOpen) {
          this.setState({
            exited: true
          });
        }
        return;
      }
      if (!this.props.isOpen) {
        this.setState({
          exited: true
        });
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.autoHideDuration) {
        this.setAutoHideTimer();
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.isOpen) {
        this.setState({
          exited: false
        });
      }
      if (nextProps.isOpen !== this.props.isOpen) {
        this.initializeIsOpen(nextProps);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.isOpen !== this.props.isOpen) {
        if (this.props.isOpen) {
          this.setAutoHideTimer();
        } else {
          clearTimeout(this.timerAutoHide);
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.timerAutoHide);
    }
  }, {
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme', 'autoHideDuration', 'toggle']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          Tag = _omit.tag,
          color = _omit.color,
          isOpen = _omit.isOpen,
          onClick = _omit.onClick,
          children = _omit.children,
          onExited = _omit.onExited,
          transition = _omit.transition,
          uncontrolled = _omit.uncontrolled,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "tag", "color", "isOpen", "onClick", "children", "onExited", "transition", "uncontrolled"]);
      var classes = mapToCssModules(classnames(className, 'alert', "alert-".concat(color), {
        'alert-dismissible': uncontrolled || onClick
      }), cssModule);
      if (!isOpen && this.state.exited) {
        return null;
      }
      var transitionProps = {
        in: uncontrolled ? this.state.uncontrolledOpen : isOpen,
        appear: true,
        onExited: tools_8(this.handleExited, onExited)
      };
      return React.createElement(Fade, _extends({
        tag: Tag,
        className: classes,
        in: uncontrolled ? this.state.uncontrolledOpen : isOpen,
        role: "alert"
      }, attributes, transition, transitionProps), (uncontrolled || onClick) && React.createElement(Close, {
        onDismiss: this.toggle
      }), children);
    }
  }]);
  return AlertUnstyled;
}(React.Component);
_defineProperty(AlertUnstyled, "propTypes", propTypes$5);
_defineProperty(AlertUnstyled, "defaultProps", defaultProps$5);
var Alert = styled(AlertUnstyled).withConfig({
  displayName: "Alert",
  componentId: "sc-16i3bf4-0"
})(["", ""], function (props) {
  return "\n    /*\n    Base styles\n    */\n    \n    &.alert {\n      padding: ".concat(props.theme['$alert-padding-y'], " ").concat(props.theme['$alert-padding-x'], ";\n      margin-bottom: ").concat(props.theme['$alert-margin-bottom'], ";\n      border: ").concat(props.theme['$alert-border-width'], " solid transparent;\n      ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$alert-border-radius']), "\n    }\n    \n    /* Headings for larger alerts */\n    &.alert-heading {\n      /* Specified to prevent conflicts of changing $headings-color */\n      color: inherit;\n    }\n    \n    /* Provide class for links that match alerts */\n    & .alert-link { \n      font-weight: ").concat(props.theme['$alert-link-font-weight'], ";\n    }\n    \n    /* Dismissible alerts Expand the right padding and account for the close buttons positioning. */\n    \n    &.alert-dismissible {    \n      /* Adjust close link position */\n      & .close {\n        position: relative;\n        top: -").concat(props.theme['$alert-padding-y'], ";\n        right: -").concat(props.theme['$alert-padding-x'], ";\n        padding: ").concat(props.theme['$alert-padding-y'], " ").concat(props.theme['$alert-padding-x'], ";\n        color: inherit;\n      }\n    }\n    /* Alternate styles Generate contextual modifier classes for colorizing the alert. */\n\n    &.alert-success {\n      ").concat(alert_1(props.theme['$alert-success-bg'], props.theme['$alert-success-border'], props.theme['$alert-success-text']), "    \n    }\n    &.alert-info {\n      ").concat(alert_1(props.theme['$alert-info-bg'], props.theme['$alert-info-border'], props.theme['$alert-info-text']), "\n    } \n    &.alert-warning {\n      ").concat(alert_1(props.theme['$alert-warning-bg'], props.theme['$alert-warning-border'], props.theme['$alert-warning-text']), " \n    }\n    &.alert-danger {\n      ").concat(alert_1(props.theme['$alert-danger-bg'], props.theme['$alert-danger-border'], props.theme['$alert-danger-text']), " \n    }\n  ");
});
Alert.propTypes = propTypes$5;
Alert.defaultProps = defaultProps$5;

var Area = styled.area.withConfig({
  displayName: "Area",
  componentId: "sc-3gq087-0"
})(["display:inline;cursor:pointer;"]);

var Article = function Article(props) {
  return React.createElement("article", props);
};

var defaultProps$6 = {
  tag: 'blockquote',
  theme: {
    '$blockquote-small-color': '#636c72',
    '$blockquote-font-size': '1.25rem',
    '$blockquote-border-color': '#eceeef',
    '$blockquote-border-width': '.25rem'
  }
};
var propTypes$6 = {
  className: propTypes.string,
  tag: propTypes.any,
  theme: propTypes.shape({
    '$blockquote-small-color': propTypes.string,
    '$blockquote-font-size': propTypes.string,
    '$blockquote-border-color': propTypes.string,
    '$blockquote-border-width': propTypes.string
  }),
  reverse: propTypes.bool,
  cssModule: propTypes.object
};
var BlockquoteUnstyled =
function (_React$Component) {
  _inherits(BlockquoteUnstyled, _React$Component);
  function BlockquoteUnstyled() {
    _classCallCheck(this, BlockquoteUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(BlockquoteUnstyled).apply(this, arguments));
  }
  _createClass(BlockquoteUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          reverse = _omit.reverse,
          Tag = _omit.tag,
          cssModule = _omit.cssModule,
          attributes = _objectWithoutProperties(_omit, ["className", "reverse", "tag", "cssModule"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'blockquote', {
          'blockquote-reverse': reverse
        }), cssModule)
      }, attributes));
    }
  }]);
  return BlockquoteUnstyled;
}(React.Component);
_defineProperty(BlockquoteUnstyled, "propTypes", propTypes$6);
_defineProperty(BlockquoteUnstyled, "defaultProps", defaultProps$6);
var Blockquote = styled(BlockquoteUnstyled).withConfig({
  displayName: "Blockquote",
  componentId: "sc-1lvysn5-0"
})(["  ", " "], function (props) {
  return "\n    &.blockquote {\n      padding: ".concat(props.theme['$spacer-halved'], " ").concat(props.theme['$spacer'], ";\n      margin-bottom: ").concat(props.theme['$spacer'], ";\n      font-size: ").concat(props.theme['$blockquote-font-size'], ";\n      border-left: ").concat(props.theme['$blockquote-border-width'], " solid ").concat(props.theme['$blockquote-border-color'], ";\n      \n      .blockquote-footer {\n        display: block;\n        font-size: 80%; \n        color: ").concat(props.theme['$blockquote-small-color'], ";\n        &::before {\n          content: '\\2014 \\00A0';\n        }\n      }\n    }\n\n    &.blockquote-reverse {\n      padding-right: ").concat(props.theme['$spacer'], ";\n      padding-left: 0;\n      text-align: right;\n      border-right: ").concat(props.theme['$blockquote-border-width'], " solid ").concat(props.theme['$blockquote-border-color'], ";\n      border-left: 0;\n      \n      .blockquote-footer {\n        display: block;\n        font-size: 80%; \n        color: ").concat(props.theme['$blockquote-small-color'], ";\n        &::before {\n          content: \"\";\n        }\n        &::after {\n          content: '\\00A0 \\2014';\n        }\n      }\n    }\n    \n    /* Reboot from bootstrap v4 */\n    margin: 0 0 1rem;\n ");
});
Blockquote.defaultProps = defaultProps$6;
Blockquote.propTypes = propTypes$6;

var clearfix_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clearfix = clearfix;
exports.default = void 0;
function clearfix() {
  return "\n    &::after {\n      content: \"\";\n      display: table;\n      clear: both;\n    }\n  ";
}
var _default = {
  clearfix: clearfix
};
exports.default = _default;
});
unwrapExports(clearfix_1);
var clearfix_2 = clearfix_1.clearfix;

var defaultProps$7 = {
  tag: 'ol',
  theme: {
    '$breadcrumb-padding-y': '.75rem',
    '$breadcrumb-padding-x': '1rem',
    '$breadcrumb-item-padding': '.5rem',
    '$breadcrumb-bg': '#eceeef',
    '$breadcrumb-divider-color': '#636c72',
    '$breadcrumb-active-color': '#636c72',
    '$breadcrumb-divider': '"/"',
    '$enable-rounded': false
  }
};
var propTypes$7 = {
  className: propTypes.string,
  tag: propTypes.any,
  theme: propTypes.shape({
    '$breadcrumb-padding-y': propTypes.string,
    '$breadcrumb-padding-x': propTypes.string,
    '$breadcrumb-item-padding': propTypes.string,
    '$breadcrumb-bg': propTypes.string,
    '$breadcrumb-divider-color': propTypes.string,
    '$breadcrumb-active-color': propTypes.string,
    '$breadcrumb-divider': propTypes.string,
    '$enable-rounded': propTypes.bool
  }),
  cssModule: propTypes.object
};
var BreadcrumbUnstyled =
function (_React$Component) {
  _inherits(BreadcrumbUnstyled, _React$Component);
  function BreadcrumbUnstyled() {
    _classCallCheck(this, BreadcrumbUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(BreadcrumbUnstyled).apply(this, arguments));
  }
  _createClass(BreadcrumbUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          Tag = _omit.tag,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "tag"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'breadcrumb'), cssModule)
      }, attributes));
    }
  }]);
  return BreadcrumbUnstyled;
}(React.Component);
_defineProperty(BreadcrumbUnstyled, "propTypes", propTypes$7);
_defineProperty(BreadcrumbUnstyled, "defaultProps", defaultProps$7);
var Breadcrumb = styled(BreadcrumbUnstyled).withConfig({
  displayName: "Breadcrumb",
  componentId: "sc-15mocrt-0"
})(["", ""], function (props) {
  return "\n    &.breadcrumb {\n      padding: ".concat(props.theme['$breadcrumb-padding-y'], " ").concat(props.theme['$breadcrumb-padding-x'], ";\n      margin-bottom: ").concat(props.theme['$spacer-y'], ";\n      list-style: none;\n      background-color: ").concat(props.theme['$breadcrumb-bg'], ";\n \n      ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$border-radius']), "\n            \n      ").concat(clearfix_2(), "\n    }\n\n    & .breadcrumb-item {\n      float: left;\n    \n      /* The separator between breadcrumbs (by default, a forward-slash: \"/\") */\n      + .breadcrumb-item::before {\n        display: inline-block; /* Suppress underlining of the separator in modern browsers */\n        padding-right: ").concat(props.theme['$breadcrumb-item-padding'], ";\n        padding-left: ").concat(props.theme['$breadcrumb-item-padding'], ";\n        color: ").concat(props.theme['$breadcrumb-divider-color'], ";\n        content: ").concat(props.theme['$breadcrumb-divider'], ";\n      }\n  \n      /* IE9-11 hack to properly handle hyperlink underlines for breadcrumbs built\n       without 'ul's. The '::before' pseudo-element generates an element\n       *within* the .breadcrumb-item and thereby inherits the 'text-decoration'.\n      \n       To trick IE into suppressing the underline, we give the pseudo-element an\n       underline and then immediately remove it.\n      */\n      \n      + .breadcrumb-item:hover::before {\n        text-decoration: underline;\n      }\n      + .breadcrumb-item:hover::before {\n        text-decoration: none;\n      }\n    \n      &.active {\n        color: ").concat(props.theme['$breadcrumb-active-color'], ";\n      }\n    }\n  ");
});
Breadcrumb.defaultProps = defaultProps$7;
Breadcrumb.propTypes = propTypes$7;

var defaultProps$8 = {
  tag: 'li'
};
var propTypes$8 = {
  className: propTypes.string,
  tag: propTypes.any,
  active: propTypes.bool,
  cssModule: propTypes.object
};
var BreadcrumbItem =
function (_React$Component) {
  _inherits(BreadcrumbItem, _React$Component);
  function BreadcrumbItem() {
    _classCallCheck(this, BreadcrumbItem);
    return _possibleConstructorReturn(this, _getPrototypeOf(BreadcrumbItem).apply(this, arguments));
  }
  _createClass(BreadcrumbItem, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          active = _this$props.active,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "active", "tag"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'breadcrumb-item', {
          active: active
        }), cssModule)
      }, attributes));
    }
  }]);
  return BreadcrumbItem;
}(React.Component);
_defineProperty(BreadcrumbItem, "propTypes", propTypes$8);
_defineProperty(BreadcrumbItem, "defaultProps", defaultProps$8);
BreadcrumbItem.defaultProps = defaultProps$8;
BreadcrumbItem.propTypes = propTypes$8;

var boxShadow_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.boxShadow = boxShadow;
exports.default = exports.defaultProps = void 0;
var defaultProps = {
  '$enable-shadows': false
};
exports.defaultProps = defaultProps;
function boxShadow() {
  var enableShadows = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-shadows'];
  if (enableShadows) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }
    return "\n      box-shadow: ".concat(args.join(' '), ";\n    ");
  }
  return '';
}
var _default = {
  defaultProps: defaultProps,
  boxShadow: boxShadow
};
exports.default = _default;
});
unwrapExports(boxShadow_1);
var boxShadow_2 = boxShadow_1.boxShadow;
var boxShadow_3 = boxShadow_1.defaultProps;

var transition_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.transition = transition;
exports.default = exports.defaultProps = void 0;
var defaultProps = {
  '$enable-transitions': true
};
exports.defaultProps = defaultProps;
function transition() {
  var enableTransitions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-transitions'];
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }
  if (enableTransitions && args.length) {
    return "\n      transition: ".concat(args.join(' '), ";\n    ");
  }
  return '';
}
var _default = {
  transition: transition
};
exports.default = _default;
});
unwrapExports(transition_1);
var transition_2 = transition_1.transition;
var transition_3 = transition_1.defaultProps;

var conditional = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ifThen = ifThen;
exports.ifElse = ifElse;
exports.default = void 0;
function ifThen(conditions, returnTrue) {
  return ifElse(conditions, returnTrue, '');
}
function ifElse(conditions, returnTrue, returnFalse) {
  return conditions ? returnTrue : returnFalse;
}
var _default = {
  ifThen: ifThen,
  ifElse: ifElse
};
exports.default = _default;
});
unwrapExports(conditional);
var conditional_1 = conditional.ifThen;
var conditional_2 = conditional.ifElse;

var regex = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.linearGradientRe = void 0;
var linearGradientRe = /#[0-9a-fA-F]{3,6}|rgb ?\([ 0-9.%,]+?\)/g;
exports.linearGradientRe = linearGradientRe;
});
unwrapExports(regex);
var regex_1 = regex.linearGradientRe;

var buttons = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buttonVariant = buttonVariant;
exports.buttonOutlineVariant = buttonOutlineVariant;
exports.buttonSize = buttonSize;
exports.button = button;
exports.default = exports.defaultProps = void 0;
var _color = _interopRequireDefault(ColorWrapper);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var defaultProps = {
  '$enable-shadows': true,
  '$enable-hover-media-query': false,
  '$enable-transitions': true,
  '$enable-rounded': true,
  '$font-weight-normal': 'normal',
  '$btn-font-weight': 'normal',
  '$btn-line-height': '1.25',
  '$btn-transition': 'all .2s ease-in-out',
  '$btn-border-width': '1px',
  '$btn-padding-x': '1rem',
  '$btn-padding-y': '.5refm',
  '$font-size-base': '1rem',
  '$btn-border-radius': '.25rem',
  '$btn-box-shadow': 'inset 0 1px 0 rgba(255, 255, 255, 0.15), 0 1px 1px rgba(0, 0, 0, 0.075)',
  '$btn-focus-box-shadow': '0 0 0 2px rgba(2, 117, 216, 0.25)',
  '$btn-disabled-opacity': '.65',
  '$btn-active-box-shadow': 'inset 0 3px 5px rgba(0, 0, 0, 0.125)',
  '$cursor-disabled': 'not-allowed',
  '$link-color': '#0275d8',
  '$link-hover-color': 'hsl(207.79999999999995, 98.2%, 27.8%)',
  '$link-hover-decoration': 'underline',
  '$btn-link-disabled-color': '#636c72',
  '$btn-padding-x-lg': '1.5rem',
  '$btn-padding-y-lg': '.75rem',
  '$font-size-lg': '1.25rem',
  '$btn-border-radius-lg': '.3rem',
  '$btn-padding-x-sm': '.5rem',
  '$btn-padding-y-sm': '.25rem',
  '$font-size-sm': '.875rem',
  '$btn-border-radius-sm': '.2rem',
  '$btn-block-spacing-y': '.5rem',
  '$btn-primary-color': '#fff',
  '$btn-primary-bg': '#0275d8',
  '$btn-primary-border': '#0275d8',
  '$btn-secondary-color': '#292b2c',
  '$btn-secondary-bg': '#fff',
  '$btn-secondary-border': '#ccc',
  '$btn-info-color': '#fff',
  '$btn-info-bg': '#5bc0de',
  '$btn-info-border': '#5bc0de',
  '$btn-success-color': '#fff',
  '$btn-success-bg': '#5cb85c',
  '$btn-success-border': '#5cb85c',
  '$btn-warning-color': '#fff',
  '$btn-warning-bg': '#f0ad4e',
  '$btn-warning-border': '#f0ad4e',
  '$btn-danger-color': '#fff',
  '$btn-danger-bg': '#d9534f',
  '$btn-danger-border': '#d9534f'
};
exports.defaultProps = defaultProps;
function buttonVariant() {
  var enableShadows = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-shadows'];
  var buttonColor = arguments.length > 1 ? arguments[1] : undefined;
  var background = arguments.length > 2 ? arguments[2] : undefined;
  var border = arguments.length > 3 ? arguments[3] : undefined;
  var btnActiveBoxShadow = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : defaultProps['$btn-active-box-shadow'];
  var btnBoxShadow = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : defaultProps['$btn-box-shadow'];
  var activeBackground = (0, _color.default)(background).darken(0.2).toString();
  if (background && background.includes('linear-gradient')) {
    var res = background.match(regex.linearGradientRe);
    activeBackground = "linear-gradient(".concat(res.map(function (v) {
      return (0, _color.default)(v).darken(0.2).toString();
    }).join(', '), ")");
  }
  var activeBorder = (0, _color.default)(border).darken(0.12).toString();
  return "\n    color: ".concat(buttonColor, ";\n    background: ").concat(background, ";\n    border-color: ").concat(border, ";\n    ").concat((0, boxShadow_1.boxShadow)(enableShadows, btnBoxShadow), "\n  \n    ").concat((0, hover_1.hover)("\n      color: ".concat(buttonColor, ";\n      background-color: ").concat(activeBackground, ";\n      border-color: ").concat(activeBorder, ";\n    ")), "\n  \n    &:focus,\n    &.focus {\n      ").concat((0, conditional.ifElse)(enableShadows, "\n        box-shadow: ".concat(btnBoxShadow, ", 0 0 0 2px ").concat((0, _color.default)(border).alpha(0.5).toString(), ";\n      "), "\n        box-shadow: 0 0 0 2px ".concat((0, _color.default)(border).alpha(0.5).toString(), ";\n      ")), "\n    }\n  \n    /* Disabled comes first so active can properly restyle */\n    &.disabled,\n    &:disabled {\n      background-color: ").concat(background, ";\n      border-color: ").concat(border, ";\n    }\n    \n    &:active,\n    &.active,\n    .show > &.dropdown-toggle {\n      color: ").concat(buttonColor, ";\n      ").concat((0, conditional.ifElse)(activeBackground.includes('linear-gradient'), "\n        background: ".concat(activeBackground, ";\n      "), "\n        background-color: ".concat(activeBackground, ";\n        background-image: none;\n      ")), "\n      \n      border-color: ").concat(activeBorder, ";\n      ").concat((0, boxShadow_1.boxShadow)(enableShadows, btnActiveBoxShadow), "\n    }\n  ");
}
function buttonOutlineVariant(buttonColor) {
  var buttonColorHover = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '#fff';
  return "\n    color: ".concat(buttonColor, ";\n    background-image: none;\n    background-color: transparent;\n    border-color: ").concat(buttonColor, ";\n  \n    ").concat((0, hover_1.hover)("\n      color: ".concat(buttonColorHover, ";\n      background-color: ").concat(buttonColor, ";\n      border-color: ").concat(buttonColor, ";\n    ")), "\n  \n    &:focus,\n    &.focus {\n      box-shadow: 0 0 0 2px ").concat((0, _color.default)(buttonColor).alpha(0.5).toString(), ";\n    }\n  \n    &.disabled,\n    &:disabled {\n      color: ").concat(buttonColor, ";\n      border-color: transparent;\n    }\n    \n    &:active,\n    &.active,\n    & .open > &.dropdown-toggle {\n      color: ").concat(buttonColorHover, ";\n      background-color: ").concat(buttonColor, ";\n      border-color: ").concat(buttonColor, ";\n    }\n  ");
}
function buttonSize() {
  var enableRounded = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-rounded'];
  var paddingY = arguments.length > 1 ? arguments[1] : undefined;
  var paddingX = arguments.length > 2 ? arguments[2] : undefined;
  var fontSize = arguments.length > 3 ? arguments[3] : undefined;
  var btnBorderRadius = arguments.length > 4 ? arguments[4] : undefined;
  return "\n    padding: ".concat(paddingY, " ").concat(paddingX, ";\n    font-size: ").concat(fontSize, ";\n    ").concat((0, borderRadius_1.borderRadius)(enableRounded, btnBorderRadius), "\n  ");
}
function button() {
  var $enableShadows = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-shadows'];
  var $enableHoverMediaQuery = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$enable-hover-media-query'];
  var $enableTransitions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$enable-transitions'];
  var $enableRounded = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : defaultProps['$enable-rounded'];
  var $fontWeightNormal = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : defaultProps['$font-weight-normal'];
  var $btnFontWeight = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : defaultProps['$btn-font-weight'];
  var $btnLineHeight = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : defaultProps['$btn-line-height'];
  var $btnTransition = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : defaultProps['$btn-transition'];
  var $btnBorderWidth = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : defaultProps['$btn-border-width'];
  var $btnPaddingX = arguments.length > 9 && arguments[9] !== undefined ? arguments[9] : defaultProps['$btn-padding-x'];
  var $btnPaddingY = arguments.length > 10 && arguments[10] !== undefined ? arguments[10] : defaultProps['$btn-padding-y'];
  var $fontSizeBase = arguments.length > 11 && arguments[11] !== undefined ? arguments[11] : defaultProps['$font-size-base'];
  var $btnBorderRadius = arguments.length > 12 && arguments[12] !== undefined ? arguments[12] : defaultProps['$btn-border-radius'];
  var $btnBoxShadow = arguments.length > 13 && arguments[13] !== undefined ? arguments[13] : defaultProps['$btn-box-shadow'];
  var $btnFocusBoxShadow = arguments.length > 14 && arguments[14] !== undefined ? arguments[14] : defaultProps['$btn-focus-box-shadow'];
  var $btnActiveBoxShadow = arguments.length > 15 && arguments[15] !== undefined ? arguments[15] : defaultProps['$btn-active-box-shadow'];
  var $cursorDisabled = arguments.length > 16 && arguments[16] !== undefined ? arguments[16] : defaultProps['$cursor-disabled'];
  var $linkColor = arguments.length > 17 && arguments[17] !== undefined ? arguments[17] : defaultProps['$link-color'];
  var $linkHoverColor = arguments.length > 18 && arguments[18] !== undefined ? arguments[18] : defaultProps['$link-hover-color'];
  var $linkHoverDecoration = arguments.length > 19 && arguments[19] !== undefined ? arguments[19] : defaultProps['$link-hover-decoration'];
  var $btnLinkDisabledColor = arguments.length > 20 && arguments[20] !== undefined ? arguments[20] : defaultProps['$btn-link-disabled-color'];
  var $btnPaddingXLg = arguments.length > 21 && arguments[21] !== undefined ? arguments[21] : defaultProps['$btn-padding-x-lg'];
  var $btnPaddingYLg = arguments.length > 22 && arguments[22] !== undefined ? arguments[22] : defaultProps['$btn-padding-y-lg'];
  var $fontSizeLg = arguments.length > 23 && arguments[23] !== undefined ? arguments[23] : defaultProps['$font-size-lg'];
  var $btnBorderRadiusLg = arguments.length > 24 && arguments[24] !== undefined ? arguments[24] : defaultProps['$btn-border-radius-lg'];
  var $btnPaddingXSm = arguments.length > 25 && arguments[25] !== undefined ? arguments[25] : defaultProps['$btn-padding-x-sm'];
  var $btnPaddingYSm = arguments.length > 26 && arguments[26] !== undefined ? arguments[26] : defaultProps['$btn-padding-y-sm'];
  var $fontSizeSm = arguments.length > 27 && arguments[27] !== undefined ? arguments[27] : defaultProps['$font-size-sm'];
  var $btnBorderRadiusSm = arguments.length > 28 && arguments[28] !== undefined ? arguments[28] : defaultProps['$btn-border-radius-sm'];
  var $btnBlockSpacingY = arguments.length > 29 && arguments[29] !== undefined ? arguments[29] : defaultProps['$btn-block-spacing-y'];
  var $btnPrimaryColor = arguments.length > 30 && arguments[30] !== undefined ? arguments[30] : defaultProps['$btn-primary-color'];
  var $btnPrimaryBg = arguments.length > 31 && arguments[31] !== undefined ? arguments[31] : defaultProps['$btn-primary-bg'];
  var $btnPrimaryBorder = arguments.length > 32 && arguments[32] !== undefined ? arguments[32] : defaultProps['$btn-primary-border'];
  var $btnSecondaryColor = arguments.length > 33 && arguments[33] !== undefined ? arguments[33] : defaultProps['$btn-secondary-color'];
  var $btnSecondaryBg = arguments.length > 34 && arguments[34] !== undefined ? arguments[34] : defaultProps['$btn-secondary-bg'];
  var $btnSecondaryBorder = arguments.length > 35 && arguments[35] !== undefined ? arguments[35] : defaultProps['$btn-secondary-border'];
  var $btnInfoColor = arguments.length > 36 && arguments[36] !== undefined ? arguments[36] : defaultProps['$btn-info-color'];
  var $btnInfoBg = arguments.length > 37 && arguments[37] !== undefined ? arguments[37] : defaultProps['$btn-info-bg'];
  var $btnInfoBorder = arguments.length > 38 && arguments[38] !== undefined ? arguments[38] : defaultProps['$btn-info-border'];
  var $btnSuccessColor = arguments.length > 39 && arguments[39] !== undefined ? arguments[39] : defaultProps['$btn-success-color'];
  var $btnSuccessBg = arguments.length > 40 && arguments[40] !== undefined ? arguments[40] : defaultProps['$btn-success-bg'];
  var $btnSuccessBorder = arguments.length > 41 && arguments[41] !== undefined ? arguments[41] : defaultProps['$btn-success-border'];
  var $btnWarningColor = arguments.length > 42 && arguments[42] !== undefined ? arguments[42] : defaultProps['$btn-warning-color'];
  var $btnWarningBg = arguments.length > 43 && arguments[43] !== undefined ? arguments[43] : defaultProps['$btn-warning-bg'];
  var $btnWarningBorder = arguments.length > 44 && arguments[44] !== undefined ? arguments[44] : defaultProps['$btn-warning-border'];
  var $btnDangerColor = arguments.length > 45 && arguments[45] !== undefined ? arguments[45] : defaultProps['$btn-danger-color'];
  var $btnDangerBg = arguments.length > 46 && arguments[46] !== undefined ? arguments[46] : defaultProps['$btn-danger-bg'];
  var $btnDangerBorder = arguments.length > 47 && arguments[47] !== undefined ? arguments[47] : defaultProps['$btn-danger-border'];
  var $btnDisabledOpacity = arguments.length > 48 && arguments[48] !== undefined ? arguments[48] : defaultProps['$btn-disabled-opacity'];
  return "\n  \n    font-family: inherit;\n    \n    &.btn {\n      display: inline-block;\n      font-weight: ".concat($btnFontWeight, ";\n      line-height: ").concat($btnLineHeight, ";\n      text-align: center;\n      white-space: nowrap;\n      vertical-align: middle;\n      user-select: none;\n      border: ").concat($btnBorderWidth, " solid transparent;\n      ").concat(buttonSize($enableRounded, $btnPaddingY, $btnPaddingX, $fontSizeBase, $btnBorderRadius), "\n      ").concat((0, transition_1.transition)($enableTransitions, $btnTransition), "\n      ").concat((0, hover_1.hoverFocus)($enableHoverMediaQuery, 'text-decoration: none;'), "\n\n      &:focus,\n      &.focus {\n        outline: 0;\n        box-shadow: ").concat($btnFocusBoxShadow, ";\n      }\n\n      /* Disabled comes first so active can properly restyle */\n      &.disabled,\n      &:disabled {\n        cursor: ").concat($cursorDisabled, ";\n        opacity: ").concat($btnDisabledOpacity, ";\n        ").concat((0, boxShadow_1.boxShadow)($enableShadows, 'none'), "\n      }  \n\n      // Opinionated: add \"hand\" cursor to non-disabled .btn elements\n      &:not(:disabled):not(.disabled) {\n        cursor: pointer;\n      }\n      &:not(:disabled):not(.disabled):active,\n      &:not(:disabled):not(.disabled).active {\n        ").concat((0, boxShadow_1.boxShadow)($enableShadows, $btnActiveBoxShadow), "\n    \n        &:focus {\n          ").concat((0, boxShadow_1.boxShadow)($enableShadows, $btnFocusBoxShadow, $btnActiveBoxShadow), "\n        }\n      }\n    }\n    \n    a.btn.disabled,\n    fieldset[disabled] a.btn {\n      pointer-events: none;\n    }\n   \n   \n    /* Alternate buttons */\n   \n    &.btn-primary {\n      ").concat(buttonVariant($enableShadows, $btnPrimaryColor, $btnPrimaryBg, $btnPrimaryBorder, $btnActiveBoxShadow, $btnBoxShadow), "\n    }\n    &.btn-secondary {\n      ").concat(buttonVariant($enableShadows, $btnSecondaryColor, $btnSecondaryBg, $btnSecondaryBorder, $btnActiveBoxShadow, $btnBoxShadow), "\n    }\n    &.btn-info {\n      ").concat(buttonVariant($enableShadows, $btnInfoColor, $btnInfoBg, $btnInfoBorder, $btnActiveBoxShadow, $btnBoxShadow), "\n    }\n    &.btn-success {\n      ").concat(buttonVariant($enableShadows, $btnSuccessColor, $btnSuccessBg, $btnSuccessBorder, $btnActiveBoxShadow, $btnBoxShadow), "\n    }\n    &.btn-warning {\n      ").concat(buttonVariant($enableShadows, $btnWarningColor, $btnWarningBg, $btnWarningBorder, $btnActiveBoxShadow, $btnBoxShadow), "\n    }\n    &.btn-danger {\n      ").concat(buttonVariant($enableShadows, $btnDangerColor, $btnDangerBg, $btnDangerBorder, $btnActiveBoxShadow, $btnBoxShadow), "\n    }\n   \n    &.btn-outline-primary {\n      ").concat(buttonOutlineVariant($btnPrimaryBg, $btnPrimaryColor), "\n    }    \n    &.btn-outline-secondary {\n      ").concat(buttonOutlineVariant($btnSecondaryBorder, $btnSecondaryColor), "\n    }    \n    &.btn-outline-info {\n      ").concat(buttonOutlineVariant($btnInfoBg, $btnInfoColor), "\n    }    \n    &.btn-outline-success {\n      ").concat(buttonOutlineVariant($btnSuccessBg, $btnSuccessColor), "\n    }\n    &.btn-outline-warning {\n      ").concat(buttonOutlineVariant($btnWarningBg, $btnWarningColor), "\n    }\n    &.btn-outline-danger {\n      ").concat(buttonOutlineVariant($btnDangerBg, $btnDangerColor), "\n    }\n   \n    /*\n     Link buttons\n    */\n   \n    &.btn-link {\n      font-weight: ").concat($fontWeightNormal, ";\n      color: ").concat($linkColor, ";\n      border-radius: 0;\n   \n      &,\n      &:active,\n      &.active,\n      &:disabled {\n        background-color: transparent;\n        ").concat((0, boxShadow_1.boxShadow)($enableShadows, 'none'), "\n      }\n     \n      &,\n      &:focus,\n      &:active {\n        border-color: transparent;\n      }\n     \n      ").concat((0, hover_1.hover)('border-color: transparent;'), "\n     \n      ").concat((0, hover_1.hoverFocus)($enableHoverMediaQuery, "\n        color: ".concat($linkHoverColor, ";\n        text-decoration: ").concat($linkHoverDecoration, ";\n        background-color: transparent;\n      ")), "\n     \n      &:disabled {\n        color: ").concat($btnLinkDisabledColor, ";\n        ").concat((0, hover_1.hoverFocus)($enableHoverMediaQuery, "\n          text-decoration: none;\n        "), "\n      }\n    }\n  \n  \n    /*\n     Button Sizes\n    */\n   \n    &.btn-lg {\n      /* line-height: ensure even-numbered height of button next to large input */\n      ").concat(buttonSize($enableRounded, $btnPaddingYLg, $btnPaddingXLg, $fontSizeLg, $btnBorderRadiusLg), "\n    }\n   \n    &.btn-sm {\n      /* line-height: ensure proper height of button next to small input */\n      ").concat(buttonSize($enableRounded, $btnPaddingYSm, $btnPaddingXSm, $fontSizeSm, $btnBorderRadiusSm), "\n    }\n   \n   \n    /*\n     Block button\n    */\n   \n    &.btn-block {\n      display: block;\n      width: 100%;\n    }\n   \n    /* Vertically space out multiple block buttons */\n    &.btn-block + .btn-block {\n      margin-top: ").concat($btnBlockSpacingY, ";\n    }\n   \n    /* Specificity overrides */\n    input[type=\"submit\"],\n    input[type=\"reset\"],\n    input[type=\"button\"] {\n      &.btn-block {\n        width: 100%;\n      }\n    }\n   \n    /* Reboot Scss */\n    touch-action: manipulation;\n    line-height: inherit;\n    &:focus{\n      outline: 1px dotted;\n      outline: 5px auto -webkit-focus-ring-color;\n    }\n    \n    &[type=\"button\"],\n    &[type=\"reset\"],\n    &[type=\"submit\"] {\n      -webkit-appearance: button;\n    }\n    \n    &::-moz-focus-inner,\n    &[type=\"button\"]::-moz-focus-inner,\n    &[type=\"reset\"]::-moz-focus-inner,\n    &[type=\"submit\"]::-moz-focus-inner {\n      padding: 0;\n      border-style: none;\n    }\n\n  ");
}
var _default = {
  defaultProps: defaultProps,
  buttonVariant: buttonVariant,
  buttonOutlineVariant: buttonOutlineVariant,
  buttonSize: buttonSize,
  button: button
};
exports.default = _default;
});
unwrapExports(buttons);
var buttons_1 = buttons.buttonVariant;
var buttons_2 = buttons.buttonOutlineVariant;
var buttons_3 = buttons.buttonSize;
var buttons_4 = buttons.button;
var buttons_5 = buttons.defaultProps;

var defaultProps$9 = {
  tag: 'button',
  color: 'primary',
  hover: false,
  focus: false,
  theme: {
    '$enable-rounded': true,
    '$enable-shadows': false,
    '$enable-hover-media-query': true,
    '$enable-transitions': true,
    '$btn-border-width': '1px',
    '$btn-padding-x': '1rem',
    '$btn-padding-y': '.5rem',
    '$btn-line-height': '1.25',
    '$btn-box-shadow': 'inset 0 1px 0 rgba(255, 255, 255, 0.15), 0 1px 1px rgba(0, 0, 0, 0.075)',
    '$btn-focus-box-shadow': '0 0 0 2px rgba(2, 117, 216, 0.25)',
    '$btn-active-box-shadow': 'inset 0 3px 5px rgba(0, 0, 0, 0.125)',
    '$btn-primary-color': '#fff',
    '$btn-primary-bg': '#0275d8',
    '$btn-primary-border': '#0275d8',
    '$btn-secondary-color': '#292b2c',
    '$btn-secondary-bg': '#fff',
    '$btn-secondary-border': '#ccc',
    '$btn-info-color': '#fff',
    '$btn-info-bg': '#5bc0de',
    '$btn-info-border': '#5bc0de',
    '$btn-success-color': '#fff',
    '$btn-success-bg': '#5cb85c',
    '$btn-success-border': '#5cb85c',
    '$btn-warning-color': '#fff',
    '$btn-warning-bg': '#f0ad4e',
    '$btn-warning-border': '#f0ad4e',
    '$btn-danger-color': '#fff',
    '$btn-danger-bg': '#d9534f',
    '$btn-danger-border': '#d9534f',
    '$btn-link-disabled-color': '#636c72',
    '$btn-padding-x-sm': '.5rem',
    '$btn-padding-y-sm': '.25rem',
    '$btn-padding-x-lg': '1.5rem',
    '$btn-padding-y-lg': '.75rem',
    '$btn-block-spacing-y': '.5rem',
    '$btn-border-radius': '.25rem',
    '$btn-border-radius-lg': '.3rem',
    '$btn-border-radius-sm': '.2rem',
    '$btn-transition': 'all .2s ease-in-out'
  }
};
var propTypes$9 = {
  active: propTypes.bool,
  block: propTypes.bool,
  hover: propTypes.bool,
  focus: propTypes.bool,
  disabled: propTypes.bool,
  outline: propTypes.bool,
  className: propTypes.string,
  color: propTypes.oneOf(['link', 'primary', 'secondary', 'success', 'info', 'warning', 'danger']),
  ref: propTypes.func,
  onClick: propTypes.func,
  size: propTypes.oneOf(['sm', 'lg']),
  dropup: propTypes.bool,
  tag: propTypes.any,
  theme: propTypes.shape({
    '$btn-padding-x': propTypes.string,
    '$btn-padding-y': propTypes.string,
    '$btn-line-height': propTypes.string,
    '$btn-font-weight': propTypes.string,
    '$btn-box-shadow': propTypes.string,
    '$btn-focus-box-shadow': propTypes.string,
    '$btn-disabled-opacity': propTypes.string,
    '$btn-active-box-shadow': propTypes.string,
    '$btn-primary-color': propTypes.string,
    '$btn-primary-bg': propTypes.string,
    '$btn-primary-border': propTypes.string,
    '$btn-secondary-color': propTypes.string,
    '$btn-secondary-bg': propTypes.string,
    '$btn-secondary-border': propTypes.string,
    '$btn-info-color': propTypes.string,
    '$btn-info-bg': propTypes.string,
    '$btn-info-border': propTypes.string,
    '$btn-success-color': propTypes.string,
    '$btn-success-bg': propTypes.string,
    '$btn-success-border': propTypes.string,
    '$btn-warning-color': propTypes.string,
    '$btn-warning-bg': propTypes.string,
    '$btn-warning-border': propTypes.string,
    '$btn-danger-color': propTypes.string,
    '$btn-danger-bg': propTypes.string,
    '$btn-danger-border': propTypes.string,
    '$btn-link-disabled-color': propTypes.string,
    '$btn-padding-x-sm': propTypes.string,
    '$btn-padding-y-sm': propTypes.string,
    '$btn-padding-x-lg': propTypes.string,
    '$btn-padding-y-lg': propTypes.string,
    '$btn-block-spacing-y': propTypes.string,
    '$btn-border-radius': propTypes.string,
    '$btn-border-radius-lg': propTypes.string,
    '$btn-border-radius-sm': propTypes.string,
    '$btn-transition': propTypes.string,
    '$btn-border-width': propTypes.string,
    '$link-hover-decoration': propTypes.string,
    '$enable-rounded': propTypes.bool,
    '$enable-shadows': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool,
    '$enable-transitions': propTypes.bool
  }),
  cssModule: propTypes.object
};
var ButtonUnstyled =
function (_React$Component) {
  _inherits(ButtonUnstyled, _React$Component);
  function ButtonUnstyled() {
    var _getPrototypeOf2;
    var _this;
    _classCallCheck(this, ButtonUnstyled);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ButtonUnstyled)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _defineProperty(_assertThisInitialized(_this), "onClick", function (e) {
      if (_this.props.disabled) {
        e.preventDefault();
        return;
      }
      if (_this.props.onClick) {
        _this.props.onClick(e);
      }
    });
    return _this;
  }
  _createClass(ButtonUnstyled, [{
    key: "render",
    value: function render() {
      var _cn;
      var _omit = lodash_omit(this.props, ['theme']),
          active = _omit.active,
          disabled = _omit.disabled,
          block = _omit.block,
          className = _omit.className,
          cssModule = _omit.cssModule,
          dropup = _omit.dropup,
          color = _omit.color,
          outline = _omit.outline,
          size = _omit.size,
          ref = _omit.ref,
          Tag = _omit.tag,
          hover = _omit.hover,
          focus = _omit.focus,
          attributes = _objectWithoutProperties(_omit, ["active", "disabled", "block", "className", "cssModule", "dropup", "color", "outline", "size", "ref", "tag", "hover", "focus"]);
      var classes = mapToCssModules(classnames(className, 'btn', (_cn = {
        hover: hover,
        focus: focus,
        dropup: dropup,
        active: active,
        disabled: disabled
      }, _defineProperty(_cn, "btn-".concat(size), size), _defineProperty(_cn, 'btn-block', block), _cn), "btn".concat(outline ? '-outline' : '', "-").concat(color)), cssModule);
      if (attributes.href && Tag === 'button') {
        Tag = 'a';
      }
      return React.createElement(Tag, _extends({
        type: Tag === 'button' && attributes.onClick ? 'button' : undefined,
        className: classes,
        ref: ref
      }, attributes, {
        onClick: this.onClick
      }));
    }
  }]);
  return ButtonUnstyled;
}(React.Component);
_defineProperty(ButtonUnstyled, "propTypes", propTypes$9);
_defineProperty(ButtonUnstyled, "defaultProps", defaultProps$9);
var Button = styled(ButtonUnstyled).withConfig({
  displayName: "Button",
  componentId: "h8watj-0"
})(["", " "], function (props) {
  return "\n    ".concat(buttons_4(props.theme['$enable-shadows'], props.theme['$enable-hover-media-query'], props.theme['$enable-transitions'], props.theme['$enable-rounded'], props.theme['$font-weight-normal'], props.theme['$btn-font-weight'], props.theme['$btn-line-height'], props.theme['$btn-transition'], props.theme['$btn-border-width'], props.theme['$btn-padding-x'], props.theme['$btn-padding-y'], props.theme['$font-size-base'], props.theme['$btn-border-radius'], props.theme['$btn-box-shadow'], props.theme['$btn-focus-box-shadow'], props.theme['$btn-active-box-shadow'], props.theme['$cursor-disabled'], props.theme['$link-color'], props.theme['$link-hover-color'], props.theme['$link-hover-decoration'], props.theme['$btn-link-disabled-color'], props.theme['$btn-padding-x-lg'], props.theme['$btn-padding-y-lg'], props.theme['$font-size-lg'], props.theme['$btn-border-radius-lg'], props.theme['$btn-padding-x-sm'], props.theme['$btn-padding-y-sm'], props.theme['$font-size-sm'], props.theme['$btn-border-radius-sm'], props.theme['$btn-block-spacing-y'], props.theme['$btn-primary-color'], props.theme['$btn-primary-bg'], props.theme['$btn-primary-border'], props.theme['$btn-secondary-color'], props.theme['$btn-secondary-bg'], props.theme['$btn-secondary-border'], props.theme['$btn-info-color'], props.theme['$btn-info-bg'], props.theme['$btn-info-border'], props.theme['$btn-success-color'], props.theme['$btn-success-bg'], props.theme['$btn-success-border'], props.theme['$btn-warning-color'], props.theme['$btn-warning-bg'], props.theme['$btn-warning-border'], props.theme['$btn-danger-color'], props.theme['$btn-danger-bg'], props.theme['$btn-danger-border'], props.theme['$btn-disabled-opacity']), "\n ");
});
Button.defaultProps = defaultProps$9;
Button.propTypes = propTypes$9;

var unitUtils = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
var UnitUtils = function UnitUtils() {
  var _this = this;
  _classCallCheck(this, UnitUtils);
  this.UNIT = {
    EM: 'em',
    REM: 'rem',
    PX: 'px',
    PERCENT: '%'
  };
  this.math = {
    addition: function addition(a, b) {
      var unit = this.detectUnit(a) || this.detectUnit(b);
      return this.rmUnit(a) + this.rmUnit(b) + unit;
    }.bind(this),
    subtract: function subtract(a, b) {
      var unit = this.detectUnit(a) || this.detectUnit(b);
      return this.rmUnit(a) - this.rmUnit(b) + unit;
    }.bind(this),
    multiply: function multiply(a, b) {
      var unit = this.detectUnit(a) || this.detectUnit(b);
      return this.rmUnit(a) * this.rmUnit(b) + unit;
    }.bind(this),
    divide: function divide(a, b) {
      var unit = this.detectUnit(a) || this.detectUnit(b);
      return this.rmUnit(a) / this.rmUnit(b) + unit;
    }.bind(this)
  };
  this.detectUnit = function (value) {
    var ext;
    var valueStr = value.toString();
    if (valueStr.match(_this.UNIT.PX)) {
      ext = _this.UNIT.PX;
    } else if (valueStr.match(_this.UNIT.REM)) {
      ext = _this.UNIT.REM;
    } else if (valueStr.match(_this.UNIT.EM)) {
      ext = _this.UNIT.EM;
    } else if (valueStr.match(_this.UNIT.PERCENT)) {
      ext = _this.UNIT.PERCENT;
    } else if (!isNaN(value)) {
      return null;
    } else {
      throw new Error("detectUnit can't find unit for ".concat(value));
    }
    return ext;
  };
  this.rmUnit = function (value, unit) {
    var valueStr = value.toString();
    var ext = unit || _this.detectUnit(valueStr);
    var number = valueStr.replace(ext, '');
    return parseFloat(number);
  };
  this.toPercent = function (value) {
    var total = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 100;
    var decimal = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 2;
    return "".concat(Math.floor(value / total * 100 * Math.pow(10, decimal)) / Math.pow(10, decimal)).concat(_this.UNIT.PERCENT);
  };
};
var _default = new UnitUtils();
exports.default = _default;
module.exports = exports.default;
});
var unitUtils$1 = unwrapExports(unitUtils);

var navDivider_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.navDivider = navDivider;
exports.default = exports.defaultProps = void 0;
var _unitUtils = _interopRequireDefault(unitUtils);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var defaultProps = {
  '$spacer-y': '1rem'
};
exports.defaultProps = defaultProps;
function navDivider() {
  var spacerY = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$spacer-y'];
  var dividerColor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '#e5e5e5';
  var marginY = "".concat(_unitUtils.default.rmUnit(spacerY, _unitUtils.default.UNIT.REM) / 2).concat(_unitUtils.default.UNIT.REM);
  return "\n    height: 1px;\n    margin: calc(".concat(marginY, " / 2) 0;\n    overflow: hidden;\n    background-color: ").concat(dividerColor, ";\n  ");
}
var _default = {
  defaultProps: defaultProps,
  navDivider: navDivider
};
exports.default = _default;
});
unwrapExports(navDivider_1);
var navDivider_2 = navDivider_1.navDivider;
var navDivider_3 = navDivider_1.defaultProps;

var buttonGroup_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buttonGroup = buttonGroup;
exports.default = exports.defaultProps = void 0;
var _unitUtils = _interopRequireDefault(unitUtils);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var defaultProps = {
  '$enable-shadows': true,
  '$enable-rounded': true,
  '$input-btn-border-width': '1px',
  '$btn-padding-x': '1rem',
  '$btn-active-box-shadow': 'inset 0 3px 5px rgba(0,0,0,.125)',
  '$btn-padding-x-lg': '1.5rem',
  '$btn-padding-y-lg': '.75rem',
  '$font-size-lg': '1.25rem',
  '$btn-border-radius-lg': '.3rem',
  '$btn-padding-y-sm': '.25rem',
  '$btn-padding-x-sm': '.5rem',
  '$font-size-sm': '.875rem',
  '$btn-border-radius-sm': '.2rem',
  '$btn-border-width': '1px'
};
exports.defaultProps = defaultProps;
function buttonGroup() {
  var $enableShadows = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-shadows'];
  var $enableRounded = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$enable-rounded'];
  var $inputBtnBorderWidth = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$input-btn-border-width'];
  var $btnPaddingX = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : defaultProps['$btn-padding-x'];
  var $btnActiveBoxShadow = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : defaultProps['$btn-active-box-shadow'];
  var $btnPaddingXLg = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : defaultProps['$btn-padding-x-lg'];
  var $btnPaddingYLg = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : defaultProps['$btn-padding-y-lg'];
  var $fontSizeLg = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : defaultProps['$font-size-lg'];
  var $btnBorderRadiusLg = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : defaultProps['$btn-border-radius-lg'];
  var $btnPaddingXSm = arguments.length > 9 && arguments[9] !== undefined ? arguments[9] : defaultProps['$btn-padding-x-sm'];
  var $btnPaddingYSm = arguments.length > 10 && arguments[10] !== undefined ? arguments[10] : defaultProps['$btn-padding-y-sm'];
  var $fontSizeSm = arguments.length > 11 && arguments[11] !== undefined ? arguments[11] : defaultProps['$font-size-sm'];
  var $btnBorderRadiusSm = arguments.length > 12 && arguments[12] !== undefined ? arguments[12] : defaultProps['$btn-border-radius-sm'];
  return " \n    /*  Make the div behave like a button */\n    &.btn-group,\n    & .btn-group,\n    &.btn-group-vertical,\n    & .btn-group-vertical {\n      position: relative;\n      display: inline-flex;\n      vertical-align: middle; /* match .btn alignment given font-size hack above */\n    \n      > .btn {\n        position: relative;\n        flex: 0 1 auto;\n        margin-bottom: 0;\n    \n        /* Bring the \"active\" button to the front */\n        &:focus,\n        &:active,\n        &.active {\n          z-index: 2;\n        }\n        ".concat((0, hover_1.hover)("\n          z-index: 2;\n        "), "\n      }\n    }\n    \n    /*  Prevent double borders when buttons are next to each other */\n    &.btn-group,\n    & .btn-group {\n      .btn + .btn,\n      .btn + .btn-group,\n      .btn-group + .btn,\n      .btn-group + .btn-group {\n        margin-left: -").concat($inputBtnBorderWidth, ";\n      }\n    }\n    \n    /* Optional: Group multiple button groups together for a toolbar */\n    &.btn-toolbar,\n    & .btn-toolbar {\n      display: flex;\n      flex-wrap: wrap;\n      justify-content: flex-start;\n    \n      .input-group {\n        width: auto;\n      }\n    }\n     \n    &.btn-group,\n    & .btn-group {\n      > .btn:not(:first-child):not(:last-child):not(.dropdown-toggle) {\n        border-radius: 0;\n      }\n    }\n    \n    /* Set corners individual because sometimes a single button can be in a .btn-group and we need :first-child and :last-child to both match */\n    &.btn-group,\n    & .btn-group {\n      > .btn:first-child {\n        margin-left: 0;\n    \n        &:not(:last-child):not(.dropdown-toggle) {\n          ").concat((0, borderRadius_1.borderRightRadius)($enableRounded, '0'), "\n        }\n      }\n    }\n    /* Need .dropdown-toggle since :last-child does not apply given a .dropdown-menu immediately after it */\n    &.btn-group > .btn:last-child:not(:first-child),\n    & .btn-group > .btn:last-child:not(:first-child),\n    &.btn-group > .dropdown-toggle:not(:first-child),\n    & .btn-group > .dropdown-toggle:not(:first-child) {\n      ").concat((0, borderRadius_1.borderLeftRadius)($enableRounded, '0'), "\n    }\n    \n    /* Custom edits for including btn-groups within btn-groups (useful for including dropdown buttons within a btn-group) */\n    &.btn-group > .btn-group,\n    & .btn-group > .btn-group {\n      float: left;\n    }\n    &.btn-group > .btn-group:not(:first-child):not(:last-child) > .btn,\n    & .btn-group > .btn-group:not(:first-child):not(:last-child) > .btn {\n      border-radius: 0;\n    }\n    &.btn-group > .btn-group:first-child:not(:last-child),\n    & .btn-group > .btn-group:first-child:not(:last-child) {\n      > .btn:last-child,\n      > .dropdown-toggle {\n        ").concat((0, borderRadius_1.borderRightRadius)($enableRounded, '0'), "\n      }\n    }\n    &.btn-group > .btn-group:last-child:not(:first-child) > .btn:first-child,\n    & .btn-group > .btn-group:last-child:not(:first-child) > .btn:first-child {\n      ").concat((0, borderRadius_1.borderLeftRadius)($enableRounded, '0'), "\n    }\n    \n    /* On active and open, do not show outline */\n    &.btn-group .dropdown-toggle:active,\n    & .btn-group .dropdown-toggle:active,\n    &.btn-group.open .dropdown-toggle,\n    & .btn-group.open .dropdown-toggle {\n      outline: 0;\n    }\n    \n    \n    /* \n    Sizing Remix the default button sizing classes into new ones for easier manipulation.\n    */\n    \n    &.btn-group-sm > .btn,\n    & .btn-group-sm > .btn { \n      ").concat((0, buttons.buttonSize)($enableRounded, $btnPaddingYSm, $btnPaddingXSm, $fontSizeSm, $btnBorderRadiusSm), "\n    }\n    &.btn-group-lg > .btn,\n    & .btn-group-lg > .btn {\n      ").concat((0, buttons.buttonSize)($enableRounded, $btnPaddingYLg, $btnPaddingXLg, $fontSizeLg, $btnBorderRadiusLg), "\n    }\n    \n    /*\n     Split button dropdowns\n    */\n    \n    & .btn + .dropdown-toggle-split {\n      padding-right: ").concat(_unitUtils.default.math.multiply($btnPaddingX, 0.75), ";\n      padding-left: ").concat(_unitUtils.default.math.multiply($btnPaddingX, 0.75), ";\n    \n      &::after {\n        margin-left: 0;\n      }\n    }\n    \n    & .btn-sm + .dropdown-toggle-split {\n      padding-right: ").concat(_unitUtils.default.math.multiply($btnPaddingXSm, 0.75), ";\n      padding-left: ").concat(_unitUtils.default.math.multiply($btnPaddingXSm, 0.75), ";\n    }\n    \n    & .btn-lg + .dropdown-toggle-split {\n      padding-right: ").concat(_unitUtils.default.math.multiply($btnPaddingXLg, 0.75), ";\n      padding-left: ").concat(_unitUtils.default.math.multiply($btnPaddingXLg, 0.75), ";\n    }\n    \n    \n    /* The clickable button for toggling the menu */\n    /* Remove the gradient and set the same inset shadow as the :active state */\n    &.btn-group.open .dropdown-toggle {\n      ").concat((0, boxShadow_1.boxShadow)($enableShadows, $btnActiveBoxShadow), "\n    \n      /* Show no shadow for .btn-link since it has no other button styles. */\n      &.btn-link {\n        ").concat((0, boxShadow_1.boxShadow)($enableShadows, 'none'), "\n      }\n    }\n\n    /*\n     Vertical button groups\n    */\n    \n    &.btn-group-vertical,\n    & .btn-group-vertical {\n      display: inline-flex;\n      flex-direction: column;\n      align-items: flex-start;\n      justify-content: center;\n    \n      .btn,\n      .btn-group {\n        width: 100%;\n      }\n      \n      > .btn + .btn,\n      > .btn + .btn-group,\n      > .btn-group + .btn,\n      > .btn-group + .btn-group {\n        margin-top: -").concat($inputBtnBorderWidth, ";\n        margin-left: 0;\n      }\n    }\n    \n    &.btn-group-vertical > .btn,\n    & .btn-group-vertical > .btn {\n      &:not(:first-child):not(:last-child) {\n        border-radius: 0;\n      }\n      &:first-child:not(:last-child) {\n        ").concat((0, borderRadius_1.borderBottomRadius)($enableRounded, '0'), "\n      }\n      &:last-child:not(:first-child) {\n        ").concat((0, borderRadius_1.borderTopRadius)($enableRounded, '0'), "\n      }\n    }\n    \n    &.btn-group-vertical > .btn-group:not(:first-child):not(:last-child) > .btn,\n    & .btn-group-vertical > .btn-group:not(:first-child):not(:last-child) > .btn {\n      border-radius: 0;\n    }\n    \n    &.btn-group-vertical > .btn-group:first-child:not(:last-child),\n    & .btn-group-vertical > .btn-group:first-child:not(:last-child) {\n      > .btn:last-child,\n      > .dropdown-toggle {\n        ").concat((0, borderRadius_1.borderBottomRadius)($enableRounded, '0'), "      \n      }\n    }\n    &.btn-group-vertical > .btn-group:last-child:not(:first-child) > .btn:first-child,\n    & .btn-group-vertical > .btn-group:last-child:not(:first-child) > .btn:first-child {\n      ").concat((0, borderRadius_1.borderTopRadius)($enableRounded, '0'), "\n    }\n    \n    &.btn-group {\n      > .btn,\n      > .btn-group > .btn {\n        input[type=\"radio\"],\n        input[type=\"checkbox\"] {\n          position: absolute;\n          clip: rect(0,0,0,0);\n          pointer-events: none;\n        }\n      }\n    }\n  ");
}
var _default = {
  defaultProps: defaultProps,
  buttonGroup: buttonGroup
};
exports.default = _default;
});
unwrapExports(buttonGroup_1);
var buttonGroup_2 = buttonGroup_1.buttonGroup;
var buttonGroup_3 = buttonGroup_1.defaultProps;

var defaultProps$a = {
  tag: 'div'
};
var propTypes$a = {
  children: propTypes.node.isRequired,
  className: propTypes.string,
  cssModule: propTypes.object,
  right: propTypes.bool,
  tag: propTypes.any
};
var contextTypes = {
  isOpen: propTypes.bool.isRequired
};
var DropdownMenu = function DropdownMenu(props, context) {
  var className = props.className,
      cssModule = props.cssModule,
      right = props.right,
      Tag = props.tag,
      attributes = _objectWithoutProperties(props, ["className", "cssModule", "right", "tag"]);
  var classes = mapToCssModules(classnames(className, 'dropdown-menu', {
    'dropdown-menu-right': right
  }), cssModule);
  return React.createElement(Tag, _extends({}, attributes, {
    tabIndex: "-1",
    "aria-hidden": !context.isOpen,
    role: "menu",
    className: classes
  }));
};
DropdownMenu.propTypes = propTypes$a;
DropdownMenu.defaultProps = defaultProps$a;
DropdownMenu.contextTypes = contextTypes;

var tether = createCommonjsModule(function (module, exports) {
/*! tether-fix 1.4.0-fix-PR240 */
(function(root, factory) {
  {
    module.exports = factory(commonjsRequire, exports, module);
  }
}(commonjsGlobal, function(require, exports, module) {
var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();
var _get = function get(_x8, _x9, _x10) { var _again = true; _function: while (_again) { var object = _x8, property = _x9, receiver = _x10; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x8 = parent; _x9 = property; _x10 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };
var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();
function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }
var TetherBase = { modules: [] };
var zeroElement = null;
var deferred = [];
var defer = function defer(fn) {
  deferred.push(fn);
};
var flush = function flush() {
  var fn = undefined;
  while (fn = deferred.pop()) {
    fn();
  }
};
function extend() {
  var out = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }
  args.forEach(function (obj) {
    if (obj) {
      for (var key in obj) {
        if (({}).hasOwnProperty.call(obj, key)) {
          out[key] = obj[key];
        }
      }
    }
  });
  return out;
}
function getClassName(el) {
  if (el.className instanceof el.ownerDocument.defaultView.SVGAnimatedString) {
    return el.className.baseVal;
  }
  return el.className;
}
function setClassName(el, className) {
  el.setAttribute('class', className);
}
function getActualBoundingClientRect(node) {
  var boundingRect = node.getBoundingClientRect();
  var rect = {};
  for (var k in boundingRect) {
    rect[k] = boundingRect[k];
  }
  if (node.ownerDocument !== document) {
    var _frameElement = node.ownerDocument.defaultView.frameElement;
    if (_frameElement) {
      var frameRect = getActualBoundingClientRect(_frameElement);
      rect.top += frameRect.top;
      rect.bottom += frameRect.top;
      rect.left += frameRect.left;
      rect.right += frameRect.left;
    }
  }
  return rect;
}
function getScrollParents(el) {
  var computedStyle = getComputedStyle(el) || {};
  var position = computedStyle.position;
  var parents = [];
  if (position === 'fixed') {
    return [el];
  }
  var parent = el;
  while ((parent = parent.parentNode) && parent && parent.nodeType === 1) {
    var style = undefined;
    try {
      style = getComputedStyle(parent);
    } catch (err) {}
    if (typeof style === 'undefined' || style === null) {
      parents.push(parent);
      return parents;
    }
    var _style = style;
    var overflow = _style.overflow;
    var overflowX = _style.overflowX;
    var overflowY = _style.overflowY;
    if (/(auto|scroll|overlay)/.test(overflow + overflowY + overflowX)) {
      if (position !== 'absolute' || ['relative', 'absolute', 'fixed'].indexOf(style.position) >= 0) {
        parents.push(parent);
      }
    }
  }
  parents.push(el.ownerDocument.body);
  if (el.ownerDocument !== document) {
    parents.push(el.ownerDocument.defaultView);
  }
  return parents;
}
var uniqueId = (function () {
  var id = 0;
  return function () {
    return ++id;
  };
})();
var zeroPosCache = {};
var getOrigin = function getOrigin() {
  var node = zeroElement;
  if (!node || !document.body.contains(node)) {
    node = document.createElement('div');
    node.setAttribute('data-tether-id', uniqueId());
    extend(node.style, {
      top: 0,
      left: 0,
      position: 'absolute'
    });
    document.body.appendChild(node);
    zeroElement = node;
  }
  var id = node.getAttribute('data-tether-id');
  if (typeof zeroPosCache[id] === 'undefined') {
    zeroPosCache[id] = getActualBoundingClientRect(node);
    defer(function () {
      delete zeroPosCache[id];
    });
  }
  return zeroPosCache[id];
};
function removeUtilElements() {
  if (zeroElement) {
    document.body.removeChild(zeroElement);
  }
  zeroElement = null;
}
function getBounds(el) {
  var doc = undefined;
  if (el === document) {
    doc = document;
    el = document.documentElement;
  } else {
    doc = el.ownerDocument;
  }
  var docEl = doc.documentElement;
  var box = getActualBoundingClientRect(el);
  var origin = getOrigin();
  box.top -= origin.top;
  box.left -= origin.left;
  if (typeof box.width === 'undefined') {
    box.width = document.body.scrollWidth - box.left - box.right;
  }
  if (typeof box.height === 'undefined') {
    box.height = document.body.scrollHeight - box.top - box.bottom;
  }
  box.top -= docEl.clientTop;
  box.left -= docEl.clientLeft;
  box.right = doc.body.clientWidth - box.width - box.left;
  box.bottom = doc.body.clientHeight - box.height - box.top;
  return box;
}
function getOffsetParent(el) {
  return el.offsetParent || document.documentElement;
}
var _scrollBarSize = null;
function getScrollBarSize() {
  if (_scrollBarSize) {
    return _scrollBarSize;
  }
  var inner = document.createElement('div');
  inner.style.width = '100%';
  inner.style.height = '200px';
  var outer = document.createElement('div');
  extend(outer.style, {
    position: 'absolute',
    top: 0,
    left: 0,
    pointerEvents: 'none',
    visibility: 'hidden',
    width: '200px',
    height: '150px',
    overflow: 'hidden'
  });
  outer.appendChild(inner);
  document.body.appendChild(outer);
  var widthContained = inner.offsetWidth;
  outer.style.overflow = 'scroll';
  var widthScroll = inner.offsetWidth;
  if (widthContained === widthScroll) {
    widthScroll = outer.clientWidth;
  }
  document.body.removeChild(outer);
  var width = widthContained - widthScroll;
  _scrollBarSize = { width: width, height: width };
  return _scrollBarSize;
}
function removeClass(el, name) {
  if (typeof el.classList !== 'undefined') {
    name.split(' ').forEach(function (cls) {
      if (cls.trim()) {
        el.classList.remove(cls);
      }
    });
  } else {
    var regex = new RegExp('(^| )' + name.split(' ').join('|') + '( |$)', 'gi');
    var className = getClassName(el).replace(regex, ' ');
    setClassName(el, className);
  }
}
function addClass(el, name) {
  if (typeof el.classList !== 'undefined') {
    name.split(' ').forEach(function (cls) {
      if (cls.trim()) {
        el.classList.add(cls);
      }
    });
  } else {
    removeClass(el, name);
    var cls = getClassName(el) + (' ' + name);
    setClassName(el, cls);
  }
}
function hasClass(el, name) {
  if (typeof el.classList !== 'undefined') {
    return el.classList.contains(name);
  }
  var className = getClassName(el);
  return new RegExp('(^| )' + name + '( |$)', 'gi').test(className);
}
function updateClasses(el, add, all) {
  all.forEach(function (cls) {
    if (add.indexOf(cls) === -1 && hasClass(el, cls)) {
      removeClass(el, cls);
    }
  });
  add.forEach(function (cls) {
    if (!hasClass(el, cls)) {
      addClass(el, cls);
    }
  });
}
var Evented = (function () {
  function Evented() {
    _classCallCheck(this, Evented);
  }
  _createClass(Evented, [{
    key: 'on',
    value: function on(event, handler, ctx) {
      var once = arguments.length <= 3 || arguments[3] === undefined ? false : arguments[3];
      if (typeof this.bindings === 'undefined') {
        this.bindings = {};
      }
      if (typeof this.bindings[event] === 'undefined') {
        this.bindings[event] = [];
      }
      this.bindings[event].push({ handler: handler, ctx: ctx, once: once });
    }
  }, {
    key: 'once',
    value: function once(event, handler, ctx) {
      this.on(event, handler, ctx, true);
    }
  }, {
    key: 'off',
    value: function off(event, handler) {
      if (typeof this.bindings === 'undefined' || typeof this.bindings[event] === 'undefined') {
        return;
      }
      if (typeof handler === 'undefined') {
        delete this.bindings[event];
      } else {
        var i = 0;
        while (i < this.bindings[event].length) {
          if (this.bindings[event][i].handler === handler) {
            this.bindings[event].splice(i, 1);
          } else {
            ++i;
          }
        }
      }
    }
  }, {
    key: 'trigger',
    value: function trigger(event) {
      if (typeof this.bindings !== 'undefined' && this.bindings[event]) {
        var i = 0;
        for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }
        while (i < this.bindings[event].length) {
          var _bindings$event$i = this.bindings[event][i];
          var handler = _bindings$event$i.handler;
          var ctx = _bindings$event$i.ctx;
          var once = _bindings$event$i.once;
          var context = ctx;
          if (typeof context === 'undefined') {
            context = this;
          }
          handler.apply(context, args);
          if (once) {
            this.bindings[event].splice(i, 1);
          } else {
            ++i;
          }
        }
      }
    }
  }]);
  return Evented;
})();
function within(a, b) {
  var diff = arguments.length <= 2 || arguments[2] === undefined ? 1 : arguments[2];
  return a + diff >= b && b >= a - diff;
}
var transformKey = (function () {
  if (typeof document === 'undefined') {
    return '';
  }
  var el = document.createElement('div');
  var transforms = ['transform', 'WebkitTransform', 'OTransform', 'MozTransform', 'msTransform'];
  for (var i = 0; i < transforms.length; ++i) {
    var key = transforms[i];
    if (el.style[key] !== undefined) {
      return key;
    }
  }
  return '';
})();
var tethers = [];
var position = function position() {
  tethers.forEach(function (tether) {
    tether.position(false);
  });
  flush();
};
function now() {
  if (typeof performance !== 'undefined' && typeof performance.now !== 'undefined') {
    return performance.now();
  }
  return +new Date();
}
(function () {
  var lastCall = null;
  var lastDuration = null;
  var pendingTimeout = null;
  var tick = function tick() {
    if (typeof lastDuration !== 'undefined' && lastDuration > 16) {
      lastDuration = Math.min(lastDuration - 16, 250);
      pendingTimeout = setTimeout(tick, 250);
      return;
    }
    if (typeof lastCall !== 'undefined' && now() - lastCall < 10) {
      return;
    }
    if (pendingTimeout != null) {
      clearTimeout(pendingTimeout);
      pendingTimeout = null;
    }
    lastCall = now();
    position();
    lastDuration = now() - lastCall;
  };
  if (typeof window !== 'undefined' && typeof window.addEventListener !== 'undefined') {
    ['resize', 'scroll', 'touchmove'].forEach(function (event) {
      window.addEventListener(event, tick);
    });
  }
})();
var MIRROR_LR = {
  center: 'center',
  left: 'right',
  right: 'left'
};
var MIRROR_TB = {
  middle: 'middle',
  top: 'bottom',
  bottom: 'top'
};
var OFFSET_MAP = {
  top: 0,
  left: 0,
  middle: '50%',
  center: '50%',
  bottom: '100%',
  right: '100%'
};
var autoToFixedAttachment = function autoToFixedAttachment(attachment, relativeToAttachment) {
  var left = attachment.left;
  var top = attachment.top;
  if (left === 'auto') {
    left = MIRROR_LR[relativeToAttachment.left];
  }
  if (top === 'auto') {
    top = MIRROR_TB[relativeToAttachment.top];
  }
  return { left: left, top: top };
};
var attachmentToOffset = function attachmentToOffset(attachment) {
  var left = attachment.left;
  var top = attachment.top;
  if (typeof OFFSET_MAP[attachment.left] !== 'undefined') {
    left = OFFSET_MAP[attachment.left];
  }
  if (typeof OFFSET_MAP[attachment.top] !== 'undefined') {
    top = OFFSET_MAP[attachment.top];
  }
  return { left: left, top: top };
};
function addOffset() {
  var out = { top: 0, left: 0 };
  for (var _len3 = arguments.length, offsets = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
    offsets[_key3] = arguments[_key3];
  }
  offsets.forEach(function (_ref) {
    var top = _ref.top;
    var left = _ref.left;
    if (typeof top === 'string') {
      top = parseFloat(top, 10);
    }
    if (typeof left === 'string') {
      left = parseFloat(left, 10);
    }
    out.top += top;
    out.left += left;
  });
  return out;
}
function offsetToPx(offset, size) {
  if (typeof offset.left === 'string' && offset.left.indexOf('%') !== -1) {
    offset.left = parseFloat(offset.left, 10) / 100 * size.width;
  }
  if (typeof offset.top === 'string' && offset.top.indexOf('%') !== -1) {
    offset.top = parseFloat(offset.top, 10) / 100 * size.height;
  }
  return offset;
}
var parseOffset = function parseOffset(value) {
  var _value$split = value.split(' ');
  var _value$split2 = _slicedToArray(_value$split, 2);
  var top = _value$split2[0];
  var left = _value$split2[1];
  return { top: top, left: left };
};
var parseAttachment = parseOffset;
var TetherClass = (function (_Evented) {
  _inherits(TetherClass, _Evented);
  function TetherClass(options) {
    var _this = this;
    _classCallCheck(this, TetherClass);
    _get(Object.getPrototypeOf(TetherClass.prototype), 'constructor', this).call(this);
    this.position = this.position.bind(this);
    tethers.push(this);
    this.history = [];
    this.setOptions(options, false);
    TetherBase.modules.forEach(function (module) {
      if (typeof module.initialize !== 'undefined') {
        module.initialize.call(_this);
      }
    });
    this.position();
  }
  _createClass(TetherClass, [{
    key: 'getClass',
    value: function getClass() {
      var key = arguments.length <= 0 || arguments[0] === undefined ? '' : arguments[0];
      var classes = this.options.classes;
      if (typeof classes !== 'undefined' && classes[key]) {
        return this.options.classes[key];
      }
      if (this.options.classPrefix) {
        return this.options.classPrefix + '-' + key;
      }
      return key;
    }
  }, {
    key: 'setOptions',
    value: function setOptions(options) {
      var _this2 = this;
      var pos = arguments.length <= 1 || arguments[1] === undefined ? true : arguments[1];
      var defaults = {
        offset: '0 0',
        targetOffset: '0 0',
        targetAttachment: 'auto auto',
        classPrefix: 'tether'
      };
      this.options = extend(defaults, options);
      var _options = this.options;
      var element = _options.element;
      var target = _options.target;
      var targetModifier = _options.targetModifier;
      this.element = element;
      this.target = target;
      this.targetModifier = targetModifier;
      if (this.target === 'viewport') {
        this.target = document.body;
        this.targetModifier = 'visible';
      } else if (this.target === 'scroll-handle') {
        this.target = document.body;
        this.targetModifier = 'scroll-handle';
      }
      ['element', 'target'].forEach(function (key) {
        if (typeof _this2[key] === 'undefined') {
          throw new Error('Tether Error: Both element and target must be defined');
        }
        if (typeof _this2[key].jquery !== 'undefined') {
          _this2[key] = _this2[key][0];
        } else if (typeof _this2[key] === 'string') {
          _this2[key] = document.querySelector(_this2[key]);
        }
      });
      addClass(this.element, this.getClass('element'));
      if (this.options.addTargetClasses !== false) {
        addClass(this.target, this.getClass('target'));
      }
      if (!this.options.attachment) {
        throw new Error('Tether Error: You must provide an attachment');
      }
      this.targetAttachment = parseAttachment(this.options.targetAttachment);
      this.attachment = parseAttachment(this.options.attachment);
      this.offset = parseOffset(this.options.offset);
      this.targetOffset = parseOffset(this.options.targetOffset);
      if (typeof this.scrollParents !== 'undefined') {
        this.disable();
      }
      if (this.targetModifier === 'scroll-handle') {
        this.scrollParents = [this.target];
      } else {
        this.scrollParents = getScrollParents(this.target);
      }
      if (this.options.enabled !== false) {
        this.enable(pos);
      }
    }
  }, {
    key: 'getTargetBounds',
    value: function getTargetBounds() {
      if (typeof this.targetModifier !== 'undefined') {
        if (this.targetModifier === 'visible') {
          if (this.target === document.body) {
            return { top: pageYOffset, left: pageXOffset, height: innerHeight, width: innerWidth };
          }
          var bounds = getBounds(this.target);
          var out = {
            height: bounds.height,
            width: bounds.width,
            top: bounds.top,
            left: bounds.left
          };
          out.height = Math.min(out.height, bounds.height - (pageYOffset - bounds.top));
          out.height = Math.min(out.height, bounds.height - (bounds.top + bounds.height - (pageYOffset + innerHeight)));
          out.height = Math.min(innerHeight, out.height);
          out.height -= 2;
          out.width = Math.min(out.width, bounds.width - (pageXOffset - bounds.left));
          out.width = Math.min(out.width, bounds.width - (bounds.left + bounds.width - (pageXOffset + innerWidth)));
          out.width = Math.min(innerWidth, out.width);
          out.width -= 2;
          if (out.top < pageYOffset) {
            out.top = pageYOffset;
          }
          if (out.left < pageXOffset) {
            out.left = pageXOffset;
          }
          return out;
        }
        if (this.targetModifier === 'scroll-handle') {
          var bounds = undefined;
          var target = this.target;
          if (target === document.body) {
            target = document.documentElement;
            bounds = {
              left: pageXOffset,
              top: pageYOffset,
              height: innerHeight,
              width: innerWidth
            };
          } else {
            bounds = getBounds(target);
          }
          var style = getComputedStyle(target);
          var hasBottomScroll = target.scrollWidth > target.clientWidth || [style.overflow, style.overflowX].indexOf('scroll') >= 0 || this.target !== document.body;
          var scrollBottom = 0;
          if (hasBottomScroll) {
            scrollBottom = 15;
          }
          var height = bounds.height - parseFloat(style.borderTopWidth) - parseFloat(style.borderBottomWidth) - scrollBottom;
          var out = {
            width: 15,
            height: height * 0.975 * (height / target.scrollHeight),
            left: bounds.left + bounds.width - parseFloat(style.borderLeftWidth) - 15
          };
          var fitAdj = 0;
          if (height < 408 && this.target === document.body) {
            fitAdj = -0.00011 * Math.pow(height, 2) - 0.00727 * height + 22.58;
          }
          if (this.target !== document.body) {
            out.height = Math.max(out.height, 24);
          }
          var scrollPercentage = this.target.scrollTop / (target.scrollHeight - height);
          out.top = scrollPercentage * (height - out.height - fitAdj) + bounds.top + parseFloat(style.borderTopWidth);
          if (this.target === document.body) {
            out.height = Math.max(out.height, 24);
          }
          return out;
        }
      }
      return getBounds(this.target);
    }
  }, {
    key: 'clearCache',
    value: function clearCache() {
      this._cache = {};
    }
  }, {
    key: 'cache',
    value: function cache(k, getter) {
      if (typeof this._cache === 'undefined') {
        this._cache = {};
      }
      if (typeof this._cache[k] === 'undefined') {
        this._cache[k] = getter.call(this);
      }
      return this._cache[k];
    }
  }, {
    key: 'enable',
    value: function enable() {
      var _this3 = this;
      var pos = arguments.length <= 0 || arguments[0] === undefined ? true : arguments[0];
      if (this.options.addTargetClasses !== false) {
        addClass(this.target, this.getClass('enabled'));
      }
      addClass(this.element, this.getClass('enabled'));
      this.enabled = true;
      this.scrollParents.forEach(function (parent) {
        if (parent !== _this3.target.ownerDocument) {
          parent.addEventListener('scroll', _this3.position);
        }
      });
      if (pos) {
        this.position();
      }
    }
  }, {
    key: 'disable',
    value: function disable() {
      var _this4 = this;
      removeClass(this.target, this.getClass('enabled'));
      removeClass(this.element, this.getClass('enabled'));
      this.enabled = false;
      if (typeof this.scrollParents !== 'undefined') {
        this.scrollParents.forEach(function (parent) {
          parent.removeEventListener('scroll', _this4.position);
        });
      }
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      var _this5 = this;
      this.disable();
      tethers.forEach(function (tether, i) {
        if (tether === _this5) {
          tethers.splice(i, 1);
        }
      });
      if (tethers.length === 0) {
        removeUtilElements();
      }
    }
  }, {
    key: 'updateAttachClasses',
    value: function updateAttachClasses(elementAttach, targetAttach) {
      var _this6 = this;
      elementAttach = elementAttach || this.attachment;
      targetAttach = targetAttach || this.targetAttachment;
      var sides = ['left', 'top', 'bottom', 'right', 'middle', 'center'];
      if (typeof this._addAttachClasses !== 'undefined' && this._addAttachClasses.length) {
        this._addAttachClasses.splice(0, this._addAttachClasses.length);
      }
      if (typeof this._addAttachClasses === 'undefined') {
        this._addAttachClasses = [];
      }
      var add = this._addAttachClasses;
      if (elementAttach.top) {
        add.push(this.getClass('element-attached') + '-' + elementAttach.top);
      }
      if (elementAttach.left) {
        add.push(this.getClass('element-attached') + '-' + elementAttach.left);
      }
      if (targetAttach.top) {
        add.push(this.getClass('target-attached') + '-' + targetAttach.top);
      }
      if (targetAttach.left) {
        add.push(this.getClass('target-attached') + '-' + targetAttach.left);
      }
      var all = [];
      sides.forEach(function (side) {
        all.push(_this6.getClass('element-attached') + '-' + side);
        all.push(_this6.getClass('target-attached') + '-' + side);
      });
      defer(function () {
        if (typeof _this6._addAttachClasses === 'undefined') {
          return;
        }
        updateClasses(_this6.element, _this6._addAttachClasses, all);
        if (_this6.options.addTargetClasses !== false) {
          updateClasses(_this6.target, _this6._addAttachClasses, all);
        }
        delete _this6._addAttachClasses;
      });
    }
  }, {
    key: 'position',
    value: function position() {
      var _this7 = this;
      var flushChanges = arguments.length <= 0 || arguments[0] === undefined ? true : arguments[0];
      if (!this.enabled) {
        return undefined;
      }
      this.clearCache();
      var targetAttachment = autoToFixedAttachment(this.targetAttachment, this.attachment);
      this.updateAttachClasses(this.attachment, targetAttachment);
      var elementPos = this.cache('element-bounds', function () {
        return getBounds(_this7.element);
      });
      var width = elementPos.width;
      var height = elementPos.height;
      if (width === 0 && height === 0 && typeof this.lastSize !== 'undefined') {
        var _lastSize = this.lastSize;
        width = _lastSize.width;
        height = _lastSize.height;
      } else {
        this.lastSize = { width: width, height: height };
      }
      var targetPos = this.cache('target-bounds', function () {
        return _this7.getTargetBounds();
      });
      var targetSize = targetPos;
      var offset = offsetToPx(attachmentToOffset(this.attachment), { width: width, height: height });
      var targetOffset = offsetToPx(attachmentToOffset(targetAttachment), targetSize);
      var scrollbarSize = undefined;
      var manualOffset = offsetToPx(this.offset, { width: width, height: height });
      var manualTargetOffset = offsetToPx(this.targetOffset, targetSize);
      offset = addOffset(offset, manualOffset);
      targetOffset = addOffset(targetOffset, manualTargetOffset);
      var left = targetPos.left + targetOffset.left - offset.left;
      var top = targetPos.top + targetOffset.top - offset.top;
      for (var i = 0; i < TetherBase.modules.length; ++i) {
        var _module2 = TetherBase.modules[i];
        var ret = _module2.position.call(this, {
          left: left,
          top: top,
          targetAttachment: targetAttachment,
          targetPos: targetPos,
          elementPos: elementPos,
          offset: offset,
          targetOffset: targetOffset,
          manualOffset: manualOffset,
          manualTargetOffset: manualTargetOffset,
          scrollbarSize: scrollbarSize,
          attachment: this.attachment
        });
        if (ret === false) {
          return false;
        }
        if (typeof ret === 'undefined' || typeof ret !== 'object') {
          continue;
        }
        top = ret.top;
        left = ret.left;
      }
      var next = {
        page: { top: top, left: left },
        viewport: {
          top: top - pageYOffset,
          bottom: pageYOffset - top - height + innerHeight,
          left: left - pageXOffset,
          right: pageXOffset - left - width + innerWidth
        }
      };
      var doc = this.target.ownerDocument;
      var win = doc.defaultView;
      if (win.innerHeight > doc.documentElement.clientHeight) {
        scrollbarSize = this.cache('scrollbar-size', getScrollBarSize);
        next.viewport.bottom -= scrollbarSize.height;
      }
      if (win.innerWidth > doc.documentElement.clientWidth) {
        scrollbarSize = this.cache('scrollbar-size', getScrollBarSize);
        next.viewport.right -= scrollbarSize.width;
      }
      if (['', 'static'].indexOf(doc.body.style.position) === -1 || ['', 'static'].indexOf(doc.body.parentElement.style.position) === -1) {
        next.page.bottom = doc.body.scrollHeight - top - height;
        next.page.right = doc.body.scrollWidth - left - width;
      }
      if (typeof this.options.optimizations !== 'undefined' && this.options.optimizations.moveElement !== false && !(typeof this.targetModifier !== 'undefined')) {
        (function () {
          var offsetParent = _this7.cache('target-offsetparent', function () {
            return getOffsetParent(_this7.target);
          });
          var offsetPosition = _this7.cache('target-offsetparent-bounds', function () {
            return getBounds(offsetParent);
          });
          var offsetParentStyle = getComputedStyle(offsetParent);
          var offsetParentSize = offsetPosition;
          var offsetBorder = {};
          ['Top', 'Left', 'Bottom', 'Right'].forEach(function (side) {
            offsetBorder[side.toLowerCase()] = parseFloat(offsetParentStyle['border' + side + 'Width']);
          });
          offsetPosition.right = doc.body.scrollWidth - offsetPosition.left - offsetParentSize.width + offsetBorder.right;
          offsetPosition.bottom = doc.body.scrollHeight - offsetPosition.top - offsetParentSize.height + offsetBorder.bottom;
          if (next.page.top >= offsetPosition.top + offsetBorder.top && next.page.bottom >= offsetPosition.bottom) {
            if (next.page.left >= offsetPosition.left + offsetBorder.left && next.page.right >= offsetPosition.right) {
              var scrollTop = offsetParent.scrollTop;
              var scrollLeft = offsetParent.scrollLeft;
              next.offset = {
                top: next.page.top - offsetPosition.top + scrollTop - offsetBorder.top,
                left: next.page.left - offsetPosition.left + scrollLeft - offsetBorder.left
              };
            }
          }
        })();
      }
      this.move(next);
      this.history.unshift(next);
      if (this.history.length > 3) {
        this.history.pop();
      }
      if (flushChanges) {
        flush();
      }
      return true;
    }
  }, {
    key: 'move',
    value: function move(pos) {
      var _this8 = this;
      if (typeof this.element.parentNode === 'undefined') {
        return;
      }
      var same = {};
      for (var type in pos) {
        same[type] = {};
        for (var key in pos[type]) {
          var found = false;
          for (var i = 0; i < this.history.length; ++i) {
            var point = this.history[i];
            if (typeof point[type] !== 'undefined' && !within(point[type][key], pos[type][key])) {
              found = true;
              break;
            }
          }
          if (!found) {
            same[type][key] = true;
          }
        }
      }
      var css = { top: '', left: '', right: '', bottom: '' };
      var transcribe = function transcribe(_same, _pos) {
        var hasOptimizations = typeof _this8.options.optimizations !== 'undefined';
        var gpu = hasOptimizations ? _this8.options.optimizations.gpu : null;
        if (gpu !== false) {
          var yPos = undefined,
              xPos = undefined;
          if (_same.top) {
            css.top = 0;
            yPos = _pos.top;
          } else {
            css.bottom = 0;
            yPos = -_pos.bottom;
          }
          if (_same.left) {
            css.left = 0;
            xPos = _pos.left;
          } else {
            css.right = 0;
            xPos = -_pos.right;
          }
          if (window.matchMedia) {
            var retina = window.matchMedia('only screen and (min-resolution: 1.3dppx)').matches || window.matchMedia('only screen and (-webkit-min-device-pixel-ratio: 1.3)').matches;
            if (!retina) {
              xPos = Math.round(xPos);
              yPos = Math.round(yPos);
            }
          }
          css[transformKey] = 'translateX(' + xPos + 'px) translateY(' + yPos + 'px)';
          if (transformKey !== 'msTransform') {
            css[transformKey] += ' translateZ(0)';
          }
        } else {
          if (_same.top) {
            css.top = _pos.top + 'px';
          } else {
            css.bottom = _pos.bottom + 'px';
          }
          if (_same.left) {
            css.left = _pos.left + 'px';
          } else {
            css.right = _pos.right + 'px';
          }
        }
      };
      var moved = false;
      if ((same.page.top || same.page.bottom) && (same.page.left || same.page.right)) {
        css.position = 'absolute';
        transcribe(same.page, pos.page);
      } else if ((same.viewport.top || same.viewport.bottom) && (same.viewport.left || same.viewport.right)) {
        css.position = 'fixed';
        transcribe(same.viewport, pos.viewport);
      } else if (typeof same.offset !== 'undefined' && same.offset.top && same.offset.left) {
        (function () {
          css.position = 'absolute';
          var offsetParent = _this8.cache('target-offsetparent', function () {
            return getOffsetParent(_this8.target);
          });
          if (getOffsetParent(_this8.element) !== offsetParent) {
            defer(function () {
              _this8.element.parentNode.removeChild(_this8.element);
              offsetParent.appendChild(_this8.element);
            });
          }
          transcribe(same.offset, pos.offset);
          moved = true;
        })();
      } else {
        css.position = 'absolute';
        transcribe({ top: true, left: true }, pos.page);
      }
      if (!moved) {
        if (this.options.bodyElement) {
          this.options.bodyElement.appendChild(this.element);
        } else {
          var offsetParentIsBody = true;
          var currentNode = this.element.parentNode;
          while (currentNode && currentNode.nodeType === 1 && currentNode.tagName !== 'BODY') {
            if (getComputedStyle(currentNode).position !== 'static') {
              offsetParentIsBody = false;
              break;
            }
            currentNode = currentNode.parentNode;
          }
          if (!offsetParentIsBody) {
            this.element.parentNode.removeChild(this.element);
            this.element.ownerDocument.body.appendChild(this.element);
          }
        }
      }
      var writeCSS = {};
      var write = false;
      for (var key in css) {
        var val = css[key];
        var elVal = this.element.style[key];
        if (elVal !== val) {
          write = true;
          writeCSS[key] = val;
        }
      }
      if (write) {
        defer(function () {
          extend(_this8.element.style, writeCSS);
          _this8.trigger('repositioned');
        });
      }
    }
  }]);
  return TetherClass;
})(Evented);
TetherClass.modules = [];
TetherBase.position = position;
var Tether = extend(TetherClass, TetherBase);
var BOUNDS_FORMAT = ['left', 'top', 'right', 'bottom'];
function getBoundingRect(tether, to) {
  if (to === 'scrollParent') {
    to = tether.scrollParents[0];
  } else if (to === 'window') {
    to = [pageXOffset, pageYOffset, innerWidth + pageXOffset, innerHeight + pageYOffset];
  }
  if (to === document) {
    to = to.documentElement;
  }
  if (typeof to.nodeType !== 'undefined') {
    (function () {
      var node = to;
      var size = getBounds(to);
      var pos = size;
      var style = getComputedStyle(to);
      to = [pos.left, pos.top, size.width + pos.left, size.height + pos.top];
      if (node.ownerDocument !== document) {
        var win = node.ownerDocument.defaultView;
        to[0] += win.pageXOffset;
        to[1] += win.pageYOffset;
        to[2] += win.pageXOffset;
        to[3] += win.pageYOffset;
      }
      BOUNDS_FORMAT.forEach(function (side, i) {
        side = side[0].toUpperCase() + side.substr(1);
        if (side === 'Top' || side === 'Left') {
          to[i] += parseFloat(style['border' + side + 'Width']);
        } else {
          to[i] -= parseFloat(style['border' + side + 'Width']);
        }
      });
    })();
  }
  return to;
}
TetherBase.modules.push({
  position: function position(_ref2) {
    var _this9 = this;
    var top = _ref2.top;
    var left = _ref2.left;
    var targetAttachment = _ref2.targetAttachment;
    if (!this.options.constraints) {
      return true;
    }
    var _cache = this.cache('element-bounds', function () {
      return getBounds(_this9.element);
    });
    var height = _cache.height;
    var width = _cache.width;
    if (width === 0 && height === 0 && typeof this.lastSize !== 'undefined') {
      var _lastSize2 = this.lastSize;
      width = _lastSize2.width;
      height = _lastSize2.height;
    }
    var targetSize = this.cache('target-bounds', function () {
      return _this9.getTargetBounds();
    });
    var targetHeight = targetSize.height;
    var targetWidth = targetSize.width;
    var allClasses = [this.getClass('pinned'), this.getClass('out-of-bounds')];
    this.options.constraints.forEach(function (constraint) {
      var outOfBoundsClass = constraint.outOfBoundsClass;
      var pinnedClass = constraint.pinnedClass;
      if (outOfBoundsClass) {
        allClasses.push(outOfBoundsClass);
      }
      if (pinnedClass) {
        allClasses.push(pinnedClass);
      }
    });
    allClasses.forEach(function (cls) {
      ['left', 'top', 'right', 'bottom'].forEach(function (side) {
        allClasses.push(cls + '-' + side);
      });
    });
    var addClasses = [];
    var tAttachment = extend({}, targetAttachment);
    var eAttachment = extend({}, this.attachment);
    this.options.constraints.forEach(function (constraint) {
      var to = constraint.to;
      var attachment = constraint.attachment;
      var pin = constraint.pin;
      if (typeof attachment === 'undefined') {
        attachment = '';
      }
      var changeAttachX = undefined,
          changeAttachY = undefined;
      if (attachment.indexOf(' ') >= 0) {
        var _attachment$split = attachment.split(' ');
        var _attachment$split2 = _slicedToArray(_attachment$split, 2);
        changeAttachY = _attachment$split2[0];
        changeAttachX = _attachment$split2[1];
      } else {
        changeAttachX = changeAttachY = attachment;
      }
      var bounds = getBoundingRect(_this9, to);
      if (changeAttachY === 'target' || changeAttachY === 'both') {
        if (top < bounds[1] && tAttachment.top === 'top') {
          top += targetHeight;
          tAttachment.top = 'bottom';
        }
        if (top + height > bounds[3] && tAttachment.top === 'bottom') {
          top -= targetHeight;
          tAttachment.top = 'top';
        }
      }
      if (changeAttachY === 'together') {
        if (tAttachment.top === 'top') {
          if (eAttachment.top === 'bottom' && top < bounds[1]) {
            top += targetHeight;
            tAttachment.top = 'bottom';
            top += height;
            eAttachment.top = 'top';
          } else if (eAttachment.top === 'top' && top + height > bounds[3] && top - (height - targetHeight) >= bounds[1]) {
            top -= height - targetHeight;
            tAttachment.top = 'bottom';
            eAttachment.top = 'bottom';
          }
        }
        if (tAttachment.top === 'bottom') {
          if (eAttachment.top === 'top' && top + height > bounds[3]) {
            top -= targetHeight;
            tAttachment.top = 'top';
            top -= height;
            eAttachment.top = 'bottom';
          } else if (eAttachment.top === 'bottom' && top < bounds[1] && top + (height * 2 - targetHeight) <= bounds[3]) {
            top += height - targetHeight;
            tAttachment.top = 'top';
            eAttachment.top = 'top';
          }
        }
        if (tAttachment.top === 'middle') {
          if (top + height > bounds[3] && eAttachment.top === 'top') {
            top -= height;
            eAttachment.top = 'bottom';
          } else if (top < bounds[1] && eAttachment.top === 'bottom') {
            top += height;
            eAttachment.top = 'top';
          }
        }
      }
      if (changeAttachX === 'target' || changeAttachX === 'both') {
        if (left < bounds[0] && tAttachment.left === 'left') {
          left += targetWidth;
          tAttachment.left = 'right';
        }
        if (left + width > bounds[2] && tAttachment.left === 'right') {
          left -= targetWidth;
          tAttachment.left = 'left';
        }
      }
      if (changeAttachX === 'together') {
        if (left < bounds[0] && tAttachment.left === 'left') {
          if (eAttachment.left === 'right') {
            left += targetWidth;
            tAttachment.left = 'right';
            left += width;
            eAttachment.left = 'left';
          } else if (eAttachment.left === 'left') {
            left += targetWidth;
            tAttachment.left = 'right';
            left -= width;
            eAttachment.left = 'right';
          }
        } else if (left + width > bounds[2] && tAttachment.left === 'right') {
          if (eAttachment.left === 'left') {
            left -= targetWidth;
            tAttachment.left = 'left';
            left -= width;
            eAttachment.left = 'right';
          } else if (eAttachment.left === 'right') {
            left -= targetWidth;
            tAttachment.left = 'left';
            left += width;
            eAttachment.left = 'left';
          }
        } else if (tAttachment.left === 'center') {
          if (left + width > bounds[2] && eAttachment.left === 'left') {
            left -= width;
            eAttachment.left = 'right';
          } else if (left < bounds[0] && eAttachment.left === 'right') {
            left += width;
            eAttachment.left = 'left';
          }
        }
      }
      if (changeAttachY === 'element' || changeAttachY === 'both') {
        if (top < bounds[1] && eAttachment.top === 'bottom') {
          top += height;
          eAttachment.top = 'top';
        }
        if (top + height > bounds[3] && eAttachment.top === 'top') {
          top -= height;
          eAttachment.top = 'bottom';
        }
      }
      if (changeAttachX === 'element' || changeAttachX === 'both') {
        if (left < bounds[0]) {
          if (eAttachment.left === 'right') {
            left += width;
            eAttachment.left = 'left';
          } else if (eAttachment.left === 'center') {
            left += width / 2;
            eAttachment.left = 'left';
          }
        }
        if (left + width > bounds[2]) {
          if (eAttachment.left === 'left') {
            left -= width;
            eAttachment.left = 'right';
          } else if (eAttachment.left === 'center') {
            left -= width / 2;
            eAttachment.left = 'right';
          }
        }
      }
      if (typeof pin === 'string') {
        pin = pin.split(',').map(function (p) {
          return p.trim();
        });
      } else if (pin === true) {
        pin = ['top', 'left', 'right', 'bottom'];
      }
      pin = pin || [];
      var pinned = [];
      var oob = [];
      if (top < bounds[1]) {
        if (pin.indexOf('top') >= 0) {
          top = bounds[1];
          pinned.push('top');
        } else {
          oob.push('top');
        }
      }
      if (top + height > bounds[3]) {
        if (pin.indexOf('bottom') >= 0) {
          top = bounds[3] - height;
          pinned.push('bottom');
        } else {
          oob.push('bottom');
        }
      }
      if (left < bounds[0]) {
        if (pin.indexOf('left') >= 0) {
          left = bounds[0];
          pinned.push('left');
        } else {
          oob.push('left');
        }
      }
      if (left + width > bounds[2]) {
        if (pin.indexOf('right') >= 0) {
          left = bounds[2] - width;
          pinned.push('right');
        } else {
          oob.push('right');
        }
      }
      if (pinned.length) {
        (function () {
          var pinnedClass = undefined;
          if (typeof _this9.options.pinnedClass !== 'undefined') {
            pinnedClass = _this9.options.pinnedClass;
          } else {
            pinnedClass = _this9.getClass('pinned');
          }
          addClasses.push(pinnedClass);
          pinned.forEach(function (side) {
            addClasses.push(pinnedClass + '-' + side);
          });
        })();
      }
      if (oob.length) {
        (function () {
          var oobClass = undefined;
          if (typeof _this9.options.outOfBoundsClass !== 'undefined') {
            oobClass = _this9.options.outOfBoundsClass;
          } else {
            oobClass = _this9.getClass('out-of-bounds');
          }
          addClasses.push(oobClass);
          oob.forEach(function (side) {
            addClasses.push(oobClass + '-' + side);
          });
        })();
      }
      if (pinned.indexOf('left') >= 0 || pinned.indexOf('right') >= 0) {
        eAttachment.left = tAttachment.left = false;
      }
      if (pinned.indexOf('top') >= 0 || pinned.indexOf('bottom') >= 0) {
        eAttachment.top = tAttachment.top = false;
      }
      if (tAttachment.top !== targetAttachment.top || tAttachment.left !== targetAttachment.left || eAttachment.top !== _this9.attachment.top || eAttachment.left !== _this9.attachment.left) {
        _this9.updateAttachClasses(eAttachment, tAttachment);
        _this9.trigger('update', {
          attachment: eAttachment,
          targetAttachment: tAttachment
        });
      }
    });
    defer(function () {
      if (_this9.options.addTargetClasses !== false) {
        updateClasses(_this9.target, addClasses, allClasses);
      }
      updateClasses(_this9.element, addClasses, allClasses);
    });
    return { top: top, left: left };
  }
});
TetherBase.modules.push({
  position: function position(_ref3) {
    var _this10 = this;
    var top = _ref3.top;
    var left = _ref3.left;
    var _cache2 = this.cache('element-bounds', function () {
      return getBounds(_this10.element);
    });
    var height = _cache2.height;
    var width = _cache2.width;
    var targetPos = this.getTargetBounds();
    var bottom = top + height;
    var right = left + width;
    var abutted = [];
    if (top <= targetPos.bottom && bottom >= targetPos.top) {
      ['left', 'right'].forEach(function (side) {
        var targetPosSide = targetPos[side];
        if (targetPosSide === left || targetPosSide === right) {
          abutted.push(side);
        }
      });
    }
    if (left <= targetPos.right && right >= targetPos.left) {
      ['top', 'bottom'].forEach(function (side) {
        var targetPosSide = targetPos[side];
        if (targetPosSide === top || targetPosSide === bottom) {
          abutted.push(side);
        }
      });
    }
    var allClasses = [];
    var addClasses = [];
    var sides = ['left', 'top', 'right', 'bottom'];
    allClasses.push(this.getClass('abutted'));
    sides.forEach(function (side) {
      allClasses.push(_this10.getClass('abutted') + '-' + side);
    });
    if (abutted.length) {
      addClasses.push(this.getClass('abutted'));
    }
    abutted.forEach(function (side) {
      addClasses.push(_this10.getClass('abutted') + '-' + side);
    });
    defer(function () {
      if (_this10.options.addTargetClasses !== false) {
        updateClasses(_this10.target, addClasses, allClasses);
      }
      updateClasses(_this10.element, addClasses, allClasses);
    });
    return true;
  }
});
TetherBase.modules.push({
  position: function position(_ref4) {
    var top = _ref4.top;
    var left = _ref4.left;
    if (!this.options.shift) {
      return undefined;
    }
    var shift = this.options.shift;
    if (typeof this.options.shift === 'function') {
      shift = this.options.shift.call(this, { top: top, left: left });
    }
    var shiftTop = undefined,
        shiftLeft = undefined;
    if (typeof shift === 'string') {
      shift = shift.split(' ');
      shift[1] = shift[1] || shift[0];
      var _shift = shift;
      var _shift2 = _slicedToArray(_shift, 2);
      shiftTop = _shift2[0];
      shiftLeft = _shift2[1];
      shiftTop = parseFloat(shiftTop, 10);
      shiftLeft = parseFloat(shiftLeft, 10);
    } else {
      shiftTop = shift.top;
      shiftLeft = shift.left;
    }
    top += shiftTop;
    left += shiftLeft;
    return { top: top, left: left };
  }
});
return Tether;
}));
});

var defaultProps$b = {
  isOpen: false,
  tetherRef: null
};
var propTypes$b = {
  className: propTypes.string,
  children: propTypes.node,
  isOpen: propTypes.bool,
  disabled: propTypes.bool,
  toggle: propTypes.func.isRequired,
  tether: propTypes.object.isRequired,
  tetherRef: propTypes.func,
  style: propTypes.node
};
var TetherContent =
function (_React$Component) {
  _inherits(TetherContent, _React$Component);
  function TetherContent() {
    var _getPrototypeOf2;
    var _this;
    _classCallCheck(this, TetherContent);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(TetherContent)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _defineProperty(_assertThisInitialized(_this), "componentDidMount", function () {
      _this.handleProps();
    });
    _defineProperty(_assertThisInitialized(_this), "componentDidUpdate", function (prevProps) {
      if (_this.props.isOpen !== prevProps.isOpen) {
        _this.handleProps();
      } else if (_this.element) {
        _this.renderIntoSubtree();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "componentWillUnmount", function () {
      _this.hide();
    });
    _defineProperty(_assertThisInitialized(_this), "getTarget", function () {
      var target = _this.props.tether.target;
      if (lodash_omit(target)) {
        return target();
      }
      return target;
    });
    _defineProperty(_assertThisInitialized(_this), "getTetherConfig", function () {
      var config = _objectSpread({}, _this.props.tether);
      config.element = _this.element;
      config.target = _this.getTarget();
      return config;
    });
    _defineProperty(_assertThisInitialized(_this), "handleDocumentClick", function (e) {
      var container = _this.element;
      if (e.target === container || !container.contains(e.target)) {
        _this.toggle();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "handleProps", function () {
      if (_this.props.isOpen) {
        _this.show();
      } else {
        _this.hide();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "hide", function () {
      document.removeEventListener('click', _this.handleDocumentClick, true);
      if (_this.element) {
        document.body.removeChild(_this.element);
        ReactDOM.unmountComponentAtNode(_this.element);
        _this.element = null;
      }
      if (_this.tether) {
        _this.tether.destroy();
        _this.tether = null;
        if (_this.props.tetherRef) {
          _this.props.tetherRef(_this.tether);
        }
      }
    });
    _defineProperty(_assertThisInitialized(_this), "show", function () {
      document.addEventListener('click', _this.handleDocumentClick, true);
      _this.element = document.createElement('div');
      _this.element.className = _this.props.className;
      document.body.appendChild(_this.element);
      _this.renderIntoSubtree();
      _this.tether = new tether(_this.getTetherConfig());
      if (_this.props.tetherRef) {
        _this.props.tetherRef(_this.tether);
      }
      _this.tether.position();
    });
    _defineProperty(_assertThisInitialized(_this), "toggle", function (e) {
      if (_this.props.disabled) {
        return e && e.preventDefault();
      }
      return _this.props.toggle();
    });
    _defineProperty(_assertThisInitialized(_this), "renderIntoSubtree", function () {
      ReactDOM.unstable_renderSubtreeIntoContainer(_assertThisInitialized(_this), _this.renderChildren(), _this.element);
    });
    _defineProperty(_assertThisInitialized(_this), "renderChildren", function () {
      var _this$props = _this.props,
          children = _this$props.children,
          style = _this$props.style;
      return React.cloneElement(children, {
        style: style
      });
    });
    return _this;
  }
  _createClass(TetherContent, [{
    key: "render",
    value: function render() {
      return null;
    }
  }]);
  return TetherContent;
}(React.Component);
_defineProperty(TetherContent, "propTypes", propTypes$b);
_defineProperty(TetherContent, "defaultProps", defaultProps$b);
TetherContent.defaultProps = defaultProps$b;
TetherContent.propTypes = propTypes$b;

var defaultTetherConfig = {
  classes: {
    element: 'dropdown',
    enabled: 'show'
  },
  classPrefix: 'bs-tether',
  constraints: [{
    to: 'scrollParent',
    attachment: 'together none'
  }, {
    to: 'window',
    attachment: 'together none'
  }]
};
var defaultProps$c = {
  isOpen: false,
  tag: 'div',
  group: false,
  theme: {
    '$enable-rounded': true,
    '$enable-shadows': false,
    '$enable-gradients': false,
    '$enable-hover-media-query': false,
    '$spacer-y': '1rem',
    '$body-color': 'black',
    '$border-width': '1px',
    '$font-size-sm': '.875rem',
    '$font-weight-normal': 'normal',
    '$font-size-base': '1rem',
    '$font-size-lg': '1.25rem',
    '$zindex-dropdown-backdrop': '990',
    '$zindex-dropdown': '1000',
    '$component-active-color': '#fff',
    '$component-active-bg': '#0275d8',
    '$caret-width': '.3em',
    '$line-height-lg': '1.6',
    '$border-radius-lg': '.3rem',
    '$border-radius-sm': '.2rem',
    '$input-padding-y-lg': '.75rem',
    '$dropdown-min-width': '10rem',
    '$dropdown-padding-y': '.5rem',
    '$dropdown-margin-top': '.125rem',
    '$dropdown-bg': '#fff',
    '$dropdown-border-color': 'rgba(0, 0, 0, 0.15)',
    '$dropdown-border-width': '1px',
    '$dropdown-divider-bg': '#eceeef',
    '$dropdown-box-shadow': '0 .5rem 1rem rgba(#000,.175)',
    '$dropdown-link-color': '#292b2c',
    '$dropdown-link-hover-color': 'hsl(200, 3.5%, 15.8%)',
    '$dropdown-link-hover-bg': '#f7f7f9',
    '$dropdown-link-active-color': 'hsl(200, 3.5%, 15.8%)',
    '$dropdown-link-active-bg': '#fff',
    '$dropdown-link-disabled-color': '#636c72',
    '$dropdown-item-padding-x': '1.5rem',
    '$dropdown-header-color': '#636c72',
    '$input-btn-border-width': '1px',
    '$cursor-disabled': 'not-allowed',
    '$btn-padding-x': '1rem',
    '$btn-active-box-shadow': 'inset 0 3px 5px rgba(0, 0, 0, 0.125)',
    '$btn-padding-x-lg': '1.5rem',
    '$btn-padding-y-lg': '.75rem',
    '$btn-border-radius-lg': '.3rem',
    '$btn-border-radius-sm': '.2rem',
    '$btn-padding-x-sm': '.5rem',
    '$btn-padding-y-sm': '.25rem',
    '$input-height-lg': '3.5rem'
  }
};
var propTypes$c = {
  className: propTypes.string,
  children: propTypes.node,
  disabled: propTypes.bool,
  dropup: propTypes.bool,
  group: propTypes.bool,
  isOpen: propTypes.bool,
  size: propTypes.oneOf(['sm', 'lg', '']),
  tether: propTypes.oneOfType([propTypes.object, propTypes.bool]),
  toggle: propTypes.func,
  theme: propTypes.shape({
    '$enable-rounded': propTypes.bool,
    '$enable-shadows': propTypes.bool,
    '$enable-gradients': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool,
    '$spacer-y': propTypes.string,
    '$body-color': propTypes.string,
    '$border-width': propTypes.string,
    '$font-size-sm': propTypes.string,
    '$font-weight-normal': propTypes.string,
    '$font-size-base': propTypes.string,
    '$font-size-lg': propTypes.string,
    '$zindex-dropdown-backdrop': propTypes.string,
    '$zindex-dropdown': propTypes.string,
    '$component-active-color': propTypes.string,
    '$component-active-bg': propTypes.string,
    '$caret-width': propTypes.string,
    '$line-height-lg': propTypes.string,
    '$border-radius-lg': propTypes.string,
    '$border-radius-sm': propTypes.string,
    '$input-padding-y-lg': propTypes.string,
    '$dropdown-min-width': propTypes.string,
    '$dropdown-padding-y': propTypes.string,
    '$dropdown-margin-top': propTypes.string,
    '$dropdown-bg': propTypes.string,
    '$dropdown-border-color': propTypes.string,
    '$dropdown-border-width': propTypes.string,
    '$dropdown-divider-bg': propTypes.string,
    '$dropdown-box-shadow': propTypes.string,
    '$dropdown-link-color': propTypes.string,
    '$dropdown-link-hover-color': propTypes.string,
    '$dropdown-link-hover-bg': propTypes.string,
    '$dropdown-link-active-color': propTypes.string,
    '$dropdown-link-active-bg': propTypes.string,
    '$dropdown-link-disabled-color': propTypes.string,
    '$dropdown-item-padding-x': propTypes.string,
    '$dropdown-header-color': propTypes.string,
    '$input-btn-border-width': propTypes.string,
    '$cursor-disabled': propTypes.string,
    '$btn-padding-x': propTypes.string,
    '$btn-active-box-shadow': propTypes.string,
    '$btn-padding-x-lg': propTypes.string,
    '$btn-padding-y-lg': propTypes.string,
    '$btn-border-radius-lg': propTypes.string,
    '$btn-border-radius-sm': propTypes.string,
    '$btn-padding-x-sm': propTypes.string,
    '$btn-padding-y-sm': propTypes.string,
    '$input-height-lg': propTypes.string
  }),
  tag: propTypes.any,
  cssModule: propTypes.object
};
var DropdownUnstyled =
function (_React$Component) {
  _inherits(DropdownUnstyled, _React$Component);
  function DropdownUnstyled() {
    var _getPrototypeOf2;
    var _this;
    _classCallCheck(this, DropdownUnstyled);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(DropdownUnstyled)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _defineProperty(_assertThisInitialized(_this), "getTetherConfig", function (childProps) {
      var target = function target() {
        return _this.getTetherTarget();
      };
      var vElementAttach = 'top';
      var hElementAttach = 'left';
      var vTargetAttach = 'bottom';
      var hTargetAttach = 'left';
      if (childProps.right) {
        hElementAttach = 'right';
        hTargetAttach = 'right';
      }
      if (_this.props.dropup) {
        vElementAttach = 'bottom';
        vTargetAttach = 'top';
      }
      return _objectSpread({}, defaultTetherConfig, {
        attachment: vElementAttach + ' ' + hElementAttach,
        targetAttachment: vTargetAttach + ' ' + hTargetAttach,
        target: target
      }, _this.props.tether);
    });
    _defineProperty(_assertThisInitialized(_this), "addEvents", function () {
      document.addEventListener('click', _this.handleDocumentClick, true);
    });
    _defineProperty(_assertThisInitialized(_this), "removeEvents", function () {
      document.removeEventListener('click', _this.handleDocumentClick, true);
    });
    _defineProperty(_assertThisInitialized(_this), "handleDocumentClick", function (e) {
      var container = ReactDOM.findDOMNode(_assertThisInitialized(_this));
      if (container.contains(e.target) && container !== e.target) {
        return;
      }
      _this.toggle();
    });
    _defineProperty(_assertThisInitialized(_this), "toggle", function (e) {
      if (_this.props.disabled) {
        return e && e.preventDefault();
      }
      return _this.props.toggle();
    });
    return _this;
  }
  _createClass(DropdownUnstyled, [{
    key: "getChildContext",
    value: function getChildContext() {
      return {
        isOpen: this.props.isOpen,
        toggle: this.props.toggle
      };
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.handleProps();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.isOpen !== prevProps.isOpen) {
        this.handleProps();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.removeEvents();
    }
  }, {
    key: "getTetherTarget",
    value: function getTetherTarget() {
      var container = ReactDOM.findDOMNode(this);
      return container.querySelector('[data-toggle="dropdown"]');
    }
  }, {
    key: "handleProps",
    value: function handleProps() {
      if (this.props.tether) {
        return;
      }
      if (this.props.isOpen) {
        this.addEvents();
      } else {
        this.removeEvents();
      }
    }
  }, {
    key: "renderChildren",
    value: function renderChildren() {
      var _this2 = this;
      var _this$props = this.props,
          tether = _this$props.tether,
          children = _this$props.children,
          attrs = _objectWithoutProperties(_this$props, ["tether", "children"]);
      attrs.toggle = this.toggle;
      return React.Children.map(React.Children.toArray(children), function (child) {
        if (tether && child.type === DropdownMenu) {
          var tetherConfig = _this2.getTetherConfig(child.props);
          return React.createElement(TetherContent, _extends({}, attrs, {
            tether: tetherConfig
          }), child);
        }
        return child;
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _cn;
      var _omit = lodash_omit(this.props, ['toggle', 'tether', 'theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          dropup = _omit.dropup,
          group = _omit.group,
          size = _omit.size,
          Tag = _omit.tag,
          isOpen = _omit.isOpen,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "dropup", "group", "size", "tag", "isOpen"]);
      var classes = mapToCssModules(classnames(className, (_cn = {
        'btn-group': group
      }, _defineProperty(_cn, "btn-group-".concat(size), !!size), _defineProperty(_cn, "dropdown", !group), _defineProperty(_cn, "show", isOpen), _defineProperty(_cn, "dropup", dropup), _cn)), cssModule);
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }), this.renderChildren());
    }
  }]);
  return DropdownUnstyled;
}(React.Component);
_defineProperty(DropdownUnstyled, "propTypes", propTypes$c);
_defineProperty(DropdownUnstyled, "childContextTypes", {
  isOpen: propTypes.bool.isRequired,
  toggle: propTypes.func.isRequired
});
_defineProperty(DropdownUnstyled, "defaultProps", defaultProps$c);
var Dropdown = styled(DropdownUnstyled).withConfig({
  displayName: "Dropdown",
  componentId: "sc-1dbo397-0"
})(["", ""], function (props) {
  return "\n    &.dropup,\n    &.dropdown {\n      position: relative;\n    }\n\n    & .dropdown-hide {\n      display: none;\n    }\n    \n    & .dropdown-toggle {\n      /* Generate the caret automatically */\n      &::after {\n        display: inline-block;\n        width: 0;\n        height: 0;\n        margin-left: ".concat(props.theme['$caret-width'], ";\n        vertical-align: middle;\n        content: '';\n        border-top: ").concat(props.theme['$caret-width'], " solid;\n        border-right: ").concat(props.theme['$caret-width'], " solid transparent;\n        border-left: ").concat(props.theme['$caret-width'], " solid transparent;\n      }\n\n      /* Prevent the focus on the dropdown toggle when closing dropdowns */\n      &:focus {\n        outline: 0;\n      }\n    }\n\n    &.dropup {\n      .dropdown-toggle {\n        &::after {\n          border-top: 0;\n          border-bottom: ").concat(props.theme['$caret-width'], " solid;\n        }\n      }\n    }\n\n    & .dropdown-menu {\n      clear: left;\n      position: absolute;\n      top: 100%;\n      left: 0;\n      z-index: ").concat(props.theme['$zindex-dropdown'], ";\n      display: none; // none by default, but block on \"open\" of the menu\n      float: left;\n      min-width: ").concat(props.theme['$dropdown-min-width'], ";\n      padding: ").concat(props.theme['$dropdown-padding-y'], " 0;\n      margin: ").concat(props.theme['$dropdown-margin-top'], " 0; /* override default ul */\n      font-size: ").concat(props.theme['$font-size-base'], ";\n      color: ").concat(props.theme['$body-color'], ";\n      text-align: left; /* Ensures proper alignment if parent has it changed (e.g., modal footer) */\n      list-style: none;\n      background-color: ").concat(props.theme['$dropdown-bg'], ";\n      background-clip: padding-box;\n      border: ").concat(props.theme['$dropdown-border-width'], " solid ").concat(props.theme['$dropdown-border-color'], ";\n      ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$border-radius']), "\n      ").concat(boxShadow_2(props.theme['$enable-shadows'], props.theme['$dropdown-box-shadow']), "\n    }\n\n    /* mixin from bootstrap 4, see : scss/mixins/_nav-divider.css */\n    & .dropdown-divider {\n      ").concat(navDivider_2(props.theme['$spacer-y'], props.theme['$dropdown-divider-bg']), "\n    }\n\n    & .dropdown-item {\n      display: block;\n      width: 100%; /* For <button>s */\n      padding: 3px ").concat(props.theme['$dropdown-item-padding-x'], ";\n      clear: both;\n      font-weight: ").concat(props.theme['$font-weight-normal'], ";\n      color: ").concat(props.theme['$dropdown-link-color'], ";\n      text-align: inherit; /* For <button>s */\n      white-space: nowrap; /* prevent links from randomly breaking onto new lines */\n      background: none; /* For <button>s */\n      border: 0; /* For <button>s */\n\n      ").concat(hover_3(props.theme['$enable-hover-media-query'], "\n        color: ".concat(props.theme['$dropdown-link-hover-color'], ";\n        text-decoration: none;\n        background-color: ").concat(props.theme['$dropdown-link-hover-bg'], "\n      ")), "\n\n      &.active,\n      &:active {\n        color: ").concat(props.theme['$dropdown-link-active-color'], ";\n        text-decoration: none;\n        background-color: ").concat(props.theme['$dropdown-link-active-bg'], "\n      }\n\n      &.disabled,\n      &:disabled{\n        color: ").concat(props.theme['$dropdown-link-disabled-color'], ";\n        cursor: ").concat(props.theme['$cursor-disabled'], ";\n        background-color: transparent;\n        ").concat(conditional_1(props.theme['$enable-gradients'], 'background-image: none; /* Remove CSS gradient */'), "\n      }\n    }\n\n    &.show {\n      /* show the menu */\n      &>.dropdown-menu {\n        display: block;\n      }\n\n      & > a {\n        outline: 0;\n      }\n    }\n\n\n    /* Menu positioning */\n\n    /* Add extra class to .dropdown-menu to flip the alignment of the dropdown*\n    /* menu with the parent. */\n    & .dropdown-menu-right {\n      right: 0;\n      left: auto; /* Reset the default from .dropdown-menu */\n    }\n\n    & .dropdown-menu-left {\n      right: auto;\n      left: 0;\n    }\n\n    /* Dropdown section headers */\n    & .dropdown-header {\n      display: block;\n      padding: ").concat(props.theme['$dropdown-padding-y'], " ").concat(props.theme['$dropdown-item-padding-x'], ";\n      margin-bottom: 0; /* for use with heading elements */\n      font-size: ").concat(props.theme['$font-size-sm'], ";\n      color: ").concat(props.theme['$dropdown-header-color'], ";\n      white-space: nowrap; /* as with > li > a */\n    }\n    /* Dropdown section footers */\n    & .dropdown-footer {\n      display: block;\n      padding: ").concat(props.theme['$dropdown-padding-y'], " ").concat(props.theme['$dropdown-item-padding-x'], ";\n      margin-bottom: 0; /* for use with heading elements */\n      font-size: ").concat(props.theme['$font-size-sm'], ";\n      color: ").concat(props.theme['$dropdown-header-color'], ";\n      white-space: nowrap; /* as with > li > a */\n    }\n    \n\n    /* Backdrop to catch body clicks on mobile, etc. */\n    & .dropdown-backdrop {\n      position: fixed;\n      top: 0;\n      right: 0;\n      bottom: 0;\n      left: 0;\n      z-index: ").concat(props.theme['$zindex-dropdown-backdrop'], ";\n    }\n\n    /* Allow for dropdowns to go bottom up (aka, dropup-menu) */\n\n    /* Just add .dropup after the standard .dropdown class and you're set. */\n    /* TODO: abstract this so that the navbar fixed styles are not placed here? */\n\n    &.dropup {\n      .dropdown-menu {\n        top: auto;\n        bottom: 100%;\n        margin-bottom: ").concat(props.theme['$dropdown-margin-top'], ";\n      }\n    }\n        \n    /* Added Mixin boutonGroup to enable dropdown to beneficiate from buttonGroup classes */\n    ").concat(buttonGroup_2(props.theme['$enable-shadows'], props.theme['$enable-rounded'], props.theme['$input-btn-border-width'], props.theme['$btn-padding-x'], props.theme['$btn-active-box-shadow'], props.theme['$btn-padding-x-lg'], props.theme['$btn-padding-y-lg'], props.theme['$font-size-lg'], props.theme['$btn-border-radius-lg'], props.theme['$btn-padding-x-sm'], props.theme['$btn-padding-y-sm'], props.theme['$font-size-sm'], props.theme['$btn-border-radius-sm']), "\n  ");
});
Dropdown.defaultProps = defaultProps$c;
Dropdown.propTypes = propTypes$c;

var propTypes$d = {
  children: propTypes.node,
  isOpen: propTypes.bool.isRequired,
  toggle: propTypes.func.isRequired
};
var ButtonDropdown = function ButtonDropdown(props) {
  return React.createElement(Dropdown, _extends({}, props, {
    group: true
  }));
};
ButtonDropdown.propTypes = propTypes$d;

var defaultProps$d = {
  tag: 'div',
  role: 'group',
  theme: {
    '$input-btn-border-width': '1px',
    '$btn-padding-x': '1rem',
    '$btn-active-box-shadow': 'inset 0 3px 5px rgba(0, 0, 0, 0.125)',
    '$btn-padding-x-lg': '1.5rem',
    '$btn-padding-y-lg': '.75rem',
    '$font-size-lg': '1.25rem',
    '$btn-padding-x-sm': '.5rem',
    '$btn-padding-y-sm': '.25rem',
    '$font-size-sm': '.875rem',
    '$btn-border-radius-lg': '.3rem',
    '$btn-border-radius-sm': '.2rem',
    '$enable-rounded': true,
    '$enable-shadows': true
  }
};
var propTypes$e = {
  className: propTypes.string,
  tag: propTypes.any,
  theme: propTypes.shape({
    '$input-btn-border-width': propTypes.string,
    '$btn-padding-x': propTypes.string,
    '$btn-active-box-shadow': propTypes.string,
    '$btn-padding-x-lg': propTypes.string,
    '$btn-padding-y-lg': propTypes.string,
    '$font-size-lg': propTypes.string,
    '$btn-padding-x-sm': propTypes.string,
    '$btn-padding-y-sm': propTypes.string,
    '$font-size-sm': propTypes.string,
    '$btn-border-radius-lg': propTypes.string,
    '$btn-border-radius-sm': propTypes.string,
    '$enable-rounded': propTypes.bool,
    '$enable-shadows': propTypes.bool
  }),
  size: propTypes.oneOf(['sm', 'lg']),
  vertical: propTypes.bool,
  cssModule: propTypes.object
};
var ButtonGroupUnstyled =
function (_React$Component) {
  _inherits(ButtonGroupUnstyled, _React$Component);
  function ButtonGroupUnstyled() {
    _classCallCheck(this, ButtonGroupUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(ButtonGroupUnstyled).apply(this, arguments));
  }
  _createClass(ButtonGroupUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          size = _omit.size,
          vertical = _omit.vertical,
          Tag = _omit.tag,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "size", "vertical", "tag"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, vertical ? 'btn-group-vertical' : 'btn-group', _defineProperty({}, "btn-group-".concat(size), size)), cssModule)
      }, attributes));
    }
  }]);
  return ButtonGroupUnstyled;
}(React.Component);
_defineProperty(ButtonGroupUnstyled, "propTypes", {
  tag: propTypes.any,
  className: propTypes.string,
  cssModule: propTypes.object,
  size: propTypes.string,
  vertical: propTypes.bool,
  theme: propTypes.object
});
var ButtonGroup = styled(ButtonGroupUnstyled).withConfig({
  displayName: "ButtonGroup",
  componentId: "sc-1wk454k-0"
})(["", "  "], function (props) {
  return "\n    ".concat(buttonGroup_2(props.theme['$enable-shadows'], props.theme['$enable-rounded'], props.theme['$input-btn-border-width'], props.theme['$btn-padding-x'], props.theme['$btn-active-box-shadow'], props.theme['$btn-padding-x-lg'], props.theme['$btn-padding-y-lg'], props.theme['$font-size-lg'], props.theme['$btn-border-radius-lg'], props.theme['$btn-padding-x-sm'], props.theme['$btn-padding-y-sm'], props.theme['$font-size-sm'], props.theme['$btn-border-radius-sm']), "\n  ");
});
ButtonGroup.defaultProps = defaultProps$d;
ButtonGroup.propTypes = propTypes$e;

var defaultProps$e = {
  tag: 'div',
  role: 'toolbar',
  theme: {
    '$input-btn-border-width': '1px',
    '$btn-padding-x': '1rem',
    '$btn-active-box-shadow': 'inset 0 3px 5px rgba(0, 0, 0, 0.125)',
    '$btn-padding-x-lg': '1.5rem',
    '$btn-padding-y-lg': '.75rem',
    '$font-size-lg': '1.25rem',
    '$btn-padding-x-sm': '.5rem',
    '$btn-padding-y-sm': '.25rem',
    '$font-size-sm': '.875rem',
    '$btn-border-radius-lg': '.3rem',
    '$btn-border-radius-sm': '.2rem',
    '$enable-rounded': true,
    '$enable-shadows': true
  }
};
var propTypes$f = {
  className: propTypes.string,
  role: propTypes.string,
  tag: propTypes.any,
  theme: propTypes.shape({
    '$input-btn-border-width': propTypes.string,
    '$btn-padding-x': propTypes.string,
    '$btn-active-box-shadow': propTypes.string,
    '$btn-padding-x-lg': propTypes.string,
    '$btn-padding-y-lg': propTypes.string,
    '$font-size-lg': propTypes.string,
    '$btn-padding-x-sm': propTypes.string,
    '$btn-padding-y-sm': propTypes.string,
    '$font-size-sm': propTypes.string,
    '$btn-border-radius-lg': propTypes.string,
    '$btn-border-radius-sm': propTypes.string,
    '$enable-rounded': propTypes.bool,
    '$enable-shadows': propTypes.bool
  }),
  cssModule: propTypes.object
};
var ButtonToolbarUnstyled =
function (_React$Component) {
  _inherits(ButtonToolbarUnstyled, _React$Component);
  function ButtonToolbarUnstyled() {
    _classCallCheck(this, ButtonToolbarUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(ButtonToolbarUnstyled).apply(this, arguments));
  }
  _createClass(ButtonToolbarUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          Tag = _omit.tag,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "tag"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'btn-toolbar'), cssModule)
      }, attributes));
    }
  }]);
  return ButtonToolbarUnstyled;
}(React.Component);
_defineProperty(ButtonToolbarUnstyled, "propTypes", propTypes$f);
_defineProperty(ButtonToolbarUnstyled, "defaultProps", defaultProps$e);
var ButtonToolbar = styled(ButtonToolbarUnstyled).withConfig({
  displayName: "ButtonToolbar",
  componentId: "sc-12kivnc-0"
})(["", "  "], function (props) {
  return "\n    ".concat(buttonGroup_2(props.theme['$enable-shadows'], props.theme['$enable-rounded'], props.theme['$input-btn-border-width'], props.theme['$btn-padding-x'], props.theme['$btn-active-box-shadow'], props.theme['$btn-padding-x-lg'], props.theme['$btn-padding-y-lg'], props.theme['$font-size-lg'], props.theme['$btn-border-radius-lg'], props.theme['$btn-padding-x-sm'], props.theme['$btn-padding-y-sm'], props.theme['$font-size-sm'], props.theme['$btn-border-radius-sm']), "\n  ");
});
ButtonToolbar.defaultProps = defaultProps$e;
ButtonToolbar.propTypes = propTypes$f;

var defaultProps$f = {
  theme: {
    '$table-cell-padding': '.75rem',
    '$text-muted': '#636c72'
  }
};
var propTypes$g = {
  theme: propTypes.shape({
    '$table-cell-padding': propTypes.string,
    '$text-muted': propTypes.string
  })
};
var Caption = styled.caption.withConfig({
  displayName: "Caption",
  componentId: "sc-1miu1rz-0"
})(["", ""], function (props) {
  return "\n    padding-top: ".concat(props.theme['$table-cell-padding'], ";\n    padding-bottom: ").concat(props.theme['$table-cell-padding'], ";\n    color: ").concat(props.theme['$text-muted'], ";\n    text-align: left;\n    caption-side: top;\n  ");
});
Caption.defaultProps = defaultProps$f;
Caption.propTypes = propTypes$g;

var defaultProps$g = {
  tag: 'a',
  theme: {
    '$code-font-size': '90%',
    '$code-padding-x': '.4rem',
    '$code-padding-y': '.2rem',
    '$code-color': '#bd4147',
    '$code-bg': '#f7f7f9',
    '$enable-rounded': false
  }
};
var propTypes$h = {
  className: propTypes.string,
  tag: propTypes.any,
  theme: propTypes.shape({
    '$code-font-size': propTypes.string,
    '$code-padding-x': propTypes.string,
    '$code-padding-y': propTypes.string,
    '$code-color': propTypes.string,
    '$code-bg': propTypes.string,
    '$enable-rounded': propTypes.bool
  })
};
var CodeUnstyled =
function (_React$Component) {
  _inherits(CodeUnstyled, _React$Component);
  function CodeUnstyled() {
    _classCallCheck(this, CodeUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(CodeUnstyled).apply(this, arguments));
  }
  _createClass(CodeUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          children = _omit.children,
          Tag = _omit.tag,
          attributes = _objectWithoutProperties(_omit, ["className", "children", "tag"]);
      return React.createElement(Tag, _extends({
        className: className
      }, attributes), children);
    }
  }]);
  return CodeUnstyled;
}(React.Component);
_defineProperty(CodeUnstyled, "propTypes", propTypes$h);
_defineProperty(CodeUnstyled, "defaultProps", defaultProps$g);
var Code = styled(CodeUnstyled).withConfig({
  displayName: "Code",
  componentId: "sc-72e29r-0"
})(["", ""], function (props) {
  return "\n    /* Inline code */\n    padding: ".concat(props.theme['$code-padding-y'], " ").concat(props.theme['$code-padding-x'], ";\n    font-size: ").concat(props.theme['$code-font-size'], ";\n    color: ").concat(props.theme['$code-color'], ";\n    background-color: ").concat(props.theme['$code-bg'], ";\n    ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$border-radius']), ";\n    \n    /* Streamline the style when inside anchors to avoid broken underline and more */\n    a > & {\n      padding: 0;\n      color: inherit;\n      background-color: inherit;\n    }\n    \n    /* Bootstrap 4 does not place this css rule straight into Code tag see: bootstrap/scss/code.scss */\n    font-family: ").concat(props.theme['$font-family-monospace'], ";\n  ");
});
Code.defaultProps = defaultProps$g;
Code.propTypes = propTypes$h;

var breakpoints = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.breakpointNext = breakpointNext;
exports.breakpointMin = breakpointMin;
exports.breakpointMax = breakpointMax;
exports.breakpointInfix = breakpointInfix;
exports.mediaBreakpointUp = mediaBreakpointUp;
exports.mediaBreakpointDown = mediaBreakpointDown;
exports.mediaBreakpointBetween = mediaBreakpointBetween;
exports.mediaBreakpointOnly = mediaBreakpointOnly;
exports.default = exports.defaultProps = void 0;
var _unitUtils = _interopRequireDefault(unitUtils);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var defaultProps = {
  '$grid-breakpoints': {
    xs: '0',
    sm: '576px',
    md: '768px',
    lg: '992px',
    xl: '1200px'
  }
};
exports.defaultProps = defaultProps;
function breakpointNext(name) {
  var breakpoints = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$grid-breakpoints'];
  var breakpointNames = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : Object.keys(breakpoints);
  var n = breakpointNames.indexOf(name);
  if (n !== -1 && n + 1 < breakpointNames.length) {
    return breakpointNames[n + 1];
  }
  return null;
}
function breakpointMin(name) {
  var breakpoints = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$grid-breakpoints'];
  var min = breakpoints[name];
  return min !== '0' ? min : null;
}
function breakpointMax(name) {
  var breakpoints = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$grid-breakpoints'];
  var next = breakpointNext(name, breakpoints);
  if (next) {
    var min = _unitUtils.default.rmUnit(breakpointMin(next, breakpoints), _unitUtils.default.UNIT.PX);
    return (min - 1).toString() + _unitUtils.default.UNIT.PX;
  }
  return null;
}
function breakpointInfix(name) {
  var breakpoints = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$grid-breakpoints'];
  return !name || breakpointMin(name, breakpoints) === null ? '' : "-".concat(name);
}
function mediaBreakpointUp(name) {
  var breakpoints = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$grid-breakpoints'];
  var content = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  var min = breakpointMin(name, breakpoints);
  if (min) {
    return "\n      @media (min-width: ".concat(min, ") {\n        ").concat(content, "\n      }\n    ");
  }
  return content;
}
function mediaBreakpointDown(name) {
  var breakpoints = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$grid-breakpoints'];
  var content = arguments.length > 2 ? arguments[2] : undefined;
  var max = breakpointMax(name, breakpoints);
  if (max) {
    return "\n      @media (max-width: ".concat(max, ") {\n        ").concat(content, "\n      }\n    ");
  }
  return content;
}
function mediaBreakpointBetween(lower, upper) {
  var breakpoints = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$grid-breakpoints'];
  var content = arguments.length > 3 ? arguments[3] : undefined;
  var min = breakpointMin(lower, breakpoints);
  var max = breakpointMax(upper, breakpoints);
  if (min && max) {
    return "\n      @media (min-width: ".concat(min, ") and (max-width: ").concat(max, ") {\n        ").concat(content, "\n      }\n    ");
  } else if (min) {
    return "\n      @media (min-width: ".concat(min, ") {\n        ").concat(content, "\n      }\n    ");
  } else if (max) {
    return "\n      @media (max-width: ".concat(max, ") {\n        ").concat(content, "\n      }\n    ");
  }
  return content;
}
function mediaBreakpointOnly(name) {
  var breakpoints = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$grid-breakpoints'];
  var content = arguments.length > 2 ? arguments[2] : undefined;
  return mediaBreakpointBetween(name, name, breakpoints, content);
}
var _default = {
  defaultProps: defaultProps,
  up: mediaBreakpointUp,
  down: mediaBreakpointDown,
  between: mediaBreakpointBetween,
  only: mediaBreakpointOnly
};
exports.default = _default;
});
unwrapExports(breakpoints);
var breakpoints_1 = breakpoints.breakpointNext;
var breakpoints_2 = breakpoints.breakpointMin;
var breakpoints_3 = breakpoints.breakpointMax;
var breakpoints_4 = breakpoints.breakpointInfix;
var breakpoints_5 = breakpoints.mediaBreakpointUp;
var breakpoints_6 = breakpoints.mediaBreakpointDown;
var breakpoints_7 = breakpoints.mediaBreakpointBetween;
var breakpoints_8 = breakpoints.mediaBreakpointOnly;
var breakpoints_9 = breakpoints.defaultProps;

var grid = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeContainer = makeContainer;
exports.makeContainerMaxWidths = makeContainerMaxWidths;
exports.makeRow = makeRow;
exports.makeColReady = makeColReady;
exports.makeCol = makeCol;
exports.makeColOffset = makeColOffset;
exports.default = exports.defaultProps = void 0;
var _unitUtils = _interopRequireDefault(unitUtils);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var toPercent = _unitUtils.default.toPercent;
var defaultProps = {
  '$grid-gutter-width': '30px',
  '$container-max-widths': {
    sm: '540px',
    md: '720px',
    lg: '960px',
    xl: '1140px'
  },
  '$grid-breakpoints': {
    xs: '0',
    sm: '576px',
    md: '768px',
    lg: '992px',
    xl: '1200px'
  },
  '$grid-columns': 12,
  '$enable-grid-classes': true
};
exports.defaultProps = defaultProps;
function makeContainer() {
  var enableGridClasses = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-grid-classes'];
  var gridGutterWidth = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$grid-gutter-width'];
  return enableGridClasses ? "\n    width: 100%;\n    padding-right: calc(".concat(gridGutterWidth, " / 2);\n    padding-left: calc(").concat(gridGutterWidth, " / 2);\n    margin-right: auto;\n    margin-left: auto;\n  ") : '';
}
function makeContainerMaxWidths() {
  var enableGridClasses = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-grid-classes'];
  var maxWidths = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$container-max-widths'];
  var breakpoints$1 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$grid-breakpoints'];
  return enableGridClasses ? Object.keys(breakpoints$1).map(function (bp) {
    return maxWidths[bp] ? (0, breakpoints.mediaBreakpointUp)(bp, breakpoints$1, "max-width: ".concat(maxWidths[bp], ";")) : '';
  }).join('\n') : '';
}
function makeRow() {
  var enableGridClasses = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-grid-classes'];
  var gridGutterWidth = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$grid-gutter-width'];
  return enableGridClasses ? "\n    display: flex;\n    flex-wrap: wrap;\n    margin-right: calc(".concat(gridGutterWidth, " / -2);\n    margin-left: calc(").concat(gridGutterWidth, " / -2);\n  ") : '';
}
function makeColReady() {
  var gridGutterWidth = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$grid-gutter-width'];
  return "\n    position: relative;\n    width: 100%;\n    min-height: 1px; // Prevent collapsing\n    padding-right: calc(".concat(gridGutterWidth, " / 2);\n    padding-left: calc(").concat(gridGutterWidth, " / 2);\n  ");
}
function makeCol() {
  var size = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  var columns = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$grid-columns'];
  return "\n    flex: 0 0 ".concat(toPercent(size, columns), ";\n    max-width: ").concat(toPercent(size, columns), ";\n  ");
}
function makeColOffset() {
  var size = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  var columns = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$grid-columns'];
  return "margin-left: ".concat(toPercent(size, columns), ";");
}
var _default = {
  makeRow: makeRow,
  makeContainer: makeContainer,
  makeContainerMaxWidths: makeContainerMaxWidths
};
exports.default = _default;
});
unwrapExports(grid);
var grid_1 = grid.makeContainer;
var grid_2 = grid.makeContainerMaxWidths;
var grid_3 = grid.makeRow;
var grid_4 = grid.makeColReady;
var grid_5 = grid.makeCol;
var grid_6 = grid.makeColOffset;
var grid_7 = grid.defaultProps;

var gridFramework = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeGridColumns = makeGridColumns;
exports.default = void 0;
function makeGridColumns() {
  var enableGridClasses = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : grid.defaultProps['$enable-grid-classes'];
  var columns = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : grid.defaultProps['$grid-columns'];
  var gutter = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : grid.defaultProps['$grid-gutter-width'];
  var breakpoints$1 = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : grid.defaultProps['$grid-breakpoints'];
  var gridColumn = "\n    position: relative;\n    width: 100%;\n    min-height: 1px; // Prevent columns from collapsing when empty\n    padding-right: calc(".concat(gutter, " / 2);\n    padding-left: calc(").concat(gutter, " / 2);\n  ");
  return enableGridClasses ? Object.keys(breakpoints$1).map(function (bp) {
    var infix = (0, breakpoints.breakpointInfix)(bp, breakpoints$1);
    return "".concat(Array.from({
      length: columns
    }, function (_, ind) {
      var i = ind + 1;
      return "&.col".concat(infix, "-").concat(i, ", & .col").concat(infix, "-").concat(i, " { ").concat(gridColumn, " }");
    }).join('\n'), "\n      \n      &.col").concat(infix, ",\n      & .col").concat(infix, "-auto {\n        ").concat(gridColumn, "\n      }\n      \n").concat(
    (0, breakpoints.mediaBreakpointUp)(bp, breakpoints$1, "\n        &.col".concat(infix, ",\n        & .col").concat(infix, " {\n          flex-basis: 0;\n          flex-grow: 1;\n          max-width: 100%;\n        }\n        &.col").concat(infix, "-auto,\n        & .col").concat(infix, "-auto {\n          flex: 0 0 auto;\n          width: auto;\n          max-width: none; // reset earlier grid tiers\n        }\n        \n        ").concat(Array.from({
      length: columns
    }, function (_, i) {
      return "\n          &.col".concat(infix, "-").concat(i + 1, ",\n          & .col").concat(infix, "-").concat(i + 1, " {\n            ").concat((0, grid.makeCol)(i + 1, columns), "\n          }\n        ");
    }), "\n        \n        &.order").concat(infix, "-first,\n        & .order").concat(infix, "-first { order: -1; }\n        \n        &.order").concat(infix, "-last,\n        & .order").concat(infix, "-last { order: ").concat(columns + 1, "; }\n        \n        ").concat(Array.from({
      length: columns
    }, function (_, i) {
      return "\n          &.order".concat(infix, "-").concat(i, ",\n          & .order").concat(infix, "-").concat(i, " { \n            order: ").concat(i, "; \n          }\n        ");
    }).join('\n'), "\n        \n        ").concat(
    Array.from({
      length: columns - 1
    }, function (_, i) {
      return "\n          &.offset".concat(infix, "-").concat(i, ",\n          & .offset").concat(infix, "-").concat(i, " {\n            ").concat((0, grid.makeColOffset)(i, columns), "\n          }\n        ");
    }).join('\n'), "\n      ")), "\n");
  }).join('\n') : '';
}
var _default = {
  makeGridColumns: makeGridColumns
};
exports.default = _default;
});
unwrapExports(gridFramework);
var gridFramework_1 = gridFramework.makeGridColumns;

var colWidths = ['xs', 'sm', 'md', 'lg', 'xl'];
var stringOrNumberProp = propTypes.oneOfType([propTypes.number, propTypes.string]);
var columnProps = propTypes.oneOfType([propTypes.bool, propTypes.number, propTypes.string, propTypes.shape({
  size: propTypes.oneOfType([propTypes.bool, propTypes.number, propTypes.string]),
  push: stringOrNumberProp,
  pull: stringOrNumberProp,
  offset: stringOrNumberProp
})]);
var getColumnSizeClass = function getColumnSizeClass(isXs, colWidth, colSize) {
  if (colSize === true || colSize === '') {
    return isXs ? '' : "col-".concat(colWidth);
  } else if (colSize === 'auto') {
    return isXs ? 'col-auto' : "col-".concat(colWidth, "-auto");
  }
  return isXs ? "col-".concat(colSize) : "col-".concat(colWidth, "-").concat(colSize);
};
var defaultProps$h = {
  tag: 'div',
  widths: colWidths,
  theme: {
    '$enable-grid-classes': true,
    '$grid-breakpoints': {
      xs: '0',
      sm: '576px',
      md: '768px',
      lg: '992px',
      xl: '1200px'
    },
    '$grid-columns': '12',
    '$grid-gutter-width': '30px'
  }
};
var propTypes$i = {
  className: propTypes.string,
  tag: propTypes.any,
  xs: columnProps,
  sm: columnProps,
  md: columnProps,
  lg: columnProps,
  xl: columnProps,
  widths: propTypes.array,
  theme: propTypes.shape({}),
  cssModule: propTypes.object
};
var ColUnstyled =
function (_React$Component) {
  _inherits(ColUnstyled, _React$Component);
  function ColUnstyled() {
    _classCallCheck(this, ColUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(ColUnstyled).apply(this, arguments));
  }
  _createClass(ColUnstyled, [{
    key: "render",
    value: function render() {
      var _this = this;
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          widths = _omit.widths,
          Tag = _omit.tag,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "widths", "tag"]);
      var colClasses = [];
      widths.forEach(function (colWidth) {
        var columnProp = _this.props[colWidth];
        var isXs = colWidth === 'xs';
        if (isXs && columnProp === undefined) {
          columnProp = true;
        }
        delete attributes[colWidth];
        if (!columnProp) {
          return;
        }
        var colClass;
        if (_typeof(columnProp) === 'object') {
          var _cn;
          var colSizeInterfix = isXs ? '-' : "-".concat(colWidth, "-");
          colClass = getColumnSizeClass(isXs, colWidth, columnProp.size);
          colClasses.push(mapToCssModules(classnames((_cn = {}, _defineProperty(_cn, colClass, columnProp.size || columnProp.size === ''), _defineProperty(_cn, "push".concat(colSizeInterfix).concat(columnProp.push), columnProp.push), _defineProperty(_cn, "pull".concat(colSizeInterfix).concat(columnProp.pull), columnProp.pull), _defineProperty(_cn, "offset".concat(colSizeInterfix).concat(columnProp.offset), columnProp.offset), _cn))), cssModule);
        } else {
          colClass = getColumnSizeClass(isXs, colWidth, columnProp);
          colClasses.push(colClass);
        }
      });
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, colClasses, {
          col: colWidths.filter(function (w) {
            return _this.props[w];
          }).length === 0
        }), cssModule)
      }, attributes));
    }
  }]);
  return ColUnstyled;
}(React.Component);
_defineProperty(ColUnstyled, "propTypes", propTypes$i);
_defineProperty(ColUnstyled, "defaultProps", defaultProps$h);
var Col = styled(ColUnstyled).withConfig({
  displayName: "Col",
  componentId: "sc-14ninbu-0"
})(["", ""], function (props) {
  return "\n    ".concat(gridFramework_1(props.theme['$enable-grid-classes'], props.theme['$grid-columns'], props.theme['$grid-gutter-width'], props.theme['$grid-breakpoints']), "\n  ");
});
Col.defaultProps = defaultProps$h;
Col.propTypes = propTypes$i;

var parseTransition_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var parseTransition = function parseTransition(transitions) {
  if (!transitions) {
    return [];
  }
  var sample = transitions;
  var RULE_DELIMITER = ',';
  var PROPERTY_DELIMITER = ' ';
  var MS_UNIT = 'ms';
  var TMP_STR = 'TMP';
  var DEFAULT_PROPERTY = 'all';
  var DEFAULT_DURATION = 0;
  var DEFAULT_TIMING_FUNCTION = 'ease';
  var DEFAULT_DELAY = 0;
  var BEZIER_REGEX = /cubic-bezier\([^\)]+\)/gi;
  var cubicBezierList = transitions.match(BEZIER_REGEX);
  if (cubicBezierList) {
    sample = sample.replace(BEZIER_REGEX, TMP_STR);
  }
  var transitionList = sample.split(RULE_DELIMITER).map(function (rule) {
    var properties = rule.trim().split(PROPERTY_DELIMITER);
    return {
      property: properties[0] || DEFAULT_PROPERTY,
      duration: properties[1] && !(properties[1].indexOf(MS_UNIT) !== -1) ? parseFloat(properties[1]) * 1000 : parseFloat(properties[1]) || DEFAULT_DURATION,
      timingFunction: properties[2] && properties[2] !== TMP_STR ? properties[2] : cubicBezierList ? cubicBezierList.shift() : DEFAULT_TIMING_FUNCTION,
      delay: properties[3] && !(properties[3].indexOf(MS_UNIT) !== -1) ? parseFloat(properties[3]) * 1000 : parseFloat(properties[3]) || DEFAULT_DELAY
    };
  });
  return transitionList;
};
var _default = parseTransition;
exports.default = _default;
module.exports = exports.default;
});
var parseTransition = unwrapExports(parseTransition_1);

var SHOW = 'SHOW';
var SHOWN = 'SHOWN';
var HIDE = 'HIDE';
var HIDDEN = 'HIDDEN';
var Collapse =
function (_Component) {
  _inherits(Collapse, _Component);
  function Collapse() {
    var _getPrototypeOf2;
    var _this;
    _classCallCheck(this, Collapse);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Collapse)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _defineProperty(_assertThisInitialized(_this), "state", {
      collapse: HIDDEN,
      height: null
    });
    _defineProperty(_assertThisInitialized(_this), "element", null);
    return _this;
  }
  _createClass(Collapse, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      this.updateVisibility({
        collapse: this.props.isOpen ? SHOWN : HIDDEN
      });
      this.updateTransition({
        delay: this.props.delay,
        theme: this.props.theme
      });
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;
      var willOpen = nextProps.isOpen;
      var collapse = this.state.collapse;
      if (willOpen && collapse === HIDDEN) {
        this.setState({
          collapse: SHOW
        }, function () {
          _this2.setState({
            height: _this2.getHeight()
          });
          _this2.transitionTag = setTimeout(function () {
            _this2.setState({
              collapse: SHOWN,
              height: null
            });
          }, _this2.getDelay('show'));
        });
      } else if (!willOpen && collapse === SHOWN) {
        this.setState({
          height: this.getHeight()
        }, function () {
          _this2.setState({
            collapse: HIDE,
            height: _this2.getHeight()
          }, function () {
            _this2.setState({
              height: 0
            });
          });
        });
        this.transitionTag = setTimeout(function () {
          _this2.setState({
            collapse: HIDDEN,
            height: null
          });
        }, this.getDelay('hide'));
      }
      if (nextProps.theme['$transition-collapse'] !== this.props.theme['$transition-collapse'] || nextProps.delay.show !== this.props.delay.show || nextProps.delay.hide !== this.props.delay.hide) {
        this.updateTransition({
          delay: nextProps.delay,
          theme: nextProps.theme
        });
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      if (this.state.collapse === SHOWN && prevState && prevState.collapse !== SHOWN) {
        if (this.props.onOpened) {
          this.props.onOpened();
        }
      }
      if (this.state.collapse === HIDDEN && prevState && prevState.collapse !== HIDDEN) {
        if (this.props.onClosed) {
          this.props.onClosed();
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.transitionTag);
    }
  }, {
    key: "getDelay",
    value: function getDelay(key) {
      var delay = this.state.delay;
      if (_typeof(delay) === 'object') {
        return delay[key];
      }
      return delay;
    }
  }, {
    key: "getHeight",
    value: function getHeight() {
      return this.element.scrollHeight;
    }
  }, {
    key: "updateTransition",
    value: function updateTransition(_ref) {
      var delay = _ref.delay,
          theme = _ref.theme;
      var transition = parseTransition(theme['$transition-collapse'])[0];
      var newDelay = {
        show: delay.show !== undefined ? delay.show : transition.duration,
        hide: delay.hide !== undefined ? delay.hide : transition.duration
      };
      if (_typeof(delay) !== 'object' && delay !== undefined) {
        newDelay = {
          show: delay,
          hide: delay
        };
      }
      this.setState({
        delay: newDelay
      });
    }
  }, {
    key: "updateVisibility",
    value: function updateVisibility(_ref2) {
      var collapse = _ref2.collapse;
      this.setState({
        collapse: collapse
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _omit = lodash_omit(this.props, ['isOpen', 'theme', 'delay', 'onOpened', 'onClosed']),
          navbar = _omit.navbar,
          className = _omit.className,
          cssModule = _omit.cssModule,
          Tag = _omit.tag,
          attributes = _objectWithoutProperties(_omit, ["navbar", "className", "cssModule", "tag"]);
      var _this$state = this.state,
          collapse = _this$state.collapse,
          height = _this$state.height;
      var collapseClass;
      if (collapse === SHOW || collapse === HIDE) {
        collapseClass = 'collapsing';
      } else if (collapse === SHOWN) {
        collapseClass = 'collapse show';
      } else if (collapse === HIDDEN) {
        collapseClass = 'collapse';
      }
      var classes = mapToCssModules(classnames(className, collapseClass, navbar && 'navbar-collapse'), cssModule);
      var style = height === null ? null : {
        height: height
      };
      return React.createElement(Tag, _extends({}, attributes, {
        style: _objectSpread({}, attributes.style, style),
        className: classes,
        ref: function ref(c) {
          _this3.element = c;
        }
      }));
    }
  }]);
  return Collapse;
}(Component);
_defineProperty(Collapse, "propTypes", {
  className: propTypes.string,
  tag: propTypes.any,
  delay: propTypes.oneOfType([propTypes.shape({
    show: propTypes.number,
    hide: propTypes.number
  }), propTypes.number]),
  isOpen: propTypes.bool,
  navbar: propTypes.bool,
  onOpened: propTypes.func,
  onClosed: propTypes.func,
  theme: propTypes.shape({
    '$transition-collapse': propTypes.string
  }),
  cssModule: propTypes.object
});
_defineProperty(Collapse, "defaultProps", {
  isOpen: false,
  theme: {
    '$transition-collapse': 'height .35s ease'
  },
  tag: 'div',
  delay: {
    show: 350,
    hide: 350
  },
  onOpened: null,
  onClosed: null
});

var defaultProps$i = {
  theme: {
    '$grid-columns': '12',
    '$grid-gutter-width': '30px',
    '$grid-breakpoints': {
      xs: '0',
      sm: '576px',
      md: '768px',
      lg: '992px',
      xl: '1200px'
    },
    '$enable-grid-classes': true
  }
};
var propTypes$j = {
  theme: propTypes.shape({
    '$grid-columns': propTypes.string,
    '$grid-gutter-width': propTypes.string,
    '$grid-breakpoints': propTypes.object,
    '$enable-grid-classes': propTypes.bool
  })
};
var Dd = styled.dd.withConfig({
  displayName: "Dd",
  componentId: "sc-1b1ksu8-0"
})(["  margin-bottom:.5rem;margin-left:0;", ""], function (props) {
  return "\n    ".concat(gridFramework_1(props.theme['$enable-grid-classes'], props.theme['$grid-columns'], props.theme['$grid-gutter-width'], props.theme['$grid-breakpoints']), "\n  ");
});
Dd.defaultProps = defaultProps$i;
Dd.propTypes = propTypes$j;

var Dfn = styled.dfn.withConfig({
  displayName: "Dfn",
  componentId: "sc-10t3p5i-0"
})(["font-style:italic;"]);

var Details = function Details(props) {
  return React.createElement("details", props);
};

var defaultProps$j = {
  theme: {
    '$grid-gutter-width': '30px',
    '$enable-grid-classes': true
  }
};
var propTypes$k = {
  theme: propTypes.shape({
    '$grid-gutter-width': propTypes.string,
    '$enable-grid-classes': propTypes.bool
  })
};
var Dl = styled.dl.withConfig({
  displayName: "Dl",
  componentId: "cr4d3a-0"
})(["  margin-top:0;margin-bottom:1rem;", ""], function (props) {
  return "\n    ".concat(grid_3(props.theme['$enable-grid-classes'], props.theme['$grid-gutter-width']), "\n  ");
});
Dl.defaultProps = defaultProps$j;
Dl.propTypes = propTypes$k;

var defaultProps$k = {
  active: false,
  theme: {
    '$enable-rounded': true,
    '$enable-shadows': true,
    $white: '#fff',
    '$drawer-bg': '#fff',
    '$drawer-transition': 'transform 450ms cubic-bezier(0.23, 1, 0.32, 1) 0ms',
    '$drawer-box-shadow': 'rgba(0, 0, 0, 0.16) 0px 3px 10px, rgba(0, 0, 0, 0.23) 0px 3px 10px',
    '$drawer-border-radius': '0px',
    '$drawer-zindex': '1030',
    '$drawer-docked-width': '55px'
  }
};
var propTypes$l = {
  className: propTypes.string,
  active: propTypes.bool,
  top: propTypes.string,
  right: propTypes.string,
  bottom: propTypes.string,
  left: propTypes.string,
  docked: propTypes.bool,
  theme: propTypes.shape({
    '$enable-rounded': propTypes.bool,
    '$enable-shadows': propTypes.bool,
    '$drawer-bg': propTypes.string,
    '$drawer-transition': propTypes.string,
    '$drawer-box-shadow': propTypes.string,
    '$drawer-border-radius': propTypes.string,
    '$drawer-zindex': propTypes.string,
    '$drawer-docked-width': propTypes.string
  }),
  cssModule: propTypes.object
};
var DrawerUnstyled =
function (_React$Component) {
  _inherits(DrawerUnstyled, _React$Component);
  function DrawerUnstyled() {
    _classCallCheck(this, DrawerUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(DrawerUnstyled).apply(this, arguments));
  }
  _createClass(DrawerUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          active = _omit.active,
          top = _omit.top,
          right = _omit.right,
          bottom = _omit.bottom,
          left = _omit.left,
          docked = _omit.docked,
          cssModule = _omit.cssModule,
          props = _objectWithoutProperties(_omit, ["className", "active", "top", "right", "bottom", "left", "docked", "cssModule"]);
      var classes = mapToCssModules(classnames(className, !docked ? 'drawer' : 'drawer-docked', {
        active: active,
        'drawer-top': top,
        'drawer-right': right,
        'drawer-bottom': bottom,
        'drawer-left': left
      }, cssModule));
      return React.createElement("div", _extends({
        className: classes
      }, props));
    }
  }]);
  return DrawerUnstyled;
}(React.Component);
_defineProperty(DrawerUnstyled, "propTypes", propTypes$l);
_defineProperty(DrawerUnstyled, "defaultProps", defaultProps$k);
var Drawer = styled(DrawerUnstyled).withConfig({
  displayName: "Drawer",
  componentId: "rffq8f-0"
})(["", ""], function (props) {
  return "\n    &.drawer {\n      background-color: ".concat(props.theme['$drawer-bg'], ";\n      transition: ").concat(props.theme['$drawer-transition'], ";\n      position: fixed;\n      flex: 1 0 auto;\n      z-index: ").concat(props.theme['$drawer-zindex'], ";\n      overflow-y: auto;\n      outline: none;\n      ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$drawer-border-radius']), "\n      ").concat(boxShadow_2(props.theme['$enable-shadows'], props.theme['$drawer-box-shadow']), "\n      &.drawer-top {\n        ").concat(conditional_1(props.top, "\n            left: 0;\n            top: 0;\n            width: 100%;\n            height: ".concat(props.top, ";\n            transform: translate(0px, -").concat(props.top && unitUtils$1.math.addition(props.top, 4), ");\n            &.active {\n              transform: translate(0px, 0px);\n            }\n          ")), "\n      }\n      &.drawer-right {\n        ").concat(conditional_1(props.right, "\n            bottom: 0;\n            right: 0;\n            height: 100%;\n            width: ".concat(props.right, ";\n            transform: translate(").concat(props.right && unitUtils$1.math.addition(props.right, 4), ", 0px);\n            &.active {\n              transform: translate(0px, 0px);\n            }\n          ")), "\n      }\n      &.drawer-bottom {\n        ").concat(conditional_1(props.bottom, "\n            left: 0;\n            bottom: 0;\n            width: 100%;\n            height: ".concat(props.bottom, ";\n            transform: translate(0px, ").concat(props.bottom && unitUtils$1.math.addition(props.bottom, 4), ");\n            &.active {\n              transform: translate(0px, 0px);\n            }\n          ")), "\n      }\n      &.drawer-left {\n        ").concat(conditional_1(props.left, "\n            bottom: 0;\n            left: 0;\n            height: 100%;\n            width: ".concat(props.left, ";\n            transform: translate(-").concat(props.left && unitUtils$1.math.addition(props.left, 4), ", 0px);\n            &.active {\n              transform: translate(0px, 0px);\n            }\n          ")), "\n      }\n    }\n    &.drawer-docked { \n      flex: 0 0 auto;\n      overflow: hidden;\n      background-color: ").concat(props.theme['$drawer-bg'], ";\n      &.drawer-left {\n        ").concat(conditional_1(props.left, "\n          width: ".concat(props.theme['$drawer-docked-width'], ";\n          transition: width 195ms cubic-bezier(0.4, 0, 0.6, 1) 0ms;\n          &.active {\n            width: ").concat(props.left, ";\n          }\n          ")), "\n      }\n    }\n  ");
});
Drawer.propTypes = propTypes$l;
Drawer.defaultProps = defaultProps$k;

var defaultProps$l = {
  theme: {
    '$grid-columns': '12',
    '$grid-gutter-width': '30px',
    '$grid-breakpoints': {
      xs: '0',
      sm: '576px',
      md: '768px',
      lg: '992px',
      xl: '1200px'
    },
    '$enable-grid-classes': true
  }
};
var propTypes$m = {
  theme: propTypes.shape({
    '$grid-columns': propTypes.string,
    '$grid-gutter-width': propTypes.string,
    '$grid-breakpoints': propTypes.object,
    '$enable-grid-classes': propTypes.bool
  })
};
var Dt = styled.dt.withConfig({
  displayName: "Dt",
  componentId: "sc-5rnls5-0"
})(["  ", ""], function (props) {
  return "\n    /* Reboot Scss */\n    font-weight: ".concat(props.theme['$dt-font-weight'], ";\n    ").concat(gridFramework_1(props.theme['$enable-grid-classes'], props.theme['$grid-columns'], props.theme['$grid-gutter-width'], props.theme['$grid-breakpoints']), "\n  ");
});
Dt.defaultProps = defaultProps$l;
Dt.propTypes = propTypes$m;

var defaultProps$m = {
  theme: {
    '$grid-gutter-width': '30px',
    '$enable-grid-classes': true
  }
};
var propTypes$n = {
  theme: propTypes.shape({
    '$grid-gutter-width': propTypes.string,
    '$enable-grid-classes': propTypes.bool
  })
};
var Fieldset = styled.fieldset.withConfig({
  displayName: "Fieldset",
  componentId: "sc-7vwzmh-0"
})(["", ""], function (props) {
  return "\n    min-width: 0;\n    padding: 0;\n    margin: 0;\n    border: 0;\n\n    & .row {\n      ".concat(grid_3(props.theme['$enable-grid-classes'], props.theme['$grid-gutter-width']), "\n    }\n\n  ");
});
Fieldset.defaultProps = defaultProps$m;
Fieldset.propTypes = propTypes$n;

var Footer = function Footer(props) {
  return React.createElement("footer", props);
};

var typography_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.typography = typography;
exports.default = exports.defaultProps = void 0;
var defaultProps = {
  '$headings-margin-bottom': '0.5rem',
  '$headings-font-family': 'inherit',
  '$headings-font-weight': '500',
  '$headings-line-height': '1.1',
  '$headings-color': 'inherit',
  '$display1-size': '6rem',
  '$display2-size': '5.5rem',
  '$display3-size': '4.5rem',
  '$display4-size': '3.5rem',
  '$display1-weight': '300',
  '$display2-weight': '300',
  '$display3-weight': '300',
  '$display4-weight': '300'
};
exports.defaultProps = defaultProps;
function typography() {
  var $headingsMarginBottom = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$headings-margin-bottom'];
  var $headingsFontFamily = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$headings-font-family'];
  var $headingsFontWeight = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$headings-font-weight'];
  var $headingsLineHeight = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : defaultProps['$headings-line-height'];
  var $headingsColor = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : defaultProps['$headings-color'];
  var $display1Size = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : defaultProps['$display1-size'];
  var $display2Size = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : defaultProps['$display2-size'];
  var $display3Size = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : defaultProps['$display3-size'];
  var $display4Size = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : defaultProps['$display4-size'];
  var $display1Weight = arguments.length > 9 && arguments[9] !== undefined ? arguments[9] : defaultProps['$display1-weight'];
  var $display2Weight = arguments.length > 10 && arguments[10] !== undefined ? arguments[10] : defaultProps['$display2-weight'];
  var $display3Weight = arguments.length > 11 && arguments[11] !== undefined ? arguments[11] : defaultProps['$display3-weight'];
  var $display4Weight = arguments.length > 12 && arguments[12] !== undefined ? arguments[12] : defaultProps['$display4-weight'];
  return "\n    margin-bottom: ".concat($headingsMarginBottom, ";\n    font-family: ").concat($headingsFontFamily, ";\n    font-weight: ").concat($headingsFontWeight, ";\n    line-height: ").concat($headingsLineHeight, ";\n    color: ").concat($headingsColor, ";\n    \n    /* Type Scss */\n\n    &.display-1 {\n      font-size: ").concat($display1Size, ";\n      font-weight: ").concat($display1Weight, ";\n      line-height: ").concat($headingsLineHeight, ";\n\n    }\n    \n    &.display-2 {\n      font-size: ").concat($display2Size, ";\n      font-weight: ").concat($display2Weight, ";\n      line-height: ").concat($headingsLineHeight, ";\n    }\n    \n    &.display-3 {\n      font-size: ").concat($display3Size, ";\n      font-weight: ").concat($display3Weight, ";\n      line-height: ").concat($headingsLineHeight, ";\n    }\n    \n    &.display-4 {\n      font-size: ").concat($display4Size, ";\n      font-weight: ").concat($display4Weight, ";\n        line-height: ").concat($headingsLineHeight, ";\n    }\n  ");
}
var _default = {
  defaultProps: defaultProps,
  typography: typography
};
exports.default = _default;
});
unwrapExports(typography_1);
var typography_2 = typography_1.typography;
var typography_3 = typography_1.defaultProps;

var defaultProps$n = {
  theme: {
    '$font-size-h1': '2.5rem',
    '$headings-margin-bottom': '0.5rem',
    '$headings-font-family': 'inherit',
    '$headings-font-weight': '500',
    '$headings-line-height': '1.1',
    '$headings-color': 'inherit',
    '$display1-size': '6rem',
    '$display2-size': '5.5rem',
    '$display3-size': '4.5rem',
    '$display4-size': '3.5rem',
    '$display1-weight': '300',
    '$display2-weight': '300',
    '$display3-weight': '300',
    '$display4-weight': '300',
    '$lead-font-size': '1.25rem',
    '$lead-font-weight': '300'
  }
};
var propTypes$o = {
  className: propTypes.string,
  theme: propTypes.shape({
    '$link-color': propTypes.string,
    '$font-size-h1': propTypes.string,
    '$headings-margin-bottom': propTypes.string,
    '$headings-font-family': propTypes.string,
    '$headings-font-weight': propTypes.string,
    '$headings-line-height': propTypes.string,
    '$headings-color': propTypes.string,
    '$display1-size': propTypes.string,
    '$display2-size': propTypes.string,
    '$display3-size': propTypes.string,
    '$display4-size': propTypes.string,
    '$display1-weight': propTypes.string,
    '$display2-weight': propTypes.string,
    '$display3-weight': propTypes.string,
    '$display4-weight': propTypes.string,
    '$lead-font-size': propTypes.string,
    '$lead-font-weight': propTypes.string
  }),
  color: propTypes.oneOf(['white', 'muted', 'gray-dark', 'primary', 'success', 'info', 'warning', 'danger']),
  lead: propTypes.bool,
  cssModule: propTypes.object
};
var H1Unstyled =
function (_React$Component) {
  _inherits(H1Unstyled, _React$Component);
  function H1Unstyled() {
    _classCallCheck(this, H1Unstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(H1Unstyled).apply(this, arguments));
  }
  _createClass(H1Unstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          color = _omit.color,
          children = _omit.children,
          cssModule = _omit.cssModule,
          lead = _omit.lead,
          attributes = _objectWithoutProperties(_omit, ["className", "color", "children", "cssModule", "lead"]);
      var classes = mapToCssModules(classnames(className, lead ? 'lead' : false, color ? "text-".concat(color) : false), cssModule);
      return React.createElement("h1", _extends({
        className: classes
      }, attributes), children);
    }
  }]);
  return H1Unstyled;
}(React.Component);
_defineProperty(H1Unstyled, "propTypes", propTypes$o);
_defineProperty(H1Unstyled, "defaultProps", defaultProps$n);
var H1 = styled(H1Unstyled).withConfig({
  displayName: "H1",
  componentId: "xsrgru-0"
})(["", ""], function (props) {
  return "\n    font-size: ".concat(props.theme['$font-size-h1'], ";\n    ").concat(typography_2(props.theme['$headings-margin-bottom'], props.theme['$headings-font-family'], props.theme['$headings-font-weight'], props.theme['$headings-line-height'], props.theme['$headings-color'], props.theme['$display1-size'], props.theme['$display2-size'], props.theme['$display3-size'], props.theme['$display4-size'], props.theme['$display1-weight'], props.theme['$display2-weight'], props.theme['$display3-weight'], props.theme['$display4-weight']), "\n\n    &.lead {\n      font-size: ").concat(props.theme['$lead-font-size'], ";\n      font-weight: ").concat(props.theme['$lead-font-weight'], ";\n    }\n\n    /* Reboot Scss */\n    margin-top: 0;\n  ");
});
H1.defaultProps = defaultProps$n;
H1.propTypes = propTypes$o;

var defaultProps$o = {
  theme: {
    '$font-size-h2': '2rem',
    '$headings-margin-bottom': '0.5rem',
    '$headings-font-family': 'inherit',
    '$headings-font-weight': '500',
    '$headings-line-height': '1.1',
    '$headings-color': 'inherit',
    '$display1-size': '6rem',
    '$display2-size': '5.5rem',
    '$display3-size': '4.5rem',
    '$display4-size': '3.5rem',
    '$display1-weight': '300',
    '$display2-weight': '300',
    '$display3-weight': '300',
    '$display4-weight': '300',
    '$lead-font-size': '1.25rem',
    '$lead-font-weight': '300'
  }
};
var propTypes$p = {
  className: propTypes.string,
  theme: propTypes.shape({
    '$link-color': propTypes.string,
    '$font-size-h2': propTypes.string,
    '$headings-margin-bottom': propTypes.string,
    '$headings-font-family': propTypes.string,
    '$headings-font-weight': propTypes.string,
    '$headings-line-height': propTypes.string,
    '$headings-color': propTypes.string,
    '$display1-size': propTypes.string,
    '$display2-size': propTypes.string,
    '$display3-size': propTypes.string,
    '$display4-size': propTypes.string,
    '$display1-weight': propTypes.string,
    '$display2-weight': propTypes.string,
    '$display3-weight': propTypes.string,
    '$display4-weight': propTypes.string,
    '$lead-font-size': propTypes.string,
    '$lead-font-weight': propTypes.string
  }),
  color: propTypes.oneOf(['white', 'muted', 'gray-dark', 'primary', 'success', 'info', 'warning', 'danger']),
  lead: propTypes.bool,
  cssModule: propTypes.object
};
var H2Unstyled =
function (_React$Component) {
  _inherits(H2Unstyled, _React$Component);
  function H2Unstyled() {
    _classCallCheck(this, H2Unstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(H2Unstyled).apply(this, arguments));
  }
  _createClass(H2Unstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          color = _omit.color,
          children = _omit.children,
          cssModule = _omit.cssModule,
          lead = _omit.lead,
          attributes = _objectWithoutProperties(_omit, ["className", "color", "children", "cssModule", "lead"]);
      var classes = mapToCssModules(classnames(className, lead ? 'lead' : false, color ? "text-".concat(color) : false), cssModule);
      return React.createElement("h2", _extends({
        className: classes
      }, attributes), children);
    }
  }]);
  return H2Unstyled;
}(React.Component);
_defineProperty(H2Unstyled, "propTypes", propTypes$p);
_defineProperty(H2Unstyled, "defaultProps", defaultProps$o);
var H2 = styled(H2Unstyled).withConfig({
  displayName: "H2",
  componentId: "kplljn-0"
})(["", ""], function (props) {
  return "\n\n    font-size: ".concat(props.theme['$font-size-h2'], ";\n    ").concat(typography_2(props.theme['$headings-margin-bottom'], props.theme['$headings-font-family'], props.theme['$headings-font-weight'], props.theme['$headings-line-height'], props.theme['$headings-color'], props.theme['$display1-size'], props.theme['$display2-size'], props.theme['$display3-size'], props.theme['$display4-size'], props.theme['$display1-weight'], props.theme['$display2-weight'], props.theme['$display3-weight'], props.theme['$display4-weight']), "\n\n    &.lead {\n      font-size: ").concat(props.theme['$lead-font-size'], ";\n      font-weight: ").concat(props.theme['$lead-font-weight'], ";\n    }\n\n    /* Reboot Scss */\n    margin-top: 0;\n  ");
});
H2.defaultProps = defaultProps$o;
H2.propTypes = propTypes$p;

var defaultProps$p = {
  theme: {
    '$font-size-h3': '1.75rem',
    '$headings-margin-bottom': '0.5rem',
    '$headings-font-family': 'inherit',
    '$headings-font-weight': '500',
    '$headings-line-height': '1.1',
    '$headings-color': 'inherit',
    '$display1-size': '6rem',
    '$display2-size': '5.5rem',
    '$display3-size': '4.5rem',
    '$display4-size': '3.5rem',
    '$display1-weight': '300',
    '$display2-weight': '300',
    '$display3-weight': '300',
    '$display4-weight': '300',
    '$lead-font-size': '1.25rem',
    '$lead-font-weight': '300'
  }
};
var propTypes$q = {
  className: propTypes.string,
  theme: propTypes.shape({
    '$link-color': propTypes.string,
    '$font-size-h3': propTypes.string,
    '$headings-margin-bottom': propTypes.string,
    '$headings-font-family': propTypes.string,
    '$headings-font-weight': propTypes.string,
    '$headings-line-height': propTypes.string,
    '$headings-color': propTypes.string,
    '$display1-size': propTypes.string,
    '$display2-size': propTypes.string,
    '$display3-size': propTypes.string,
    '$display4-size': propTypes.string,
    '$display1-weight': propTypes.string,
    '$display2-weight': propTypes.string,
    '$display3-weight': propTypes.string,
    '$display4-weight': propTypes.string,
    '$lead-font-size': propTypes.string,
    '$lead-font-weight': propTypes.string
  }),
  color: propTypes.oneOf(['white', 'muted', 'gray-dark', 'primary', 'success', 'info', 'warning', 'danger']),
  lead: propTypes.bool,
  cssModule: propTypes.object
};
var H3Unstyled =
function (_React$Component) {
  _inherits(H3Unstyled, _React$Component);
  function H3Unstyled() {
    _classCallCheck(this, H3Unstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(H3Unstyled).apply(this, arguments));
  }
  _createClass(H3Unstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          color = _omit.color,
          children = _omit.children,
          cssModule = _omit.cssModule,
          lead = _omit.lead,
          attributes = _objectWithoutProperties(_omit, ["className", "color", "children", "cssModule", "lead"]);
      var classes = mapToCssModules(classnames(className, lead ? 'lead' : false, color ? "text-".concat(color) : false), cssModule);
      return React.createElement("h3", _extends({
        className: classes
      }, attributes), children);
    }
  }]);
  return H3Unstyled;
}(React.Component);
_defineProperty(H3Unstyled, "propTypes", propTypes$q);
_defineProperty(H3Unstyled, "defaultProps", defaultProps$p);
var H3 = styled(H3Unstyled).withConfig({
  displayName: "H3",
  componentId: "sc-89yvsz-0"
})(["", ""], function (props) {
  return "\n    font-size: ".concat(props.theme['$font-size-h3'], ";\n    ").concat(typography_2(props.theme['$headings-margin-bottom'], props.theme['$headings-font-family'], props.theme['$headings-font-weight'], props.theme['$headings-line-height'], props.theme['$headings-color'], props.theme['$display1-size'], props.theme['$display2-size'], props.theme['$display3-size'], props.theme['$display4-size'], props.theme['$display1-weight'], props.theme['$display2-weight'], props.theme['$display3-weight'], props.theme['$display4-weight']), "\n\n    &.lead {\n      font-size: ").concat(props.theme['$lead-font-size'], ";\n      font-weight: ").concat(props.theme['$lead-font-weight'], ";\n    }\n\n    /* Reboot Scss */\n    margin-top: 0;\n  ");
});
H3.defaultProps = defaultProps$p;
H3.propTypes = propTypes$q;

var defaultProps$q = {
  theme: {
    '$font-size-h4': '1.5rem',
    '$headings-margin-bottom': '0.5rem',
    '$headings-font-family': 'inherit',
    '$headings-font-weight': '500',
    '$headings-line-height': '1.1',
    '$headings-color': 'inherit',
    '$display1-size': '6rem',
    '$display2-size': '5.5rem',
    '$display3-size': '4.5rem',
    '$display4-size': '3.5rem',
    '$display1-weight': '300',
    '$display2-weight': '300',
    '$display3-weight': '300',
    '$display4-weight': '300',
    '$lead-font-size': '1.25rem',
    '$lead-font-weight': '300'
  }
};
var propTypes$r = {
  className: propTypes.string,
  theme: propTypes.shape({
    '$link-color': propTypes.string,
    '$font-size-h4': propTypes.string,
    '$headings-margin-bottom': propTypes.string,
    '$headings-font-family': propTypes.string,
    '$headings-font-weight': propTypes.string,
    '$headings-line-height': propTypes.string,
    '$headings-color': propTypes.string,
    '$display1-size': propTypes.string,
    '$display2-size': propTypes.string,
    '$display3-size': propTypes.string,
    '$display4-size': propTypes.string,
    '$display1-weight': propTypes.string,
    '$display2-weight': propTypes.string,
    '$display3-weight': propTypes.string,
    '$display4-weight': propTypes.string,
    '$lead-font-size': propTypes.string,
    '$lead-font-weight': propTypes.string
  }),
  color: propTypes.oneOf(['white', 'muted', 'gray-dark', 'primary', 'success', 'info', 'warning', 'danger']),
  lead: propTypes.bool,
  cssModule: propTypes.object
};
var H4Unstyled =
function (_React$Component) {
  _inherits(H4Unstyled, _React$Component);
  function H4Unstyled() {
    _classCallCheck(this, H4Unstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(H4Unstyled).apply(this, arguments));
  }
  _createClass(H4Unstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          color = _omit.color,
          children = _omit.children,
          cssModule = _omit.cssModule,
          lead = _omit.lead,
          attributes = _objectWithoutProperties(_omit, ["className", "color", "children", "cssModule", "lead"]);
      var classes = mapToCssModules(classnames(className, lead ? 'lead' : false, color ? "text-".concat(color) : false), cssModule);
      return React.createElement("h4", _extends({
        className: classes
      }, attributes), children);
    }
  }]);
  return H4Unstyled;
}(React.Component);
_defineProperty(H4Unstyled, "propTypes", propTypes$r);
_defineProperty(H4Unstyled, "defaultProps", defaultProps$q);
var H4 = styled(H4Unstyled).withConfig({
  displayName: "H4",
  componentId: "sc-1gsd57f-0"
})(["", ""], function (props) {
  return "\n    font-size: ".concat(props.theme['$font-size-h4'], ";\n    ").concat(typography_2(props.theme['$headings-margin-bottom'], props.theme['$headings-font-family'], props.theme['$headings-font-weight'], props.theme['$headings-line-height'], props.theme['$headings-color'], props.theme['$display1-size'], props.theme['$display2-size'], props.theme['$display3-size'], props.theme['$display4-size'], props.theme['$display1-weight'], props.theme['$display2-weight'], props.theme['$display3-weight'], props.theme['$dis$play4-weight']), "\n\n    &.lead {\n      font-size: ").concat(props.theme['$lead-font-size'], ";\n      font-weight: ").concat(props.theme['$lead-font-weight'], ";\n    }\n\n    /* Reboot Scss */\n    margin-top: 0;\n  ");
});
H4.defaultProps = defaultProps$q;
H4.propTypes = propTypes$r;

var defaultProps$r = {
  theme: {
    '$font-size-h5': '1.25rem',
    '$headings-margin-bottom': '0.5rem',
    '$headings-font-family': 'inherit',
    '$headings-font-weight': '500',
    '$headings-line-height': '1.1',
    '$headings-color': 'inherit',
    '$display1-size': '6rem',
    '$display2-size': '5.5rem',
    '$display3-size': '4.5rem',
    '$display4-size': '3.5rem',
    '$display1-weight': '300',
    '$display2-weight': '300',
    '$display3-weight': '300',
    '$display4-weight': '300',
    '$lead-font-size': '1.25rem',
    '$lead-font-weight': '300'
  }
};
var propTypes$s = {
  className: propTypes.string,
  theme: propTypes.shape({
    '$link-color': propTypes.string,
    '$font-size-h5': propTypes.string,
    '$headings-margin-bottom': propTypes.string,
    '$headings-font-family': propTypes.string,
    '$headings-font-weight': propTypes.string,
    '$headings-line-height': propTypes.string,
    '$headings-color': propTypes.string,
    '$display1-size': propTypes.string,
    '$display2-size': propTypes.string,
    '$display3-size': propTypes.string,
    '$display4-size': propTypes.string,
    '$display1-weight': propTypes.string,
    '$display2-weight': propTypes.string,
    '$display3-weight': propTypes.string,
    '$display4-weight': propTypes.string,
    '$lead-font-size': propTypes.string,
    '$lead-font-weight': propTypes.string
  }),
  color: propTypes.oneOf(['white', 'muted', 'gray-dark', 'primary', 'success', 'info', 'warning', 'danger']),
  lead: propTypes.bool,
  cssModule: propTypes.object
};
var H5Unstyled =
function (_React$Component) {
  _inherits(H5Unstyled, _React$Component);
  function H5Unstyled() {
    _classCallCheck(this, H5Unstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(H5Unstyled).apply(this, arguments));
  }
  _createClass(H5Unstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          color = _omit.color,
          children = _omit.children,
          cssModule = _omit.cssModule,
          lead = _omit.lead,
          attributes = _objectWithoutProperties(_omit, ["className", "color", "children", "cssModule", "lead"]);
      var classes = mapToCssModules(classnames(className, lead ? 'lead' : false, color ? "text-".concat(color) : false), cssModule);
      return React.createElement("h5", _extends({
        className: classes
      }, attributes), children);
    }
  }]);
  return H5Unstyled;
}(React.Component);
_defineProperty(H5Unstyled, "propTypes", propTypes$s);
_defineProperty(H5Unstyled, "defaultProps", defaultProps$r);
var H5 = styled(H5Unstyled).withConfig({
  displayName: "H5",
  componentId: "dz5a7l-0"
})(["", ""], function (props) {
  return "\n    font-size: ".concat(props.theme['$font-size-h5'], ";\n    ").concat(typography_2(props.theme['$headings-margin-bottom'], props.theme['$headings-font-family'], props.theme['$headings-font-weight'], props.theme['$headings-line-height'], props.theme['$headings-color'], props.theme['$display1-size'], props.theme['$display2-size'], props.theme['$display3-size'], props.theme['$display4-size'], props.theme['$display1-weight'], props.theme['$display2-weight'], props.theme['$display3-weight'], props.theme['$display4-weight']), "\n \n    &.lead {\n     font-size: ").concat(props.theme['$lead-font-size'], ";\n     font-weight: ").concat(props.theme['$lead-font-weight'], ";\n    }\n\n    /* Reboot Scss */\n    margin-top: 0;\n  ");
});
H5.defaultProps = defaultProps$r;
H5.propTypes = propTypes$s;

var defaultProps$s = {
  theme: {
    '$font-size-h6': '1rem',
    '$headings-margin-bottom': '0.5rem',
    '$headings-font-family': 'inherit',
    '$headings-font-weight': '500',
    '$headings-line-height': '1.1',
    '$headings-color': 'inherit',
    '$display1-size': '6rem',
    '$display2-size': '5.5rem',
    '$display3-size': '4.5rem',
    '$display4-size': '3.5rem',
    '$display1-weight': '300',
    '$display2-weight': '300',
    '$display3-weight': '300',
    '$display4-weight': '300',
    '$lead-font-size': '1.25rem',
    '$lead-font-weight': '300'
  }
};
var propTypes$t = {
  className: propTypes.string,
  theme: propTypes.shape({
    '$link-color': propTypes.string,
    '$font-size-h6': propTypes.string,
    '$headings-margin-bottom': propTypes.string,
    '$headings-font-family': propTypes.string,
    '$headings-font-weight': propTypes.string,
    '$headings-line-height': propTypes.string,
    '$headings-color': propTypes.string,
    '$display1-size': propTypes.string,
    '$display2-size': propTypes.string,
    '$display3-size': propTypes.string,
    '$display4-size': propTypes.string,
    '$display1-weight': propTypes.string,
    '$display2-weight': propTypes.string,
    '$display3-weight': propTypes.string,
    '$display4-weight': propTypes.string,
    '$lead-font-size': propTypes.string,
    '$lead-font-weight': propTypes.string
  }),
  color: propTypes.oneOf(['white', 'muted', 'gray-dark', 'primary', 'success', 'info', 'warning', 'danger']),
  lead: propTypes.bool,
  cssModule: propTypes.object
};
var H6Unstyled =
function (_React$Component) {
  _inherits(H6Unstyled, _React$Component);
  function H6Unstyled() {
    _classCallCheck(this, H6Unstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(H6Unstyled).apply(this, arguments));
  }
  _createClass(H6Unstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          color = _omit.color,
          children = _omit.children,
          cssModule = _omit.cssModule,
          lead = _omit.lead,
          attributes = _objectWithoutProperties(_omit, ["className", "color", "children", "cssModule", "lead"]);
      var classes = mapToCssModules(classnames(className, lead ? 'lead' : false, color ? "text-".concat(color) : false), cssModule);
      return React.createElement("h6", _extends({
        className: classes
      }, attributes), children);
    }
  }]);
  return H6Unstyled;
}(React.Component);
_defineProperty(H6Unstyled, "propTypes", propTypes$t);
_defineProperty(H6Unstyled, "defaultProps", defaultProps$s);
var H6 = styled(H6Unstyled).withConfig({
  displayName: "H6",
  componentId: "sc-4drlv1-0"
})(["", ""], function (props) {
  return "\n    font-size: ".concat(props.theme['$font-size-h6'], ";\n    ").concat(typography_2(props.theme['$headings-margin-bottom'], props.theme['$headings-font-family'], props.theme['$headings-font-weight'], props.theme['$headings-line-height'], props.theme['$headings-color'], props.theme['$display1-size'], props.theme['$display2-size'], props.theme['$display3-size'], props.theme['$display4-size'], props.theme['$display1-weight'], props.theme['$display2-weight'], props.theme['$display3-weight'], props.theme['$display4-weight']), "\n    \n    &.lead {\n     font-size: ").concat(props.theme['$lead-font-size'], ";\n     font-weight: ").concat(props.theme['$lead-font-weight'], ";\n    }\n    \n    /* Reboot Scss */\n    margin-top: 0;\n  ");
});
H6.defaultProps = defaultProps$s;
H6.propTypes = propTypes$t;

var navbarToggleable_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.navbarToggleable = navbarToggleable;
exports.default = exports.defaultProps = void 0;
var defaultProps = {
  '$grid-breakpoints': {
    xs: '0',
    sm: '576px',
    md: '768px',
    lg: '992px',
    xl: '1200px'
  }
};
exports.defaultProps = defaultProps;
function navbarToggleable() {
  var gridBreakpoints = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$grid-breakpoints'];
  var navbarBreakpointList = [];
  Object.keys(gridBreakpoints).forEach(function (breakpoint) {
    var next = (0, breakpoints.breakpointNext)(breakpoint, gridBreakpoints);
    var infix = (0, breakpoints.breakpointInfix)(breakpoint, gridBreakpoints);
    var navbarBreakpoint = "\n      &.navbar-toggleable".concat(infix, " {\n        ").concat((0, breakpoints.mediaBreakpointDown)(breakpoint, gridBreakpoints, "\n          .navbar-nav {\n            .dropdown-menu {\n              position: static;\n              float: none;\n            }\n          }\n\n          > .container {\n            padding-right: 0;\n            padding-left: 0;\n          }\n        "), "\n        ").concat((0, breakpoints.mediaBreakpointUp)(next, gridBreakpoints, "\n          flex-direction: row;\n          flex-wrap: nowrap;\n          align-items: center;\n  \n          .navbar-nav {\n            flex-direction: row;\n  \n            .nav-link {\n              padding-right: .5rem;\n              padding-left: .5rem;\n            }\n          }\n  \n          /* For nesting containers, have to redeclare for alignment purposes */\n          > .container {\n            display: flex;\n            flex-wrap: nowrap;\n            align-items: center;\n          }\n  \n          .navbar-collapse {\n            display: flex !important;\n            width: 100%;\n\n           }\n           \n          .navbar-toggler {\n            display: none;\n          }\n        "), "\n      }\n    ");
    navbarBreakpointList.push(navbarBreakpoint);
  });
  return "\n    ".concat(navbarBreakpointList.join('\n'), "\n  ");
}
var _default = {
  defaultProps: defaultProps,
  navbarToggleable: navbarToggleable
};
exports.default = _default;
});
unwrapExports(navbarToggleable_1);
var navbarToggleable_2 = navbarToggleable_1.navbarToggleable;
var navbarToggleable_3 = navbarToggleable_1.defaultProps;

var navbar_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.navbar = navbar;
exports.default = exports.defaultProps = void 0;
var defaultProps = {
  '$grid-breakpoints': {
    xs: '0',
    sm: '576px',
    md: '768px',
    lg: '992px',
    xl: '1200px'
  },
  '$enable-rounded': true,
  '$enable-hover-media-query': false,
  '$navbar-padding-y': '0.5rem',
  '$navbar-padding-x': '1rem',
  '$zindex-navbar': '1000',
  '$zindex-navbar-fixed': '1030',
  '$zindex-navbar-sticky': '1030',
  '$navbar-brand-padding-y': '.25rem',
  '$font-size-lg': '1.25rem',
  '$navbar-divider-padding-y': '.425rem',
  '$navbar-toggler-padding-y': '.5rem',
  '$navbar-toggler-padding-x': '.75rem',
  '$navbar-toggler-font-size': '1.25rem',
  '$border-width': '1px',
  '$navbar-toggler-border-radius': '.25rem',
  '$navbar-light-active-color': 'rgba(0,0,0,.9)',
  '$navbar-light-color': 'rgba(0,0,0,.5)',
  '$navbar-light-hover-color': 'rgba(0,0,0,.7)',
  '$navbar-light-toggler-border': 'rgba(0,0,0,.1)',
  '$navbar-light-toggler-bg': 'url(\'data:image/svg+xml;charset=utf8,%3Csvg viewBox="0 0 30 30" xmlns="http://www.w3.org/2000/svg"%3E%3Cpath stroke="rgba(0,0,0,.5)" stroke-width="2" stroke-linecap="round" stroke-miterlimit="10" d="M4 7h22M4 15h22M4 23h22"/%3E%3C/svg%3E\')',
  '$navbar-light-disabled-color': 'rgba(0, 0, 0, 0.3)',
  '$navbar-inverse-active-color': 'rgba(255,255,255,1)',
  '$navbar-inverse-color': 'rgba(255,255,255,.5)',
  '$navbar-inverse-hover-color': 'rgba(255,255,255,.75)',
  '$navbar-inverse-toggler-border': 'rgba(255,255,255,.1)',
  '$navbar-inverse-toggler-bg': 'url(\'data:image/svg+xml;charset=utf8,%3Csvg viewBox="0 0 30 30" xmlns="http://www.w3.org/2000/svg"%3E%3Cpath stroke="rgba(255,255,255,.5)" stroke-width="2" stroke-linecap="round" stroke-miterlimit="10" d="M4 7h22M4 15h22M4 23h22"/%3E%3C/svg%3E\')',
  '$navbar-inverse-disabled-color': 'rgba(255, 255, 255, 0.25)'
};
exports.defaultProps = defaultProps;
function navbar() {
  var $gridBreakpoints = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$grid-breakpoints'];
  var $enableRounded = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$enable-rounded'];
  var $enableHoverMediaQuery = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$enable-hover-media-query'];
  var $navbarPaddingY = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : defaultProps['$navbar-padding-y'];
  var $navbarPaddingX = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : defaultProps['$navbar-padding-x'];
  var $zindexNavbar = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : defaultProps['$zindex-navbar'];
  var $zindexNavbarFixed = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : defaultProps['$zindex-navbar-fixed'];
  var $zindexNavbarSticky = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : defaultProps['$zindex-navbar-sticky'];
  var $navbarBrandPaddingY = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : defaultProps['$navbar-brand-padding-y'];
  var $fontSizeLg = arguments.length > 9 && arguments[9] !== undefined ? arguments[9] : defaultProps['$font-size-lg'];
  var $navbarDividerPaddingY = arguments.length > 10 && arguments[10] !== undefined ? arguments[10] : defaultProps['$navbar-divider-padding-y'];
  var $navbarTogglerPaddingY = arguments.length > 11 && arguments[11] !== undefined ? arguments[11] : defaultProps['$navbar-toggler-padding-y'];
  var $navbarTogglerPaddingX = arguments.length > 12 && arguments[12] !== undefined ? arguments[12] : defaultProps['$navbar-toggler-padding-x'];
  var $navbarTogglerFontSize = arguments.length > 13 && arguments[13] !== undefined ? arguments[13] : defaultProps['$navbar-toggler-font-size'];
  var $borderWidth = arguments.length > 14 && arguments[14] !== undefined ? arguments[14] : defaultProps['$border-width'];
  var $navbarTogglerBorderRadius = arguments.length > 15 && arguments[15] !== undefined ? arguments[15] : defaultProps['$navbar-toggler-border-radius'];
  var $navbarLightActiveColor = arguments.length > 16 && arguments[16] !== undefined ? arguments[16] : defaultProps['$navbar-light-active-color'];
  var $navbarLightColor = arguments.length > 17 && arguments[17] !== undefined ? arguments[17] : defaultProps['$navbar-light-color'];
  var $navbarLightHoverColor = arguments.length > 18 && arguments[18] !== undefined ? arguments[18] : defaultProps['$navbar-light-hover-color'];
  var $navbarLightTogglerBorder = arguments.length > 19 && arguments[19] !== undefined ? arguments[19] : defaultProps['$navbar-light-toggler-border'];
  var $navbarLightDisabledColor = arguments.length > 20 && arguments[20] !== undefined ? arguments[20] : defaultProps['$navbar-light-disabled-color'];
  var $navbarLightTogglerBg = arguments.length > 21 && arguments[21] !== undefined ? arguments[21] : defaultProps['$navbar-light-toggler-bg'];
  var $navbarInverseActiveColor = arguments.length > 22 && arguments[22] !== undefined ? arguments[22] : defaultProps['$navbar-inverse-active-color'];
  var $navbarInverseColor = arguments.length > 23 && arguments[23] !== undefined ? arguments[23] : defaultProps['$navbar-inverse-color'];
  var $navbarInverseHoverColor = arguments.length > 24 && arguments[24] !== undefined ? arguments[24] : defaultProps['$navbar-inverse-hover-color'];
  var $navbarInverseTogglerBorder = arguments.length > 25 && arguments[25] !== undefined ? arguments[25] : defaultProps['$navbar-inverse-toggler-border'];
  var $navbarInverseTogglerBg = arguments.length > 26 && arguments[26] !== undefined ? arguments[26] : defaultProps['$navbar-inverse-toggler-bg'];
  var $navbarInverseDisabledColor = arguments.length > 27 && arguments[27] !== undefined ? arguments[27] : defaultProps['$navbar-inverse-disabled-color'];
  return "\n    /* Wrapper and base class\n\n     Provide a static navbar from which we expand to create full-width, fixed, and\n     other navbar variations.\n    */\n\n    &.navbar {\n      position: relative;\n      display: flex;\n      flex-direction: column;\n      padding: ".concat($navbarPaddingY, " ").concat($navbarPaddingX, ";\n    }\n    \n    /*\n     Brand/project name\n    */\n\n    & .navbar-brand {\n      display: inline-block;\n      padding-top: ").concat($navbarBrandPaddingY, ";\n      padding-bottom: ").concat($navbarBrandPaddingY, ";\n      margin-right: ").concat($navbarPaddingX, ";\n      font-size: ").concat($fontSizeLg, ";\n      line-height: inherit;\n      white-space: nowrap;\n      ").concat((0, hover_1.hoverFocus)($enableHoverMediaQuery, 'text-decoration: none;'), "\n    }\n    \n    /* Navigation\n\n     Custom navbar navigation built on the base .nav styles.\n    */\n\n    &.navbar-nav,\n    & .navbar-nav {\n      display: flex;\n      flex-direction: column; /* cannot use inherit to get the .navbars value */\n      padding-left: 0;\n      margin-bottom: 0;\n      list-style: none;\n    \n      .nav-link {\n        padding-right: 0;\n        padding-left: 0;\n      }\n    }\n    \n    /* Navbar text  */\n\n    & .navbar-text {\n      display: inline-block;\n      padding-top:    .425rem;\n      padding-bottom: .425rem;\n    }\n\n\n    /* Navbar toggle\n\n     Custom button for toggling the .navbar-collapse, powered by the collapse\n     Bootstrap JavaScript plugin.\n    */\n\n    & .navbar-toggler {\n      align-self: flex-start; \n      padding: ").concat($navbarTogglerPaddingY, " ").concat($navbarTogglerPaddingX, ";\n      font-size: ").concat($navbarTogglerFontSize, ";\n      line-height: 1;\n      background: transparent;\n      border: ").concat($borderWidth, " solid transparent;\n      ").concat((0, borderRadius_1.borderRadius)($enableRounded, $navbarTogglerBorderRadius), "\n      ").concat((0, hover_1.hoverFocus)($enableHoverMediaQuery, 'text-decoration: none;'), "\n    }\n    \n    /* Keep as a separate element so folks can easily override it with another icon or image file as needed. */\n    & .navbar-toggler-icon {\n      display: inline-block;\n      width: 1.5em;\n      height: 1.5em;\n      vertical-align: middle;\n      content: \"\";\n      background: no-repeat center center;\n      background-size: 100% 100%;\n    }\n    \n    /* Use position on the toggler to prevent it from being auto placed as a flex item and allow easy placement. */\n    & .navbar-toggler-left {\n      position: absolute;\n      left: ").concat($navbarPaddingX, ";\n    }\n    & .navbar-toggler-right {\n      position: absolute;\n      right: ").concat($navbarPaddingX, ";\n    }\n\n    /* Dark links against a light background */\n    &.navbar-light {\n      .navbar-brand,\n      .navbar-toggler {\n        color: ").concat($navbarLightActiveColor, ";\n\n        ").concat((0, hover_1.hoverFocus)($enableHoverMediaQuery, "color: ".concat($navbarLightActiveColor, ";")), "\n      }\n\n      .navbar-nav {\n        .nav-link {\n          color: ").concat($navbarLightColor, ";\n          ").concat((0, hover_1.hoverFocus)($enableHoverMediaQuery, "color: ".concat($navbarLightHoverColor, ";")), "\n          &.disabled {\n            color: ").concat($navbarLightDisabledColor, ";\n          }\n        }\n\n        .open > .nav-link,\n        .active > .nav-link,\n        .nav-link.open,\n        .nav-link.active {\n          color: ").concat($navbarLightActiveColor, ";\n        }\n      }\n\n      .navbar-toggler {\n        border-color: ").concat($navbarLightTogglerBorder, ";\n      }\n      .navbar-toggler-icon {\n        background-image: ").concat($navbarLightTogglerBg, ";\n      }\n  \n      .navbar-text {\n        color: ").concat($navbarLightColor, ";\n      }\n    }\n      \n\n    /* White links against a dark background */\n    &.navbar-inverse {\n      .navbar-brand,\n      .navbar-toggler {\n        color: ").concat($navbarInverseActiveColor, ";\n        ").concat((0, hover_1.hoverFocus)($enableHoverMediaQuery, "color: ".concat($navbarInverseActiveColor, ";")), "\n      }\n\n      .navbar-nav {\n        .nav-link {\n          color: ").concat($navbarInverseColor, ";\n          ").concat((0, hover_1.hoverFocus)($enableHoverMediaQuery, "color: ".concat($navbarInverseHoverColor, ";")), "\n          &.disabled {\n            color: ").concat($navbarInverseDisabledColor, ";\n          }\n        }\n\n        .open > .nav-link,\n        .active > .nav-link,\n        .nav-link.open,\n        .nav-link.active {\n          color: ").concat($navbarInverseActiveColor, ";\n        }\n      }\n\n      .navbar-toggler {\n        border-color: ").concat($navbarInverseTogglerBorder, ";\n      }\n      \n      .navbar-toggler-icon {\n        background-image: ").concat($navbarInverseTogglerBg, ";\n      }\n    \n      .navbar-text {\n        color: ").concat($navbarInverseColor, ";\n      }\n    }\n    \n\n    ").concat((0, navbarToggleable_1.navbarToggleable)($gridBreakpoints), "\n    \n    /* DELETED IN LATEST BOOTSTRAP VERSINO */\n    \n    /* Navbar alignment options\n\n     Display the navbar across the entirety of the page or fixed it to the top or\n     bottom of the page.\n    */\n\n    /* A static, full width modifier with no rounded corners. */\n    &.navbar-full {\n      z-index: ").concat($zindexNavbar, ";\n      ").concat((0, breakpoints.mediaBreakpointUp)('sm', $gridBreakpoints, (0, borderRadius_1.borderRadius)($enableRounded, '0')), "\n    }\n\n      /* Fix the top/bottom navbars when screen real estate supports it */\n    &.navbar-fixed-top,\n    &.navbar-fixed-bottom {\n      position: fixed;\n      right: 0;\n      left: 0;\n      z-index: ").concat($zindexNavbarFixed, ";\n      /*  Undo the rounded corners */\n      ").concat((0, breakpoints.mediaBreakpointUp)('sm', $gridBreakpoints, (0, borderRadius_1.borderRadius)($enableRounded, '0')), "\n    }\n\n    &.navbar-fixed-top {\n      top: 0;\n    }\n\n    &.navbar-fixed-bottom {\n      bottom: 0;\n    }\n\n    /* position sticky does not seem to be working AJT*/\n\n    &.navbar-sticky-top {\n      position: sticky;\n      top: 0;\n      z-index: ").concat($zindexNavbarSticky, ";\n      width: 100%;\n\n        /*  Undo the rounded corners */\n      ").concat((0, breakpoints.mediaBreakpointUp)('sm', $gridBreakpoints, (0, borderRadius_1.borderRadius)($enableRounded, '0')), "\n    }\n\n    & .navbar-divider {\n      float: left;\n      width: ").concat($borderWidth, ";\n      padding-top: ").concat($navbarDividerPaddingY, ";\n      padding-bottom: ").concat($navbarDividerPaddingY, ";\n      margin-right: ").concat($navbarPaddingX, ";\n      margin-left:  ").concat($navbarPaddingX, ";\n      overflow: hidden;\n\n      &::before {\n        content: '\0a0';\n      }\n    }\n  ");
}
var _default = {
  defaultProps: defaultProps,
  navbar: navbar
};
exports.default = _default;
});
unwrapExports(navbar_1);
var navbar_2 = navbar_1.navbar;
var navbar_3 = navbar_1.defaultProps;

var defaultProps$t = {
  theme: {
    '$enable-rounded': true,
    '$enable-hover-media-query': false,
    '$border-width': '1px',
    '$font-size-lg': '1.25rem',
    '$border-radius': '.25rem',
    '$navbar-padding-x': '1rem',
    '$navbar-padding-y': '0.5rem',
    '$zindex-navbar': '1000',
    '$zindex-navbar-fixed': '1030',
    '$zindex-navbar-sticky': '1030',
    '$navbar-brand-padding-y': '.25rem',
    '$navbar-divider-padding-y': '.425rem',
    '$navbar-toggler-padding-y': '.5rem',
    '$navbar-toggler-padding-x': '.75rem',
    '$navbar-toggler-font-size': '1.25rem',
    '$navbar-toggler-border-radius': '.25rem',
    '$navbar-light-active-color': 'rgba(0,0,0,.9)',
    '$navbar-light-color': 'rgba(0,0,0,.5)',
    '$navbar-light-hover-color': 'rgba(0,0,0,.7)',
    '$navbar-light-toggler-border': 'rgba(0,0,0,.1)',
    '$navbar-light-disabled-color': 'rgba(0, 0, 0, 0.3)',
    '$navbar-light-toggler-bg': 'url(\'data:image/svg+xml;charset=utf8,%3Csvg viewBox="0 0 30 30" xmlns="http://www.w3.org/2000/svg"%3E%3Cpath stroke="rgba(0,0,0,.5)" stroke-width="2" stroke-linecap="round" stroke-miterlimit="10" d="M4 7h22M4 15h22M4 23h22"/%3E%3C/svg%3E\')',
    '$navbar-inverse-active-color': 'rgba(255,255,255,1)',
    '$navbar-inverse-color': 'rgba(255,255,255,.5)',
    '$navbar-inverse-hover-color': 'rgba(255,255,255,.75)',
    '$navbar-inverse-toggler-border': 'rgba(255,255,255,.1)',
    '$navbar-inverse-toggler-bg': 'url(\'data:image/svg+xml;charset=utf8,%3Csvg viewBox="0 0 30 30" xmlns="http://www.w3.org/2000/svg"%3E%3Cpath stroke="rgba(255,255,255,.5)" stroke-width="2" stroke-linecap="round" stroke-miterlimit="10" d="M4 7h22M4 15h22M4 23h22"/%3E%3C/svg%3E\')',
    '$navbar-inverse-disabled-color': 'rgba(255, 255, 255, 0.25)'
  }
};
var propTypes$u = {
  shadowHeader: propTypes.bool,
  theme: propTypes.shape({
    '$enable-rounded': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool,
    '$border-width': propTypes.string,
    '$font-size-lg': propTypes.string,
    '$border-radius': propTypes.string,
    '$navbar-padding-x': propTypes.string,
    '$navbar-padding-y': propTypes.string,
    '$zindex-navbar': propTypes.string,
    '$zindex-navbar-fixed': propTypes.string,
    '$zindex-navbar-sticky': propTypes.string,
    '$navbar-brand-padding-y': propTypes.string,
    '$navbar-divider-padding-y': propTypes.string,
    '$navbar-toggler-padding-y': propTypes.string,
    '$navbar-toggler-padding-x': propTypes.string,
    '$navbar-toggler-font-size': propTypes.string,
    '$navbar-toggler-border-radius': propTypes.string,
    '$navbar-light-active-color': propTypes.string,
    '$navbar-light-color': propTypes.string,
    '$navbar-light-hover-color': propTypes.string,
    '$navbar-light-toggler-border': propTypes.string,
    '$navbar-light-disabled-color': propTypes.string,
    '$navbar-light-toggler-bg': propTypes.string,
    '$navbar-inverse-active-color': propTypes.string,
    '$navbar-inverse-color': propTypes.string,
    '$navbar-inverse-hover-color': propTypes.string,
    '$navbar-inverse-toggler-border': propTypes.string,
    '$navbar-inverse-toggler-bg': propTypes.string,
    '$navbar-inverse-disabled-color': propTypes.string
  })
};
var Header = styled.header.withConfig({
  displayName: "Header",
  componentId: "sc-1gwmqbb-0"
})(["", "  "], function (props) {
  return "\n    ".concat(navbar_2(props.theme['$grid-breakpoints'], props.theme['$enable-rounded'], props.theme['$enable-hover-media-query'], props.theme['$navbar-padding-y'], props.theme['$navbar-padding-x'], props.theme['$zindex-navbar'], props.theme['$zindex-navbar-fixed'], props.theme['$zindex-navbar-sticky'], props.theme['$navbar-brand-padding-y'], props.theme['$font-size-lg'], props.theme['$navbar-divider-padding-y'], props.theme['$navbar-toggler-padding-y'], props.theme['$navbar-toggler-padding-x'], props.theme['$navbar-toggler-font-size'], props.theme['$border-width'], props.theme['$navbar-toggler-border-radius'], props.theme['$navbar-light-active-color'], props.theme['$navbar-light-color'], props.theme['$navbar-light-hover-color'], props.theme['$navbar-light-toggler-border'], props.theme['$navbar-light-disabled-color'], props.theme['$navbar-light-toggler-bg'], props.theme['$navbar-inverse-active-color'], props.theme['$navbar-inverse-color'], props.theme['$navbar-inverse-hover-color'], props.theme['$navbar-inverse-toggler-border'], props.theme['$navbar-inverse-toggler-bg'], props.theme['$navbar-inverse-disabled-color']), "\n    ").concat(conditional_1(props.shadowHeader, 'box-shadow: 0 1px 4px 0 rgba(0,0,0,.37);'), "\n  ");
});
Header.defaultProps = defaultProps$t;
Header.propTypes = propTypes$u;

var defaultProps$u = {
  theme: {
    '$hr-border-width': '1px',
    '$hr-border-color': 'rgba(0, 0, 0, 0.1)'
  }
};
var propTypes$v = {
  theme: propTypes.shape({
    '$hr-border-width': propTypes.string,
    '$hr-border-color': propTypes.string
  })
};
var Hr = styled.hr.withConfig({
  displayName: "Hr",
  componentId: "sc-1a12p8r-0"
})(["", ""], function (props) {
  return "\n    margin-top: ".concat(props.theme['$spacer-y'], ";\n    margin-bottom: ").concat(props.theme['$spacer-y'], ";\n    border: 0;\n    border-top: ").concat(props.theme['$hr-border-width'], " solid ").concat(props.theme['$hr-border-color'], ";\n  ");
});
Hr.defaultProps = defaultProps$u;
Hr.propTypes = propTypes$v;

var image = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.imgFluid = imgFluid;
exports.imgRetina = imgRetina;
exports.default = void 0;
function imgFluid() {
  return "\n    /* Part 1: Set a maximum relative to the parent */\n    max-width: 100%;\n    /* Part 2: Override the height to auto, otherwise images will be stretched */\n    /* when setting a width and height attribute on the img element. */\n    height: auto;\n  ";
}
function imgRetina(file1x, file2x, width1x, height1x) {
  return "\n    background-image: url(".concat(file1x, ");\n\n    /* Autoprefixer takes care of adding -webkit-min-device-pixel-ratio and -o-min-device-pixel-ratio, */\n    /* but doesn't convert dppx=>dpi. */\n    /* There's no such thing as unprefixed min-device-pixel-ratio since it's nonstandard. */\n    /* Compatibility info: http://caniuse.com/#feat=css-media-resolution */\n    @media only screen and (min-resolution: 192dpi), /* IE9-11 don't support dppx */\n      only screen and (min-resolution: 2dppx) { /* Standardized */\n        background-image: url(").concat(file2x, ");\n        background-size: ").concat(width1x, " ").concat(height1x, ";\n    }\n  ");
}
var _default = {
  imgFluid: imgFluid,
  imgRetina: imgRetina
};
exports.default = _default;
});
unwrapExports(image);
var image_1 = image.imgFluid;
var image_2 = image.imgRetina;

var defaultProps$v = {
  tag: 'img',
  theme: {
    '$enable-rounded': true,
    '$enable-transitions': true,
    '$enable-shadows': false,
    '$spacer-halved': '0.5rem',
    '$border-width': '1px',
    '$border-radius': '.25rem',
    '$thumbnail-padding': '.25rem',
    '$thumbnail-bg': '#fff',
    '$thumbnail-border-width': '1px',
    '$thumbnail-border-color': '#ddd',
    '$thumbnail-border-radius': '.25rem',
    '$thumbnail-box-shadow': '0 1px 2px rgba(0, 0, 0, 0.75)',
    '$thumbnail-transition': 'all .2s ease-in-out',
    '$figure-caption-font-size': '90%',
    '$figure-caption-color': '#636c72'
  }
};
var propTypes$w = {
  className: propTypes.string,
  tag: propTypes.any,
  fluid: propTypes.bool,
  figure: propTypes.bool,
  src: propTypes.oneOfType([propTypes.string, propTypes.object]).isRequired,
  alt: propTypes.oneOfType([propTypes.string, propTypes.object]).isRequired,
  theme: propTypes.shape({
    '$enable-rounded': propTypes.bool,
    '$enable-transitions': propTypes.bool,
    '$enable-shadows': propTypes.bool,
    '$spacer-halved': propTypes.string,
    '$border-width': propTypes.string,
    '$border-radius': propTypes.string,
    '$thumbnail-padding': propTypes.string,
    '$thumbnail-bg': propTypes.string,
    '$thumbnail-border-width': propTypes.string,
    '$thumbnail-border-color': propTypes.string,
    '$thumbnail-border-radius': propTypes.string,
    '$thumbnail-box-shadow': propTypes.string,
    '$thumbnail-transition': propTypes.string,
    '$figure-caption-font-size': propTypes.string,
    '$figure-caption-color': propTypes.string
  }),
  cssModule: propTypes.object
};
var ImgUnstyled =
function (_React$Component) {
  _inherits(ImgUnstyled, _React$Component);
  function ImgUnstyled() {
    _classCallCheck(this, ImgUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(ImgUnstyled).apply(this, arguments));
  }
  _createClass(ImgUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          src = _omit.src,
          alt = _omit.alt,
          fluid = _omit.fluid,
          figure = _omit.figure,
          thumbnail = _omit.thumbnail,
          cssModule = _omit.cssModule,
          Tag = _omit.tag,
          attributes = _objectWithoutProperties(_omit, ["className", "src", "alt", "fluid", "figure", "thumbnail", "cssModule", "tag"]);
      var classes = mapToCssModules(classnames(className, fluid ? 'img-fluid' : false, thumbnail ? 'img-thumbnail' : false, figure ? 'figure-img' : false), cssModule);
      return React.createElement(Tag, _extends({
        className: classes,
        src: src,
        alt: alt
      }, attributes));
    }
  }]);
  return ImgUnstyled;
}(React.Component);
_defineProperty(ImgUnstyled, "propTypes", propTypes$w);
_defineProperty(ImgUnstyled, "defaultProps", defaultProps$v);
var Img = styled(ImgUnstyled).withConfig({
  displayName: "Img",
  componentId: "sc-10y4zbe-0"
})(["", ""], function (props) {
  return "\n    \n    /* \n      Responsive images (ensure images does not scale beyond their parents)\n      This is purposefully opt-in via an explicit class rather than being the default for all <img>.\n      We previously tried the \"images are responsive by default\" approach in Bootstrap v2,\n      and abandoned it in Bootstrap v3 because it breaks lots of third-party widgets (including Google Maps)\n      which we are not expecting the images within themselves to be involuntarily resized.\n      See also https://github.com/twbs/bootstrap/issues/18178\n    */\n    \n    &.img-fluid {\n      ".concat(image_1(), "\n    }\n    \n    \n     /* Image thumbnails */ \n    &.img-thumbnail {\n      padding: ").concat(props.theme['$thumbnail-padding'], ";\n      background-color: ").concat(props.theme['$thumbnail-bg'], ";\n      border: ").concat(props.theme['$thumbnail-border-width'], " solid ").concat(props.theme['$thumbnail-border-color'], ";\n      ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$thumbnail-border-radius']), "\n      ").concat(transition_2(props.theme['$enable-transitions'], props.theme['$thumbnail-transition']), "\n      ").concat(boxShadow_2(props.theme['$enable-shadows'], props.theme['$thumbnail-box-shadow']), "\n      /* Keep them at most 100% wide */\n      ").concat(image_1(), "\n    }\n   \n    &.figure-img {\n      margin-bottom: ").concat(props.theme['$spacer-halved'], ";\n      line-height: 1;\n    }\n    \n    /* Reboot Scss */\n    \n    /*\n     By default, <img> are inline-block. This assumes that, and vertically\n     centers them. This will not apply should you reset them to block level.\n    */\n    vertical-align: middle;\n    /*\n     Note: <img> are deliberately not made responsive by default.\n     For the rationale behind this, see the comments on the .img-fluid class.\n    */\n  ");
});
Img.defaultProps = defaultProps$v;
Img.propTypes = propTypes$w;

var FigureUnstyled =
function (_React$Component) {
  _inherits(FigureUnstyled, _React$Component);
  function FigureUnstyled() {
    _classCallCheck(this, FigureUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(FigureUnstyled).apply(this, arguments));
  }
  _createClass(FigureUnstyled, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          children = _this$props.children,
          rest = _objectWithoutProperties(_this$props, ["className", "children"]);
      return React.createElement("figure", _extends({
        className: classnames('figure', className)
      }, rest), children);
    }
  }]);
  return FigureUnstyled;
}(React.Component);
_defineProperty(FigureUnstyled, "propTypes", {
  children: propTypes.node.isRequired,
  className: propTypes.string
});
var Figure = styled(FigureUnstyled).withConfig({
  displayName: "Figure",
  componentId: "sc-1suz1fd-0"
})(["&.figure{display:inline-block;}margin:0 0 1rem;"]);

var utils = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.allowFalseValue = allowFalseValue;
exports.assertAscending = assertAscending;
exports.assertStartAtZero = assertStartAtZero;
exports.comparable = comparable;
exports.default = void 0;
var _unitUtils = _interopRequireDefault(unitUtils);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function allowFalseValue(userValue, defaultValue) {
  return userValue === false ? userValue : userValue || defaultValue;
}
function assertAscending(map, mapName) {
  var prevKey;
  var prevNum;
  var asserted = true;
  Object.keys(map).forEach(function (key) {
    var num = map[key];
    if (prevNum == null) ; else if (!comparable(_unitUtils.default.rmUnit(prevNum), _unitUtils.default.rmUnit(num))) {
      {
        console.warn("Potentially invalid value for ".concat(mapName, ": This map must be in ascending order, but key '").concat(key, "' has value ").concat(num, " whose unit makes it incomparable to ").concat(prevNum, ", the value of the previous key '").concat(prevKey, "' !"));
      }
      asserted = false;
    } else if (_unitUtils.default.rmUnit(prevNum) >= _unitUtils.default.rmUnit(num)) {
      {
        console.warn("Invalid value for ".concat(mapName, ": This map must be in ascending order, but key '").concat(key, "' has value ").concat(num, " which isn't greater than ").concat(prevNum, ", the value of the previous key '").concat(prevKey, "' !"));
      }
      asserted = false;
    }
    prevKey = key;
    prevNum = num;
  });
  return asserted;
}
function assertStartAtZero(map) {
  var values = Object.keys(map).map(function (key) {
    return map[key];
  });
  var firstValue = _unitUtils.default.rmUnit(values[0]);
  var asserted = true;
  if (firstValue !== 0) {
    {
      console.warn("First breakpoint in $grid-breakpoints must start at 0, but starts at ".concat(firstValue, "."));
    }
    asserted = false;
  }
  return asserted;
}
function comparable(a, b) {
  return !isNaN(a + b);
}
var _default = {
  assertAscending: assertAscending,
  assertStartAtZero: assertStartAtZero,
  comparable: comparable
};
exports.default = _default;
});
unwrapExports(utils);
var utils_1 = utils.allowFalseValue;
var utils_2 = utils.assertAscending;
var utils_3 = utils.assertStartAtZero;
var utils_4 = utils.comparable;

var regex$1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.linearGradientRe = void 0;
var linearGradientRe = /#[0-9a-fA-F]{3,6}|rgb ?\([ 0-9.%,]+?\)/g;
exports.linearGradientRe = linearGradientRe;
});
unwrapExports(regex$1);
var regex_1$1 = regex$1.linearGradientRe;

var theme = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.makeTheme = void 0;
var _color = _interopRequireDefault(ColorWrapper);
var _unitUtils = _interopRequireDefault(unitUtils);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var detectUnit = _unitUtils.default.detectUnit,
    rmUnit = _unitUtils.default.rmUnit;
function makeOriginal() {
  var userTheme = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var v = {};
  var u = userTheme;
  var detectedUnit;
  v._name = u._name || 'bootstrap-styled';
  v['$white'] = u['$white'] || '#fff';
  v['$black'] = u['$black'] || '#000';
  v['$red'] = u['$red'] || '#d9534f';
  v['$orange'] = u['$orange'] || '#f0ad4e';
  v['$yellow'] = u['$yellow'] || '#ffd500';
  v['$green'] = u['$green'] || '#5cb85c';
  v['$blue'] = u['$blue'] || '#0275d8';
  v['$teal'] = u['$teal'] || '#5bc0de';
  v['$pink'] = u['$pink'] || '#ff5b77';
  v['$purple'] = u['$purple'] || '#613d7c';
  v['$gray-dark'] = u['$gray-dark'] || '#292b2c';
  v['$gray'] = u['$gray'] || '#464a4c';
  v['$gray-light'] = u['$gray-light'] || '#636c72';
  v['$gray-lighter'] = u['$gray-lighter'] || '#eceeef';
  v['$gray-lightest'] = u['$gray-lightest'] || '#f7f7f9';
  v['$brand-primary'] = u['$brand-primary'] || v['$blue'];
  v['$brand-success'] = u['$brand-success'] || v['$green'];
  v['$brand-info'] = u['$brand-info'] || v['$teal'];
  v['$brand-warning'] = u['$brand-warning'] || v['$orange'];
  v['$brand-danger'] = u['$brand-danger'] || v['$red'];
  v['$brand-inverse'] = u['$brand-inverse'] || v['$gray-dark'];
  v['$enable-rounded'] = (0, utils.allowFalseValue)(u['$enable-rounded'], true);
  v['$enable-shadows'] = (0, utils.allowFalseValue)(u['$enable-shadows'], false);
  v['$enable-gradients'] = (0, utils.allowFalseValue)(u['$enable-gradients'], false);
  v['$enable-transitions'] = (0, utils.allowFalseValue)(u['$enable-transitions'], true);
  v['$enable-hover-media-query'] = (0, utils.allowFalseValue)(u['$enable-hover-media-query'], false);
  v['$enable-grid-classes'] = (0, utils.allowFalseValue)(u['$enable-grid-classes'], true);
  v['$enable-print-styles'] = (0, utils.allowFalseValue)(u['$enable-print-styles'], true);
  v['$spacer'] = u['$spacer'] || '1rem';
  detectedUnit = detectUnit(v['$spacer']);
  v['$spacer-halved'] = u['$spacer-halved'] || rmUnit(v['$spacer'], detectedUnit) / 2 + detectedUnit;
  v['$spacer-x'] = u['$spacer-x'] || v['$spacer'];
  v['$spacer-y'] = u['$spacer-y'] || v['$spacer'];
  v['$spacers'] = u['$spacers'] || {
    0: {
      x: 0,
      y: 0
    },
    1: {
      x: rmUnit(v['$spacer-x']) * 0.25 + detectedUnit,
      y: rmUnit(v['$spacer-y']) * 0.25 + detectedUnit
    },
    2: {
      x: rmUnit(v['$spacer-x']) * 0.5 + detectedUnit,
      y: rmUnit(v['$spacer-y']) * 0.5 + detectedUnit
    },
    3: {
      x: v['$spacer-x'],
      y: v['$spacer-y']
    },
    4: {
      x: rmUnit(v['$spacer-x']) * 1.5 + detectedUnit,
      y: rmUnit(v['$spacer-y']) * 1.5 + detectedUnit
    },
    5: {
      x: rmUnit(v['$spacer-x']) * 3 + detectedUnit,
      y: rmUnit(v['$spacer-y']) * 3 + detectedUnit
    }
  };
  v['$border-width'] = u['$border-width'] || '1px';
  v['$sizes'] = u['$sizes'] || {
    25: '25%',
    50: '50%',
    75: '75%',
    100: '100%'
  };
  v['$body-bg'] = u['$body-bg'] || v['$white'];
  v['$body-color'] = u['$body-color'] || v['$gray-dark'];
  v['$link-color'] = u['$link-color'] || v['$brand-primary'];
  v['$link-decoration'] = u['$link-decoration'] || 'none';
  v['$link-hover-color'] = u['$link-hover-color'] || (0, _color.default)(v['$link-color']).darken(0.35).toString();
  v['$link-hover-decoration'] = u['$link-hover-decoration'] || 'underline';
  v['$grid-breakpoints'] = u['$grid-breakpoints'] || {
    xs: '0',
    sm: '576px',
    md: '768px',
    lg: '992px',
    xl: '1200px',
    xxl: '1452px'
  };
  (0, utils.assertAscending)(v['$grid-breakpoints'], '$grid-breakpoints');
  (0, utils.assertStartAtZero)(v['$grid-breakpoints']);
  v['$container-max-widths'] = u['$container-max-widths'] || {
    sm: '540px',
    md: '720px',
    lg: '960px',
    xl: '1140px'
  };
  (0, utils.assertAscending)(v['$container-max-widths'], '$container-max-widths');
  v['$grid-columns'] = u['$grid-columns'] || '12';
  v['$grid-gutter-width'] = u['$grid-gutter-width'] || '30px';
  v['$font-family-sans-serif'] = u['$font-family-sans-serif'] || '-apple-system, system-ui, BlinkMacSystemFont, "Segoe UI", Roboto, "Helvetica Neue", Arial, sans-serif';
  v['$font-family-monospace'] = u['$font-family-monospace'] || 'Menlo, Monaco, Consolas, "Liberation Mono", "Courier New", monospace';
  v['$font-family-base'] = u['$font-family-base'] || v['$font-family-sans-serif'];
  v['$font-size-base'] = u['$font-size-base'] || '1rem';
  v['$font-size-lg'] = u['$font-size-lg'] || '1.25rem';
  v['$font-size-sm'] = u['$font-size-sm'] || '.875rem';
  v['$font-size-xs'] = u['$font-size-xs'] || '.75rem';
  v['$font-weight-normal'] = u['$font-weight-normal'] || 'normal';
  v['$font-weight-bold'] = u['$font-weight-bold'] || 'bold';
  v['$font-weight-base'] = u['$font-weight-base'] || v['$font-weight-normal'];
  v['$line-height-base'] = u['$line-height-base'] || '1.5';
  v['$font-size-h1'] = u['$font-size-h1'] || '2.5rem';
  v['$font-size-h2'] = u['$font-size-h2'] || '2rem';
  v['$font-size-h3'] = u['$font-size-h3'] || '1.75rem';
  v['$font-size-h4'] = u['$font-size-h4'] || '1.5rem';
  v['$font-size-h5'] = u['$font-size-h5'] || '1.25rem';
  v['$font-size-h6'] = u['$font-size-h6'] || '1rem';
  detectedUnit = detectUnit(v['$spacer']);
  v['$headings-margin-bottom'] = u['$headings-margin-bottom'] || rmUnit(v['$spacer'], detectedUnit) / 2 + detectedUnit;
  v['$headings-font-family'] = u['$headings-font-family'] || 'inherit';
  v['$headings-font-weight'] = u['$headings-font-weight'] || '500';
  v['$headings-line-height'] = u['$headings-line-height'] || '1.1';
  v['$headings-color'] = u['$headings-color'] || 'inherit';
  v['$display1-size'] = u['$display1-size'] || '6rem';
  v['$display2-size'] = u['$display2-size'] || '5.5rem';
  v['$display3-size'] = u['$display3-size'] || '4.5rem';
  v['$display4-size'] = u['$display4-size'] || '3.5rem';
  v['$display1-weight'] = u['$display1-weight'] || '300';
  v['$display2-weight'] = u['$display2-weight'] || '300';
  v['$display3-weight'] = u['$display3-weight'] || '300';
  v['$display4-weight'] = u['$display4-weight'] || '300';
  v['$display-line-height'] = u['$display-line-height'] || v['$headings-line-height'];
  v['$lead-font-size'] = u['$lead-font-size'] || '1.25rem';
  v['$lead-font-weight'] = u['$lead-font-weight'] || '300';
  v['$small-font-size'] = u['$small-font-size'] || '80%';
  v['$text-muted'] = u['$text-muted'] || v['$gray-light'];
  v['$blockquote-small-color'] = u['$blockquote-small-color'] || v['$gray-light'];
  detectedUnit = detectUnit(v['$font-size-base']);
  v['$blockquote-font-size'] = u['$blockquote-font-size'] || rmUnit(v['$font-size-base'], detectedUnit) * 1.25 + detectedUnit;
  v['$blockquote-border-color'] = u['$blockquote-border-color'] || v['$gray-lighter'];
  v['$blockquote-border-width'] = u['$blockquote-border-width'] || '.25rem';
  v['$hr-border-color'] = u['$hr-border-color'] || (0, _color.default)(v['$black']).alpha(0.1).toString();
  v['$hr-border-width'] = u['$hr-border-width'] || v['$border-width'];
  v['$mark-padding'] = u['$mark-padding'] || '.2em';
  v['$dt-font-weight'] = u['$dt-font-weight'] || v['$font-weight-bold'];
  v['$list-inline-padding'] = u['$list-inline-padding'] || '5px';
  v['$line-height-lg'] = u['$line-height-lg'] || '1.6';
  v['$line-height-sm'] = u['$line-height-sm'] || '1.3';
  v['$border-radius'] = u['$border-radius'] || '.25rem';
  v['$border-radius-lg'] = u['$border-radius-lg'] || '.3rem';
  v['$border-radius-sm'] = u['$border-radius-sm'] || '.2rem';
  v['$component-active-color'] = u['$component-active-color'] || v['$white'];
  v['$component-active-bg'] = u['$component-active-bg'] || v['$brand-primary'];
  v['$caret-width'] = u['$caret-width'] || '.3em';
  v['$transition-base'] = u['$transition-base'] || 'all .2s ease-in-out';
  v['$transition-fade'] = u['$transition-fade'] || 'opacity .15s linear';
  v['$transition-collapse'] = u['$transition-collapse'] || 'height .35s ease';
  v['$table-cell-padding'] = u['$table-cell-padding'] || '.75rem';
  v['$table-sm-cell-padding'] = u['$table-sm-cell-padding'] || '.3rem';
  v['$table-bg'] = u['$table-bg'] || 'transparent';
  v['$table-inverse-bg'] = u['$table-inverse-bg'] || v['$gray-dark'];
  v['$table-inverse-bg-accent'] = u['$table-inverse-bg-accent'] || (0, _color.default)(v['$white']).alpha(0.05).toString();
  v['$table-inverse-bg-hover'] = u['$table-inverse-bg-hover'] || (0, _color.default)(v['$white']).alpha(0.075).toString();
  v['$table-inverse-color'] = u['$table-inverse-color'] || v['$body-bg'];
  v['$table-inverse-border'] = u['$table-inverse-border'] || (0, _color.default)(v['$gray-dark']).lighten(0.075).toString();
  v['$table-bg-accent'] = u['$table-bg-accent'] || (0, _color.default)(v['$black']).alpha(0.05).toString();
  v['$table-bg-hover'] = u['$table-bg-hover'] || (0, _color.default)(v['$black']).alpha(0.075).toString();
  v['$table-bg-active'] = u['$table-bg-active'] || v['$table-bg-hover'];
  v['$table-head-bg'] = u['$table-head-bg'] || v['$gray-lighter'];
  v['$table-head-color'] = u['$table-head-color'] || v['$gray'];
  v['$table-border-width'] = u['$table-border-width'] || v['$border-width'];
  v['$table-border-color'] = u['$table-border-color'] || v['$gray-lighter'];
  v['$btn-padding-x'] = u['$btn-padding-x'] || '1rem';
  v['$btn-padding-y'] = u['$btn-padding-y'] || '.5rem';
  v['$btn-line-height'] = u['$btn-line-height'] || '1.25';
  v['$btn-font-weight'] = u['$btn-font-weight'] || v['$font-weight-normal'];
  v['$btn-box-shadow'] = u['$btn-box-shadow'] || "inset 0 1px 0 ".concat((0, _color.default)(v['$white']).alpha(0.15).toString(), ", 0 1px 1px ").concat((0, _color.default)(v['$black']).alpha(0.075).toString());
  v['$btn-focus-box-shadow'] = u['$btn-focus-box-shadow'] || "0 0 0 2px ".concat((0, _color.default)(v['$brand-primary']).alpha(0.25).toString());
  v['$btn-disabled-opacity'] = u['$btn-disabled-opacity'] || '.65';
  v['$btn-active-box-shadow'] = u['$btn-active-box-shadow'] || "inset 0 3px 5px ".concat((0, _color.default)(v['$black']).alpha(0.125).toString());
  v['$btn-primary-color'] = u['$btn-primary-color'] || v['$white'];
  v['$btn-primary-bg'] = u['$btn-primary-bg'] || v['$brand-primary'];
  v['$btn-secondary-color'] = u['$btn-secondary-color'] || v['$gray-dark'];
  v['$btn-secondary-bg'] = u['$btn-secondary-bg'] || v['$white'];
  v['$btn-info-color'] = u['$btn-info-color'] || v['$white'];
  v['$btn-info-bg'] = u['$btn-info-bg'] || v['$brand-info'];
  v['$btn-success-color'] = u['$btn-success-color'] || v['$white'];
  v['$btn-success-bg'] = u['$btn-success-bg'] || v['$brand-success'];
  v['$btn-warning-color'] = u['$btn-warning-color'] || v['$white'];
  v['$btn-warning-bg'] = u['$btn-warning-bg'] || v['$brand-warning'];
  v['$btn-danger-color'] = u['$btn-danger-color'] || v['$white'];
  v['$btn-danger-bg'] = u['$btn-danger-bg'] || v['$brand-danger'];
  ['primary', 'secondary', 'info', 'success', 'warning', 'danger'].forEach(function (type) {
    if (v["$btn-".concat(type, "-bg")].includes('linear-gradient')) {
      v["$btn-".concat(type, "-border")] = v["$btn-".concat(type, "-bg")].match(regex$1.linearGradientRe)[1];
    } else if (type === 'secondary') {
      v['$btn-secondary-border'] = u['$btn-secondary-border'] || '#ccc';
    } else {
      v["$btn-".concat(type, "-border")] = u["$btn-".concat(type, "-border")] || v["$btn-".concat(type, "-bg")];
    }
  });
  v['$btn-link-disabled-color'] = u['$btn-link-disabled-color'] || v['$gray-light'];
  v['$btn-padding-x-sm'] = u['$btn-padding-x-sm'] || '.5rem';
  v['$btn-padding-y-sm'] = u['$btn-padding-y-sm'] || '.25rem';
  v['$btn-padding-x-lg'] = u['$btn-padding-x-lg'] || '1.5rem';
  v['$btn-padding-y-lg'] = u['$btn-padding-y-lg'] || '.75rem';
  v['$btn-block-spacing-y'] = u['$btn-block-spacing-y'] || '.5rem';
  v['$btn-border-radius'] = u['$btn-border-radius'] || v['$border-radius'];
  v['$btn-border-radius-lg'] = u['$btn-border-radius-lg'] || v['$border-radius-lg'];
  v['$btn-border-radius-sm'] = u['$btn-border-radius-sm'] || v['$border-radius-sm'];
  v['$btn-border-width'] = u['$btn-border-width'] || '1px';
  v['$btn-transition'] = u['$btn-transition'] || v['$transition-base'];
  v['$input-padding-x'] = u['$input-padding-x'] || '.75rem';
  v['$input-padding-y'] = u['$input-padding-y'] || '.5rem';
  v['$input-line-height'] = u['$input-line-height'] || '1.25';
  v['$input-bg'] = u['$input-bg'] || v['$white'];
  v['$input-bg-disabled'] = u['$input-bg-disabled'] || v['$gray-lighter'];
  v['$input-color'] = u['$input-color'] || v['$gray'];
  v['$input-border-color'] = u['$input-border-color'] || (0, _color.default)(v['$black']).alpha(0.15).toString();
  v['$input-btn-border-width'] = u['$input-btn-border-width'] || v['$border-width'];
  v['$input-box-shadow'] = u['$input-box-shadow'] || "inset 0 1px 1px ".concat((0, _color.default)(v['$black']).alpha(0.075).toString());
  v['$input-border-radius'] = u['$input-border-radius'] || v['$border-radius'];
  v['$input-border-radius-lg'] = u['$input-border-radius-lg'] || v['$border-radius-lg'];
  v['$input-border-radius-sm'] = u['$input-border-radius-sm'] || v['$border-radius-sm'];
  v['$input-bg-focus'] = u['$input-bg-focus'] || v['$input-bg'];
  v['$input-border-focus'] = u['$input-border-focus'] || (0, _color.default)(v['$brand-primary']).lighten(0.25).toString();
  v['$input-box-shadow-focus'] = u['$input-box-shadow-focus'] || "".concat(v['$input-box-shadow'], ", 0 0 8px rgba(").concat(v['$input-border-focus'], ",.6)");
  v['$input-color-focus'] = u['$input-color-focus'] || v['$input-color'];
  v['$input-color-placeholder'] = u['$input-color-placeholder'] || v['$gray-light'];
  v['$input-padding-x-sm'] = u['$input-padding-x-sm'] || '.5rem';
  v['$input-padding-y-sm'] = u['$input-padding-y-sm'] || '.25rem';
  v['$input-padding-x-lg'] = u['$input-padding-x-lg'] || '1.5rem';
  v['$input-padding-y-lg'] = u['$input-padding-y-lg'] || '.75rem';
  detectedUnit = detectUnit(v['$font-size-base']);
  v['$input-height'] = u['$input-height'] || rmUnit(v['$font-size-base'], detectedUnit) * v['$line-height-base'] + rmUnit(v['$input-padding-y'], detectedUnit) * 2 + detectedUnit;
  v['$input-height-sm'] = u['$input-height-sm'] || rmUnit(v['$font-size-sm'], detectedUnit) * v['$line-height-sm'] + rmUnit(v['$input-padding-y-sm'], detectedUnit) * 2 + detectedUnit;
  v['$input-height-lg'] = u['$input-height-lg'] || rmUnit(v['$font-size-lg'], detectedUnit) * v['$line-height-lg'] + rmUnit(v['$input-padding-y-lg'], detectedUnit) * 2 + detectedUnit;
  v['$input-transition'] = u['$input-transition'] || 'border-color ease-in-out .15s, box-shadow ease-in-out .15s';
  v['$label-margin-bottom'] = u['$label-margin-bottom'] || '.5rem';
  v['$form-text-margin-top'] = u['$form-text-margin-top'] || '.25rem';
  v['$form-feedback-margin-top'] = u['$form-feedback-margin-top'] || v['$form-text-margin-top'];
  v['$form-check-margin-bottom'] = u['$form-check-margin-bottom'] || '.5rem';
  v['$form-check-input-gutter'] = u['$form-check-input-gutter'] || '1.25rem';
  v['$form-check-input-margin-y'] = u['$form-check-input-margin-y'] || '.25rem';
  v['$form-check-input-margin-x'] = u['$form-check-input-margin-x'] || '.25rem';
  v['$form-check-inline-margin-x'] = u['$form-check-inline-margin-x'] || '.75rem';
  v['$form-group-margin-bottom'] = u['$form-group-margin-bottom'] || v['$spacer-y'];
  v['$input-group-addon-bg'] = u['$input-group-addon-bg'] || v['$gray-lighter'];
  v['$input-group-addon-border-color'] = u['$input-group-addon-border-color'] || v['$input-border-color'];
  v['$cursor-disabled'] = u['$cursor-disabled'] || 'not-allowed';
  v['$custom-control-gutter'] = u['$custom-control-gutter'] || '1.5rem';
  v['$custom-control-spacer-x'] = u['$custom-control-spacer-x'] || '1rem';
  v['$custom-control-spacer-y'] = u['$custom-control-spacer-y'] || '.25rem';
  v['$custom-control-indicator-size'] = u['$custom-control-indicator-size'] || '1rem';
  v['$custom-control-indicator-bg'] = u['$custom-control-indicator-bg'] || '#ddd';
  v['$custom-control-indicator-bg-size'] = u['$custom-control-indicator-bg-size'] || '50% 50%';
  v['$custom-control-indicator-box-shadow'] = u['$custom-control-indicator-box-shadow'] || "inset 0 .25rem .25rem ".concat((0, _color.default)(v['$black']).alpha(0.1).toString());
  v['$custom-control-disabled-cursor'] = u['$custom-control-disabled-cursor'] || v['$cursor-disabled'];
  v['$custom-control-disabled-indicator-bg'] = u['$custom-control-disabled-indicator-bg'] || v['$gray-lighter'];
  v['$custom-control-disabled-description-color'] = u['$custom-control-disabled-description-color'] || v['$gray-light'];
  v['$custom-control-checked-indicator-color'] = u['$custom-control-checked-indicator-color'] || v['$white'];
  v['$custom-control-checked-indicator-bg'] = u['$custom-control-checked-indicator-bg'] || v['$brand-primary'];
  v['$custom-control-checked-indicator-box-shadow'] = u['$custom-control-checked-indicator-box-shadow'] || 'none';
  v['$custom-control-focus-indicator-box-shadow'] = u['$custom-control-focus-indicator-box-shadow'] || "0 0 0 1px ".concat(v['$body-bg'], ", 0 0 0 3px ").concat(v['$brand-primary']);
  v['$custom-control-active-indicator-color'] = u['$custom-control-active-indicator-color'] || v['$white'];
  v['$custom-control-active-indicator-bg'] = u['$custom-control-active-indicator-bg'] || (0, _color.default)(v['$brand-primary']).lighten(0.35).toString();
  v['$custom-control-active-indicator-box-shadow'] = u['$custom-control-active-indicator-box-shadow'] || 'none';
  v['$custom-checkbox-radius'] = u['$custom-checkbox-radius'] || v['$border-radius'];
  v['$custom-checkbox-checked-icon'] = u['$custom-checkbox-checked-icon'] || "url('data:image/svg+xml;charset=utf8,%3Csvg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 8 8\"%3E%3Cpath fill=\"".concat(v['$custom-control-checked-indicator-color'], "\" d=\"M6.564.75l-3.59 3.612-1.538-1.55L0 4.26 2.974 7.25 8 2.193z\"/%3E%3C/svg%3E')");
  v['$custom-checkbox-indeterminate-bg'] = u['$custom-checkbox-indeterminate-bg'] || v['$brand-primary'];
  v['$custom-checkbox-indeterminate-indicator-color'] = u['$custom-checkbox-indeterminate-indicator-color'] || v['$custom-control-checked-indicator-color'];
  v['$custom-checkbox-indeterminate-icon'] = u['$custom-checkbox-indeterminate-icon'] || "url('data:image/svg+xml;charset=utf8,%3Csvg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 4 4\"%3E%3Cpath stroke=\"".concat(v['$custom-checkbox-indeterminate-indicator-color'], "\" d=\"M0 2h4\"/%3E%3C/svg%3E')");
  v['$custom-checkbox-indeterminate-box-shadow'] = u['$custom-checkbox-indeterminate-box-shadow'] || 'none';
  v['$custom-radio-radius'] = u['$custom-radio-radius'] || '50%';
  v['$custom-radio-checked-icon'] = u['$custom-radio-checked-icon'] || "url('data:image/svg+xml;charset=utf8,%3Csvg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"-4 -4 8 8\"%3E%3Ccircle r=\"3\" fill=\"".concat(v['$custom-control-checked-indicator-color'], "\"/%3E%3C/svg%3E')");
  v['$custom-select-padding-x'] = u['$custom-select-padding-x'] || '.75rem ';
  v['$custom-select-padding-y'] = u['$custom-select-padding-y'] || '.375rem';
  v['$custom-select-indicator-padding'] = u['$custom-select-indicator-padding'] || '1rem';
  v['$custom-select-line-height'] = u['$custom-select-line-height'] || v['$input-line-height'];
  v['$custom-select-color'] = u['$custom-select-color'] || v['$input-color'];
  v['$custom-select-disabled-color'] = u['$custom-select-disabled-color'] || v['$gray-light'];
  v['$custom-select-bg'] = u['$custom-select-bg'] || v['$white'];
  v['$custom-select-disabled-bg'] = u['$custom-select-disabled-bg'] || v['$gray-lighter'];
  v['$custom-select-bg-size'] = u['$custom-select-bg-size'] || '8px 10px';
  v['$custom-select-indicator-color'] = u['$custom-select-indicator-color'] || '#333';
  v['$custom-select-indicator'] = u['$custom-select-indicator'] || "url('data:image/svg+xml;charset=utf8,%3Csvg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 4 5\"%3E%3Cpath fill=\"".concat(v['$custom-select-indicator-color'], "\" d=\"M2 0L0 2h4zm0 5L0 3h4z\"/%3E%3C/svg%3E')");
  v['$custom-select-border-width'] = u['$custom-select-border-width'] || v['$input-btn-border-width'];
  v['$custom-select-border-color'] = u['$custom-select-border-color'] || v['$input-border-color'];
  v['$custom-select-border-radius'] = u['$custom-select-border-radius'] || v['$border-radius'];
  v['$custom-select-focus-border-color'] = u['$custom-select-focus-border-color'] || (0, _color.default)(v['$brand-primary']).lighten(0.25).toString();
  v['$custom-select-focus-box-shadow'] = u['$custom-select-focus-box-shadow'] || "inset 0 1px 2px ".concat((0, _color.default)(v['$black']).alpha(0.75).toString(), ", 0 0 5px rgba(").concat(v['$custom-select-focus-border-color'], ", .5)");
  v['$custom-select-sm-font-size'] = u['$custom-select-sm-font-size'] || '75%';
  v['$custom-file-height'] = u['$custom-file-height'] || '2.5rem';
  v['$custom-file-width'] = u['$custom-file-width'] || '14rem';
  v['$custom-file-focus-box-shadow'] = u['$custom-file-focus-box-shadow'] || "0 0 0 .075rem ".concat(v['$white'], ", 0 0 0 .2rem ").concat(v['$brand-primary']);
  v['$custom-file-padding-x'] = u['$custom-file-padding-x'] || '.5rem';
  v['$custom-file-padding-y'] = u['$custom-file-padding-y'] || '1rem';
  v['$custom-file-line-height'] = u['$custom-file-line-height'] || '1.5';
  v['$custom-file-color'] = u['$custom-file-color'] || v['$gray'];
  v['$custom-file-bg'] = u['$custom-file-bg'] || v['$white'];
  v['$custom-file-border-width'] = u['$custom-file-border-width'] || v['$border-width'];
  v['$custom-file-border-color'] = u['$custom-file-border-color'] || v['$input-border-color'];
  v['$custom-file-border-radius'] = u['$custom-file-border-radius'] || v['$border-radius'];
  v['$custom-file-box-shadow'] = u['$custom-file-box-shadow'] || "inset 0 .2rem .4rem ".concat((0, _color.default)(v['$black']).alpha(0.05).toString());
  v['$custom-file-button-color'] = u['$custom-file-button-color'] || v['$custom-file-color'];
  v['$custom-file-button-bg'] = u['$custom-file-button-bg'] || v['$gray-lighter'];
  v['$custom-file-text'] = u['$custom-file-text'] || {
    placeholder: {
      en: 'Choose file...'
    },
    'button-label': {
      en: 'Browse'
    }
  };
  v['$form-icon-success-color'] = u['$form-icon-success-color'] || v['$brand-success'];
  v['$form-icon-success'] = u['$form-icon-success'] || "url('data:image/svg+xml;charset=utf8,%3Csvg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 8 8\"%3E%3Cpath fill=\"".concat(v['$form-icon-success-color'], "\" d=\"M2.3 6.73L.6 4.53c-.4-1.04.46-1.4 1.1-.8l1.1 1.4 3.4-3.8c.6-.63 1.6-.27 1.2.7l-4 4.6c-.43.5-.8.4-1.1.1z\"/%3E%3C/svg%3E')");
  v['$form-icon-warning-color'] = u['$form-icon-warning-color'] || v['$brand-warning'];
  v['$form-icon-warning'] = u['$form-icon-warning'] || "url('data:image/svg+xml;charset=utf8,%3Csvg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 8 8\"%3E%3Cpath fill=\"".concat(v['$form-icon-warning-color'], "\" d=\"M4.4 5.324h-.8v-2.46h.8zm0 1.42h-.8V5.89h.8zM3.76.63L.04 7.075c-.115.2.016.425.26.426h7.397c.242 0 .372-.226.258-.426C6.726 4.924 5.47 2.79 4.253.63c-.113-.174-.39-.174-.494 0z\"/%3E%3C/svg%3E')");
  v['$form-icon-danger-color'] = u['$form-icon-danger-color'] || v['$brand-danger'];
  v['$form-icon-danger'] = u['$form-icon-danger'] || "url('data:image/svg+xml;charset=utf8,%3Csvg xmlns=\"http://www.w3.org/2000/svg\" fill=\"".concat(v['$form-icon-danger-color'], "\" viewBox=\"-2 -2 7 7\"%3E%3Cpath stroke=\"%23d9534f\" d=\"M0 0l3 3m0-3L0 3\"/%3E%3Ccircle r=\".5\"/%3E%3Ccircle cx=\"3\" r=\".5\"/%3E%3Ccircle cy=\"3\" r=\".5\"/%3E%3Ccircle cx=\"3\" cy=\"3\" r=\".5\"/%3E%3C/svg%3E')");
  v['$dropdown-min-width'] = u['$dropdown-min-width'] || '10rem';
  v['$dropdown-padding-y'] = u['$dropdown-padding-y'] || '.5rem';
  v['$dropdown-margin-top'] = u['$dropdown-margin-top'] || '.125rem';
  v['$dropdown-bg'] = u['$dropdown-bg'] || v['$white'];
  v['$dropdown-border-color'] = u['$dropdown-border-color'] || (0, _color.default)(v['$black']).alpha(0.15).toString();
  v['$dropdown-border-width'] = u['$dropdown-border-width'] || v['$border-width'];
  v['$dropdown-divider-bg'] = u['$dropdown-divider-bg'] || v['$gray-lighter'];
  v['$dropdown-box-shadow'] = u['$dropdown-box-shadow'] || "0 .5rem 1rem rgba(".concat(v['$black'], ",.175)");
  v['$dropdown-link-color'] = u['$dropdown-link-color'] || v['$gray-dark'];
  v['$dropdown-link-hover-color'] = u['$dropdown-link-hover-color'] || (0, _color.default)(v['$gray-dark']).darken(0.05).toString();
  v['$dropdown-link-hover-bg'] = u['$dropdown-link-hover-bg'] || v['$gray-lightest'];
  v['$dropdown-link-active-color'] = u['$dropdown-link-active-color'] || v['$component-active-color'];
  v['$dropdown-link-active-bg'] = u['$dropdown-link-active-bg'] || v['$component-active-bg'];
  v['$dropdown-link-disabled-color'] = u['$dropdown-link-disabled-color'] || v['$gray-light'];
  v['$dropdown-item-padding-x'] = u['$dropdown-item-padding-x'] || '1.5rem';
  v['$dropdown-header-color'] = u['$dropdown-header-color'] || v['$gray-light'];
  v['$zindex-dropdown-backdrop'] = u['$zindex-dropdown-backdrop'] || '990';
  v['$zindex-dropdown'] = u['$zindex-dropdown'] || '1000';
  v['$zindex-modal-backdrop'] = u['$zindex-modal-backdrop'] || '2040';
  v['$zindex-modal'] = u['$zindex-modal'] || '2050';
  v['$zindex-popover'] = u['$zindex-popover'] || '1060';
  v['$zindex-tooltip'] = u['$zindex-tooltip'] || '1070';
  v['$zindex-navbar'] = u['$zindex-navbar'] || '1000';
  v['$zindex-navbar-fixed'] = u['$zindex-navbar-fixed'] || '1030';
  v['$zindex-navbar-sticky'] = u['$zindex-navbar-sticky'] || '1030';
  v['$navbar-padding-x'] = u['$navbar-padding-x'] || v['$spacer'];
  v['$navbar-padding-y'] = u['$navbar-padding-y'] || v['$spacer-halved'];
  v['$navbar-brand-padding-y'] = u['$navbar-brand-padding-y'] || '.25rem';
  v['$navbar-divider-padding-y'] = u['$navbar-divider-padding-y'] || '.425rem';
  v['$navbar-toggler-padding-x'] = u['$navbar-toggler-padding-x'] || '.75rem';
  v['$navbar-toggler-padding-y'] = u['$navbar-toggler-padding-y'] || '.25rem';
  v['$navbar-toggler-font-size'] = u['$navbar-toggler-font-size'] || v['$font-size-lg'];
  v['$navbar-toggler-border-radius'] = u['$navbar-toggler-border-radius'] || v['$btn-border-radius'];
  v['$navbar-inverse-color'] = u['$navbar-inverse-color'] || (0, _color.default)(v['$white']).alpha(0.5).toString();
  v['$navbar-inverse-hover-color'] = u['$navbar-inverse-hover-color'] || (0, _color.default)(v['$white']).alpha(0.75).toString();
  v['$navbar-inverse-active-color'] = u['$navbar-inverse-active-color'] || (0, _color.default)(v['$white']).alpha(1).toString();
  v['$navbar-inverse-disabled-color'] = u['$navbar-inverse-disabled-color'] || (0, _color.default)(v['$white']).alpha(0.25).toString();
  v['$navbar-inverse-toggler-bg'] = u['$navbar-inverse-toggler-bg'] || "url('data:image/svg+xml;charset=utf8,%3Csvg viewBox=\"0 0 30 30\" xmlns=\"http://www.w3.org/2000/svg\"%3E%3Cpath stroke=\"".concat(v['$navbar-inverse-color'], "\" stroke-width=\"2\" stroke-linecap=\"round\" stroke-miterlimit=\"10\" d=\"M4 7h22M4 15h22M4 23h22\"/%3E%3C/svg%3E')");
  v['$navbar-inverse-toggler-border'] = u['$navbar-inverse-toggler-border'] || (0, _color.default)(v['$white']).alpha(0.1).toString();
  v['$navbar-light-color'] = u['$navbar-light-color'] || (0, _color.default)(v['$black']).alpha(0.5).toString();
  v['$navbar-light-hover-color'] = u['$navbar-light-hover-color'] || (0, _color.default)(v['$black']).alpha(0.7).toString();
  v['$navbar-light-active-color'] = u['$navbar-light-active-color'] || (0, _color.default)(v['$black']).alpha(0.9).toString();
  v['$navbar-light-disabled-color'] = u['$navbar-light-disabled-color'] || (0, _color.default)(v['$black']).alpha(0.3).toString();
  v['$navbar-light-toggler-bg'] = u['$navbar-light-toggler-bg'] || "url('data:image/svg+xml;charset=utf8,%3Csvg viewBox=\"0 0 30 30\" xmlns=\"http://www.w3.org/2000/svg\"%3E%3Cpath stroke=\"".concat(v['$navbar-light-color'], "\" stroke-width=\"2\" stroke-linecap=\"round\" stroke-miterlimit=\"10\" d=\"M4 7h22M4 15h22M4 23h22\"/%3E%3C/svg%3E')");
  v['$navbar-light-toggler-border'] = u['$navbar-light-toggler-border'] || (0, _color.default)(v['$black']).alpha(0.1).toString();
  v['$nav-link-padding'] = u['$nav-link-padding'] || '.5em 1em';
  v['$nav-disabled-link-color'] = u['$nav-disabled-link-color'] || v['$gray-light'];
  v['$nav-tabs-border-color'] = u['$nav-tabs-border-color'] || '#ddd';
  v['$nav-tabs-border-width'] = u['$nav-tabs-border-width'] || v['$border-width'];
  v['$nav-tabs-border-radius'] = u['$nav-tabs-border-radius'] || v['$border-radius'];
  v['$nav-tabs-link-hover-border-color'] = u['$nav-tabs-link-hover-border-color'] || v['$gray-lighter'];
  v['$nav-tabs-active-link-hover-color'] = u['$nav-tabs-active-link-hover-color'] || v['$gray'];
  v['$nav-tabs-active-link-hover-bg'] = u['$nav-tabs-active-link-hover-bg'] || v['$body-bg'];
  v['$nav-tabs-active-link-hover-border-color'] = u['$nav-tabs-active-link-hover-border-color'] || '#ddd';
  v['$nav-pills-border-radius'] = u['$nav-pills-border-radius'] || v['$border-radius'];
  v['$nav-pills-active-link-color'] = u['$nav-pills-active-link-color'] || v['$component-active-color'];
  v['$nav-pills-active-link-bg'] = u['$nav-pills-active-link-bg'] || v['$component-active-bg'];
  v['$pagination-padding-x'] = u['$pagination-padding-x'] || '.75rem';
  v['$pagination-padding-y'] = u['$pagination-padding-y'] || '.5rem';
  v['$pagination-padding-x-sm'] = u['$pagination-padding-x-sm'] || '.5rem';
  v['$pagination-padding-y-sm'] = u['$pagination-padding-y-sm'] || '.25rem';
  v['$pagination-padding-x-lg'] = u['$pagination-padding-x-lg'] || '1.5rem';
  v['$pagination-padding-y-lg'] = u['$pagination-padding-y-lg'] || '.75rem';
  v['$pagination-line-height'] = u['$pagination-line-height'] || '1.25';
  v['$pagination-color'] = u['$pagination-color'] || v['$link-color'];
  v['$pagination-bg'] = u['$pagination-bg'] || v['$white'];
  v['$pagination-border-width'] = u['$pagination-border-width'] || v['$border-width'];
  v['$pagination-border-color'] = u['$pagination-border-color'] || '#ddd';
  v['$pagination-hover-color'] = u['$pagination-hover-color'] || v['$link-hover-color'];
  v['$pagination-hover-bg'] = u['$pagination-hover-bg'] || v['$gray-lighter'];
  v['$pagination-hover-border'] = u['$pagination-hover-border'] || '#ddd';
  v['$pagination-active-color'] = u['$pagination-active-color'] || v['$white'];
  v['$pagination-active-bg'] = u['$pagination-active-bg'] || v['$brand-primary'];
  v['$pagination-active-border'] = u['$pagination-active-border'] || v['$brand-primary'];
  v['$pagination-disabled-color'] = u['$pagination-disabled-color'] || v['$gray-light'];
  v['$pagination-disabled-bg'] = u['$pagination-disabled-bg'] || v['$white'];
  v['$pagination-disabled-border'] = u['$pagination-disabled-border'] || '#ddd';
  v['$jumbotron-padding'] = u['$jumbotron-padding'] || '2rem';
  v['$jumbotron-bg'] = u['$jumbotron-bg'] || v['$gray-lighter'];
  v['$state-success-text'] = u['$state-success-text'] || '#3c763d';
  v['$state-success-bg'] = u['$state-success-bg'] || '#dff0d8';
  v['$state-success-border'] = u['$state-success-border'] || (0, _color.default)(v['$state-success-bg']).darken(0.05).toString();
  v['$state-info-text'] = u['$state-info-text'] || '#31708f';
  v['$state-info-bg'] = u['$state-info-bg'] || '#d9edf7';
  v['$state-info-border'] = u['$state-info-border'] || (0, _color.default)(v['$state-info-bg']).darken(0.07).toString();
  v['$state-warning-text'] = u['$state-warning-text'] || '#8a6d3b';
  v['$state-warning-bg'] = u['$state-warning-bg'] || '#fcf8e3';
  v['$state-warning-border'] = u['$state-warning-border'] || (0, _color.default)(v['$state-warning-bg']).darken(0.05).toString();
  v['$mark-bg'] = u['$mark-bg'] || v['$state-warning-bg'];
  v['$state-danger-text'] = u['$state-danger-text'] || '#a94442';
  v['$state-danger-bg'] = u['$state-danger-bg'] || '#f2dede';
  v['$state-danger-border'] = u['$state-danger-border'] || (0, _color.default)(v['$state-danger-bg']).darken(0.05).toString();
  v['$card-spacer-x'] = u['$card-spacer-x'] || '1.25rem';
  v['$card-spacer-y'] = u['$card-spacer-y'] || '.75rem';
  v['$card-border-width'] = u['$card-border-width'] || '1px';
  v['$card-border-radius'] = u['$card-border-radius'] || v['$border-radius'];
  v['$card-border-color'] = u['$card-border-color'] || (0, _color.default)(v['$black']).alpha(0.125).toString();
  v['$card-border-radius-inner'] = u['$card-border-radius-inner'] || "calc(".concat(v['$card-border-radius'], " - ").concat(v['$card-border-width'], ")");
  v['$card-cap-bg'] = u['$card-cap-bg'] || v['$gray-lightest'];
  v['$card-bg'] = u['$card-bg'] || v['$white'];
  v['$card-link-hover-color'] = u['$card-link-hover-color'] || v['$white'];
  v['$card-img-overlay-padding'] = u['$card-img-overlay-padding'] || '1.25rem';
  detectedUnit = detectUnit(v['$grid-gutter-width']);
  v['$card-group-margin'] = u['$card-group-margin'] || rmUnit(v['$grid-gutter-width'], detectedUnit) / 2 + detectedUnit;
  v['$card-deck-margin'] = u['$card-deck-margin'] || v['$card-group-margin'];
  v['$card-columns-count-md'] = u['$card-columns-count-md'] || '2';
  v['$card-columns-gap-md'] = u['$card-columns-gap-md'] || '1rem';
  v['$card-columns-margin-md'] = u['$card-columns-margin-md'] || v['$card-spacer-y'];
  v['$card-columns-count-lg'] = u['$card-columns-count-lg'] || '2';
  v['$card-columns-gap-lg'] = u['$card-columns-gap-lg'] || '1.15rem';
  v['$card-columns-margin-lg'] = u['$card-columns-margin-lg'] || v['$card-spacer-y'];
  v['$card-columns-count-xl'] = u['$card-columns-count-xl'] || '3';
  v['$card-columns-gap-xl'] = u['$card-columns-gap-xl'] || '1.25rem';
  v['$card-columns-margin-xl'] = u['$card-columns-margin-xl'] || v['$card-spacer-y'];
  v['$card-columns-count-xxl'] = u['$card-columns-count-xxl'] || '4';
  v['$card-columns-gap-xxl'] = u['$card-columns-gap-xxl'] || '1.25rem';
  v['$card-columns-margin-xxl'] = u['$card-columns-margin-xxl'] || v['$card-spacer-y'];
  v['$tooltip-max-width'] = u['$tooltip-max-width'] || '200px';
  v['$tooltip-color'] = u['$tooltip-color'] || v['$white'];
  v['$tooltip-bg'] = u['$tooltip-bg'] || v['$black'];
  v['$tooltip-opacity'] = u['$tooltip-opacity'] || '.9';
  v['$tooltip-padding-y'] = u['$tooltip-padding-y'] || '3px';
  v['$tooltip-padding-x'] = u['$tooltip-padding-x'] || '8px';
  v['$tooltip-margin'] = u['$tooltip-margin'] || '3px';
  v['$tooltip-arrow-width'] = u['$tooltip-arrow-width'] || '5px';
  v['$tooltip-arrow-color'] = u['$tooltip-arrow-color'] || v['$tooltip-bg'];
  v['$popover-inner-padding'] = u['$popover-inner-padding'] || '1px';
  v['$popover-bg'] = u['$popover-bg'] || v['$white'];
  v['$popover-max-width'] = u['$popover-max-width'] || '276px';
  v['$popover-border-width'] = u['$popover-border-width'] || v['$border-width'];
  v['$popover-border-color'] = u['$popover-border-color'] || (0, _color.default)(v['$black']).alpha(0.2).toString();
  v['$popover-box-shadow'] = u['$popover-box-shadow'] || "0 5px 10px ".concat((0, _color.default)(v['$black']).alpha(0.2).toString());
  v['$popover-title-bg'] = u['$popover-title-bg'] || (0, _color.default)(v['$popover-bg']).darken(0.03).toString();
  v['$popover-title-padding-x'] = u['$popover-title-padding-x'] || '14px';
  v['$popover-title-padding-y'] = u['$popover-title-padding-y'] || '8px';
  v['$popover-content-padding-x'] = u['$popover-content-padding-x'] || '14px';
  v['$popover-content-padding-y'] = u['$popover-content-padding-y'] || '9px';
  v['$popover-arrow-width'] = u['$popover-arrow-width'] || '10px';
  v['$popover-arrow-color'] = u['$popover-arrow-color'] || v['$popover-bg'];
  detectedUnit = detectUnit(v['$popover-arrow-width']);
  v['$popover-arrow-outer-width'] = u['$popover-arrow-outer-width'] || rmUnit(v['$popover-arrow-width'], detectedUnit) + 1 + detectedUnit;
  v['$popover-arrow-outer-color'] = u['$popover-arrow-outer-color'] || (0, _color.default)(v['$popover-border-color']).fade(0.5).toString();
  v['$badge-default-bg'] = u['$badge-default-bg'] || v['$gray-light'];
  v['$badge-primary-bg'] = u['$badge-primary-bg'] || v['$brand-primary'];
  v['$badge-success-bg'] = u['$badge-success-bg'] || v['$brand-success'];
  v['$badge-info-bg'] = u['$badge-info-bg'] || v['$brand-info'];
  v['$badge-warning-bg'] = u['$badge-warning-bg'] || v['$brand-warning'];
  v['$badge-danger-bg'] = u['$badge-danger-bg'] || v['$brand-danger'];
  v['$badge-color'] = u['$badge-color'] || v['$white'];
  v['$badge-link-hover-color'] = u['$badge-link-hover-color'] || v['$white'];
  v['$badge-font-size'] = u['$badge-font-size'] || '75%';
  v['$badge-font-weight'] = u['$badge-font-weight'] || v['$font-weight-bold'];
  v['$badge-padding-x'] = u['$badge-padding-x'] || '.4em';
  v['$badge-padding-y'] = u['$badge-padding-y'] || '.25em';
  v['$badge-pill-padding-x'] = u['$badge-pill-padding-x'] || '.6em';
  v['$badge-pill-border-radius'] = u['$badge-pill-border-radius'] || '10rem';
  v['$modal-inner-padding'] = u['$modal-inner-padding'] || '15px';
  v['$modal-dialog-margin'] = u['$modal-dialog-margin'] || '10px';
  v['$modal-dialog-sm-up-margin-y'] = u['$modal-dialog-sm-up-margin-y'] || '30px';
  v['$modal-title-line-height'] = u['$modal-title-line-height'] || v['$line-height-base'];
  v['$modal-content-bg'] = u['$modal-content-bg'] || v['$white'];
  v['$modal-content-border-color'] = u['$modal-content-border-color'] || (0, _color.default)(v['$black']).alpha(0.2).toString();
  v['$modal-content-border-width'] = u['$modal-content-border-width'] || v['$border-width'];
  v['$modal-content-xs-box-shadow'] = u['$modal-content-xs-box-shadow'] || "0 3px 9px ".concat((0, _color.default)(v['$black']).alpha(0.5).toString());
  v['$modal-content-sm-up-box-shadow'] = u['$modal-content-sm-up-box-shadow'] || "0 5px 15px ".concat((0, _color.default)(v['$black']).alpha(0.5).toString());
  v['$modal-backdrop-bg'] = u['$modal-backdrop-bg'] || v['$black'];
  v['$modal-backdrop-opacity'] = u['$modal-backdrop-opacity'] || '.5';
  v['$modal-header-border-color'] = u['$modal-header-border-color'] || v['$gray-lighter'];
  v['$modal-footer-border-color'] = u['$modal-footer-border-color'] || v['$modal-header-border-color'];
  v['$modal-header-border-width'] = u['$modal-header-border-width'] || v['$modal-content-border-width'];
  v['$modal-footer-border-width'] = u['$modal-footer-border-width'] || v['$modal-header-border-width'];
  v['$modal-header-padding'] = u['$modal-header-padding'] || '15px';
  v['$modal-lg'] = u['$modal-lg'] || '800px';
  v['$modal-md'] = u['$modal-md'] || '500px';
  v['$modal-sm'] = u['$modal-sm'] || '300px';
  v['$modal-transition'] = u['$modal-transition'] || 'transform .3s ease-out';
  v['$alert-padding-x'] = u['$alert-padding-x'] || '1.25rem';
  v['$alert-padding-y'] = u['$alert-padding-y'] || '.75rem';
  v['$alert-margin-bottom'] = u['$alert-margin-bottom'] || v['$spacer-y'];
  v['$alert-border-radius'] = u['$alert-border-radius'] || v['$border-radius'];
  v['$alert-link-font-weight'] = u['$alert-link-font-weight'] || v['$font-weight-bold'];
  v['$alert-border-width'] = u['$alert-border-width'] || v['$border-width'];
  v['$alert-success-bg'] = u['$alert-success-bg'] || v['$state-success-bg'];
  v['$alert-success-text'] = u['$alert-success-text'] || v['$state-success-text'];
  v['$alert-success-border'] = u['$alert-success-border'] || v['$state-success-border'];
  v['$alert-info-bg'] = u['$alert-info-bg'] || v['$state-info-bg'];
  v['$alert-info-text'] = u['$alert-info-text'] || v['$state-info-text'];
  v['$alert-info-border'] = u['$alert-info-border'] || v['$state-info-border'];
  v['$alert-warning-bg'] = u['$alert-warning-bg'] || v['$state-warning-bg'];
  v['$alert-warning-text'] = u['$alert-warning-text'] || v['$state-warning-text'];
  v['$alert-warning-border'] = u['$alert-warning-border'] || v['$state-warning-border'];
  v['$alert-danger-bg'] = u['$alert-danger-bg'] || v['$state-danger-bg'];
  v['$alert-danger-text'] = u['$alert-danger-text'] || v['$state-danger-text'];
  v['$alert-danger-border'] = u['$alert-danger-border'] || v['$state-danger-border'];
  v['$progress-height'] = u['$progress-height'] || '1rem';
  v['$progress-font-size'] = u['$progress-font-size'] || '.75rem';
  v['$progress-bg'] = u['$progress-bg'] || v['$gray-lighter'];
  v['$progress-border-radius'] = u['$progress-border-radius'] || v['$border-radius'];
  v['$progress-box-shadow'] = u['$progress-box-shadow'] || "inset 0 .1rem .1rem ".concat((0, _color.default)(v['$black']).alpha(0.1).toString());
  v['$progress-bar-color'] = u['$progress-bar-color'] || v['$white'];
  v['$progress-bar-bg'] = u['$progress-bar-bg'] || v['$brand-primary'];
  v['$progress-bar-animation-timing'] = u['$progress-bar-animation-timing'] || '1s linear infinite';
  v['$list-group-color'] = u['$list-group-color'] || v['$body-color'];
  v['$list-group-bg'] = u['$list-group-bg'] || v['$white'];
  v['$list-group-border-color'] = u['$list-group-border-color'] || (0, _color.default)(v['$black']).alpha(0.125).toString();
  v['$list-group-border-width'] = u['$list-group-border-width'] || v['$border-width'];
  v['$list-group-border-radius'] = u['$list-group-border-radius'] || v['$border-radius'];
  v['$list-group-item-padding-x'] = u['$list-group-item-padding-x'] || '1.25rem';
  v['$list-group-item-padding-y'] = u['$list-group-item-padding-y'] || '.75rem';
  v['$list-group-hover-bg'] = u['$list-group-hover-bg'] || v['$gray-lightest'];
  v['$list-group-active-color'] = u['$list-group-active-color'] || v['$component-active-color'];
  v['$list-group-active-bg'] = u['$list-group-active-bg'] || v['$component-active-bg'];
  v['$list-group-active-border'] = u['$list-group-active-border'] || v['$list-group-active-bg'];
  v['$list-group-disabled-color'] = u['$list-group-disabled-color'] || v['$gray-light'];
  v['$list-group-disabled-bg'] = u['$list-group-disabled-bg'] || v['$list-group-bg'];
  v['$list-group-link-color'] = u['$list-group-link-color'] || v['$gray'];
  v['$list-group-link-hover-color'] = u['$list-group-link-hover-color'] || v['$list-group-link-color'];
  v['$list-group-link-active-color'] = u['$list-group-link-active-color'] || v['$list-group-color'];
  v['$list-group-link-active-bg'] = u['$list-group-link-active-bg'] || v['$gray-lighter'];
  v['$thumbnail-padding'] = u['$thumbnail-padding'] || '.25rem';
  v['$thumbnail-bg'] = u['$thumbnail-bg'] || v['$body-bg'];
  v['$thumbnail-border-width'] = u['$thumbnail-border-width'] || v['$border-width'];
  v['$thumbnail-border-color'] = u['$thumbnail-border-color'] || '#ddd';
  v['$thumbnail-border-radius'] = u['$thumbnail-border-radius'] || v['$border-radius'];
  v['$thumbnail-box-shadow'] = u['$thumbnail-box-shadow'] || "0 1px 2px ".concat((0, _color.default)(v['$black']).alpha(0.75).toString());
  v['$thumbnail-transition'] = u['$thumbnail-transition'] || 'all .2s ease-in-out';
  v['$figure-caption-font-size'] = u['$figure-caption-font-size'] || '90%';
  v['$figure-caption-color'] = u['$figure-caption-color'] || v['$gray-light'];
  v['$breadcrumb-padding-y'] = u['$breadcrumb-padding-y'] || '.75rem';
  v['$breadcrumb-padding-x'] = u['$breadcrumb-padding-x'] || '1rem';
  v['$breadcrumb-item-padding'] = u['$breadcrumb-item-padding'] || '.5rem';
  v['$breadcrumb-bg'] = u['$breadcrumb-bg'] || v['$gray-lighter'];
  v['$breadcrumb-divider-color'] = u['$breadcrumb-divider-color'] || v['$gray-light'];
  v['$breadcrumb-active-color'] = u['$breadcrumb-active-color'] || v['$gray-light'];
  v['$breadcrumb-divider'] = u['$breadcrumb-divider'] || '"/"';
  v['$close-font-size'] = u['$close-font-size'] || rmUnit(v['$font-size-base']) * 1.5 + detectUnit(v['$font-size-base']);
  v['$close-font-weight'] = u['$close-font-weight'] || v['$font-weight-bold'];
  v['$close-color'] = u['$close-color'] || v['$black'];
  v['$close-text-shadow'] = u['$close-text-shadow'] || "0 1px 0 ".concat(v['$white']);
  v['$code-font-size'] = u['$code-font-size'] || '90%';
  v['$code-padding-x'] = u['$code-padding-x'] || '.4rem';
  v['$code-padding-y'] = u['$code-padding-y'] || '.2rem';
  v['$code-color'] = u['$code-color'] || '#bd4147';
  v['$code-bg'] = u['$code-bg'] || v['$gray-lightest'];
  v['$kbd-color'] = u['$kbd-color'] || v['$white'];
  v['$kbd-bg'] = u['$kbd-bg'] || v['$gray-dark'];
  v['$kbd-box-shadow'] = u['$kbd-box-shadow'] || "inset 0 -.1rem 0 ".concat((0, _color.default)(v['$black']).alpha(0.25).toString());
  v['$nested-kbd-font-weight'] = u['$nested-kbd-font-weight'] || v['$font-weight-bold'];
  v['$pre-color'] = u['$pre-color'] || v['$gray-dark'];
  v['$pre-scrollable-max-height'] = u['$pre-scrollable-max-height'] || '340px';
  return Object.assign({}, u, v);
}
var makeTheme = makeOriginal;
exports.makeTheme = makeTheme;
var _default = makeOriginal();
exports.default = _default;
});
var bsTheme = unwrapExports(theme);
var theme_1 = theme.makeTheme;

var FigCaptionUnstyled =
function (_React$Component) {
  _inherits(FigCaptionUnstyled, _React$Component);
  function FigCaptionUnstyled() {
    _classCallCheck(this, FigCaptionUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(FigCaptionUnstyled).apply(this, arguments));
  }
  _createClass(FigCaptionUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          children = _omit.children,
          right = _omit.right,
          rest = _objectWithoutProperties(_omit, ["className", "children", "right"]);
      var classes = classnames('figure-caption', className, right ? 'text-right' : null);
      return React.createElement("figcaption", _extends({
        className: classes
      }, rest), children);
    }
  }]);
  return FigCaptionUnstyled;
}(React.Component);
_defineProperty(FigCaptionUnstyled, "propTypes", {
  children: propTypes.node,
  className: propTypes.string,
  right: propTypes.bool,
  theme: propTypes.object
});
_defineProperty(FigCaptionUnstyled, "defaultProps", {
  theme: bsTheme
});
var FigCaption = styled(FigCaptionUnstyled).withConfig({
  displayName: "FigCaption",
  componentId: "sc-16ki7fr-0"
})(["", ""], function (props) {
  return "\n    &.figure-caption {\n      font-size: ".concat(props.theme['$figure-caption-font-size'], ";\n      color: ").concat(props.theme['$figure-caption-color'], ";\n    }\n  ");
});

var defaultProps$w = {
  tag: 'input',
  theme: {
    '$enable-rounded': true,
    '$enable-shadows': false,
    '$enable-hover-media-query': false,
    '$enable-transitions': true,
    '$font-weight-normal': 'normal',
    '$font-size-base': '1rem',
    '$font-size-lg': '1.25rem',
    '$font-size-sm': '.875rem',
    '$font-size-xs': '.75rem',
    '$btn-padding-x': '1rem',
    '$btn-padding-y': '.5rem',
    '$btn-line-height': '1.25',
    '$btn-font-weight': 'normal',
    '$btn-transition': 'all .2s ease-in-out',
    '$btn-box-shadow': 'inset 0 1px 0 rgba(255, 255, 255, 0.15), 0 1px 1px rgba(0, 0, 0, 0.075)',
    '$btn-block-spacing-y': '.5rem',
    '$btn-primary-color': '#fff',
    '$btn-primary-bg': '#0275d8',
    '$btn-primary-border': '#0275d8',
    '$btn-secondary-color': '#292b2c',
    '$btn-secondary-bg': '#fff',
    '$btn-secondary-border': '#ccc',
    '$btn-info-color': '#fff',
    '$btn-info-bg': '#5bc0de',
    '$btn-info-border': '#5bc0de',
    '$btn-success-color': '#fff',
    '$btn-success-bg': '#5cb85c',
    '$btn-success-border': '#5cb85c',
    '$btn-warning-color': '#fff',
    '$btn-warning-bg': '#f0ad4e',
    '$btn-warning-border': '#f0ad4e',
    '$btn-danger-color': '#fff',
    '$btn-danger-bg': '#d9534f',
    '$btn-danger-border': '#d9534f',
    '$btn-link-disabled-color': '#636c72',
    '$btn-padding-x-lg': '1.5rem',
    '$btn-padding-y-lg': '.75rem',
    '$btn-padding-x-sm': '.5rem',
    '$btn-padding-y-sm': '.25rem',
    '$btn-border-radius': '.25rem',
    '$btn-border-radius-lg': '1.25rem',
    '$btn-border-radius-sm': '.875rem',
    '$input-btn-border-width': '1px',
    '$link-color': '#0275d8',
    '$link-hover-color': 'hsl(207.79999999999995, 98.2%, 27.8%)',
    '$link-hover-decoration': 'underline',
    '$cursor-disabled': 'not-allowed'
  },
  type: 'text'
};
var propTypes$x = {
  className: propTypes.string,
  children: propTypes.node,
  type: propTypes.oneOf(['button', 'checkbox', 'color', 'date', 'datetime', 'datetime-local', 'email', 'file', 'hidden', 'image', 'month', 'number', 'password', 'radio', 'range', 'reset', 'search', 'submit', 'tel', 'text', 'textarea', 'select', 'time', 'url', 'week']),
  size: propTypes.oneOf(['sm', 'lg']),
  state: propTypes.oneOf(['success', 'warning', 'danger']),
  ref: propTypes.func,
  static: propTypes.bool,
  addon: propTypes.bool,
  onChange: propTypes.func,
  indeterminate: propTypes.bool,
  tag: propTypes.any,
  theme: propTypes.shape({
    '$enable-rounded': propTypes.bool,
    '$enable-shadows': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool,
    '$enable-transitions': propTypes.bool,
    '$font-weight-normal': propTypes.string,
    '$font-size-base': propTypes.string,
    '$font-size-lg': propTypes.string,
    '$font-size-sm': propTypes.string,
    '$font-size-xs': propTypes.string,
    '$btn-padding-x': propTypes.string,
    '$btn-padding-y': propTypes.string,
    '$btn-line-height': propTypes.string,
    '$btn-font-weight': propTypes.string,
    '$btn-transition': propTypes.string,
    '$btn-box-shadow': propTypes.string,
    '$btn-block-spacing-y': propTypes.string,
    '$btn-primary-color': propTypes.string,
    '$btn-primary-bg': propTypes.string,
    '$btn-primary-border': propTypes.string,
    '$btn-secondary-color': propTypes.string,
    '$btn-secondary-bg': propTypes.string,
    '$btn-secondary-border': propTypes.string,
    '$btn-info-color': propTypes.string,
    '$btn-info-bg': propTypes.string,
    '$btn-info-border': propTypes.string,
    '$btn-success-color': propTypes.string,
    '$btn-success-bg': propTypes.string,
    '$btn-success-border': propTypes.string,
    '$btn-warning-color': propTypes.string,
    '$btn-warning-bg': propTypes.string,
    '$btn-warning-border': propTypes.string,
    '$btn-danger-color': propTypes.string,
    '$btn-danger-bg': propTypes.string,
    '$btn-danger-border': propTypes.string,
    '$btn-link-disabled-color': propTypes.string,
    '$btn-padding-x-lg': propTypes.string,
    '$btn-padding-y-lg': propTypes.string,
    '$btn-padding-x-sm': propTypes.string,
    '$btn-padding-y-sm': propTypes.string,
    '$btn-border-radius': propTypes.string,
    '$btn-border-radius-lg': propTypes.string,
    '$btn-border-radius-sm': propTypes.string,
    '$input-btn-border-width': propTypes.string,
    '$link-color': propTypes.string,
    '$link-hover-color': propTypes.string,
    '$link-hover-decoration': propTypes.string,
    '$cursor-disabled': propTypes.string
  }),
  cssModule: propTypes.object
};
var InputUnstyled =
function (_React$Component) {
  _inherits(InputUnstyled, _React$Component);
  function InputUnstyled() {
    _classCallCheck(this, InputUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(InputUnstyled).apply(this, arguments));
  }
  _createClass(InputUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          type = _omit.type,
          size = _omit.size,
          state = _omit.state,
          tag = _omit.tag,
          addon = _omit.addon,
          staticInput = _omit.static,
          ref = _omit.ref,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "type", "size", "state", "tag", "addon", "static", "ref"]);
      var checkInput = ['radio', 'checkbox'].indexOf(type) > -1;
      var fileInput = type === 'file';
      var textareaInput = type === 'textarea';
      var selectInput = type === 'select';
      var Tag = selectInput || textareaInput ? type : 'input';
      var formControlClass = 'form-control';
      if (staticInput) {
        formControlClass = "".concat(formControlClass, "-static");
        Tag = tag;
      } else if (fileInput) {
        formControlClass = "".concat(formControlClass, "-file");
      } else if (checkInput) {
        if (addon) {
          formControlClass = null;
        } else {
          formControlClass = 'form-check-input';
        }
      }
      var classes = mapToCssModules(classnames(className, state ? "form-control-".concat(state) : false, size ? "form-control-".concat(size) : false, formControlClass), cssModule);
      if (Tag === 'input') {
        attributes.type = type;
      }
      return React.createElement(Tag, _extends({}, attributes, {
        ref: ref,
        className: classes
      }));
    }
  }]);
  return InputUnstyled;
}(React.Component);
_defineProperty(InputUnstyled, "propTypes", propTypes$x);
_defineProperty(InputUnstyled, "defaultProps", defaultProps$w);
var Input = styled(InputUnstyled).withConfig({
  displayName: "Input",
  componentId: "wun2o8-0"
})(["", ""], function (props) {
  return "\n    /* Reboot Scss */\n    touch-action: manipulation;\n    \n    &[type=\"radio\"],\n    &[type=\"checkbox\"] {\n      box-sizing: border-box; /* 1. Add the correct box sizing in IE 10- */\n      padding: 0; /* 2. Remove the padding in IE 10- */\n      /*\n       Apply a disabled cursor for radios and checkboxes.\n       Note: Neither radios nor checkboxes can be readonly.\n      */\n   \n      &:disabled {\n        cursor: ".concat(props.theme['$cursor-disabled'], ";\n      }\n    }\n    \n    /* Normalize includes font: inherit;, so font-family. font-size, etc are */\n    /* properly inherited. However, line-height is not inherited there. */\n    line-height: inherit;\n   \n    &.disabled {\n      cursor: ").concat(props.theme['$cursor-disabled'], ";\n    }\n   \n    &[type=\"date\"],\n    &[type=\"time\"],\n    &[type=\"datetime-local\"],\n    &[type=\"month\"] {\n    /* Remove the default appearance of temporal inputs to avoid a Mobile Safari\n       bug where setting a custom line-height prevents text from being vertically\n       centered within the input.\n       Bug report: https://github.com/twbs/bootstrap/issues/11266\n     */\n      -webkit-appearance: listbox;\n    }\n      \n    /* Correct the cursor style of increment and decrement buttons in Chrome. */\n    &[type=\"number\"]::-webkit-inner-spin-button,\n    &[type=\"number\"]::-webkit-outer-spin-button {\n      height: auto;\n    }\n    \n    &[type=\"search\"] {\n      /* This overrides the extra rounded corners on search inputs in iOS so that our\n      .form-control class can properly style them. Note that this cannot simply\n       be added to .form-control as it is not specific enough. For details, see\n       https://github.com/twbs/bootstrap/issues/11586.\n       */\n      outline-offset: -2px; /* 2. Correct the outline style in Safari. */\n      -webkit-appearance: none;\n    }\n    \n    /* Remove the inner padding and cancel buttons in Chrome and Safari on macOS. */\n    &[type=\"search\"]::-webkit-search-cancel-button,\n    &[type=\"search\"]::-webkit-search-decoration {\n      -webkit-appearance: none;\n    }\n    \n    ").concat(buttons_4(props.theme['$enable-shadows'], props.theme['$enable-hover-media-query'], props.theme['$enable-transitions'], props.theme['$enable-rounded'], props.theme['$font-weight-normal'], props.theme['$btn-font-weight'], props.theme['$btn-line-height'], props.theme['$btn-transition'], props.theme['$input-btn-border-width'], props.theme['$btn-padding-x'], props.theme['$btn-padding-y'], props.theme['$font-size-base'], props.theme['$btn-border-radius'], props.theme['$btn-box-shadow'], props.theme['$btn-focus-box-shadow'], props.theme['$btn-active-box-shadow'], props.theme['$cursor-disabled'], props.theme['$link-color'], props.theme['$link-hover-color'], props.theme['$link-hover-decoration'], props.theme['$btn-link-disabled-color'], props.theme['$btn-padding-x-lg'], props.theme['$btn-padding-y-lg'], props.theme['$font-size-lg'], props.theme['$btn-border-radius-lg'], props.theme['$btn-padding-x-sm'], props.theme['$btn-padding-y-sm'], props.theme['$font-size-sm'], props.theme['$btn-border-radius-sm'], props.theme['$btn-block-spacing-y'], props.theme['$btn-primary-color'], props.theme['$btn-primary-bg'], props.theme['$btn-primary-border'], props.theme['$btn-secondary-color'], props.theme['$btn-secondary-bg'], props.theme['$btn-secondary-border'], props.theme['$btn-info-color'], props.theme['$btn-info-bg'], props.theme['$btn-info-border'], props.theme['$btn-success-color'], props.theme['$btn-success-bg'], props.theme['$btn-success-border'], props.theme['$btn-warning-color'], props.theme['$btn-warning-bg'], props.theme['$btn-warning-border'], props.theme['$btn-danger-color'], props.theme['$btn-danger-bg'], props.theme['$btn-danger-border']), "\n ");
});
Input.defaultProps = defaultProps$w;
Input.propTypes = propTypes$x;

var forms = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formControl = formControl;
exports.formControlValidation = formControlValidation;
exports.formControlFocus = formControlFocus;
exports.inputSize = inputSize;
exports.default = exports.defaultProps = void 0;
var _color = _interopRequireDefault(ColorWrapper);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var defaultProps = {
  '$enable-rounded': true,
  '$enable-transitions': true,
  '$enable-shadows': false,
  '$input-height': '2.5rem',
  '$input-padding-y': '.5rem',
  '$input-padding-x': '.75rem',
  '$font-size-base': '1rem',
  '$input-line-height': '1.25',
  '$input-color': '#464a4c',
  '$input-bg': '#fff',
  '$input-border-radius': '.25rem',
  '$input-btn-border-width': '1px',
  '$input-border-color': 'rgba(0, 0, 0, 0.15)',
  '$input-transition': 'border-color ease-in-out .15s, box-shadow ease-in-out .15s',
  '$input-box-shadow': 'inset 0 1px 1px rgba(0, 0, 0, 0.075)',
  '$input-color-focus': '#464a4c',
  '$input-bg-focus': '#fff',
  '$input-border-focus': 'hsl(207.79999999999995, 98.2%, 53.4%)',
  '$input-box-shadow-focus': 'inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 8px rgba(hsl(207.79999999999995, 98.2%, 53.4%),.6)',
  '$input-color-placeholder': '#636c72',
  '$input-bg-disabled': '#eceeef',
  '$cursor-disabled': 'not-allowed'
};
exports.defaultProps = defaultProps;
function formControl() {
  var $enableRounded = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-rounded'];
  var $enableTransitions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$enable-transitions'];
  var $enableShadows = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$enable-shadows'];
  var $inputHeight = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : defaultProps['$input-height'];
  var $inputPaddingY = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : defaultProps['$input-padding-y'];
  var $inputPaddingX = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : defaultProps['$input-padding-x'];
  var $fontSizeBase = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : defaultProps['$font-size-base'];
  var $inputLineHeight = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : defaultProps['$input-line-height'];
  var $inputColor = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : defaultProps['$input-color'];
  var $inputBg = arguments.length > 9 && arguments[9] !== undefined ? arguments[9] : defaultProps['$input-bg'];
  var $inputBorderRadius = arguments.length > 10 && arguments[10] !== undefined ? arguments[10] : defaultProps['$input-border-radius'];
  var $inputBtnBorderWidth = arguments.length > 11 && arguments[11] !== undefined ? arguments[11] : defaultProps['$input-btn-border-width'];
  var $inputBorderColor = arguments.length > 12 && arguments[12] !== undefined ? arguments[12] : defaultProps['$input-border-color'];
  var $inputTransition = arguments.length > 13 && arguments[13] !== undefined ? arguments[13] : defaultProps['$input-transition'];
  var $inputBoxShadow = arguments.length > 14 && arguments[14] !== undefined ? arguments[14] : defaultProps['$input-box-shadow'];
  var $inputColorFocus = arguments.length > 15 && arguments[15] !== undefined ? arguments[15] : defaultProps['$input-color-focus'];
  var $inputBgFocus = arguments.length > 16 && arguments[16] !== undefined ? arguments[16] : defaultProps['$input-bg-focus'];
  var $inputBorderFocus = arguments.length > 17 && arguments[17] !== undefined ? arguments[17] : defaultProps['$input-border-focus'];
  var $inputBoxShadowFocus = arguments.length > 18 && arguments[18] !== undefined ? arguments[18] : defaultProps['$input-box-shadow-focus'];
  var $inputColorPlaceholder = arguments.length > 19 && arguments[19] !== undefined ? arguments[19] : defaultProps['$input-color-placeholder'];
  var $inputBgDisabled = arguments.length > 20 && arguments[20] !== undefined ? arguments[20] : defaultProps['$input-bg-disabled'];
  var $cursorDisabled = arguments.length > 21 && arguments[21] !== undefined ? arguments[21] : defaultProps['$cursor-disabled'];
  return "\n      & .form-control {\n        display: block;\n        width: 100%;\n  \n        /* Make inputs at least the height of their button counterpart (base line-height + padding + border) */\n        /* height: ".concat($inputHeight, "; */\n  \n        padding: ").concat($inputPaddingY, " ").concat($inputPaddingX, ";\n        font-size: ").concat($fontSizeBase, ";\n        line-height: ").concat($inputLineHeight, ";\n        color: ").concat($inputColor, ";\n        background-color: ").concat($inputBg, ";\n  \n        /* Reset unusual Firefox-on-Android default style; see https://github.com/necolas/normalize.css/issues/214. */\n        background-image: none;\n        background-clip: padding-box;\n        /* Note: This has no effect on selects in some browsers, due to the limited stylability of selects in CSS. */\n        ").concat($enableRounded ? "border-radius: ".concat($inputBorderRadius, ";") : 'border-radius: 0;', " /* Manually use the if/else instead of the mixin to account for iOS override */\n        border: ").concat($inputBtnBorderWidth, " solid ").concat($inputBorderColor, ";\n        ").concat((0, transition_1.transition)($enableTransitions, $inputTransition), "\n        ").concat((0, boxShadow_1.boxShadow)($enableShadows, $inputBoxShadow), "\n  \n        /* Unstyle the caret on selects in IE10+. */\n        &::-ms-expand {\n          background-color: transparent;\n          border: 0;\n        }\n  \n        /* Customize the :focus state to imitate native WebKit styles. */\n        ").concat(formControlFocus($enableShadows, $inputColorFocus, $inputBgFocus, $inputBorderFocus, $inputBoxShadowFocus), "\n  \n        /* Placeholder */\n        &::placeholder {\n          color: ").concat($inputColorPlaceholder, ";\n          /* Override Firefox unusual default opacity; see https://github.com/twbs/bootstrap/pull/11526. */\n          opacity: 1;\n        }\n  \n        /* Disabled and read-only inputs\n         HTML5 says that controls under a fieldset > legend:first-child will not be\n         disabled if the fieldset is disabled. Due to implementation difficulty, we\n         do not honor that edge case; we style them as disabled anyway.\n         */\n  \n        &:disabled,\n        &[readonly] {\n          background-color:").concat($inputBgDisabled, ";\n          /* iOS fix for unreadable disabled content; see https://github.com/twbs/bootstrap/issues/11655. */\n          opacity: 1;\n        }\n  \n        &:disabled {\n          cursor: ").concat($cursorDisabled, ";\n        }\n      }\n  ");
}
function formControlValidation() {
  var enableShadows = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-shadows'];
  var formColor = arguments.length > 1 ? arguments[1] : undefined;
  var inputBoxShadow = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$input-box-shadow'];
  return "\n    /* Color the label and help text */\n    & .form-control-feedback,\n    & .form-control-label,\n    & .col-form-label,\n    & .form-check-label,\n    & .custom-control {\n      color: ".concat(formColor, ";\n    }\n  \n    /* Set the border and box shadow on specific inputs to match */\n      \n    & .form-control,\n    & .custom-select,\n    & .custom-file-control {\n      border-color: ").concat(formColor, ";\n  \n      &:focus {\n        ").concat((0, boxShadow_1.boxShadow)(enableShadows, "".concat(inputBoxShadow, ", 0 0 6px ").concat((0, _color.default)(formColor).lighten(0.2).toString())), "\n      }\n    }\n  \n    /* Set validation states also for addons */\n    .input-group-addon {\n      color: ").concat(formColor, ";\n      border-color: ").concat(formColor, ";\n      background-color: ").concat((0, _color.default)(formColor).lighten(0.40).toString(), ";\n    }\n  ");
}
function formControlFocus() {
  var enableShadows = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-shadows'];
  var inputColorFocus = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$input-color-focus'];
  var inputBgFocus = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$input-bg-focus'];
  var inputBorderFocus = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : defaultProps['$input-border-focus'];
  var inputBoxShadowFocus = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : defaultProps['$input-box-shadow-focus'];
  return "\n    &:focus {\n      color: ".concat(inputColorFocus, ";\n      background-color: ").concat(inputBgFocus, ";\n      border-color: ").concat(inputBorderFocus, ";\n      outline: none;\n      ").concat((0, boxShadow_1.boxShadow)(enableShadows, inputBoxShadowFocus), "\n    }\n  ");
}
function inputSize() {
  var enableRounded = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-rounded'];
  var parent = arguments.length > 1 ? arguments[1] : undefined;
  var inputHeight = arguments.length > 2 ? arguments[2] : undefined;
  var paddingY = arguments.length > 3 ? arguments[3] : undefined;
  var paddingX = arguments.length > 4 ? arguments[4] : undefined;
  var fontSize = arguments.length > 5 ? arguments[5] : undefined;
  var lineHeight = arguments.length > 6 ? arguments[6] : undefined;
  var inputBorderRadius = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : defaultProps['$input-border-radius'];
  return "\n    ".concat(parent, " {\n      height: ").concat(inputHeight, ";\n      padding: ").concat(paddingY, " ").concat(paddingX, ";\n      font-size: ").concat(fontSize, ";\n      line-height: ").concat(lineHeight, ";\n      ").concat((0, borderRadius_1.borderRadius)(enableRounded, inputBorderRadius), "\n    }\n  \n    select").concat(parent, " {\n      height: ").concat(inputHeight, ";\n      line-height: ").concat(inputHeight, ";\n    }\n  \n    textarea").concat(parent, ",\n      select[multiple]").concat(parent, " {\n      height: auto;\n    }\n  ");
}
var _default = {
  defaultProps: defaultProps,
  formControl: formControl,
  formControlValidation: formControlValidation,
  formControlFocus: formControlFocus,
  inputSize: inputSize
};
exports.default = _default;
});
unwrapExports(forms);
var forms_1 = forms.formControl;
var forms_2 = forms.formControlValidation;
var forms_3 = forms.formControlFocus;
var forms_4 = forms.inputSize;
var forms_5 = forms.defaultProps;

var defaultProps$x = {
  tag: 'div',
  theme: {
    '$enable-rounded': true,
    '$enable-shadows': false,
    '$enable-hover-media-query': false,
    '$enable-transitions': true,
    '$font-size-base': '1rem',
    '$font-size-lg': '1.25rem',
    '$font-size-sm': '.875rem',
    '$font-size-xs': '.75rem',
    '$line-height-base': '1.5',
    '$border-radius': '.25rem',
    '$border-radius-lg': '.3rem',
    '$border-radius-sm': '.2rem',
    '$input-padding-x': '.75rem',
    '$input-padding-y': '.5rem',
    '$input-bg': '#fff',
    '$input-bg-disabled': '#eceeef',
    '$input-padding-x-lg': '1.5rem',
    '$input-padding-y-lg': '.75rem',
    '$input-line-height': '1.25',
    '$input-height': '2.5rem',
    '$input-box-shadow': 'inset 0 1px 1px rgba(0, 0, 0, 0.075)',
    '$input-btn-border-width': '1px',
    '$input-group-addon-bg': '#eceeef',
    '$input-border-color': 'rgba(0, 0, 0, 0.15)',
    '$input-border-focus': 'hsl(207.79999999999995, 98.2%, 53.4%)',
    '$input-box-shadow-focus': 'inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 8px rgba(hsl(207.79999999999995, 98.2%, 53.4%),.6)',
    '$input-color': '#464a4c',
    '$input-group-addon-border-color': 'rgba(0, 0, 0, 0.15)',
    '$input-padding-x-sm': '.5rem',
    '$input-padding-y-sm': '.25rem',
    '$input-color-placeholder': '#636c72',
    '$input-border-radius-lg': '.3rem',
    '$input-border-radius-sm': '.2rem',
    '$input-border-radius': '.25rem',
    '$input-transition': 'border-color ease-in-out .15s, box-shadow ease-in-out .15s',
    '$input-color-focus': '#464a4c',
    '$input-bg-focus': '#fff',
    '$cursor-disabled': 'not-allowed'
  }
};
var propTypes$y = {
  className: propTypes.string,
  size: propTypes.oneOf(['sm', 'lg']),
  tag: propTypes.any,
  theme: propTypes.shape({
    '$enable-rounded': propTypes.bool,
    '$enable-shadows': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool,
    '$enable-transitions': propTypes.bool,
    '$font-size-base': propTypes.string,
    '$font-size-lg': propTypes.string,
    '$font-size-sm': propTypes.string,
    '$font-size-xs': propTypes.string,
    '$line-height-base': propTypes.string,
    '$border-radius': propTypes.string,
    '$border-radius-lg': propTypes.string,
    '$border-radius-sm': propTypes.string,
    '$input-padding-x': propTypes.string,
    '$input-padding-y': propTypes.string,
    '$input-bg': propTypes.string,
    '$input-bg-disabled': propTypes.string,
    '$input-padding-x-lg': propTypes.string,
    '$input-padding-y-lg': propTypes.string,
    '$input-line-height': propTypes.string,
    '$input-height': propTypes.string,
    '$input-box-shadow': propTypes.string,
    '$input-btn-border-width': propTypes.string,
    '$input-group-addon-bg': propTypes.string,
    '$input-border-color': propTypes.string,
    '$input-border-focus': propTypes.string,
    '$input-box-shadow-focus': propTypes.string,
    '$input-color': propTypes.string,
    '$input-group-addon-border-color': propTypes.string,
    '$input-padding-x-sm': propTypes.string,
    '$input-padding-y-sm': propTypes.string,
    '$input-color-placeholder': propTypes.string,
    '$input-border-radius-lg': propTypes.string,
    '$input-border-radius-sm': propTypes.string,
    '$input-border-radius': propTypes.string,
    '$input-transition': propTypes.string,
    '$input-color-focus': propTypes.string,
    '$input-bg-focus': propTypes.string,
    '$cursor-disabled': propTypes.string
  }),
  cssModule: propTypes.object
};
var InputGroupUnstyled =
function (_React$Component) {
  _inherits(InputGroupUnstyled, _React$Component);
  function InputGroupUnstyled() {
    _classCallCheck(this, InputGroupUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(InputGroupUnstyled).apply(this, arguments));
  }
  _createClass(InputGroupUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          Tag = _omit.tag,
          size = _omit.size,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "tag", "size"]);
      var classes = mapToCssModules(classnames(className, 'input-group', size ? "input-group-".concat(size) : null), cssModule);
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
    }
  }]);
  return InputGroupUnstyled;
}(React.Component);
_defineProperty(InputGroupUnstyled, "propTypes", propTypes$y);
_defineProperty(InputGroupUnstyled, "defaultProps", defaultProps$x);
var InputGroup = styled(InputGroupUnstyled).withConfig({
  displayName: "InputGroup",
  componentId: "sc-8o5j9s-0"
})(["", ""], function (props) {
  return "\n    /*\n     Base styles\n    */\n   \n    &.input-group {\n      position: relative;\n      display: flex;\n      width: 100%;\n\n      .form-control {\n        /* \n          Ensure that the input is always above the *appended* addon button for\n          proper border colors.\n        */\n        \n        position: relative;\n        z-index: 2;\n        flex: 1 1 auto;\n        /* Add width 1% and flex-basis auto to ensure that button will not wrap out */\n        /* the column. Applies to IE Edge+ and Firefox. Chrome does not require this. */\n        width: 1%;\n        margin-bottom: 0;\n        \n        ".concat(hover_5(props.theme['$enable-hover-media-query'], 'z-index: 3;'), "\n      }\n    }\n    \n    & .input-group-addon,\n    & .input-group-btn,\n    &.input-group .form-control {\n      /* Vertically centers the content of the addons within the input group */\n      display: flex;\n      flex-direction: column;\n      justify-content: center;\n\n\n      &:not(:first-child):not(:last-child) {\n        ").concat(borderRadius_2(props.theme['$enable-rounded'], '0'), "\n      }\n    }\n   \n    & .input-group-addon,\n    & .input-group-btn {\n\n      white-space: nowrap;\n      vertical-align: middle; /* Match the inputs */\n    }\n   \n   \n    /* Sizing options\n    Remix the default form control sizing classes into new ones for easier\n    manipulation.\n    */\n   \n    &.input-group-lg > .form-control,\n    &.input-group-lg > .input-group-addon,\n    &.input-group-lg > .input-group-btn > .btn {\n      padding: ").concat(props.theme['$input-padding-y-lg'], " ").concat(props.theme['$input-padding-x-lg'], ";\n      font-size: ").concat(props.theme['$font-size-lg'], ";\n      ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$input-border-radius-lg']), "\n    }\n    \n    &.input-group-sm > .form-control,\n    &.input-group-sm > .input-group-addon,\n    &.input-group-sm > .input-group-btn > .btn {\n      padding: ").concat(props.theme['$input-padding-y-sm'], " ").concat(props.theme['$input-padding-x-sm'], ";\n      font-size: ").concat(props.theme['$font-size-sm'], ";\n      ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$input-border-radius-sm']), "\n    }\n   \n   \n    /*\n    Text input groups\n    */\n   \n    & .input-group-addon {\n      padding: ").concat(props.theme['$input-padding-y'], " ").concat(props.theme['$input-padding-x'], ";\n      margin-bottom: 0; /* Allow use of <label> elements by overriding our default margin-bottom */\n      font-size: ").concat(props.theme['$font-size-base'], ";\n      font-weight: normal;\n      line-height: ").concat(props.theme['$input-line-height'], ";\n      color: ").concat(props.theme['$input-color'], ";\n      text-align: center;\n      background-color: ").concat(props.theme['$input-group-addon-bg'], ";\n      border: ").concat(props.theme['$input-btn-border-width'], " solid ").concat(props.theme['$input-group-addon-border-color'], ";\n      ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$input-border-radius']), "\n   \n      /* \n      Nuke default margins from checkboxes and radios to vertically center within.\n      */\n      input[type=\"radio\"],\n      input[type=\"checkbox\"] {\n        margin-top: 0;\n      }\n    }\n   \n   \n    /*\n     Reset rounded corners\n    */\n   \n    &.input-group .form-control:not(:last-child),\n    & .input-group-addon:not(:last-child),\n    & .input-group-btn:not(:last-child) > .btn,\n    & .input-group-btn:not(:last-child) > .btn-group > .btn,\n    & .input-group-btn:not(:last-child) > .dropdown-toggle,\n    & .input-group-btn:not(:first-child) > .btn:not(:last-child):not(.dropdown-toggle),\n    & .input-group-btn:not(:first-child) > .btn-group:not(:last-child) > .btn {\n      ").concat(borderRadius_4(props.theme['$enable-rounded'], '0'), "\n    }\n    & .input-group-addon:not(:last-child) {\n      border-right: 0;\n    }\n    &.input-group .form-control:not(:first-child),\n    & .input-group-addon:not(:first-child),\n    & .input-group-btn:not(:first-child) > .btn,\n    & .input-group-btn:not(:first-child) > .btn-group > .btn,\n    & .input-group-btn:not(:first-child) > .dropdown-toggle,\n    & .input-group-btn:not(:last-child) > .btn:not(:first-child),\n    & .input-group-btn:not(:last-child) > .btn-group:not(:first-child) > .btn {\n      ").concat(borderRadius_6(props.theme['$enable-rounded'], '0'), "\n    }\n    & .form-control + .input-group-addon:not(:first-child) {\n      border-left: 0;\n    }\n   \n    /*\n     Button input groups\n    */\n   \n    & .input-group-btn {\n      position: relative;\n      /* Jankily prevent input button groups from wrapping with white-space and\n      font-size in combination with inline-block on buttons.\n      */\n      font-size: 0;\n      white-space: nowrap;\n   \n      /* Negative margin for spacing, position for bringing hovered/focused/actived\n      element above the siblings.\n      */\n      > .btn {\n        position: relative;\n        /* Vertically stretch the button and center its content */\n        flex: 1;\n        \n        + .btn {\n          margin-left: -").concat(props.theme['$input-btn-border-width'], ";\n        }\n        \n        /* Bring the active button to the front */\n        ").concat(hover_5(props.theme['$enable-hover-media-query'], 'z-index: 3;'), "\n      }\n   \n      /* Negative margin to only have a single, shared border between the two */\n      &:not(:last-child) {\n        > .btn,\n        > .btn-group {\n          margin-right: -").concat(props.theme['$input-btn-border-width'], ";\n        }\n      }\n      &:not(:first-child) {\n        > .btn,\n        > .btn-group {\n          z-index: 2;\n          margin-left: -").concat(props.theme['$input-btn-border-width'], ";\n          /* Because specificity */\n          ").concat(hover_5(props.theme['$enable-hover-media-query'], 'z-index: 3;'), "\n        }\n      }\n    }\n    \n   /* Added So that Inputs in InputGroup grab the same .form-control class as in Component Form Not Bs4 */\n   ").concat(forms_1(props.theme['$enable-rounded'], props.theme['$enable-transitions'], props.theme['$enable-shadows'], props.theme['$input-height'], props.theme['$input-padding-y'], props.theme['$input-padding-x'], props.theme['$font-size-base'], props.theme['$input-line-height'], props.theme['$input-color'], props.theme['$input-bg'], props.theme['$input-border-radius'], props.theme['$input-btn-border-width'], props.theme['$input-border-color'], props.theme['$input-transition'], props.theme['$input-box-shadow'], props.theme['$input-color-focus'], props.theme['$input-bg-focus'], props.theme['$input-border-focus'], props.theme['$input-box-shadow-focus'], props.theme['$input-color-placeholder'], props.theme['$input-bg-disabled'], props.theme['$cursor-disabled']), "\n  ");
});
InputGroup.defaultProps = defaultProps$x;
InputGroup.propTypes = propTypes$y;

var defaultProps$y = {
  tag: 'div'
};
var propTypes$z = {
  className: propTypes.string,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var InputGroupAddon =
function (_React$Component) {
  _inherits(InputGroupAddon, _React$Component);
  function InputGroupAddon() {
    _classCallCheck(this, InputGroupAddon);
    return _possibleConstructorReturn(this, _getPrototypeOf(InputGroupAddon).apply(this, arguments));
  }
  _createClass(InputGroupAddon, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "tag"]);
      var classes = mapToCssModules(classnames(className, 'input-group-addon'), cssModule);
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
    }
  }]);
  return InputGroupAddon;
}(React.Component);
_defineProperty(InputGroupAddon, "propTypes", propTypes$z);
_defineProperty(InputGroupAddon, "defaultProps", defaultProps$y);
InputGroupAddon.defaultProps = defaultProps$y;
InputGroupAddon.propTypes = propTypes$z;

var defaultProps$z = {
  tag: 'div'
};
var propTypes$A = {
  className: propTypes.string,
  children: propTypes.node,
  groupClassName: propTypes.string,
  groupAttributes: propTypes.object,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var InputGroupButton =
function (_React$Component) {
  _inherits(InputGroupButton, _React$Component);
  function InputGroupButton() {
    _classCallCheck(this, InputGroupButton);
    return _possibleConstructorReturn(this, _getPrototypeOf(InputGroupButton).apply(this, arguments));
  }
  _createClass(InputGroupButton, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          Tag = _this$props.tag,
          children = _this$props.children,
          groupClassName = _this$props.groupClassName,
          groupAttributes = _this$props.groupAttributes,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "tag", "children", "groupClassName", "groupAttributes"]);
      if (typeof children === 'string') {
        var groupClasses = mapToCssModules(classnames(groupClassName, 'input-group-btn'), cssModule);
        return React.createElement(Tag, _extends({}, groupAttributes, {
          className: groupClasses
        }), React.createElement(Button, _extends({}, attributes, {
          className: className
        }), children));
      }
      var classes = mapToCssModules(classnames(className, 'input-group-btn'), cssModule);
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }), children);
    }
  }]);
  return InputGroupButton;
}(React.Component);
_defineProperty(InputGroupButton, "propTypes", propTypes$A);
_defineProperty(InputGroupButton, "defaultProps", defaultProps$z);
InputGroupButton.defaultProps = defaultProps$z;
InputGroupButton.propTypes = propTypes$A;

function IssueIcon(props) {
  return React.createElement("svg", {
    height: "1em",
    width: "0.875em",
    className: props.className
  }, React.createElement("path", {
    d: "M7 2.3c3.14 0 5.7 2.56 5.7 5.7S10.14 13.7 7 13.7 1.3 11.14 1.3 8s2.56-5.7 5.7-5.7m0-1.3C3.14 1 0 4.14 0 8s3.14 7 7 7 7-3.14 7-7S10.86 1 7 1z m1 3H6v5h2V4z m0 6H6v2h2V10z"
  }));
}
IssueIcon.propTypes = {
  className: propTypes.string
};

var defaultProps$A = {
  theme: {
    '$enable-rounded': true,
    '$enable-shadows': false,
    '$font-family-monospace': 'Menlo, Monaco, Consolas, "Liberation Mono", "Courier New", monospace',
    '$font-weight-bold': 'bold',
    '$border-radius-sm': '.2rem',
    '$code-font-size': '90%',
    '$code-padding-x': '.4rem',
    '$code-padding-y': '.2rem',
    '$kbd-color': '#fff',
    '$kbd-bg': '#292b2c',
    '$kbd-box-shadow': 'inset 0 -.1rem 0 rgba(0, 0, 0, 0.25)',
    '$nested-kbd-font-weight': 'bold'
  }
};
var propTypes$B = {
  className: propTypes.string,
  children: propTypes.node.isRequired,
  theme: propTypes.shape({
    '$enable-rounded': propTypes.bool,
    '$enable-shadows': propTypes.bool,
    '$font-family-monospace': propTypes.string,
    '$font-weight-bold': propTypes.string,
    '$border-radius-sm': propTypes.string,
    '$code-font-size': propTypes.string,
    '$code-padding-x': propTypes.string,
    '$code-padding-y': propTypes.string,
    '$kbd-color': propTypes.string,
    '$kbd-bg': propTypes.string,
    '$kbd-box-shadow': propTypes.string,
    '$nested-kbd-font-weight': propTypes.string
  })
};
var KbdUnstyled =
function (_React$Component) {
  _inherits(KbdUnstyled, _React$Component);
  function KbdUnstyled() {
    _classCallCheck(this, KbdUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(KbdUnstyled).apply(this, arguments));
  }
  _createClass(KbdUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          children = _omit.children,
          rest = _objectWithoutProperties(_omit, ["className", "children"]);
      return React.createElement("kbd", _extends({
        className: className
      }, rest), children);
    }
  }]);
  return KbdUnstyled;
}(React.Component);
_defineProperty(KbdUnstyled, "propTypes", propTypes$B);
_defineProperty(KbdUnstyled, "defaultProps", defaultProps$A);
var Kbd = styled(KbdUnstyled).withConfig({
  displayName: "Kbd",
  componentId: "fcsgf1-0"
})(["", ""], function (props) {
  return "\n    /* User input typically entered via keyboard */\n    padding: ".concat(props.theme['$code-padding-y'], " ").concat(props.theme['$code-padding-x'], ";\n    font-size: ").concat(props.theme['$code-font-size'], ";\n    color: ").concat(props.theme['$kbd-color'], ";\n    background-color: ").concat(props.theme['$kbd-bg'], ";\n    ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$border-radius-sm']), "\n    ").concat(boxShadow_2(props.theme['$enable-shadows'], props.theme['$kbd-box-shadow']), "\n    \n    & kbd {\n      padding: 0;\n      font-size: 100%;\n      font-weight: ").concat(props.theme['$nested-kbd-font-weight'], ";\n      ").concat(boxShadow_2(props.theme['$enable-shadows'], 'none'), "\n    }\n    \n    /* Bootstrap 4 does not place this css rule straight into Kbd tag see: bootstrap/scss/code.scss */\n    font-family: ").concat(props.theme['$font-family-monospace'], ";\n  ");
});
Kbd.defaultProps = defaultProps$A;
Kbd.propTypes = propTypes$B;

var defaultProps$B = {
  tag: 'div',
  theme: {
    '$enable-rounded': true,
    '$grid-breakpoints': {
      xs: '0',
      sm: '576px',
      md: '768px',
      lg: '992px',
      xl: '1200px'
    },
    '$border-radius-lg': '.3rem',
    '$jumbotron-padding': '2rem',
    '$jumbotron-bg': '#eceeef'
  }
};
var propTypes$C = {
  className: propTypes.string,
  fluid: propTypes.bool,
  theme: propTypes.shape({
    '$enable-rounded': propTypes.bool,
    '$grid-breakpoints': propTypes.object,
    '$border-radius-lg': propTypes.string,
    '$jumbotron-padding': propTypes.string,
    '$jumbotron-bg': propTypes.string
  }),
  tag: propTypes.any,
  cssModule: propTypes.object
};
var JumbotronUnstyled =
function (_React$Component) {
  _inherits(JumbotronUnstyled, _React$Component);
  function JumbotronUnstyled() {
    _classCallCheck(this, JumbotronUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(JumbotronUnstyled).apply(this, arguments));
  }
  _createClass(JumbotronUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          Tag = _omit.tag,
          fluid = _omit.fluid,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "tag", "fluid"]);
      var classes = mapToCssModules(classnames(className, 'jumbotron', fluid ? 'jumbotron-fluid' : false), cssModule);
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
    }
  }]);
  return JumbotronUnstyled;
}(React.Component);
_defineProperty(JumbotronUnstyled, "propTypes", propTypes$C);
_defineProperty(JumbotronUnstyled, "defaultProps", defaultProps$B);
var Jumbotron = styled(JumbotronUnstyled).withConfig({
  displayName: "Jumbotron",
  componentId: "sc-4btr39-0"
})(["", ""], function (props) {
  return "\n    &.jumbotron {\n      padding: ".concat(props.theme['$jumbotron-padding'], " calc(").concat(props.theme['$jumbotron-padding'], " / 2);\n      margin-bottom: ").concat(props.theme['$jumbotron-padding'], ";\n      background-color: ").concat(props.theme['$jumbotron-bg'], ";\n      ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$border-radius-lg']), "\n    \n      ").concat(breakpoints_5('sm', props.theme['$grid-breakpoints'], "padding: calc(".concat(props.theme['$jumbotron-padding'], " * 2) ").concat(props.theme['$jumbotron-padding'], ";")), "  \n    }\n\n    & .jumbotron-hr {\n      border-top-color: ").concat(ColorWrapper(props.theme['$jumbotron-bg']).darken(0.1).toString(), ";\n    }\n    \n    &.jumbotron-fluid {\n      padding-right: 0;\n      padding-left: 0;\n      ").concat(borderRadius_2(props.theme['$enable-rounded'], '0'), "\n    }\n  ");
});
Jumbotron.defaultProps = defaultProps$B;
Jumbotron.propTypes = propTypes$C;

var colSizes = ['xs', 'sm', 'md', 'lg', 'xl'];
var stringOrNumberProp$1 = propTypes.oneOfType([propTypes.number, propTypes.string]);
var columnProps$1 = propTypes.oneOfType([propTypes.string, propTypes.number, propTypes.shape({
  size: stringOrNumberProp$1,
  push: stringOrNumberProp$1,
  pull: stringOrNumberProp$1,
  offset: stringOrNumberProp$1
})]);
var propTypes$D = {
  className: propTypes.string,
  tag: propTypes.any,
  theme: propTypes.shape({
    '$btn-padding-x': propTypes.string,
    '$btn-padding-y': propTypes.string,
    '$btn-line-height': propTypes.string,
    '$btn-font-weight': propTypes.string,
    '$btn-box-shadow': propTypes.string,
    '$btn-focus-box-shadow': propTypes.string,
    '$btn-active-box-shadow': propTypes.string,
    '$btn-primary-color': propTypes.string,
    '$btn-primary-bg': propTypes.string,
    '$btn-primary-border': propTypes.string,
    '$btn-secondary-color': propTypes.string,
    '$btn-secondary-bg': propTypes.string,
    '$btn-secondary-border': propTypes.string,
    '$btn-info-color': propTypes.string,
    '$btn-info-bg': propTypes.string,
    '$btn-info-border': propTypes.string,
    '$btn-success-color': propTypes.string,
    '$btn-success-bg': propTypes.string,
    '$btn-success-border': propTypes.string,
    '$btn-warning-color': propTypes.string,
    '$btn-warning-bg': propTypes.string,
    '$btn-warning-border': propTypes.string,
    '$btn-danger-color': propTypes.string,
    '$btn-danger-bg': propTypes.string,
    '$btn-danger-border': propTypes.string,
    '$btn-link-disabled-color': propTypes.string,
    '$btn-padding-x-sm': propTypes.string,
    '$btn-padding-y-sm': propTypes.string,
    '$btn-padding-x-lg': propTypes.string,
    '$btn-padding-y-lg': propTypes.string,
    '$btn-block-spacing-y': propTypes.string,
    '$btn-border-radius': propTypes.string,
    '$btn-border-radius-lg': propTypes.string,
    '$btn-border-radius-sm': propTypes.string,
    '$btn-transition': propTypes.string,
    '$link-hover-decoration': propTypes.string,
    '$enable-rounded': propTypes.bool,
    '$enable-shadows': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool,
    '$enable-transitions': propTypes.bool
  }),
  check: propTypes.bool,
  children: propTypes.node,
  disabled: propTypes.bool,
  for: propTypes.string,
  hidden: propTypes.bool,
  inline: propTypes.bool,
  size: propTypes.string,
  xs: columnProps$1,
  sm: columnProps$1,
  md: columnProps$1,
  lg: columnProps$1,
  xl: columnProps$1,
  cssModule: propTypes.object
};
var defaultProps$C = {
  tag: 'label',
  theme: {
    '$enable-rounded': true,
    '$enable-shadows': false,
    '$enable-hover-media-query': true,
    '$enable-transitions': true,
    '$btn-padding-x': '1rem',
    '$btn-padding-y': '.5rem',
    '$btn-line-height': '1.25',
    '$btn-font-weight': 'normal',
    '$btn-box-shadow': 'inset 0 1px 0 rgba(255, 255, 255, 0.15), 0 1px 1px rgba(0, 0, 0, 0.075)',
    '$btn-focus-box-shadow': '0 0 0 2px rgba(2, 117, 216, 0.25)',
    '$btn-active-box-shadow': 'inset 0 3px 5px rgba(0, 0, 0, 0.125)',
    '$btn-primary-color': '#fff',
    '$btn-primary-bg': '#0275d8',
    '$btn-primary-border': '#0275d8',
    '$btn-secondary-color': '#292b2c',
    '$btn-secondary-bg': '#fff',
    '$btn-secondary-border': '#ccc',
    '$btn-info-color': '#fff',
    '$btn-info-bg': '#5bc0de',
    '$btn-info-border': '#5bc0de',
    '$btn-success-color': '#fff',
    '$btn-success-bg': '#5cb85c',
    '$btn-success-border': '#5cb85c',
    '$btn-warning-color': '#fff',
    '$btn-warning-bg': '#f0ad4e',
    '$btn-warning-border': '#f0ad4e',
    '$btn-danger-color': '#fff',
    '$btn-danger-bg': '#d9534f',
    '$btn-danger-border': '#d9534f',
    '$btn-link-disabled-color': '#636c72',
    '$btn-padding-x-sm': '.5rem',
    '$btn-padding-y-sm': '.25rem',
    '$btn-padding-x-lg': '1.5rem',
    '$btn-padding-y-lg': '.75rem',
    '$btn-block-spacing-y': '.5rem',
    '$btn-border-radius': '.25rem',
    '$btn-border-radius-lg': '.3rem',
    '$btn-border-radius-sm': '.2rem',
    '$btn-transition': 'all .2s ease-in-out'
  }
};
var LabelUnstyled = function LabelUnstyled(props) {
  var _omit = lodash_omit(props, ['theme']),
      className = _omit.className,
      cssModule = _omit.cssModule,
      hidden = _omit.hidden,
      Tag = _omit.tag,
      check = _omit.check,
      inline = _omit.inline,
      disabled = _omit.disabled,
      size = _omit.size,
      htmlFor = _omit.for,
      attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "hidden", "tag", "check", "inline", "disabled", "size", "for"]);
  var colClasses = [];
  colSizes.forEach(function (colSize) {
    var columnProp = props[colSize];
    delete attributes[colSize];
    if (columnProp && columnProp.size) {
      var _cn;
      colClasses.push(mapToCssModules(classnames((_cn = {}, _defineProperty(_cn, "col-".concat(colSize, "-").concat(columnProp.size), columnProp.size), _defineProperty(_cn, "push-".concat(colSize, "-").concat(columnProp.push), columnProp.push), _defineProperty(_cn, "pull-".concat(colSize, "-").concat(columnProp.pull), columnProp.pull), _defineProperty(_cn, "offset-".concat(colSize, "-").concat(columnProp.offset), columnProp.offset), _cn))), cssModule);
    } else if (columnProp) {
      colClasses.push("col-".concat(colSize, "-").concat(columnProp));
    }
  });
  var classes = mapToCssModules(classnames(className, hidden ? 'sr-only' : false, check ? "form-check-".concat(inline ? 'inline' : 'label') : false, check && inline && disabled ? 'disabled' : false, size ? "col-form-label-".concat(size) : false, colClasses, colClasses.length ? 'col-form-label' : false), cssModule);
  return React.createElement(Tag, _extends({
    htmlFor: htmlFor
  }, attributes, {
    className: classes
  }));
};
var Label = styled(LabelUnstyled).withConfig({
  displayName: "Label",
  componentId: "sc-1f2mnn3-0"
})(["", ""], function (props) {
  return "\n    /* Reboot Scss */\n    touch-action: manipulation;\n    /* Allow labels to use margin for spacing. */\n    display: inline-block;\n    margin-bottom: ".concat(props.theme['$label-margin-bottom'], ";\n\n    ").concat(buttons_4(props.theme['$enable-shadows'], props.theme['$enable-hover-media-query'], props.theme['$enable-transitions'], props.theme['$enable-rounded'], props.theme['$font-weight-normal'], props.theme['$btn-font-weight'], props.theme['$btn-line-height'], props.theme['$btn-transition'], props.theme['$input-btn-border-width'], props.theme['$btn-padding-x'], props.theme['$btn-padding-y'], props.theme['$font-size-base'], props.theme['$btn-border-radius'], props.theme['$btn-box-shadow'], props.theme['$btn-focus-box-shadow'], props.theme['$btn-active-box-shadow'], props.theme['$cursor-disabled'], props.theme['$link-color'], props.theme['$link-hover-color'], props.theme['$link-hover-decoration'], props.theme['$btn-link-disabled-color'], props.theme['$btn-padding-x-lg'], props.theme['$btn-padding-y-lg'], props.theme['$font-size-lg'], props.theme['$btn-border-radius-lg'], props.theme['$btn-padding-x-sm'], props.theme['$btn-padding-y-sm'], props.theme['$font-size-sm'], props.theme['$btn-border-radius-sm'], props.theme['$btn-block-spacing-y'], props.theme['$btn-primary-color'], props.theme['$btn-primary-bg'], props.theme['$btn-primary-border'], props.theme['$btn-secondary-color'], props.theme['$btn-secondary-bg'], props.theme['$btn-secondary-border'], props.theme['$btn-info-color'], props.theme['$btn-info-bg'], props.theme['$btn-info-border'], props.theme['$btn-success-color'], props.theme['$btn-success-bg'], props.theme['$btn-success-border'], props.theme['$btn-warning-color'], props.theme['$btn-warning-bg'], props.theme['$btn-warning-border'], props.theme['$btn-danger-color'], props.theme['$btn-danger-bg'], props.theme['$btn-danger-border']), "\n ");
});
Label.propTypes = propTypes$D;
Label.defaultProps = defaultProps$C;

var Legend = styled.legend.withConfig({
  displayName: "Legend",
  componentId: "sc-2q2h3o-0"
})(["display:block;width:100%;padding:0;margin-bottom:.5rem;font-size:1.5rem;line-height:inherit;"]);

var media_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.media = media;
exports.default = void 0;
function media() {
  return "\n   &.media {\n    display: flex;\n    align-items: flex-start;\n  }\n  \n  & .media-body {\n    flex: 1;\n  }\n  ";
}
var _default = {
  media: media
};
exports.default = _default;
});
unwrapExports(media_1);
var media_2 = media_1.media;

var defaultProps$D = {
  theme: {
    '$list-inline-padding': '5px'
  }
};
var propTypes$E = {
  className: propTypes.string,
  children: propTypes.node,
  tag: propTypes.any,
  theme: propTypes.shape({
    '$list-inline-padding': propTypes.string
  }),
  disabled: propTypes.bool,
  separator: propTypes.bool,
  active: propTypes.bool,
  inline: propTypes.bool,
  media: propTypes.bool,
  'dropdown-item': propTypes.bool,
  'dropdown-header': propTypes.bool,
  'dropdown-footer': propTypes.bool,
  cssModule: propTypes.object
};
var LiUnstyled =
function (_React$Component) {
  _inherits(LiUnstyled, _React$Component);
  function LiUnstyled() {
    _classCallCheck(this, LiUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(LiUnstyled).apply(this, arguments));
  }
  _createClass(LiUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          children = _omit.children,
          inline = _omit.inline,
          separator = _omit.separator,
          media = _omit.media,
          dropdownItem = _omit['dropdown-item'],
          dropdownHeader = _omit['dropdown-header'],
          dropdownFooter = _omit['dropdown-footer'],
          attributes = _objectWithoutProperties(_omit, ["className", "children", "inline", "separator", "media", "dropdown-item", "dropdown-header", "dropdown-footer"]);
      var classes = mapToCssModules(classnames(className, separator ? 'dropdown-divider' : false, dropdownItem ? 'dropdown-item' : false, dropdownItem ? 'dropdown-item' : false, dropdownHeader ? 'dropdown-header' : false, dropdownFooter ? 'dropdown-footer' : false, inline ? 'list-inline-item' : false, media ? 'media' : false));
      return React.createElement("li", _extends({
        className: classes
      }, attributes), children);
    }
  }]);
  return LiUnstyled;
}(React.Component);
_defineProperty(LiUnstyled, "propTypes", propTypes$E);
_defineProperty(LiUnstyled, "defaultProps", defaultProps$D);
var Li = styled(LiUnstyled).withConfig({
  displayName: "Li",
  componentId: "sc-1knn373-0"
})(["", ""], function (props) {
  return "\n    &.list-inline-item {\n      display: inline-block;\n    \n      &:not(:last-child) {\n        margin-right: ".concat(props.theme['$list-inline-padding'], ";\n      }\n    }\n    \n    ").concat(media_2(), "\n  ");
});
Li.defaultProps = defaultProps$D;
Li.propTypes = propTypes$E;

var listGroup = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.listGroupItemVariant = listGroupItemVariant;
exports.default = exports.defaultProps = void 0;
var _color = _interopRequireDefault(ColorWrapper);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var defaultProps = {
  '$enable-hover-media-query': false
};
exports.defaultProps = defaultProps;
function listGroupItemVariant() {
  var enableHoverMediaQuery = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-hover-media-query'];
  var state = arguments.length > 1 ? arguments[1] : undefined;
  var background = arguments.length > 2 ? arguments[2] : undefined;
  var listColor = arguments.length > 3 ? arguments[3] : undefined;
  return "\n    & .list-group-item-".concat(state, " {\n      color: ").concat(listColor, ";\n      background-color: ").concat(background, ";\n    }\n  \n    & a.list-group-item-").concat(state, ",\n    button.list-group-item-").concat(state, " {\n      color: ").concat(listColor, ";\n  \n      .list-group-item-heading {\n        color: inherit;\n      }\n  \n      ").concat((0, hover_1.hoverFocus)(enableHoverMediaQuery, "\n        color: ".concat(listColor, ";\n        background-color: ").concat((0, _color.default)(background).darken(0.05).toString(), ";\n      ")), "\n  \n      &.active {\n        ").concat((0, hover_1.plainHoverFocus)(enableHoverMediaQuery, "\n          color: #fff;\n          background-color: ".concat(listColor, ";\n          border-color: ").concat(listColor, ";\n        ")), "\n      }\n    }\n  ");
}
var _default = {
  defaultProps: defaultProps,
  listGroupItemVariant: listGroupItemVariant
};
exports.default = _default;
});
unwrapExports(listGroup);
var listGroup_1 = listGroup.listGroupItemVariant;
var listGroup_2 = listGroup.defaultProps;

var nav_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.nav = nav;
exports.default = exports.defaultProps = void 0;
var defaultProps = {
  '$enable-rounded': true,
  '$enable-hover-media-query': false,
  '$nav-link-padding': '.5em 1em',
  '$nav-disabled-link-color': '#636c72',
  '$cursor-disabled': 'not-allowed',
  '$nav-tabs-border-width': '1px',
  '$nav-tabs-border-color': '#ddd',
  '$nav-tabs-border-radius': '.25rem',
  '$nav-tabs-link-hover-border-color': '#eceeef',
  '$nav-tabs-active-link-hover-color': '#464a4c',
  '$nav-tabs-active-link-hover-bg': '#fff',
  '$nav-tabs-active-link-hover-border-color': '#ddd',
  '$nav-pills-border-radius': '.25rem',
  '$nav-pills-active-link-color': '#fff',
  '$nav-pills-active-link-bg': '#0275d8'
};
exports.defaultProps = defaultProps;
function nav() {
  var $enableRounded = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-rounded'];
  var $enableHoverMediaQuery = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$enable-hover-media-query'];
  var $navLinkPadding = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$nav-link-padding'];
  var $navDisabledLinkColor = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : defaultProps['$nav-disabled-link-color'];
  var $cursorDisabled = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : defaultProps['$cursor-disabled'];
  var $navTabBorderWidth = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : defaultProps['$nav-tabs-border-width'];
  var $navTabsBorderColor = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : defaultProps['$nav-tabs-border-color'];
  var $navTabsBorderRadius = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : defaultProps['$nav-tabs-border-radius'];
  var $navTabsLinkHoverBorderColor = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : defaultProps['$nav-tabs-link-hover-border-color'];
  var $navTabsActiveLinkHoverColor = arguments.length > 9 && arguments[9] !== undefined ? arguments[9] : defaultProps['$nav-tabs-active-link-hover-color'];
  var $navTabsActiveLinkHoverBg = arguments.length > 10 && arguments[10] !== undefined ? arguments[10] : defaultProps['$nav-tabs-active-link-hover-bg'];
  var $navTabsActiveLinkHoverBorderColor = arguments.length > 11 && arguments[11] !== undefined ? arguments[11] : defaultProps['$nav-tabs-active-link-hover-border-color'];
  var $navPillsBorderRadius = arguments.length > 12 && arguments[12] !== undefined ? arguments[12] : defaultProps['$nav-pills-border-radius'];
  var $navPillsActiveLinkColor = arguments.length > 13 && arguments[13] !== undefined ? arguments[13] : defaultProps['$nav-pills-active-link-color'];
  var $navPillsActiveLinkBg = arguments.length > 14 && arguments[14] !== undefined ? arguments[14] : defaultProps['$nav-pills-active-link-bg'];
  return "\n    &.nav {\n      display: flex;\n      padding-left: 0;\n      margin-bottom: 0;\n      list-style: none;\n    }\n    \n    & .nav-link {\n      display: block;\n      padding: ".concat($navLinkPadding, ";\n      ").concat((0, hover_1.hoverFocus)($enableHoverMediaQuery, 'text-decoration: none;'), "\n      /* Disabled state lightens text and removes hover tab effects */\n      &.disabled {\n        color: ").concat($navDisabledLinkColor, ";\n        cursor: ").concat($cursorDisabled, "; \n      }\n    }\n        \n    /*\n     Tabs\n    */\n    \n    &.nav-tabs {\n      border-bottom: ").concat($navTabBorderWidth, " solid ").concat($navTabsBorderColor, ";\n      & .nav-item {\n        margin-bottom: -").concat($navTabBorderWidth, ";\n      }\n   \n      & .nav-link {\n        border: ").concat($navTabBorderWidth, " solid transparent;\n        ").concat((0, borderRadius_1.borderTopRadius)($enableRounded, $navTabsBorderRadius), "\n        ").concat((0, hover_1.hoverFocus)($enableHoverMediaQuery, "\n          border-color: ".concat($navTabsLinkHoverBorderColor, " ").concat($navTabsLinkHoverBorderColor, " ").concat($navTabsBorderColor, ";\n        ")), "\n      \n        &.disabled {\n          color: ").concat($navDisabledLinkColor, ";\n          background-color: transparent;\n          border-color: transparent;\n        }\n      }\n      \n      & .nav-link.active,\n      .nav-item.open .nav-link {\n        color: ").concat($navTabsActiveLinkHoverColor, ";\n        background-color: ").concat($navTabsActiveLinkHoverBg, ";\n        border-color: ").concat($navTabsActiveLinkHoverBorderColor, " ").concat($navTabsActiveLinkHoverBorderColor, " transparent;\n      }\n      \n      & .dropdown-menu {\n        /* Make dropdown border overlap tab border */\n        margin-top: -").concat($navTabBorderWidth, ";\n        /* Remove the top rounded corners here since there is a hard edge above the menu */\n        ").concat((0, borderRadius_1.borderTopRadius)($enableRounded, '0'), "\n      }\n    }\n    \n    /*\n     Pills\n    */\n    \n    &.nav-pills {\n      .nav-link {\n        ").concat((0, borderRadius_1.borderRadius)($enableRounded, $navPillsBorderRadius), "\n      }\n\n      .nav-link.active,\n      .nav-item.show .nav-link {\n        color: ").concat($navPillsActiveLinkColor, ";\n        background-color: ").concat($navPillsActiveLinkBg, ";\n      }\n    }\n\n    /*\n      Justified variants\n    */\n    \n    &.nav-fill {\n      .nav-item {\n        flex: 1 1 auto;\n        text-align: center;\n      }\n    }\n    \n    &.nav-justified {\n      .nav-item {\n        flex: 1 1 100%;\n        text-align: center;\n      }\n    }\n    \n    /* Hide tabbable panes to start, show them when .active */\n    &.tab-content {\n      > .tab-pane {\n        display: none;\n      }\n      > .active {\n        display: block;\n      }\n    }\n  ");
}
var _default = {
  nav: nav
};
exports.default = _default;
});
unwrapExports(nav_1);
var nav_2 = nav_1.nav;
var nav_3 = nav_1.defaultProps;

var lists = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.listUnstyled = listUnstyled;
exports.listInline = listInline;
exports.listInlineItem = listInlineItem;
exports.default = exports.defaultProps = void 0;
var defaultProps = {
  '$list-inline-padding': '5px'
};
exports.defaultProps = defaultProps;
function listUnstyled() {
  return "\n    padding-left: 0;\n    list-style: none;\n  ";
}
function listInline() {
  return listUnstyled();
}
function listInlineItem() {
  var listInlinePadding = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$list-inline-padding'];
  return "\n    display: inline-block;\n  \n    &:not(:last-child) {\n      margin-right: ".concat(listInlinePadding, ";\n    }\n  ");
}
var _default = {
  defaultProps: defaultProps,
  listInline: listInline,
  listUnstyled: listUnstyled
};
exports.default = _default;
});
unwrapExports(lists);
var lists_1 = lists.listUnstyled;
var lists_2 = lists.listInline;
var lists_3 = lists.listInlineItem;
var lists_4 = lists.defaultProps;

var defaultProps$E = {
  tag: 'nav',
  role: 'navigation',
  toggleable: 'false',
  theme: {
    '$grid-breakpoints': {
      xs: '0',
      sm: '576px',
      md: '768px',
      lg: '992px',
      xl: '1200px'
    },
    '$enable-rounded': true,
    '$enable-hover-media-query': false,
    '$border-width': '1px',
    '$font-size-lg': '1.25rem',
    '$body-bg': '#fff',
    '$component-active-bg': '#0275d8',
    '$component-active-color': '#fff',
    '$border-radius': '.25rem',
    '$navbar-padding-x': '1rem',
    '$navbar-padding-y': '0.5rem',
    '$nav-link-padding': '.5em 1em',
    '$nav-disabled-link-color': '#636c72',
    '$nav-tabs-border-color': '#ddd',
    '$nav-tabs-border-width': '1px',
    '$nav-tabs-border-radius': '.5em 1em',
    '$nav-tabs-link-hover-border-color': '#eceeef',
    '$nav-tabs-active-link-hover-color': '#464a4c',
    '$nav-tabs-active-link-hover-bg': '#fff',
    '$nav-tabs-active-link-hover-border-color': '#ddd',
    '$nav-pills-border-radius': '.25rem',
    '$nav-pills-active-link-color': '#fff',
    '$nav-pills-active-link-bg': '#0275d8',
    '$cursor-disabled': 'not-allowed',
    '$zindex-navbar': '1000',
    '$zindex-navbar-fixed': '1030',
    '$zindex-navbar-sticky': '1030',
    '$navbar-brand-padding-y': '.25rem',
    '$navbar-divider-padding-y': '.425rem',
    '$navbar-toggler-padding-y': '.5rem',
    '$navbar-toggler-padding-x': '.75rem',
    '$navbar-toggler-font-size': '1.25rem',
    '$navbar-toggler-border-radius': '.25rem',
    '$navbar-light-active-color': 'rgba(0,0,0,.9)',
    '$navbar-light-color': 'rgba(0,0,0,.5)',
    '$navbar-light-hover-color': 'rgba(0,0,0,.7)',
    '$navbar-light-toggler-border': 'rgba(0,0,0,.1)',
    '$navbar-light-disabled-color': 'rgba(0, 0, 0, 0.3)',
    '$navbar-light-toggler-bg': 'url(\'data:image/svg+xml;charset=utf8,%3Csvg viewBox="0 0 30 30" xmlns="http://www.w3.org/2000/svg"%3E%3Cpath stroke="rgba(0,0,0,.5)" stroke-width="2" stroke-linecap="round" stroke-miterlimit="10" d="M4 7h22M4 15h22M4 23h22"/%3E%3C/svg%3E\')',
    '$navbar-inverse-active-color': 'rgba(255,255,255,1)',
    '$navbar-inverse-color': 'rgba(255,255,255,.5)',
    '$navbar-inverse-hover-color': 'rgba(255,255,255,.75)',
    '$navbar-inverse-toggler-border': 'rgba(255,255,255,.1)',
    '$navbar-inverse-toggler-bg': 'url(\'data:image/svg+xml;charset=utf8,%3Csvg viewBox="0 0 30 30" xmlns="http://www.w3.org/2000/svg"%3E%3Cpath stroke="rgba(255,255,255,.5)" stroke-width="2" stroke-linecap="round" stroke-miterlimit="10" d="M4 7h22M4 15h22M4 23h22"/%3E%3C/svg%3E\')',
    '$navbar-inverse-disabled-color': 'rgba(255, 255, 255, 0.25)'
  }
};
var propTypes$F = {
  className: propTypes.string,
  tag: propTypes.any,
  children: propTypes.node.isRequired,
  role: propTypes.string,
  inline: propTypes.bool,
  unstyled: propTypes.bool,
  toggleable: propTypes.string,
  theme: propTypes.shape({
    '$enable-rounded': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool,
    '$grid-breakpoints': propTypes.object,
    '$border-width': propTypes.string,
    '$font-size-lg': propTypes.string,
    '$body-bg': propTypes.string,
    '$component-active-bg': propTypes.string,
    '$component-active-color': propTypes.string,
    '$border-radius': propTypes.string,
    '$navbar-padding-x': propTypes.string,
    '$navbar-padding-y': propTypes.string,
    '$nav-link-padding': propTypes.string,
    '$nav-disabled-link-color': propTypes.string,
    '$nav-tabs-border-color': propTypes.string,
    '$nav-tabs-border-width': propTypes.string,
    '$nav-tabs-border-radius': propTypes.string,
    '$nav-tabs-link-hover-border-color': propTypes.string,
    '$nav-tabs-active-link-hover-color': propTypes.string,
    '$nav-tabs-active-link-hover-bg': propTypes.string,
    '$nav-tabs-active-link-hover-border-color': propTypes.string,
    '$nav-pills-border-radius': propTypes.string,
    '$nav-pills-active-link-color': propTypes.string,
    '$nav-pills-active-link-bg': propTypes.string,
    '$cursor-disabled': propTypes.string,
    '$zindex-navbar': propTypes.string,
    '$zindex-navbar-fixed': propTypes.string,
    '$zindex-navbar-sticky': propTypes.string,
    '$navbar-brand-padding-y': propTypes.string,
    '$navbar-divider-padding-y': propTypes.string,
    '$navbar-toggler-padding-y': propTypes.string,
    '$navbar-toggler-padding-x': propTypes.string,
    '$navbar-toggler-font-size': propTypes.string,
    '$navbar-toggler-border-radius': propTypes.string,
    '$navbar-light-active-color': propTypes.string,
    '$navbar-light-color': propTypes.string,
    '$navbar-light-hover-color': propTypes.string,
    '$navbar-light-toggler-border': propTypes.string,
    '$navbar-light-disabled-color': propTypes.string,
    '$navbar-light-toggler-bg': propTypes.string,
    '$navbar-inverse-active-color': propTypes.string,
    '$navbar-inverse-color': propTypes.string,
    '$navbar-inverse-hover-color': propTypes.string,
    '$navbar-inverse-toggler-border': propTypes.string,
    '$navbar-inverse-toggler-bg': propTypes.string,
    '$navbar-inverse-disabled-color': propTypes.string
  })
};
var UlUnstyled =
function (_React$Component) {
  _inherits(UlUnstyled, _React$Component);
  function UlUnstyled() {
    _classCallCheck(this, UlUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(UlUnstyled).apply(this, arguments));
  }
  _createClass(UlUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          inline = _omit.inline,
          unstyled = _omit.unstyled,
          children = _omit.children,
          rest = _objectWithoutProperties(_omit, ["className", "inline", "unstyled", "children"]);
      var classes = classnames(className, inline ? 'list-inline' : false, unstyled ? 'list-unstyled' : false);
      return React.createElement("ul", _extends({
        className: classes
      }, rest), children);
    }
  }]);
  return UlUnstyled;
}(React.Component);
_defineProperty(UlUnstyled, "propTypes", propTypes$F);
_defineProperty(UlUnstyled, "defaultProps", defaultProps$E);
var Ul = styled(UlUnstyled).withConfig({
  displayName: "Ul",
  componentId: "sctud2-0"
})(["", ""], function (props) {
  return "\n    ".concat(nav_2(props.theme['$enable-rounded'], props.theme['$enable-hover-media-query'], props.theme['$nav-link-padding'], props.theme['$nav-disabled-link-color'], props.theme['$cursor-disabled'], props.theme['$nav-tabs-border-width'], props.theme['$nav-tabs-border-color'], props.theme['$nav-tabs-border-radius'], props.theme['$nav-tabs-link-hover-border-color'], props.theme['$nav-tabs-active-link-hover-color'], props.theme['$nav-tabs-active-link-hover-bg'], props.theme['$nav-tabs-active-link-hover-border-color'], props.theme['$nav-pills-border-radius'], props.theme['$nav-pills-active-link-color'], props.theme['$nav-pills-active-link-bg']), "\n    ").concat(navbar_2(props.theme['$grid-breakpoints'], props.theme['$enable-rounded'], props.theme['$enable-hover-media-query'], props.theme['$font-size-lg'], props.theme['$border-width'], props.theme['$navbar-padding-y'], props.theme['$navbar-padding-x'], props.theme['$zindex-navbar'], props.theme['$zindex-navbar-fixed'], props.theme['$zindex-navbar-sticky'], props.theme['$navbar-brand-padding-y'], props.theme['$navbar-divider-padding-y'], props.theme['$navbar-toggler-padding-y'], props.theme['$navbar-toggler-padding-x'], props.theme['$navbar-toggler-font-size'], props.theme['$navbar-toggler-border-radius'], props.theme['$navbar-light-active-color'], props.theme['$navbar-light-color'], props.theme['$navbar-light-hover-color'], props.theme['$navbar-light-toggler-border'], props.theme['$navbar-light-disabled-color'], props.theme['$navbar-light-toggler-bg'], props.theme['$navbar-inverse-active-color'], props.theme['$navbar-inverse-color'], props.theme['$navbar-inverse-hover-color'], props.theme['$navbar-inverse-toggler-border'], props.theme['$navbar-inverse-toggler-bg'], props.theme['$navbar-inverse-disabled-color']), "\n\n    /* Type Scss */\n    &.list-unstyled {\n      ").concat(lists_1(), "\n    }\n\n    &.list-inline {\n      ").concat(lists_2(), "\n    }\n    \n    /* Reboot Scss */\n    margin-top: 0;\n    margin-bottom: 1rem;\n  \n    & ol,\n    & ul {\n      margin-bottom: 0;\n    }\n  ");
});
Ul.defaultProps = defaultProps$E;
Ul.propTypes = propTypes$F;

var defaultProps$F = {
  tag: Ul,
  toggleable: 'false',
  theme: {
    '$enable-rounded': true,
    '$enable-hover-media-query': false,
    '$component-active-color': '#fff',
    '$component-active-bg': '#0275d8',
    '$list-group-color': '#292b2c',
    '$list-group-bg': '#fff',
    '$list-group-border-color': 'rgba(0, 0, 0, 0.125)',
    '$list-group-border-width': '1px',
    '$list-group-border-radius': '.25rem',
    '$list-group-item-padding-x': '1.25rem',
    '$list-group-item-padding-y': '.75rem',
    '$list-group-hover-bg': '#f7f7f9',
    '$list-group-active-color': '#fff',
    '$list-group-active-bg': '#0275d8',
    '$list-group-active-border': '#0275d8',
    '$list-group-disabled-color': '#636c72',
    '$list-group-disabled-bg': '#fff',
    '$list-group-link-color': '#464a4c',
    '$list-group-link-hover-color': '#464a4c',
    '$list-group-link-active-color': '#292b2c',
    '$list-group-link-active-bg': '#eceeef',
    '$cursor-disabled': 'not-allowed',
    '$state-success-text': '#3c763d',
    '$state-success-bg': '#dff0d8',
    '$state-info-text': '#31708f',
    '$state-info-bg': '#d9edf7',
    '$state-warning-text': '#8a6d3b',
    '$state-warning-bg': '#fcf8e3',
    '$state-danger-text': '#a94442',
    '$state-danger-bg': '#f2dede'
  }
};
var propTypes$G = {
  className: propTypes.string,
  tag: propTypes.any,
  flush: propTypes.bool,
  toggleable: propTypes.string,
  theme: propTypes.shape({
    '$enable-rounded': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool,
    '$component-active-color': propTypes.string,
    '$component-active-bg': propTypes.string,
    '$list-group-color': propTypes.string,
    '$list-group-bg': propTypes.string,
    '$list-group-border-color': propTypes.string,
    '$list-group-border-width': propTypes.string,
    '$list-group-border-radius': propTypes.string,
    '$list-group-item-padding-x': propTypes.string,
    '$list-group-item-padding-y': propTypes.string,
    '$list-group-hover-bg': propTypes.string,
    '$list-group-active-color': propTypes.string,
    '$list-group-active-bg': propTypes.string,
    '$list-group-active-border': propTypes.string,
    '$list-group-disabled-color': propTypes.string,
    '$list-group-disabled-bg': propTypes.string,
    '$list-group-link-color': propTypes.string,
    '$list-group-link-hover-color': propTypes.string,
    '$list-group-link-active-color': propTypes.string,
    '$list-group-link-active-bg': propTypes.string,
    '$cursor-disabled': propTypes.string,
    '$state-success-text': propTypes.string,
    '$state-success-bg': propTypes.string,
    '$state-info-text': propTypes.string,
    '$state-info-bg': propTypes.string,
    '$state-warning-text': propTypes.string,
    '$state-warning-bg': propTypes.string,
    '$state-danger-text': propTypes.string,
    '$state-danger-bg': propTypes.string
  }),
  cssModule: propTypes.object
};
var ListGroupUnstyled =
function (_React$Component) {
  _inherits(ListGroupUnstyled, _React$Component);
  function ListGroupUnstyled() {
    _classCallCheck(this, ListGroupUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(ListGroupUnstyled).apply(this, arguments));
  }
  _createClass(ListGroupUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          Tag = _omit.tag,
          flush = _omit.flush,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "tag", "flush"]);
      var classes = mapToCssModules(classnames(className, 'list-group', flush ? 'list-group-flush' : false), cssModule);
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
    }
  }]);
  return ListGroupUnstyled;
}(React.Component);
_defineProperty(ListGroupUnstyled, "propTypes", propTypes$G);
_defineProperty(ListGroupUnstyled, "defaultProps", defaultProps$F);
var ListGroup = styled(ListGroupUnstyled).withConfig({
  displayName: "ListGroup",
  componentId: "sc-1ugap33-0"
})(["", ""], function (props) {
  return "\n    /* \n      Base class\n      Easily usable on ul, ol, or div.\n    */\n    \n    &.list-group {\n      display: flex;\n      flex-direction: column;\n      /* No need to set list-style: none; since .list-group-item is block level */\n      padding-left: 0;  /* reset padding because ul and ol */\n      margin-bottom: 0;\n    }\n    \n    \n    /* \n      Interactive list items\n      Use anchor or button elements instead of 'li's or 'div's to create interactive\n      list items. Includes an extra '.active' modifier class for selected items.\n    */\n    \n    & .list-group-item-action {\n      width: 100%; /* For 'button's (anchors become 100% by default though) */\n      color: ".concat(props.theme['$list-group-link-color'], ";\n      text-align: inherit; /* For 'button's (anchors inherit) */\n    \n      /* Hover state */\n      ").concat(hover_3(props.theme['$enable-hover-media-query'], "\n          color: ".concat(props.theme['$list-group-link-hover-color'], ";\n          text-decoration: none;\n          background-color: ").concat(props.theme['$list-group-hover-bg'], ";\n        ")), ";\n      \n      &:active {\n        color: ").concat(props.theme['$list-group-link-active-color'], ";\n        background-color: ").concat(props.theme['$list-group-link-active-bg'], ";\n      }\n    }\n    \n    /* \n      Individual list items\n      Use on 'li's or 'div's within the '.list-group' parent.\n    */\n    \n    & .list-group-item {\n      position: relative;\n      display: flex;\n      flex-flow: row wrap;\n      align-items: center;\n      padding: ").concat(props.theme['$list-group-item-padding-y'], " ").concat(props.theme['$list-group-item-padding-x'], ";\n      /* Place the border on the list items and negative margin up for better styling */\n      margin-bottom: -").concat(props.theme['$list-group-border-width'], ";\n      background-color: ").concat(props.theme['$list-group-bg'], ";\n      border: ").concat(props.theme['$list-group-border-width'], " solid ").concat(props.theme['$list-group-border-color'], ";\n    \n      &:first-child {\n        ").concat(borderRadius_3(props.theme['$enable-rounded'], props.theme['$list-group-border-radius']), "\n      }\n\n      &:last-child {\n        margin-bottom: 0;\n        ").concat(borderRadius_5(props.theme['$enable-rounded'], props.theme['$list-group-border-radius']), "\n      }\n      \n      ").concat(hover_3(props.theme['$enable-hover-media-query'], 'text-decoration: none;'), "\n        \n      &.disabled,\n      &:disabled {   \n        color: ").concat(props.theme['$list-group-disabled-color'], ";\n        cursor: ").concat(props.theme['$cursor-disabled'], ";\n        background-color: ").concat(props.theme['$list-group-disabled-bg'], ";\n      }\n    \n    \n      &.active {\n        z-index: 2; /* Place active items above their siblings for proper border styling */\n        color: ").concat(props.theme['$list-group-active-color'], ";\n        background-color: ").concat(props.theme['$list-group-active-bg'], ";\n        border-color: ").concat(props.theme['$list-group-active-border'], ";     \n      }\n    }\n    \n    /* \n      Flush list items\n      Remove borders and border-radius to keep list group items edge-to-edge. Most\n      useful within other components (e.g., cards).\n    */\n\n    &.list-group-flush {\n      .list-group-item {\n        border-right: 0;\n        border-left: 0;\n        border-radius: 0;\n      }\n      \n      &:first-child {\n        .list-group-item:first-child {\n          border-top: 0;\n        }\n      }\n\n      &:last-child {\n        .list-group-item:last-child {\n          border-bottom: 0;\n        }\n      }\n    }\n    \n    \n    \n    /* Contextual variants\n    \n     Add modifier classes to change text and background color on individual items.\n     Organizationally, this must come after the ':hover' states.\n    */\n    \n    ").concat(listGroup_1(props.theme['$enable-hover-media-query'], 'success', props.theme['$state-success-bg'], props.theme['$state-success-text']), "\n    ").concat(listGroup_1(props.theme['$enable-hover-media-query'], 'info', props.theme['$state-info-bg'], props.theme['$state-info-text']), "\n    ").concat(listGroup_1(props.theme['$enable-hover-media-query'], 'warning', props.theme['$state-warning-bg'], props.theme['$state-warning-text']), "\n    ").concat(listGroup_1(props.theme['$enable-hover-media-query'], 'danger', props.theme['$state-danger-bg'], props.theme['$state-danger-text']), "\n  ");
});
ListGroup.defaultProps = defaultProps$F;
ListGroup.propTypes = propTypes$G;

var handleDisabledOnClick = function handleDisabledOnClick(e) {
  e.preventDefault();
};
var defaultProps$G = {
  tag: 'li'
};
var propTypes$H = {
  className: propTypes.string,
  action: propTypes.bool,
  active: propTypes.bool,
  disabled: propTypes.bool,
  color: propTypes.oneOf(['success', 'info', 'warning', 'danger', '']),
  tag: propTypes.any,
  cssModule: propTypes.object
};
var ListGroupItem =
function (_React$Component) {
  _inherits(ListGroupItem, _React$Component);
  function ListGroupItem() {
    _classCallCheck(this, ListGroupItem);
    return _possibleConstructorReturn(this, _getPrototypeOf(ListGroupItem).apply(this, arguments));
  }
  _createClass(ListGroupItem, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          Tag = _this$props.tag,
          active = _this$props.active,
          disabled = _this$props.disabled,
          action = _this$props.action,
          color = _this$props.color,
          attributes = _objectWithoutProperties(_this$props, ["className", "tag", "active", "disabled", "action", "color"]);
      var classes = classnames(className, active ? 'active' : false, disabled ? 'disabled' : false, action ? 'list-group-item-action' : false, color ? "list-group-item-".concat(color) : false, 'list-group-item');
      if (disabled) {
        attributes.onClick = handleDisabledOnClick;
      }
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
    }
  }]);
  return ListGroupItem;
}(React.Component);
_defineProperty(ListGroupItem, "propTypes", propTypes$H);
_defineProperty(ListGroupItem, "defaultProps", defaultProps$G);
ListGroupItem.defaultProps = defaultProps$G;
ListGroupItem.propTypes = propTypes$H;

var defaultProps$H = {
  tag: H5
};
var propTypes$I = {
  className: propTypes.string,
  tag: propTypes.any
};
var ListGroupItemHeading =
function (_React$Component) {
  _inherits(ListGroupItemHeading, _React$Component);
  function ListGroupItemHeading() {
    _classCallCheck(this, ListGroupItemHeading);
    return _possibleConstructorReturn(this, _getPrototypeOf(ListGroupItemHeading).apply(this, arguments));
  }
  _createClass(ListGroupItemHeading, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "tag"]);
      var classes = classnames(className, 'list-group-item-heading');
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
    }
  }]);
  return ListGroupItemHeading;
}(React.Component);
_defineProperty(ListGroupItemHeading, "propTypes", propTypes$I);
_defineProperty(ListGroupItemHeading, "defaultProps", defaultProps$H);
ListGroupItemHeading.defaultProps = defaultProps$H;
ListGroupItemHeading.propTypes = propTypes$I;

var defaultProps$I = {
  tag: 'p'
};
var propTypes$J = {
  className: propTypes.string,
  tag: propTypes.any
};
var ListGroupItemText =
function (_React$Component) {
  _inherits(ListGroupItemText, _React$Component);
  function ListGroupItemText() {
    _classCallCheck(this, ListGroupItemText);
    return _possibleConstructorReturn(this, _getPrototypeOf(ListGroupItemText).apply(this, arguments));
  }
  _createClass(ListGroupItemText, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "tag"]);
      var classes = classnames(className, 'list-group-item-text');
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
    }
  }]);
  return ListGroupItemText;
}(React.Component);
_defineProperty(ListGroupItemText, "propTypes", propTypes$J);
_defineProperty(ListGroupItemText, "defaultProps", defaultProps$I);
ListGroupItemText.defaultProps = defaultProps$I;
ListGroupItemText.propTypes = propTypes$J;

var Mapp = styled.map.withConfig({
  displayName: "Map__Mapp",
  componentId: "sc-1bvlqdw-0"
})(["display:inline;"]);

var defaultProps$J = {
  theme: {
    '$mark-padding': '.2em',
    '$mark-bg': '#fcf8e3'
  }
};
var propTypes$K = {
  theme: propTypes.shape({
    '$mark-padding': propTypes.string,
    '$mark-bg': propTypes.string
  })
};
var Mark = styled.mark.withConfig({
  displayName: "Mark",
  componentId: "sc-19blc2i-0"
})(["", ""], function (props) {
  return "\n    /* Reboot Scss */\n    padding: ".concat(props.theme['$mark-padding'], ";\n    background-color: ").concat(props.theme['$mark-bg'], ";\n  ");
});
Mark.defaultProps = defaultProps$J;
Mark.propTypes = propTypes$K;

var propTypes$L = {
  className: propTypes.string,
  children: propTypes.node,
  body: propTypes.bool,
  bottom: propTypes.bool,
  heading: propTypes.bool,
  left: propTypes.bool,
  list: propTypes.bool,
  middle: propTypes.bool,
  object: propTypes.bool,
  right: propTypes.bool,
  tag: propTypes.any,
  top: propTypes.bool,
  cssModule: propTypes.object
};
var MediaUnstyled =
function (_React$Component) {
  _inherits(MediaUnstyled, _React$Component);
  function MediaUnstyled() {
    _classCallCheck(this, MediaUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(MediaUnstyled).apply(this, arguments));
  }
  _createClass(MediaUnstyled, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          body = _this$props.body,
          bottom = _this$props.bottom,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          heading = _this$props.heading,
          left = _this$props.left,
          list = _this$props.list,
          middle = _this$props.middle,
          object = _this$props.object,
          right = _this$props.right,
          tag = _this$props.tag,
          top = _this$props.top,
          attributes = _objectWithoutProperties(_this$props, ["body", "bottom", "className", "cssModule", "heading", "left", "list", "middle", "object", "right", "tag", "top"]);
      var defaultTag;
      if (heading) {
        defaultTag = H4;
      } else if (left || right) {
        defaultTag = A;
      } else if (object) {
        defaultTag = Img;
      } else if (list) {
        defaultTag = Ul;
      } else {
        defaultTag = 'div';
      }
      var Tag = tag || defaultTag;
      var classes = mapToCssModules(classnames(className, {
        'media-body': body,
        'media-heading': heading,
        'media-left': left,
        'media-right': right,
        'media-top': top,
        'media-bottom': bottom,
        'media-middle': middle,
        'media-object': object,
        'media-list': list,
        media: !body && !heading && !left && !right && !top && !bottom && !middle && !object && !list
      }), cssModule);
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
    }
  }]);
  return MediaUnstyled;
}(React.Component);
_defineProperty(MediaUnstyled, "propTypes", propTypes$L);
var Media = styled(MediaUnstyled).withConfig({
  displayName: "Media",
  componentId: "sc-1pt808a-0"
})(["&.media,& .media{display:flex;align-items:flex-start;}& .media-body{flex:1 1 0%}", ""], media_2());
Media.propTypes = propTypes$L;

var canUseDOM = !!(typeof window !== 'undefined' && window.document && window.document.createElement);

var _createClass$1 = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
function _classCallCheck$2(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _possibleConstructorReturn$1(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }
function _inherits$1(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
var Portal = function (_React$Component) {
  _inherits$1(Portal, _React$Component);
  function Portal() {
    _classCallCheck$2(this, Portal);
    return _possibleConstructorReturn$1(this, (Portal.__proto__ || Object.getPrototypeOf(Portal)).apply(this, arguments));
  }
  _createClass$1(Portal, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.defaultNode) {
        document.body.removeChild(this.defaultNode);
      }
      this.defaultNode = null;
    }
  }, {
    key: 'render',
    value: function render() {
      if (!canUseDOM) {
        return null;
      }
      if (!this.props.node && !this.defaultNode) {
        this.defaultNode = document.createElement('div');
        document.body.appendChild(this.defaultNode);
      }
      return ReactDOM.createPortal(this.props.children, this.props.node || this.defaultNode);
    }
  }]);
  return Portal;
}(React.Component);
Portal.propTypes = {
  children: propTypes.node.isRequired,
  node: propTypes.any
};

var _createClass$2 = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
function _classCallCheck$3(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _possibleConstructorReturn$2(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }
function _inherits$2(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
var Portal$1 = function (_React$Component) {
  _inherits$2(Portal, _React$Component);
  function Portal() {
    _classCallCheck$3(this, Portal);
    return _possibleConstructorReturn$2(this, (Portal.__proto__ || Object.getPrototypeOf(Portal)).apply(this, arguments));
  }
  _createClass$2(Portal, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.renderPortal();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(props) {
      this.renderPortal();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      ReactDOM.unmountComponentAtNode(this.defaultNode || this.props.node);
      if (this.defaultNode) {
        document.body.removeChild(this.defaultNode);
      }
      this.defaultNode = null;
      this.portal = null;
    }
  }, {
    key: 'renderPortal',
    value: function renderPortal(props) {
      if (!this.props.node && !this.defaultNode) {
        this.defaultNode = document.createElement('div');
        document.body.appendChild(this.defaultNode);
      }
      var children = this.props.children;
      if (typeof this.props.children.type === 'function') {
        children = React.cloneElement(this.props.children);
      }
      this.portal = ReactDOM.unstable_renderSubtreeIntoContainer(this, children, this.props.node || this.defaultNode);
    }
  }, {
    key: 'render',
    value: function render() {
      return null;
    }
  }]);
  return Portal;
}(React.Component);
Portal$1.propTypes = {
  children: propTypes.node.isRequired,
  node: propTypes.any
};

var Portal$2 = void 0;
if (ReactDOM.createPortal) {
  Portal$2 = Portal;
} else {
  Portal$2 = Portal$1;
}
var Portal$3 = Portal$2;

var _createClass$3 = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
function _classCallCheck$4(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _possibleConstructorReturn$3(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }
function _inherits$3(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
var KEYCODES = {
  ESCAPE: 27
};
var PortalWithState = function (_React$Component) {
  _inherits$3(PortalWithState, _React$Component);
  function PortalWithState(props) {
    _classCallCheck$4(this, PortalWithState);
    var _this = _possibleConstructorReturn$3(this, (PortalWithState.__proto__ || Object.getPrototypeOf(PortalWithState)).call(this, props));
    _this.portalNode = null;
    _this.state = { active: !!props.defaultOpen };
    _this.openPortal = _this.openPortal.bind(_this);
    _this.closePortal = _this.closePortal.bind(_this);
    _this.wrapWithPortal = _this.wrapWithPortal.bind(_this);
    _this.handleOutsideMouseClick = _this.handleOutsideMouseClick.bind(_this);
    _this.handleKeydown = _this.handleKeydown.bind(_this);
    return _this;
  }
  _createClass$3(PortalWithState, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.closeOnEsc) {
        document.addEventListener('keydown', this.handleKeydown);
      }
      if (this.props.closeOnOutsideClick) {
        document.addEventListener('click', this.handleOutsideMouseClick);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.props.closeOnEsc) {
        document.removeEventListener('keydown', this.handleKeydown);
      }
      if (this.props.closeOnOutsideClick) {
        document.removeEventListener('click', this.handleOutsideMouseClick);
      }
    }
  }, {
    key: 'openPortal',
    value: function openPortal(e) {
      if (this.state.active) {
        return;
      }
      if (e && e.nativeEvent) {
        e.nativeEvent.stopImmediatePropagation();
      }
      this.setState({ active: true }, this.props.onOpen);
    }
  }, {
    key: 'closePortal',
    value: function closePortal() {
      if (!this.state.active) {
        return;
      }
      this.setState({ active: false }, this.props.onClose);
    }
  }, {
    key: 'wrapWithPortal',
    value: function wrapWithPortal(children) {
      var _this2 = this;
      if (!this.state.active) {
        return null;
      }
      return React.createElement(
        Portal$3,
        {
          node: this.props.node,
          key: 'react-portal',
          ref: function ref(portalNode) {
            return _this2.portalNode = portalNode;
          }
        },
        children
      );
    }
  }, {
    key: 'handleOutsideMouseClick',
    value: function handleOutsideMouseClick(e) {
      if (!this.state.active) {
        return;
      }
      var root = this.portalNode.props.node || this.portalNode.defaultNode;
      if (!root || root.contains(e.target) || e.button && e.button !== 0) {
        return;
      }
      this.closePortal();
    }
  }, {
    key: 'handleKeydown',
    value: function handleKeydown(e) {
      if (e.keyCode === KEYCODES.ESCAPE && this.state.active) {
        this.closePortal();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children({
        openPortal: this.openPortal,
        closePortal: this.closePortal,
        portal: this.wrapWithPortal,
        isOpen: this.state.active
      });
    }
  }]);
  return PortalWithState;
}(React.Component);
PortalWithState.propTypes = {
  children: propTypes.func.isRequired,
  defaultOpen: propTypes.bool,
  node: propTypes.any,
  closeOnEsc: propTypes.bool,
  closeOnOutsideClick: propTypes.bool,
  onOpen: propTypes.func,
  onClose: propTypes.func
};
PortalWithState.defaultProps = {
  onOpen: function onOpen() {},
  onClose: function onClose() {}
};

var transition = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getTransitionUtilities = getTransitionUtilities;
exports.fade = fade;
exports.collapse = collapse;
exports.getReactTransition = getReactTransition;
exports.default = exports.defaultProps = void 0;
var _parseTransition = _interopRequireDefault(parseTransition_1);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var defaultProps = {
  '$enable-transitions': true,
  '$transition-fade': 'opacity .15s linear',
  '$transition-collapse': 'height .35s ease'
};
exports.defaultProps = defaultProps;
function getTransitionUtilities() {
  var enableTransitions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-transitions'];
  var transitionFade = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$transition-fade'];
  var transitionCollapse = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$transition-collapse'];
  return "\n    ".concat(fade(enableTransitions, transitionFade), "\n    ").concat(collapse(enableTransitions, transitionCollapse), "\n  ");
}
function fade() {
  var enableTransitions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-transitions'];
  var transitionFade = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$transition-fade'];
  return "\n    .fade,\n     &.fade {\n      opacity: 0;\n      ".concat((0, transition_1.transition)(enableTransitions, transitionFade), "\n    \n      &.show {\n        opacity: 1;\n      }\n    }\n  ");
}
function collapse() {
  var enableTransitions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-transitions'];
  var transitionCollapse = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$transition-collapse'];
  return "\n    .collapse {\n      display: none;\n      &.show {\n        display: block;\n      }\n    }\n    \n    tr {\n      &.collapse.show {\n        display: table-row;\n      }\n    }\n    \n    tbody {\n      &.collapse.show {\n        display: table-row-group;\n      }\n    }\n    \n    .collapsing {\n      position: relative;\n      height: 0;\n      overflow: hidden;\n      ".concat((0, transition_1.transition)(enableTransitions, transitionCollapse), "\n    }\n  ");
}
function getReactTransition(enableTransition, transition) {
  var transitionList = (0, _parseTransition.default)(transition);
  var _transitionList$ = transitionList[0],
      property = _transitionList$.property,
      duration = _transitionList$.duration,
      timingFunction = _transitionList$.timingFunction,
      delay = _transitionList$.delay;
  return (0, transition_1.transition)(enableTransition, "".concat(property, " ").concat(duration, "ms ").concat(timingFunction, " ").concat(delay, "ms"));
}
var _default = {
  defaultProps: defaultProps,
  getTransitionUtilities: getTransitionUtilities,
  getReactTransition: getReactTransition,
  fade: fade,
  collapse: collapse
};
exports.default = _default;
});
unwrapExports(transition);
var transition_1$1 = transition.getTransitionUtilities;
var transition_2$1 = transition.fade;
var transition_3$1 = transition.collapse;
var transition_4 = transition.getReactTransition;
var transition_5 = transition.defaultProps;

var reboot = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getGlobalStyles = getGlobalStyles;
exports.getGlobalStyleNoBootstrapProvider = getGlobalStyleNoBootstrapProvider;
exports.html = html;
exports.boxSizing = boxSizing;
exports.ie10FixViewport = ie10FixViewport;
exports.body = body;
exports.bodyUtils = bodyUtils;
exports.tabIndex = tabIndex;
exports.svg = svg;
exports.ie10FixHidden = ie10FixHidden;
exports.webkitFileUploadButton = webkitFileUploadButton;
exports.default = exports.defaultProps = void 0;
var defaultProps = {
  '$font-family-base': '-apple-system, system-ui, BlinkMacSystemFont, "Segoe UI", Roboto, "Helvetica Neue", Arial, sans-serif',
  '$font-size-base': '1rem',
  '$font-weight-base': '1.5',
  '$line-height-base': '1.5',
  '$body-color': '#292b2c',
  '$body-bg': '#fff'
};
exports.defaultProps = defaultProps;
function getGlobalStyles() {
  return "\n    html {\n      ".concat(html(), "\n    }\n    *,\n    *::before,\n    *::after {\n      ").concat(boxSizing(), "\n    }\n    @-ms-viewport { \n      ").concat(ie10FixViewport(), " \n    }\n    body {\n      ").concat(bodyUtils(), "\n    }\n  ");
}
function getGlobalStyleNoBootstrapProvider() {
  var fontFamilyBase = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$font-family-base'];
  var fontSizeBase = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$font-size-base'];
  var fontWeightBase = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$font-weight-base'];
  var lineHeightBase = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : defaultProps['$line-height-base'];
  var bodyColor = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : defaultProps['$body-color'];
  var bodyBg = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : defaultProps['$body-bg'];
  return "\n  ".concat(getGlobalStyles(), "\n  body {\n  ").concat(body(fontFamilyBase, fontSizeBase, fontWeightBase, lineHeightBase, bodyColor, bodyBg), " \n}");
}
function html() {
  return "\n    box-sizing: border-box;\n    font-family: sans-serif;\n    line-height: 1.15;\n    -ms-text-size-adjust: 100%;\n    -webkit-text-size-adjust: 100%;\n    -ms-overflow-style: scrollbar;\n    -webkit-tap-highlight-color: rgba(0,0,0,0);\n  ";
}
function boxSizing() {
  return "\n    box-sizing: inherit;\n  ";
}
function ie10FixViewport() {
  return "\n    width: device-width;\n  ";
}
function body() {
  var fontFamilyBase = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$font-family-base'];
  var fontSizeBase = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$font-size-base'];
  var fontWeightBase = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$font-weight-base'];
  var lineHeightBase = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : defaultProps['$line-height-base'];
  var bodyColor = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : defaultProps['$body-color'];
  var bodyBg = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : defaultProps['$body-bg'];
  return "\n    margin: 0;\n    font-family: ".concat(fontFamilyBase, ";\n    font-size: ").concat(fontSizeBase, ";\n    font-weight: ").concat(fontWeightBase, ";\n    line-height: ").concat(lineHeightBase, ";\n    color: ").concat(bodyColor, ";\n    background-color: ").concat(bodyBg, ";\n    \n    ").concat(bodyUtils(), "\n    \n    [tabindex=\"-1\"]:focus {\n      ").concat(tabIndex(), "\n    }\n    svg:not(:root) {\n      ").concat(svg(), "\n    }\n    [hidden] {\n      ").concat(ie10FixHidden(), "\n    }\n    ::-webkit-file-upload-button {\n      ").concat(webkitFileUploadButton(), "\n    }\n  ");
}
function bodyUtils() {
  return "\n    &.overflow {\n      overflow: hidden;\n    }\n  ";
}
function tabIndex() {
  return "\n    outline: none !important;\n  ";
}
function svg() {
  return "\n    overflow: hidden;\n  ";
}
function ie10FixHidden() {
  return "\n    display: none !important;\n  ";
}
function webkitFileUploadButton() {
  return "\n    font: inherit;\n    -webkit-appearance: button;\n  ";
}
var _default = {
  html: html,
  boxSizing: boxSizing,
  ie10FixViewport: ie10FixViewport,
  body: body,
  bodyUtils: bodyUtils,
  tabIndex: tabIndex,
  svg: svg,
  ie10FixHidden: ie10FixHidden,
  getGlobalStyles: getGlobalStyles,
  getGlobalStyleNoBootstrapProvider: getGlobalStyleNoBootstrapProvider,
  webkitFileUploadButton: webkitFileUploadButton
};
exports.default = _default;
});
var rebootUtils = unwrapExports(reboot);
var reboot_1 = reboot.getGlobalStyles;
var reboot_2 = reboot.getGlobalStyleNoBootstrapProvider;
var reboot_3 = reboot.html;
var reboot_4 = reboot.boxSizing;
var reboot_5 = reboot.ie10FixViewport;
var reboot_6 = reboot.body;
var reboot_7 = reboot.bodyUtils;
var reboot_8 = reboot.tabIndex;
var reboot_9 = reboot.svg;
var reboot_10 = reboot.ie10FixHidden;
var reboot_11 = reboot.webkitFileUploadButton;
var reboot_12 = reboot.defaultProps;

var FadePropTypes = propTypes.shape(propTypes$3);
var propTypes$M = {
  className: propTypes.string,
  theme: propTypes.shape({
    '$grid-breakpoints': propTypes.object,
    '$modal-md': propTypes.string,
    '$modal-dialog-sm-up-margin-': propTypes.string,
    '$enable-shadows': propTypes.bool,
    '$modal-content-sm-up-box-shadow': propTypes.string,
    '$modal-sm': propTypes.string,
    '$modal-lg': propTypes.string,
    '$zindex-modal': propTypes.string,
    '$zindex-modal-backdrop': propTypes.string,
    '$enable-transitions': propTypes.bool,
    '$transition-fade': propTypes.string,
    '$modal-transition': propTypes.string,
    '$modal-dialog-margin': propTypes.string,
    '$font-family-base': propTypes.string,
    '$font-size-base': propTypes.string,
    '$font-weight-base': propTypes.string,
    '$line-height-base': propTypes.string,
    '$body-color': propTypes.string,
    '$body-bg': propTypes.string,
    '$$modal-content-bg': propTypes.string,
    '$modal-content-border-width': propTypes.string,
    '$modal-content-border-color': propTypes.string,
    '$enable-rounded': propTypes.bool,
    '$border-radius-lg': propTypes.string,
    '$modal-content-xs-box-shadow': propTypes.string,
    '$modal-backdrop-bg': propTypes.string,
    '$modal-backdrop-opacity': propTypes.string,
    '$modal-header-padding': propTypes.string,
    '$modal-header-border-width': propTypes.string,
    '$modal-header-border-color': propTypes.string,
    '$modal-title-line-height': propTypes.string,
    '$modal-inner-padding': propTypes.string,
    '$modal-footer-border-color': propTypes.string
  }),
  isOpen: propTypes.bool,
  autoFocus: propTypes.bool,
  size: propTypes.oneOf(['sm', 'lg', '']),
  toggle: propTypes.func,
  keyboard: propTypes.bool,
  role: propTypes.string,
  labelledBy: propTypes.string,
  backdrop: propTypes.oneOfType([propTypes.bool, propTypes.oneOf(['static'])]),
  onEnter: propTypes.func,
  onExit: propTypes.func,
  onOpened: propTypes.func,
  onClosed: propTypes.func,
  children: propTypes.node,
  documentClassName: propTypes.string,
  modalClassName: propTypes.string,
  backdropClassName: propTypes.string,
  contentClassName: propTypes.string,
  fade: propTypes.bool,
  cssModule: propTypes.object,
  zIndex: propTypes.oneOfType([propTypes.number, propTypes.string]),
  backdropTransition: FadePropTypes,
  modalTransition: FadePropTypes
};
var defaultProps$K = {
  isOpen: false,
  autoFocus: true,
  role: 'dialog',
  backdrop: true,
  keyboard: true,
  zIndex: 2000,
  theme: {
    '$grid-breakpoints': {
      xs: '0',
      sm: '576px',
      md: '768px',
      lg: '992px',
      xl: '1200px',
      xxl: '1452px'
    },
    '$enable-rounded': true,
    '$enable-shadows': false,
    '$enable-transitions': true,
    '$modal-dialog-sm-up-margin-y': '30px',
    '$modal-content-sm-up-box-shadow': '0 5px 15px lightgray',
    '$modal-sm': '300px',
    '$modal-md': '500px',
    '$modal-lg': '800px',
    '$zindex-modal': '2050',
    '$zindex-modal-backdrop': '2040',
    '$transition-fade': 'opacity .15s linear',
    '$modal-transition': 'transform .3s ease-out',
    '$modal-dialog-margin': '10px',
    '$font-family-base': '-apple-system, system-ui, BlinkMacSystemFont, "Segoe UI", Roboto, "Helvetica Neue", Arial, sans-serif',
    '$font-size-base': '1rem',
    '$font-weight-base': 'normal',
    '$line-height-base': '1.5',
    '$body-color': '#292b2c',
    '$body-bg': '#fff',
    '$$modal-content-bg': '#fff',
    '$modal-content-border-width': '1px',
    '$modal-content-border-color': '#eceeef',
    '$border-radius-lg': '.3rem',
    '$modal-content-xs-box-shadow': '0 3px 9px #eceeef',
    '$modal-backdrop-bg': '#000',
    '$modal-backdrop-opacity': '.5',
    '$modal-header-padding': '15px',
    '$modal-header-border-width': '#eceeef',
    '$modal-header-border-color': '#eceeef',
    '$modal-title-line-height': '1.5',
    '$modal-inner-padding': '15px',
    '$modal-footer-border-color': '#eceeef'
  },
  fade: true,
  onOpened: null,
  onClosed: null,
  modalTransition: {
    timeout: 300
  },
  backdropTransition: {
    mountOnEnter: true,
    timeout: 150
  }
};
var ModalUnstyled =
function (_React$Component) {
  _inherits(ModalUnstyled, _React$Component);
  function ModalUnstyled(props) {
    var _this;
    _classCallCheck(this, ModalUnstyled);
    _this = _possibleConstructorReturn(this, _getPrototypeOf(ModalUnstyled).call(this, props));
    _defineProperty(_assertThisInitialized(_this), "onOpened", function (node, isAppearing) {
      if (_this.props.onOpened) {
        _this.props.onOpened();
      }
      if (_this.props.modalTransition.onEntered) {
        _this.props.modalTransition.onEntered(node, isAppearing);
      }
    });
    _defineProperty(_assertThisInitialized(_this), "onClosed", function (node) {
      if (_this.props.onClosed) {
        _this.props.onClosed();
      }
      if (_this.props.modalTransition.onEntered) {
        _this.props.modalTransition.onExited(node);
      }
      _this.destroy();
      if (_this._isMounted) {
        _this.setState({
          isOpen: false
        });
      }
    });
    _defineProperty(_assertThisInitialized(_this), "handleBackdropClick", function (e) {
      e.stopPropagation();
      if (!_this.props.isOpen || _this.props.backdrop !== true) return;
      var container = _this._dialog;
      if (e.target && !container.contains(e.target) && _this.props.toggle) {
        _this.props.toggle();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "handleEscape", function (e) {
      if (_this.props.isOpen && _this.props.keyboard && e.keyCode === 27 && _this.props.toggle) {
        _this.props.toggle();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "destroy", function () {
      document.body.removeChild(_this._element);
      _this._element = null;
      var classes = document.body.className.replace(/(^| )overflow( |$)/, ' ');
      document.body.className = mapToCssModules(classnames(classes).trim(), _this.props.cssModule);
      tools_3(_this.originalBodyPadding);
    });
    _this.originalBodyPadding = null;
    _this.state = {
      isOpen: props.isOpen
    };
    if (props.isOpen) {
      _this.init();
    }
    return _this;
  }
  _createClass(ModalUnstyled, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.onEnter) {
        this.props.onEnter();
      }
      if (this.state.isOpen && this.props.autoFocus) {
        this.setFocus();
      }
      this._isMounted = true;
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.isOpen && !this.props.isOpen) {
        this.setState({
          isOpen: nextProps.isOpen
        });
      }
    }
  }, {
    key: "componentWillUpdate",
    value: function componentWillUpdate(nextProps, nextState) {
      if (nextState.isOpen && !this.state.isOpen) {
        this.init();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      if (this.props.autoFocus && this.state.isOpen && !prevState.isOpen) {
        this.setFocus();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.props.onExit) {
        this.props.onExit();
      }
      if (this.state.isOpen) {
        this.destroy();
      }
      this._isMounted = false;
    }
  }, {
    key: "setFocus",
    value: function setFocus() {
      if (this._dialog && this._dialog.parentNode && typeof this._dialog.parentNode.focus === 'function') {
        this._dialog.parentNode.focus();
      }
    }
  }, {
    key: "init",
    value: function init() {
      var classes = document.body.className;
      this._element = document.createElement('div');
      this._element.setAttribute('tabindex', '-1');
      this._element.style.position = 'relative';
      this._element.style.zIndex = this.props.zIndex;
      this.originalBodyPadding = tools_5();
      tools_6();
      document.body.appendChild(this._element);
      document.body.className = mapToCssModules(classnames(classes, 'overflow'), this.props.cssModule);
    }
  }, {
    key: "renderModalDialog",
    value: function renderModalDialog() {
      var _this2 = this;
      var attributes = lodash_omit(this.props, ['theme', 'isOpen', 'autoFocus', 'size', 'toggle', 'keyboard', 'role', 'labelledBy', 'backdrop', 'onEnter', 'onExit', 'onOpened', 'onClosed', 'children', 'className', 'documentClassName', 'modalClassName', 'backdropClassName', 'contentClassName', 'fade', 'cssModule', 'zIndex', 'backdropTransition', 'modalTransition']);
      return React.createElement("div", _extends({
        className: mapToCssModules(classnames('modal-dialog', this.props.documentClassName, _defineProperty({}, "modal-".concat(this.props.size), this.props.size)), this.props.cssModule),
        role: "document",
        ref: function ref(c) {
          _this2._dialog = c;
        }
      }, attributes), React.createElement("div", {
        className: mapToCssModules(classnames('modal-content', this.props.contentClassName), this.props.cssModule)
      }, this.props.children));
    }
  }, {
    key: "render",
    value: function render() {
      if (this.state.isOpen) {
        var _this$props = this.props,
            modalClassName = _this$props.modalClassName,
            backdropClassName = _this$props.backdropClassName,
            cssModule = _this$props.cssModule,
            isOpen = _this$props.isOpen,
            backdrop = _this$props.backdrop,
            role = _this$props.role,
            labelledBy = _this$props.labelledBy;
        var modalAttributes = {
          onClick: this.handleBackdropClick,
          onKeyUp: this.handleEscape,
          style: {
            display: 'block'
          },
          'aria-labelledby': labelledBy,
          role: role,
          tabIndex: '-1'
        };
        var hasTransition = this.props.fade;
        var modalTransition = _objectSpread({}, defaultProps$3, this.props.modalTransition, {
          baseClass: hasTransition ? this.props.modalTransition.baseClass : '',
          timeout: hasTransition ? this.props.modalTransition.timeout : 0
        });
        var backdropTransition = _objectSpread({}, defaultProps$3, this.props.backdropTransition, {
          baseClass: hasTransition ? this.props.backdropTransition.baseClass : '',
          timeout: hasTransition ? this.props.backdropTransition.timeout : 0
        });
        return React.createElement(Portal$3, {
          node: this._element
        }, React.createElement("div", {
          className: mapToCssModules(this.props.className)
        }, React.createElement(Fade, _extends({}, modalAttributes, modalTransition, {
          in: isOpen,
          onEntered: this.onOpened,
          onExited: this.onClosed,
          cssModule: cssModule,
          className: mapToCssModules(classnames('modal', modalClassName), cssModule)
        }), this.renderModalDialog()), React.createElement(Fade, _extends({}, backdropTransition, {
          in: isOpen && !!backdrop,
          cssModule: cssModule,
          className: mapToCssModules(classnames('modal-backdrop', backdropClassName), cssModule)
        }))));
      }
      return null;
    }
  }]);
  return ModalUnstyled;
}(React.Component);
_defineProperty(ModalUnstyled, "propTypes", propTypes$M);
_defineProperty(ModalUnstyled, "defaultProps", defaultProps$K);
var Modal = styled(ModalUnstyled).withConfig({
  displayName: "Modal",
  componentId: "sc-68tm7q-0"
})(["", ""], function (props) {
  return "\n    & .modal {\n      position: fixed;\n      top: 0;\n      right: 0;\n      bottom: 0;\n      left: 0;\n      z-index: ".concat(props.theme['$zindex-modal'], ";\n      display: none;\n      outline: 0;\n      overflow-x: hidden;\n      overflow-y: auto;\n      \n      ").concat(transition_2$1(props.theme['$enable-transitions'], props.theme['$transition-fade']), "\n      &.fade {\n        .modal-dialog {\n          ").concat(transition_2(props.theme['$enable-transitions'], props.theme['$modal-transition']), "\n          transform: translate(0, -25%);\n        }\n      }\n      &.show {\n        .modal-dialog {\n          transform: translate(0, 0);\n        }\n      }\n    }\n    \n    & .modal-dialog {\n      position: relative;\n      width: auto;\n      margin: ").concat(props.theme['$modal-dialog-margin'], ";\n      ").concat(rebootUtils.body(props.theme['$font-family-base'], props.theme['$font-size-base'], props.theme['$font-weight-base'], props.theme['$line-height-base'], props.theme['$body-color'], props.theme['$body-bg']), "\n    }\n    \n    \n    & .modal-content {\n      position: relative;\n      display: flex;\n      flex-direction: column;\n      background-color: ").concat(props.theme['$modal-content-bg'], ";\n      background-clip: padding-box;\n      border: ").concat(props.theme['$modal-content-border-width'], " solid ").concat(props.theme['$modal-content-border-color'], ";\n      ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$border-radius-lg']), "\n      ").concat(boxShadow_2(props.theme['$enable-shadows'], props.theme['$modal-content-xs-box-shadow']), "\n      outline: 0;\n    }\n    \n    & .modal-backdrop {\n      position: fixed;\n      top: 0;\n      right: 0;\n      bottom: 0;\n      left: 0;\n      z-index: ").concat(props.theme['$zindex-modal-backdrop'], ";\n      background-color: ").concat(props.theme['$modal-backdrop-bg'], ";\n      &.fade {\n        opacity: 0;\n        ").concat(transition_2(props.theme['$enable-transitions'], props.theme['$transition-fade']), ";\n      }\n      &.show {\n        opacity: ").concat(props.theme['$modal-backdrop-opacity'], ";\n      }\n    }\n      \n        \n    & .modal-header {\n      display: flex;\n      align-items: center;\n      justify-content: space-between;\n      padding: ").concat(props.theme['$modal-header-padding'], ";\n      border-bottom: ").concat(props.theme['$modal-header-border-width'], " solid ").concat(props.theme['$modal-header-border-color'], ";\n    }\n    \n    & .modal-title {\n      margin-bottom: 0;\n      line-height: ").concat(props.theme['$modal-title-line-height'], ";\n    }\n    \n    & .modal-body {\n      position: relative;\n      flex: 1 1 auto;\n      padding: ").concat(props.theme['$modal-inner-padding'], ";\n    }\n    \n    & .modal-footer {\n      display: flex;\n      align-items: center;\n      justify-content: flex-end;\n      padding: ").concat(props.theme['$modal-inner-padding'], ";\n      border-top: ").concat(props.theme['$modal-footer-border-width'], " solid ").concat(props.theme['$modal-footer-border-color'], ";\n      // Easily place margin between footer elements\n      > :not(:first-child) { margin-left: .25rem; }\n      > :not(:last-child) { margin-right: .25rem; }\n    }\n    \n\n  \n    // Scale up the modal\n    ").concat(breakpoints_5('sm', props.theme['$grid-breakpoints'], "\n        & .modal-dialog {\n          max-width: ".concat(props.theme['$modal-md'], ";\n          margin: ").concat(props.theme['$modal-dialog-sm-up-margin-y'], " auto;\n        }\n      \n        & .modal-content {\n          ").concat(boxShadow_2(props.theme['$enable-shadows'], props.theme['$modal-content-sm-up-box-shadow']), "\n        }\n      \n        & .modal-sm {\n          max-width: ").concat(props.theme['$modal-sm'], ";\n        }\n      ")), "\n  \n\n    ").concat(breakpoints_5('lg', props.theme['$grid-breakpoints'], "\n        & .modal-lg {\n           max-width:  ".concat(props.theme['$modal-lg'], "; \n         }\n      ")), "\n  ");
});
Modal.defaultProps = defaultProps$K;
Modal.propTypes = propTypes$M;

var defaultProps$L = {
  tag: 'div'
};
var propTypes$N = {
  className: propTypes.string,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var ModalBody = function ModalBody(props) {
  var className = props.className,
      cssModule = props.cssModule,
      Tag = props.tag,
      attributes = _objectWithoutProperties(props, ["className", "cssModule", "tag"]);
  return React.createElement(Tag, _extends({}, attributes, {
    className: mapToCssModules(classnames(className, 'modal-body'), cssModule)
  }));
};
ModalBody.propTypes = propTypes$N;
ModalBody.defaultProps = defaultProps$L;

var defaultProps$M = {
  tag: 'div'
};
var propTypes$O = {
  className: propTypes.string,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var ModalFooter = function ModalFooter(props) {
  var className = props.className,
      cssModule = props.cssModule,
      Tag = props.tag,
      attributes = _objectWithoutProperties(props, ["className", "cssModule", "tag"]);
  return React.createElement(Tag, _extends({}, attributes, {
    className: mapToCssModules(classnames(className, 'modal-footer'), cssModule)
  }));
};
ModalFooter.propTypes = propTypes$O;
ModalFooter.defaultProps = defaultProps$M;

var defaultProps$N = {
  tag: H4,
  wrapTag: 'div'
};
var propTypes$P = {
  className: propTypes.string,
  children: propTypes.node,
  tag: propTypes.any,
  wrapTag: propTypes.any,
  toggle: propTypes.func,
  cssModule: propTypes.object
};
var ModalHeader = function ModalHeader(props) {
  var closeButton;
  var className = props.className,
      cssModule = props.cssModule,
      children = props.children,
      toggle = props.toggle,
      Tag = props.tag,
      WrapTag = props.wrapTag,
      attributes = _objectWithoutProperties(props, ["className", "cssModule", "children", "toggle", "tag", "wrapTag"]);
  var classes = mapToCssModules(classnames(className, 'modal-header'), cssModule);
  if (toggle) {
    closeButton = React.createElement(Close, {
      type: "button",
      onDismiss: toggle,
      "aria-label": "Close"
    });
  }
  return React.createElement(WrapTag, _extends({}, attributes, {
    className: classes
  }), React.createElement(Tag, {
    className: mapToCssModules('modal-title', cssModule)
  }, children), closeButton);
};
ModalHeader.propTypes = propTypes$P;
ModalHeader.defaultProps = defaultProps$N;

var defaultProps$O = {
  tag: Ul,
  toggleable: 'false',
  theme: {
    '$enable-rounded': true,
    '$enable-hover-media-query': false,
    '$border-width': '1px',
    '$font-size-lg': '1.25rem',
    '$body-bg': '#fff',
    '$component-active-bg': '#0275d8',
    '$component-active-color': '#fff',
    '$border-radius': '.25rem',
    '$navbar-padding-x': '1rem',
    '$navbar-padding-y': '0.5rem',
    '$nav-link-padding': '.5em 1em',
    '$nav-disabled-link-color': '#636c72',
    '$nav-tabs-border-color': '#ddd',
    '$nav-tabs-border-width': '1px',
    '$nav-tabs-border-radius': '.5em 1em',
    '$nav-tabs-link-hover-border-color': '#eceeef',
    '$nav-tabs-active-link-hover-color': '#464a4c',
    '$nav-tabs-active-link-hover-bg': '#fff',
    '$nav-tabs-active-link-hover-border-color': '#ddd',
    '$nav-pills-border-radius': '.25rem',
    '$nav-pills-active-link-color': '#fff',
    '$nav-pills-active-link-bg': '#0275d8',
    '$cursor-disabled': 'not-allowed',
    '$zindex-navbar': '1000',
    '$zindex-navbar-fixed': '1030',
    '$zindex-navbar-sticky': '1030',
    '$navbar-brand-padding-y': '.25rem',
    '$navbar-divider-padding-y': '.425rem',
    '$navbar-toggler-padding-y': '.5rem',
    '$navbar-toggler-padding-x': '.75rem',
    '$navbar-toggler-font-size': '1.25rem',
    '$navbar-toggler-border-radius': '.25rem',
    '$navbar-light-active-color': 'rgba(0,0,0,.9)',
    '$navbar-light-color': 'rgba(0,0,0,.5)',
    '$navbar-light-hover-color': 'rgba(0,0,0,.7)',
    '$navbar-light-toggler-border': 'rgba(0,0,0,.1)',
    '$navbar-light-disabled-color': 'rgba(0, 0, 0, 0.3)',
    '$navbar-light-toggler-bg': 'url(\'data:image/svg+xml;charset=utf8,%3Csvg viewBox="0 0 30 30" xmlns="http://www.w3.org/2000/svg"%3E%3Cpath stroke="rgba(0,0,0,.5)" stroke-width="2" stroke-linecap="round" stroke-miterlimit="10" d="M4 7h22M4 15h22M4 23h22"/%3E%3C/svg%3E\')',
    '$navbar-inverse-active-color': 'rgba(255,255,255,1)',
    '$navbar-inverse-color': 'rgba(255,255,255,.5)',
    '$navbar-inverse-hover-color': 'rgba(255,255,255,.75)',
    '$navbar-inverse-toggler-border': 'rgba(255,255,255,.1)',
    '$navbar-inverse-toggler-bg': 'url(\'data:image/svg+xml;charset=utf8,%3Csvg viewBox="0 0 30 30" xmlns="http://www.w3.org/2000/svg"%3E%3Cpath stroke="rgba(255,255,255,.5)" stroke-width="2" stroke-linecap="round" stroke-miterlimit="10" d="M4 7h22M4 15h22M4 23h22"/%3E%3C/svg%3E\')',
    '$navbar-inverse-disabled-color': 'rgba(255, 255, 255, 0.25)'
  }
};
var propTypes$Q = {
  className: propTypes.string,
  toggleable: propTypes.string,
  inline: propTypes.bool,
  vertical: propTypes.bool,
  justified: propTypes.bool,
  fill: propTypes.bool,
  tabs: propTypes.bool,
  pills: propTypes.bool,
  stacked: propTypes.bool,
  navbar: propTypes.bool,
  tag: propTypes.any,
  theme: propTypes.shape({
    '$border-width': propTypes.string,
    '$font-size-lg': propTypes.string,
    '$body-bg': propTypes.string,
    '$component-active-bg': propTypes.string,
    '$component-active-color': propTypes.string,
    '$border-radius': propTypes.string,
    '$navbar-padding-x': propTypes.string,
    '$navbar-padding-y': propTypes.string,
    '$nav-link-padding': propTypes.string,
    '$nav-disabled-link-color': propTypes.string,
    '$nav-tabs-border-color': propTypes.string,
    '$nav-tabs-border-width': propTypes.string,
    '$nav-tabs-border-radius': propTypes.string,
    '$nav-tabs-link-hover-border-color': propTypes.string,
    '$nav-tabs-active-link-hover-color': propTypes.string,
    '$nav-tabs-active-link-hover-bg': propTypes.string,
    '$nav-tabs-active-link-hover-border-color': propTypes.string,
    '$nav-pills-border-radius': propTypes.string,
    '$nav-pills-active-link-color': propTypes.string,
    '$nav-pills-active-link-bg': propTypes.string,
    '$cursor-disabled': propTypes.string,
    '$zindex-navbar': propTypes.string,
    '$zindex-navbar-fixed': propTypes.string,
    '$zindex-navbar-sticky': propTypes.string,
    '$navbar-brand-padding-y': propTypes.string,
    '$navbar-divider-padding-y': propTypes.string,
    '$navbar-toggler-padding-y': propTypes.string,
    '$navbar-toggler-padding-x': propTypes.string,
    '$navbar-toggler-font-size': propTypes.string,
    '$navbar-toggler-border-radius': propTypes.string,
    '$navbar-light-active-color': propTypes.string,
    '$navbar-light-color': propTypes.string,
    '$navbar-light-hover-color': propTypes.string,
    '$navbar-light-toggler-border': propTypes.string,
    '$navbar-light-disabled-color': propTypes.string,
    '$navbar-light-toggler-bg': propTypes.string,
    '$navbar-inverse-active-color': propTypes.string,
    '$navbar-inverse-color': propTypes.string,
    '$navbar-inverse-hover-color': propTypes.string,
    '$navbar-inverse-toggler-border': propTypes.string,
    '$navbar-inverse-toggler-bg': propTypes.string,
    '$navbar-inverse-disabled-color': propTypes.string
  }),
  cssModule: propTypes.object
};
var NavUnstyled =
function (_React$Component) {
  _inherits(NavUnstyled, _React$Component);
  function NavUnstyled() {
    _classCallCheck(this, NavUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(NavUnstyled).apply(this, arguments));
  }
  _createClass(NavUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          tabs = _omit.tabs,
          pills = _omit.pills,
          fill = _omit.fill,
          inline = _omit.inline,
          stacked = _omit.stacked,
          vertical = _omit.vertical,
          justified = _omit.justified,
          navbar = _omit.navbar,
          Tag = _omit.tag,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "tabs", "pills", "fill", "inline", "stacked", "vertical", "justified", "navbar", "tag"]);
      var classes = mapToCssModules(classnames(className, navbar ? 'navbar-nav' : 'nav', {
        'nav-tabs': tabs,
        'nav-pills': pills,
        'nav-fill': fill,
        'nav-inline': inline,
        'nav-stacked': stacked,
        'nav-justified': justified,
        'flex-column': vertical
      }), cssModule);
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
    }
  }]);
  return NavUnstyled;
}(React.Component);
_defineProperty(NavUnstyled, "propTypes", propTypes$Q);
_defineProperty(NavUnstyled, "defaultProps", defaultProps$O);
var Nav = styled(NavUnstyled).withConfig({
  displayName: "Nav",
  componentId: "ggw7qv-0"
})(["", ""], function (props) {
  return "\n    ".concat(nav_2(props.theme['$enable-rounded'], props.theme['$enable-hover-media-query'], props.theme['$nav-link-padding'], props.theme['$nav-disabled-link-color'], props.theme['$cursor-disabled'], props.theme['$nav-tabs-border-width'], props.theme['$nav-tabs-border-color'], props.theme['$nav-tabs-border-radius'], props.theme['$nav-tabs-link-hover-border-color'], props.theme['$nav-tabs-active-link-hover-color'], props.theme['$nav-tabs-active-link-hover-bg'], props.theme['$nav-tabs-active-link-hover-border-color'], props.theme['$nav-pills-border-radius'], props.theme['$nav-pills-active-link-color'], props.theme['$nav-pills-active-link-bg']), "\n    \n    ").concat(navbar_2(props.theme['$grid-breakpoints'], props.theme['$enable-rounded'], props.theme['$enable-hover-media-query'], props.theme['$navbar-padding-y'], props.theme['$navbar-padding-x'], props.theme['$zindex-navbar'], props.theme['$zindex-navbar-fixed'], props.theme['$zindex-navbar-sticky'], props.theme['$navbar-brand-padding-y'], props.theme['$font-size-lg'], props.theme['$navbar-divider-padding-y'], props.theme['$navbar-toggler-padding-y'], props.theme['$navbar-toggler-padding-x'], props.theme['$navbar-toggler-font-size'], props.theme['$border-width'], props.theme['$navbar-toggler-border-radius'], props.theme['$navbar-light-active-color'], props.theme['$navbar-light-color'], props.theme['$navbar-light-hover-color'], props.theme['$navbar-light-toggler-border'], props.theme['$navbar-light-disabled-color'], props.theme['$navbar-light-toggler-bg'], props.theme['$navbar-inverse-active-color'], props.theme['$navbar-inverse-color'], props.theme['$navbar-inverse-hover-color'], props.theme['$navbar-inverse-toggler-border'], props.theme['$navbar-inverse-toggler-bg'], props.theme['$navbar-inverse-disabled-color']), "\n  ");
});
Nav.defaultProps = defaultProps$O;
Nav.propTypes = propTypes$Q;

var defaultProps$P = {
  tag: A
};
var propTypes$R = {
  className: propTypes.string,
  ref: propTypes.func,
  disabled: propTypes.bool,
  active: propTypes.bool,
  onClick: propTypes.func,
  href: propTypes.any,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var NavLink =
function (_React$Component) {
  _inherits(NavLink, _React$Component);
  function NavLink(props) {
    var _this;
    _classCallCheck(this, NavLink);
    _this = _possibleConstructorReturn(this, _getPrototypeOf(NavLink).call(this, props));
    _this.onClick = _this.onClick.bind(_assertThisInitialized(_this));
    return _this;
  }
  _createClass(NavLink, [{
    key: "onClick",
    value: function onClick(e) {
      if (this.props.disabled) {
        e.preventDefault();
        return;
      }
      if (this.props.href === '#') {
        e.preventDefault();
      }
      if (this.props.onClick) {
        this.props.onClick(e);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          active = _this$props.active,
          Tag = _this$props.tag,
          ref = _this$props.ref,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "active", "tag", "ref"]);
      var classes = mapToCssModules(classnames(className, 'nav-link', {
        disabled: attributes.disabled,
        active: active
      }), cssModule);
      return React.createElement(Tag, _extends({}, attributes, {
        ref: ref,
        onClick: this.onClick,
        className: classes
      }));
    }
  }]);
  return NavLink;
}(React.Component);
_defineProperty(NavLink, "propTypes", propTypes$R);
_defineProperty(NavLink, "defaultProps", defaultProps$P);
NavLink.defaultProps = defaultProps$P;
NavLink.propTypes = propTypes$R;

var defaultProps$Q = {
  tag: 'li'
};
var propTypes$S = {
  className: propTypes.string,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var NavItem =
function (_React$Component) {
  _inherits(NavItem, _React$Component);
  function NavItem() {
    _classCallCheck(this, NavItem);
    return _possibleConstructorReturn(this, _getPrototypeOf(NavItem).apply(this, arguments));
  }
  _createClass(NavItem, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "tag"]);
      var classes = mapToCssModules(classnames(className, 'nav-item'), cssModule);
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
    }
  }]);
  return NavItem;
}(React.Component);
_defineProperty(NavItem, "propTypes", propTypes$S);
_defineProperty(NavItem, "defaultProps", defaultProps$Q);
NavItem.defaultProps = defaultProps$Q;
NavItem.propTypes = propTypes$S;

var defaultProps$R = {
  theme: {
    '$list-inline-padding': '5px'
  }
};
var propTypes$T = {
  theme: propTypes.shape({
    '$list-inline-padding': propTypes.string
  })
};
var Ol = styled.ol.withConfig({
  displayName: "Ol",
  componentId: "kl9hp1-0"
})(["", ""], function (props) {
  return "\n    /* Type Scss */\n    &.list-unstyled {\n      ".concat(lists_1(), "\n    }\n\n    &.list-inline {\n      ").concat(lists_2(), "\n    }\n\n    &.list-inline-item {\n      ").concat(lists_3(props.theme['$list-inline-padding']), "\n    }\n\n    /* Reboot Scss */\n    margin-top: 0;\n    margin-bottom: 1rem;\n\n    & ol,\n    & ul {\n      margin-bottom: 0;\n    }\n  ");
});
Ol.defaultProps = defaultProps$R;
Ol.propTypes = propTypes$T;

var Option = function Option(props) {
  return React.createElement("option", props);
};

var OutputUnstyled =
function (_React$Component) {
  _inherits(OutputUnstyled, _React$Component);
  function OutputUnstyled() {
    _classCallCheck(this, OutputUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(OutputUnstyled).apply(this, arguments));
  }
  _createClass(OutputUnstyled, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          rest = _objectWithoutProperties(_this$props, ["className"]);
      return React.createElement("output", _extends({
        className: classnames(className, 'output')
      }, rest));
    }
  }]);
  return OutputUnstyled;
}(React.Component);
_defineProperty(OutputUnstyled, "propTypes", {
  className: propTypes.string
});
var Output = styled(OutputUnstyled).withConfig({
  displayName: "Output",
  componentId: "hh3btf-0"
})(["&.output{display:inline-block;}"]);

var defaultProps$S = {
  theme: {
    '$grid-breakpoints': {
      xs: '0',
      sm: '576px',
      md: '768px',
      lg: '992px',
      xl: '1200px'
    },
    '$enable-rounded': true,
    '$enable-hover-media-query': false,
    '$font-size-h1': '2.5rem',
    '$font-size-h2': '2rem',
    '$font-size-h3': '1.75rem',
    '$font-size-h4': '1.5rem',
    '$font-size-h5': '1.25rem',
    '$font-size-h6': '1rem',
    '$headings-margin-bottom': '0.5rem',
    '$headings-font-family': 'inherit',
    '$headings-font-weight': '500',
    '$headings-line-height': '1.1',
    '$headings-color': 'inherit',
    '$display1-size': '6rem',
    '$display2-size': '5.5rem',
    '$display3-size': '4.5rem',
    '$display4-size': '3.5rem',
    '$display1-weight': '300',
    '$display2-weight': '300',
    '$display3-weight': '300',
    '$display4-weight': '300',
    '$display-line-height': '1.1',
    '$lead-font-size': '1.25rem',
    '$lead-font-weight': '300'
  }
};
var propTypes$U = {
  className: propTypes.string,
  children: propTypes.node,
  color: propTypes.oneOf(['white', 'muted', 'gray-dark', 'primary', 'success', 'info', 'warning', 'danger']),
  lead: propTypes.bool,
  theme: propTypes.shape({
    '$enable-rounded': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool,
    '$grid-breakpoints': propTypes.object,
    '$font-size-h1': propTypes.string,
    '$font-size-h2': propTypes.string,
    '$font-size-h3': propTypes.string,
    '$font-size-h4': propTypes.string,
    '$font-size-h5': propTypes.string,
    '$font-size-h6': propTypes.string,
    '$headings-margin-bottom': propTypes.string,
    '$headings-font-family': propTypes.string,
    '$headings-font-weight': propTypes.string,
    '$headings-line-height': propTypes.string,
    '$headings-color': propTypes.string,
    '$display1-size': propTypes.string,
    '$display2-size': propTypes.string,
    '$display3-size': propTypes.string,
    '$display4-size': propTypes.string,
    '$display1-weight': propTypes.string,
    '$display2-weight': propTypes.string,
    '$display3-weight': propTypes.string,
    '$display4-weight': propTypes.string,
    '$display-line-height': propTypes.string,
    '$lead-font-size': propTypes.string,
    '$lead-font-weight': propTypes.string
  }),
  cssModule: propTypes.object
};
var PUnstyled =
function (_React$Component) {
  _inherits(PUnstyled, _React$Component);
  function PUnstyled() {
    _classCallCheck(this, PUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(PUnstyled).apply(this, arguments));
  }
  _createClass(PUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          color = _omit.color,
          children = _omit.children,
          cssModule = _omit.cssModule,
          lead = _omit.lead,
          attributes = _objectWithoutProperties(_omit, ["className", "color", "children", "cssModule", "lead"]);
      var classes = mapToCssModules(classnames(className, lead ? 'lead' : false, color ? "text-".concat(color) : false), cssModule);
      return React.createElement("p", _extends({
        className: classes
      }, attributes), children);
    }
  }]);
  return PUnstyled;
}(React.Component);
_defineProperty(PUnstyled, "propTypes", propTypes$U);
_defineProperty(PUnstyled, "defaultProps", defaultProps$S);
var P = styled(PUnstyled).withConfig({
  displayName: "P",
  componentId: "sc-31hrrf-0"
})(["", ""], function (props) {
  return "\n    /* Type Scss */\n\n    &.lead {\n      font-size: ".concat(props.theme['$lead-font-size'], ";\n      font-weight: ").concat(props.theme['$lead-font-weight'], ";\n    }\n    \n    &.h1{\n      font-size: ").concat(props.theme['$font-size-h1'], ";\n      ").concat(typography_2(props.theme['$headings-margin-bottom'], props.theme['$headings-font-family'], props.theme['$headings-font-weight'], props.theme['$headings-line-height'], props.theme['$headings-color'], props.theme['$display1-size'], props.theme['$display2-size'], props.theme['$display3-size'], props.theme['$display4-size'], props.theme['$display1-weight'], props.theme['$display2-weight'], props.theme['$display3-weight'], props.theme['$display4-weight']), "\n    }\n    \n    &.h2{\n      font-size: ").concat(props.theme['$font-size-h2'], ";\n      ").concat(typography_2(props.theme['$headings-margin-bottom'], props.theme['$headings-font-family'], props.theme['$headings-font-weight'], props.theme['$headings-line-height'], props.theme['$headings-color'], props.theme['$display1-size'], props.theme['$display2-size'], props.theme['$display3-size'], props.theme['$display4-size'], props.theme['$display1-weight'], props.theme['$display2-weight'], props.theme['$display3-weight'], props.theme['$display4-weight']), "\n    }\n    \n    &.h3{\n      font-size: ").concat(props.theme['$font-size-h3'], ";\n      ").concat(typography_2(props.theme['$headings-margin-bottom'], props.theme['$headings-font-family'], props.theme['$headings-font-weight'], props.theme['$headings-line-height'], props.theme['$headings-color'], props.theme['$display1-size'], props.theme['$display2-size'], props.theme['$display3-size'], props.theme['$display4-size'], props.theme['$display1-weight'], props.theme['$display2-weight'], props.theme['$display3-weight'], props.theme['$display4-weight']), "\n    }\n    \n    &.h4{\n      font-size: ").concat(props.theme['$font-size-h4'], ";\n      ").concat(typography_2(props.theme['$headings-margin-bottom'], props.theme['$headings-font-family'], props.theme['$headings-font-weight'], props.theme['$headings-line-height'], props.theme['$headings-color'], props.theme['$display1-size'], props.theme['$display2-size'], props.theme['$display3-size'], props.theme['$display4-size'], props.theme['$display1-weight'], props.theme['$display2-weight'], props.theme['$display3-weight'], props.theme['$display4-weight']), "\n    }\n    \n    &.h5{\n      font-size: ").concat(props.theme['$font-size-h5'], ";\n      ").concat(typography_2(props.theme['$headings-margin-bottom'], props.theme['$headings-font-family'], props.theme['$headings-font-weight'], props.theme['$headings-line-height'], props.theme['$headings-color'], props.theme['$display1-size'], props.theme['$display2-size'], props.theme['$display3-size'], props.theme['$display4-size'], props.theme['$display1-weight'], props.theme['$display2-weight'], props.theme['$display3-weight'], props.theme['$display4-weight']), "\n    }\n    \n    &.h6{\n      font-size: ").concat(props.theme['$font-size-h6'], ";\n      ").concat(typography_2(props.theme['$headings-margin-bottom'], props.theme['$headings-font-family'], props.theme['$headings-font-weight'], props.theme['$headings-line-height'], props.theme['$headings-color'], props.theme['$display1-size'], props.theme['$display2-size'], props.theme['$display3-size'], props.theme['$display4-size'], props.theme['$display1-weight'], props.theme['$display2-weight'], props.theme['$display3-weight'], props.theme['$display4-weight']), "\n    }\n    \n    /* Reboot Scss */\n    margin-top: 0;   \n    margin-bottom: 1rem;\n  ");
});

var paginations = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pagination = pagination;
exports.default = exports.paginationSize = exports.defaultProps = void 0;
var defaultProps = {
  '$enable-rounded': true,
  '$enable-hover-media-query': false,
  '$border-radius': '.25rem',
  '$pagination-active-color': '#fff',
  '$pagination-active-bg': '#0275d8',
  '$pagination-active-border': '#0275d8',
  '$pagination-disabled-color': '#636c72',
  '$cursor-disabled': 'not-allowed',
  '$pagination-disabled-bg': '#fff',
  '$pagination-disabled-border': '#ddd',
  '$pagination-padding-y': '.5rem',
  '$pagination-padding-x': '.75rem',
  '$pagination-line-height': '1.25',
  '$pagination-color': '#0275d8',
  '$pagination-bg': '#fff',
  '$pagination-border-width': '1px',
  '$pagination-border-color': '#ddd',
  '$pagination-hover-color': 'hsl(207.79999999999995, 98.2%, 27.8%)',
  '$pagination-hover-bg': '#eceeef',
  '$pagination-hover-border': '#ddd',
  '$pagination-padding-y-lg': '.75rem',
  '$pagination-padding-x-lg': '1.5rem',
  '$font-size-lg': '1.25rem',
  '$line-height-lg': '1.3',
  '$border-radius-lg': '.3rem',
  '$pagination-padding-y-sm': '.25rem',
  '$pagination-padding-x-sm': '.5rem',
  '$font-size-sm': '.875rem',
  '$line-height-sm': '1.5',
  '$border-radius-sm': '.2rem'
};
exports.defaultProps = defaultProps;
var paginationSize = function paginationSize() {
  var enableRounded = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-rounded'];
  var paddingY = arguments.length > 1 ? arguments[1] : undefined;
  var paddingX = arguments.length > 2 ? arguments[2] : undefined;
  var fontSize = arguments.length > 3 ? arguments[3] : undefined;
  var borderRadiusPagination = arguments.length > 4 ? arguments[4] : undefined;
  return "\n  .page-link {\n    padding: ".concat(paddingY, " ").concat(paddingX, ";\n    font-size: ").concat(fontSize, ";\n  }\n\n  .page-item {\n    &:first-child {\n      .page-link {\n        ").concat((0, borderRadius_1.borderLeftRadius)(enableRounded, borderRadiusPagination), "\n      }\n    }\n    &:last-child {\n      .page-link {\n        ").concat((0, borderRadius_1.borderRightRadius)(enableRounded, borderRadiusPagination), "\n      }\n    }\n  }\n");
};
exports.paginationSize = paginationSize;
function pagination() {
  var $enableRounded = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-rounded'];
  var $enableHoverMediaQuery = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$enable-hover-media-query'];
  var $borderRadius = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$border-radius'];
  var $paginationActiveColor = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : defaultProps['$pagination-active-color'];
  var $paginationActiveBg = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : defaultProps['$pagination-active-bg'];
  var $paginationActiveBorder = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : defaultProps['$pagination-active-border'];
  var $paginationDisabledColor = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : defaultProps['$pagination-disabled-color'];
  var $cursorDisabled = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : defaultProps['$cursor-disabled'];
  var $paginationDisabledBg = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : defaultProps['$pagination-disabled-bg'];
  var $paginationDisabledBorder = arguments.length > 9 && arguments[9] !== undefined ? arguments[9] : defaultProps['$pagination-disabled-border'];
  var $paginationPaddingY = arguments.length > 10 && arguments[10] !== undefined ? arguments[10] : defaultProps['$pagination-padding-y'];
  var $paginationPaddingX = arguments.length > 11 && arguments[11] !== undefined ? arguments[11] : defaultProps['$pagination-padding-x'];
  var $paginationLineHeight = arguments.length > 12 && arguments[12] !== undefined ? arguments[12] : defaultProps['$pagination-line-height'];
  var $paginationColor = arguments.length > 13 && arguments[13] !== undefined ? arguments[13] : defaultProps['$pagination-color'];
  var $paginationBg = arguments.length > 14 && arguments[14] !== undefined ? arguments[14] : defaultProps['$pagination-bg'];
  var $paginationBorderWidth = arguments.length > 15 && arguments[15] !== undefined ? arguments[15] : defaultProps['$pagination-border-width'];
  var $paginationBorderColor = arguments.length > 16 && arguments[16] !== undefined ? arguments[16] : defaultProps['$pagination-border-color'];
  var $paginationHoverColor = arguments.length > 17 && arguments[17] !== undefined ? arguments[17] : defaultProps['$pagination-hover-color'];
  var $paginationHoverBg = arguments.length > 18 && arguments[18] !== undefined ? arguments[18] : defaultProps['$pagination-hover-bg'];
  var $paginationHoverBorder = arguments.length > 19 && arguments[19] !== undefined ? arguments[19] : defaultProps['$pagination-hover-border'];
  var $paginationPaddingYLg = arguments.length > 20 && arguments[20] !== undefined ? arguments[20] : defaultProps['$pagination-padding-y-lg'];
  var $paginationPaddingXLg = arguments.length > 21 && arguments[21] !== undefined ? arguments[21] : defaultProps['$pagination-padding-x-lg'];
  var $fontSizeLg = arguments.length > 22 && arguments[22] !== undefined ? arguments[22] : defaultProps['$font-size-lg'];
  var $lineHeightLg = arguments.length > 23 && arguments[23] !== undefined ? arguments[23] : defaultProps['$line-height-lg'];
  var $borderRadiusLg = arguments.length > 24 && arguments[24] !== undefined ? arguments[24] : defaultProps['$border-radius-lg'];
  var $paginationPaddingYSm = arguments.length > 25 && arguments[25] !== undefined ? arguments[25] : defaultProps['$pagination-padding-y-sm'];
  var $paginationPaddingXSm = arguments.length > 26 && arguments[26] !== undefined ? arguments[26] : defaultProps['$pagination-padding-x-sm'];
  var $fontSizeSm = arguments.length > 27 && arguments[27] !== undefined ? arguments[27] : defaultProps['$font-size-sm'];
  var $lineHeightSm = arguments.length > 28 && arguments[28] !== undefined ? arguments[28] : defaultProps['$line-height-sm'];
  var $borderRadiusSm = arguments.length > 29 && arguments[29] !== undefined ? arguments[29] : defaultProps['$border-radius-sm'];
  return "\n  &.pagination {\n    display: flex;\n    padding-left: 0;\n    list-style: none; \n    ".concat((0, borderRadius_1.borderRadius)($enableRounded), "\n  }\n  \n  & .page-item {\n    &:first-child {\n      .page-link {\n        margin-left: 0;\n        ").concat((0, borderRadius_1.borderLeftRadius)($enableRounded, $borderRadius), "\n      }\n    }\n    &:last-child {\n      .page-link {\n      ").concat((0, borderRadius_1.borderRightRadius)($enableRounded, $borderRadius), "\n      }\n    }\n  \n    &.active .page-link {\n      z-index: 2;\n      color: ").concat($paginationActiveColor, ";\n      background-color: ").concat($paginationActiveBg, ";\n      border-color: ").concat($paginationActiveBorder, ";\n    }\n  \n    &.disabled .page-link {\n      color: ").concat($paginationDisabledColor, ";\n      pointer-events: none;\n      cursor: ").concat($cursorDisabled, ";\n      background-color: ").concat($paginationDisabledBg, ";\n      border-color: ").concat($paginationDisabledBorder, ";\n    }\n  }\n  \n  & .page-link {\n    position: relative;\n    display: block;\n    padding: ").concat($paginationPaddingY, " ").concat($paginationPaddingX, ";\n    margin-left: -1px;\n    line-height: ").concat($paginationLineHeight, ";\n    color: ").concat($paginationColor, ";\n    background-color: ").concat($paginationBg, ";\n    border: ").concat($paginationBorderWidth, " solid ").concat($paginationBorderColor, ";\n    \n    ").concat((0, hover_1.hoverFocus)($enableHoverMediaQuery, "\n      color: ".concat($paginationHoverColor, ";\n      text-decoration: none;\n      background-color: ").concat($paginationHoverBg, ";\n      border-color: ").concat($paginationHoverBorder, ";\n    ")), "\n  }\n  \n  /* Sizing */\n  &.pagination-lg {\n  ").concat(paginationSize($enableRounded, $paginationPaddingYLg, $paginationPaddingXLg, $fontSizeLg, $lineHeightLg, $borderRadiusLg), "\n  }\n  \n  &.pagination-sm {\n  ").concat(paginationSize($enableRounded, $paginationPaddingYSm, $paginationPaddingXSm, $fontSizeSm, $lineHeightSm, $borderRadiusSm), "\n  }\n  ");
}
var _default = {
  defaultProps: defaultProps,
  paginationSize: paginationSize,
  pagination: pagination
};
exports.default = _default;
});
unwrapExports(paginations);
var paginations_1 = paginations.pagination;
var paginations_2 = paginations.paginationSize;
var paginations_3 = paginations.defaultProps;

var defaultProps$T = {
  tag: 'ul',
  theme: {
    '$enable-rounded': true,
    '$enable-hover-media-query': false,
    '$pagination-padding-x': '.75rem',
    '$pagination-padding-y': '.5rem',
    '$pagination-padding-x-sm': '.5rem',
    '$pagination-padding-y-sm': '.25rem',
    '$pagination-padding-x-lg': '1.5rem',
    '$pagination-padding-y-lg': '.75rem',
    '$pagination-line-height': '1.25',
    '$pagination-color': '#0275d8',
    '$pagination-bg': '#fff',
    '$pagination-border-width': '1px',
    '$pagination-border-color': '#ddd',
    '$pagination-hover-color': 'hsl(207.79999999999995, 98.2%, 27.8%)',
    '$pagination-hover-bg': '#eceeef',
    '$pagination-hover-border': '#ddd',
    '$pagination-active-color': '#fff',
    '$pagination-active-bg': '#0275d8',
    '$pagination-active-border': '#0275d8',
    '$pagination-disabled-color': '#636c72',
    '$pagination-disabled-bg': '#fff',
    '$pagination-disabled-border': '#ddd'
  }
};
var propTypes$V = {
  className: propTypes.string,
  children: propTypes.node,
  size: propTypes.oneOf(['sm', 'lg']),
  tag: propTypes.any,
  theme: propTypes.shape({
    '$enable-rounded': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool,
    '$pagination-padding-x': propTypes.string,
    '$pagination-padding-y': propTypes.string,
    '$pagination-padding-x-sm': propTypes.string,
    '$pagination-padding-y-sm': propTypes.string,
    '$pagination-padding-x-lg': propTypes.string,
    '$pagination-padding-y-lg': propTypes.string,
    '$pagination-line-height': propTypes.string,
    '$pagination-color': propTypes.string,
    '$pagination-bg': propTypes.string,
    '$pagination-border-width': propTypes.string,
    '$pagination-border-color': propTypes.string,
    '$pagination-hover-color': propTypes.string,
    '$pagination-hover-bg': propTypes.string,
    '$pagination-hover-border': propTypes.string,
    '$pagination-active-color': propTypes.string,
    '$pagination-active-bg': propTypes.string,
    '$pagination-active-border': propTypes.string,
    '$pagination-disabled-color': propTypes.string,
    '$pagination-disabled-bg': propTypes.string,
    '$pagination-disabled-border': propTypes.string
  }),
  color: propTypes.oneOf(['white', 'muted', 'gray-dark', 'primary', 'success', 'info', 'warning', 'danger']),
  cssModule: propTypes.object
};
var PaginationUnstyled =
function (_React$Component) {
  _inherits(PaginationUnstyled, _React$Component);
  function PaginationUnstyled() {
    _classCallCheck(this, PaginationUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(PaginationUnstyled).apply(this, arguments));
  }
  _createClass(PaginationUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          Tag = _omit.tag,
          size = _omit.size,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "tag", "size"]);
      var classes = mapToCssModules(classnames(className, 'pagination', _defineProperty({}, "pagination-".concat(size), !!size)), cssModule);
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
    }
  }]);
  return PaginationUnstyled;
}(React.Component);
_defineProperty(PaginationUnstyled, "propTypes", propTypes$V);
_defineProperty(PaginationUnstyled, "defaultProps", defaultProps$T);
var Pagination = styled(PaginationUnstyled).withConfig({
  displayName: "Pagination",
  componentId: "sc-1ova3d6-0"
})(["", ""], function (props) {
  return "\n    ".concat(paginations_1(props.theme['$enable-rounded'], props.theme['$enable-hover-media-query'], props.theme['$border-radius'], props.theme['$pagination-active-color'], props.theme['$pagination-active-bg'], props.theme['$pagination-active-border'], props.theme['$pagination-disabled-color'], props.theme['$cursor-disabled'], props.theme['$pagination-disabled-bg'], props.theme['$pagination-disabled-border'], props.theme['$pagination-padding-y'], props.theme['$pagination-padding-x'], props.theme['$pagination-line-height'], props.theme['$pagination-color'], props.theme['$pagination-bg'], props.theme['$pagination-border-width'], props.theme['$pagination-border-color'], props.theme['$pagination-hover-color'], props.theme['$pagination-hover-bg'], props.theme['$pagination-hover-border'], props.theme['$pagination-padding-y-lg'], props.theme['$pagination-padding-x-lg'], props.theme['$font-size-lg'], props.theme['$line-height-lg'], props.theme['$border-radius-lg'], props.theme['$pagination-padding-y-sm'], props.theme['$pagination-padding-x-sm'], props.theme['$font-size-sm'], props.theme['$line-height-sm'], props.theme['$border-radius-sm']), "\n  ");
});
Pagination.defaultProps = defaultProps$T;
Pagination.propTypes = propTypes$V;

var PaginationItem =
function (_React$Component) {
  _inherits(PaginationItem, _React$Component);
  function PaginationItem() {
    _classCallCheck(this, PaginationItem);
    return _possibleConstructorReturn(this, _getPrototypeOf(PaginationItem).apply(this, arguments));
  }
  _createClass(PaginationItem, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          active = _this$props.active,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          disabled = _this$props.disabled,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["active", "className", "cssModule", "disabled", "tag"]);
      var classes = mapToCssModules(classnames(className, 'page-item', {
        active: active,
        disabled: disabled
      }), cssModule);
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
    }
  }]);
  return PaginationItem;
}(React.Component);
_defineProperty(PaginationItem, "propTypes", {
  active: propTypes.bool,
  className: propTypes.string,
  children: propTypes.node,
  cssModule: propTypes.object,
  disabled: propTypes.bool,
  tag: propTypes.any
});
_defineProperty(PaginationItem, "defaultProps", {
  tag: 'li'
});

var PaginationLink =
function (_React$Component) {
  _inherits(PaginationLink, _React$Component);
  function PaginationLink() {
    _classCallCheck(this, PaginationLink);
    return _possibleConstructorReturn(this, _getPrototypeOf(PaginationLink).apply(this, arguments));
  }
  _createClass(PaginationLink, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          next = _this$props.next,
          previous = _this$props.previous,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "next", "previous", "tag"]);
      var classes = mapToCssModules(classnames(className, 'page-link'), cssModule);
      var defaultAriaLabel;
      if (previous) {
        defaultAriaLabel = 'Previous';
      } else if (next) {
        defaultAriaLabel = 'Next';
      }
      var ariaLabel = this.props['aria-label'] || defaultAriaLabel;
      var defaultCaret;
      if (previous) {
        defaultCaret = "\xAB";
      } else if (next) {
        defaultCaret = "\xBB";
      }
      var children = this.props.children;
      if (previous || next) {
        children = [React.createElement("span", {
          "aria-hidden": "true",
          key: "caret"
        }, children || defaultCaret), React.createElement("span", {
          className: "sr-only",
          key: "sr"
        }, ariaLabel)];
      }
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes,
        "aria-label": ariaLabel
      }), children);
    }
  }]);
  return PaginationLink;
}(React.Component);
_defineProperty(PaginationLink, "propTypes", {
  'aria-label': propTypes.string,
  className: propTypes.string,
  children: propTypes.node,
  cssModule: propTypes.object,
  next: propTypes.bool,
  previous: propTypes.bool,
  tag: propTypes.any
});
_defineProperty(PaginationLink, "defaultProps", {
  tag: A
});

var defaultProps$U = {
  theme: {
    '$code-font-size': '90%',
    '$pre-color': '#292b2c',
    '$pre-scrollable-max-height': '340px',
    '$font-family-monospace': 'Menlo, Monaco, Consolas, "Liberation Mono", "Courier New", monospace'
  }
};
var propTypes$W = {
  theme: propTypes.shape({
    '$code-font-size': propTypes.string,
    '$pre-color': propTypes.string,
    '$pre-scrollable-max-height': propTypes.string,
    '$font-family-monospace': propTypes.string
  })
};
var Pre = styled.pre.withConfig({
  displayName: "Pre",
  componentId: "sc-1o4cukg-0"
})(["", ""], function (props) {
  return "\n    /* Blocks of code */\n    display: block;\n    margin-top: 0;\n    margin-bottom: 1rem;\n    font-size: ".concat(props.theme['$code-font-size'], ";\n    color: ").concat(props.theme['$pre-color'], ";\n    \n    /* Enable scrollable blocks of code */\n    /* AJT This class was present in bootstrap/scss/code.scss  We must decide if this class should be a mixin or not! */\n    &.pre-scrollable {\n      max-height: ").concat(props.theme['$pre-scrollable-max-height'], ";\n      overflow-y: scroll;\n    }\n\n  \n    /* Account for some code outputs that place code tags in pre tags */\n    code {\n      padding: 0;\n      font-size: inherit;\n      color: inherit;\n      background-color: transparent;\n      border-radius: 0;\n    }\n    \n    /* Reboot Scss */\n\n    /* Remove browser default top margin */\n    margin-top: 0;\n    /* Reset browser default of '1em' to use 'rem's */\n    margin-bottom: 1rem;\n    /* Normalize v4 removed this property, causing 'pre' content to break out of wrapping code snippets */\n    overflow: auto;\n    \n    /* Bootstrap 4 does not place this css rule straight into Kbd tag see: bootstrap/scss/code.scss */\n    font-family: ").concat(props.theme['$font-family-monospace'], ";\n  ");
});
Pre.defaultProps = defaultProps$U;
Pre.propTypes = propTypes$W;

var backgroundVariant = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.bgVariant = bgVariant;
exports.default = exports.defaultProps = void 0;
var _color = _interopRequireDefault(ColorWrapper);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var defaultProps = {
  '$enable-hover-media-query': false
};
exports.defaultProps = defaultProps;
function bgVariant() {
  var enableHoverMediaQuery = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-hover-media-query'];
  var selector = arguments.length > 1 ? arguments[1] : undefined;
  var bgColor = arguments.length > 2 ? arguments[2] : undefined;
  return "\n    ".concat(selector, " {\n      background-color: ").concat(bgColor, " !important;\n    }\n    a").concat(selector, " {\n      ").concat((0, hover_1.hoverFocus)(enableHoverMediaQuery, "background-color: ".concat((0, _color.default)(bgColor).darken(0.2).rgb(), " !important;")), "\n    }\n  ");
}
var _default = {
  bgVariant: bgVariant
};
exports.default = _default;
});
unwrapExports(backgroundVariant);
var backgroundVariant_1 = backgroundVariant.bgVariant;
var backgroundVariant_2 = backgroundVariant.defaultProps;

var background = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getBackgroundUtilities = getBackgroundUtilities;
exports.default = exports.bgFaded = exports.bgInverse = exports.bgDanger = exports.bgWarning = exports.bgInfo = exports.bgSuccess = exports.bgPrimary = exports.defaultProps = void 0;
var defaultProps = {
  '$enable-hover-media-query': false,
  '$brand-primary': '#0275d8',
  '$brand-success': '#5cb85c',
  '$brand-info': '#5bc0de',
  '$brand-warning': '#f0ad4e',
  '$brand-danger': '#d9543f',
  '$brand-inverse': '#373a3c',
  '$gray-lightest': '#f7f7f9'
};
exports.defaultProps = defaultProps;
function getBackgroundUtilities() {
  var $enableHoverMediaQuery = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-hover-media-query'];
  var $brandPrimary = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$brand-primary'];
  var $brandSuccess = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$brand-success'];
  var $brandInfo = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : defaultProps['$brand-info'];
  var $brandWarning = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : defaultProps['$brand-warning'];
  var $brandDanger = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : defaultProps['$brand-danger'];
  var $brandInverse = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : defaultProps['$brand-inverse'];
  var $grayLightest = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : defaultProps['$gray-lightest'];
  return "\n    ".concat((0, backgroundVariant.bgVariant)($enableHoverMediaQuery, '.bg-primary', $brandPrimary), "\n    ").concat((0, backgroundVariant.bgVariant)($enableHoverMediaQuery, '.bg-success', $brandSuccess), "\n    ").concat((0, backgroundVariant.bgVariant)($enableHoverMediaQuery, '.bg-info', $brandInfo), "\n    ").concat((0, backgroundVariant.bgVariant)($enableHoverMediaQuery, '.bg-warning', $brandWarning), "\n    ").concat((0, backgroundVariant.bgVariant)($enableHoverMediaQuery, '.bg-danger', $brandDanger), "\n    ").concat((0, backgroundVariant.bgVariant)($enableHoverMediaQuery, '.bg-inverse', $brandInverse), "\n    ").concat((0, backgroundVariant.bgVariant)($enableHoverMediaQuery, '.bg-faded', $grayLightest), "\n  ");
}
var bgPrimary = function bgPrimary($enableHoverMediaQuery) {
  var bgColor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$brand-primary'];
  return (0, backgroundVariant.bgVariant)($enableHoverMediaQuery, '.bg-primary', bgColor);
};
exports.bgPrimary = bgPrimary;
var bgSuccess = function bgSuccess($enableHoverMediaQuery) {
  var bgColor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$brand-success'];
  return (0, backgroundVariant.bgVariant)($enableHoverMediaQuery, '.bg-success', bgColor);
};
exports.bgSuccess = bgSuccess;
var bgInfo = function bgInfo($enableHoverMediaQuery) {
  var bgColor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$brand-info'];
  return (0, backgroundVariant.bgVariant)($enableHoverMediaQuery, '.bg-info', bgColor);
};
exports.bgInfo = bgInfo;
var bgWarning = function bgWarning($enableHoverMediaQuery) {
  var bgColor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$brand-warning'];
  return (0, backgroundVariant.bgVariant)($enableHoverMediaQuery, '.bg-warning', bgColor);
};
exports.bgWarning = bgWarning;
var bgDanger = function bgDanger($enableHoverMediaQuery) {
  var bgColor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$brand-danger'];
  return (0, backgroundVariant.bgVariant)($enableHoverMediaQuery, '.bg-danger', bgColor);
};
exports.bgDanger = bgDanger;
var bgInverse = function bgInverse($enableHoverMediaQuery) {
  var bgColor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$brand-inverse'];
  return (0, backgroundVariant.bgVariant)($enableHoverMediaQuery, '.bg-inverse', bgColor);
};
exports.bgInverse = bgInverse;
var bgFaded = function bgFaded($enableHoverMediaQuery) {
  var bgColor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$gray-lightest'];
  return (0, backgroundVariant.bgVariant)($enableHoverMediaQuery, '.bg-faded', bgColor);
};
exports.bgFaded = bgFaded;
var _default = {
  defaultProps: defaultProps,
  getBackgroundUtilities: getBackgroundUtilities,
  bgFaded: bgFaded,
  bgPrimary: bgPrimary,
  bgSuccess: bgSuccess,
  bgInfo: bgInfo,
  bgWarning: bgWarning,
  bgDanger: bgDanger,
  bgInverse: bgInverse
};
exports.default = _default;
});
unwrapExports(background);
var background_1 = background.getBackgroundUtilities;
var background_2 = background.bgFaded;
var background_3 = background.bgInverse;
var background_4 = background.bgDanger;
var background_5 = background.bgWarning;
var background_6 = background.bgInfo;
var background_7 = background.bgSuccess;
var background_8 = background.bgPrimary;
var background_9 = background.defaultProps;

var gradients = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.gradientX = gradientX;
exports.gradientY = gradientY;
exports.gradientDirectional = gradientDirectional;
exports.gradientXThreeColors = gradientXThreeColors;
exports.gradientYThreeColors = gradientYThreeColors;
exports.gradientRadial = gradientRadial;
exports.gradientStriped = gradientStriped;
exports.default = void 0;
function gradientX() {
  var startColor = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '#555';
  var endColor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '#333';
  var startPercent = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '0%';
  var endPercent = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : '100%';
  return "\n    background-image: linear-gradient(to right, ".concat(startColor, " ").concat(startPercent, ", ").concat(endColor, " ").concat(endPercent, ");\n    background-repeat: repeat-x;\n    filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#{ie-hex-str(").concat(startColor, ")}', endColorstr='#{ie-hex-str(").concat(endColor, ")}', GradientType=1); // IE9\n  ");
}
function gradientY() {
  var startColor = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '#555';
  var endColor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '#333';
  var startPercent = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '0%';
  var endPercent = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : '100%';
  return "\n    background-image: linear-gradient(to bottom, ".concat(startColor, " ").concat(startPercent, ", ").concat(endColor, " ").concat(endPercent, ");\n    background-repeat: repeat-x;\n    filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#{ie-hex-str(").concat(startColor, ")}', endColorstr='#{ie-hex-str(").concat(endColor, ")}', GradientType=0); // IE9\n  ");
}
function gradientDirectional() {
  var startColor = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '#555';
  var endColor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '#333';
  var deg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '45deg';
  return "\n    background-repeat: repeat-x;\n    background-image: linear-gradient(".concat(deg, ", ").concat(startColor, ", ").concat(endColor, ");\n  ");
}
function gradientXThreeColors() {
  var startColor = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '#00b3ee';
  var midColor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '#7a43b6';
  var colorStop = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '50%';
  var endColor = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : '#c3325f';
  return "\n    background-image: linear-gradient(to right, ".concat(startColor, ", ").concat(midColor, " ").concat(colorStop, ", ").concat(endColor, ");\n    background-repeat: no-repeat;\n    filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#{ie-hex-str(").concat(startColor, ")}', endColorstr='#{ie-hex-str(").concat(endColor, ")}', GradientType=1); // IE9 gets no color-stop at all for proper fallback\n  ");
}
function gradientYThreeColors() {
  var startColor = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '#00b3ee';
  var midColor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '#7a43b6';
  var colorStop = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '50%';
  var endColor = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : '#c3325f';
  return "\n    background-image: linear-gradient(".concat(startColor, ", ").concat(midColor, " ").concat(colorStop, ", ").concat(endColor, ");\n    background-repeat: no-repeat;\n    filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#{ie-hex-str(").concat(startColor, ")}', endColorstr='#{ie-hex-str(").concat(endColor, ")}', GradientType=0); // IE9 gets no color-stop at all for proper fallback\n  ");
}
function gradientRadial() {
  var innerColor = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '#555';
  var outerColor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '#333';
  return "\n    background-image: radial-gradient(circle, ".concat(innerColor, ", ").concat(outerColor, ");\n    background-repeat: no-repeat;\n  ");
}
function gradientStriped() {
  var color = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'rgba(255,255,255,.15)';
  var angle = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '45deg';
  return "\n    background-image: linear-gradient(".concat(angle, ", ").concat(color, " 25%, transparent 25%, transparent 50%, ").concat(color, " 50%, ").concat(color, " 75%, transparent 75%, transparent);\n  ");
}
var _default = {
  x: gradientX,
  y: gradientY,
  directional: gradientDirectional,
  xThreeColors: gradientXThreeColors,
  yThreeColors: gradientYThreeColors,
  radial: gradientRadial,
  striped: gradientStriped
};
exports.default = _default;
});
unwrapExports(gradients);
var gradients_1 = gradients.gradientX;
var gradients_2 = gradients.gradientY;
var gradients_3 = gradients.gradientDirectional;
var gradients_4 = gradients.gradientXThreeColors;
var gradients_5 = gradients.gradientYThreeColors;
var gradients_6 = gradients.gradientRadial;
var gradients_7 = gradients.gradientStriped;

var defaultProps$V = {
  theme: {
    '$enable-rounded': true,
    '$enable-hover-media-query': false,
    '$progress-height': '1rem',
    '$progress-font-size': '.75rem',
    '$progress-bg': '#eceeef',
    '$progress-border-radius': '.25rem',
    '$progress-box-shadow': 'inset 0 .1rem .1rem rgba(0, 0, 0, 0.1)',
    '$progress-bar-color': '#fff',
    '$progress-bar-bg': '#0275d8',
    '$progress-bar-animation-timing': '1s linear infinite'
  }
};
var propTypes$X = {
  className: propTypes.string,
  children: propTypes.node,
  theme: propTypes.shape({
    '$enable-rounded': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool,
    '$progress-height': propTypes.string,
    '$progress-font-size': propTypes.string,
    '$progress-bg': propTypes.string,
    '$progress-border-radius': propTypes.string,
    '$progress-box-shadow': propTypes.string,
    '$progress-bar-color': propTypes.string,
    '$progress-bar-bg': propTypes.string,
    '$progress-bar-animation-timing': propTypes.string
  })
};
var ProgressUnstyled =
function (_React$Component) {
  _inherits(ProgressUnstyled, _React$Component);
  function ProgressUnstyled() {
    _classCallCheck(this, ProgressUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(ProgressUnstyled).apply(this, arguments));
  }
  _createClass(ProgressUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          children = _omit.children,
          className = _omit.className,
          rest = _objectWithoutProperties(_omit, ["children", "className"]);
      return React.createElement("div", _extends({
        className: classnames('progress', className)
      }, rest), children);
    }
  }]);
  return ProgressUnstyled;
}(React.Component);
_defineProperty(ProgressUnstyled, "propTypes", propTypes$X);
_defineProperty(ProgressUnstyled, "defaultProps", defaultProps$V);
var backgroundPositionKeyFrame = function backgroundPositionKeyFrame(props) {
  return keyframes(["from{background-position:", " 0;}to{background-position:0 0;}"], props.theme['$progress-height']);
};
var animationRule = function animationRule(props) {
  return css(["", " ", ""], backgroundPositionKeyFrame(props), props.theme['$progress-bar-animation-timing']);
};
var Progress = styled(ProgressUnstyled).withConfig({
  displayName: "Progress",
  componentId: "l5upsd-0"
})(["", ""], function (props) {
  return "\n    \n    &.progress {\n      display: flex;\n      overflow: hidden; // force rounded corners by cropping it\n      font-size: ".concat(props.theme['$progress-font-size'], ";\n      line-height: ").concat(props.theme['$progress-height'], ";\n      text-align: center;\n      background-color: ").concat(props.theme['$progress-bg'], ";\n      ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$progress-border-radius']), "\n      ").concat(background_1(props.theme['$enable-hover-media-query'], props.theme['$brand-primary'], props.theme['$brand-success'], props.theme['$brand-info'], props.theme['$brand-warning'], props.theme['$brand-danger'], props.theme['$brand-inverse'], props.theme['$gray-lightest']), "\n    }\n    \n    .progress-bar {\n      height: ").concat(props.theme['$progress-height'], ";\n      line-height: ").concat(props.theme['$progress-height'], ";\n      color: ").concat(props.theme['$progress-bar-color'], ";\n      background-color: ").concat(props.theme['$progress-bar-bg'], ";\n    }\n    \n    .progress-bar-striped {\n      ").concat(gradients_7(), "\n      background-size: ").concat(props.theme['$progress-height'], " ").concat(props.theme['$progress-height'], ";\n      background-repeat: repeat; /* Not present in bootstrap original but required to repeat the background */\n    }\n    \n    .progress-bar-animated {\n      animation: ").concat(animationRule, ";\n    }\n\n  ");
});
Progress.defaultProps = defaultProps$V;
Progress.propTypes = propTypes$X;

var classCallCheck$1 = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};
var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }
  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();
var RangeUtils = function () {
  function RangeUtils() {
    classCallCheck$1(this, RangeUtils);
  }
  createClass(RangeUtils, [{
    key: "mapBetween",
    value: function mapBetween(valueNow, valueMin, valueMax) {
      var rangeMin = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
      var rangeMax = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 100;
      return (rangeMax - rangeMin) * (valueNow - valueMin) / (valueMax - valueMin) + rangeMin;
    }
  }]);
  return RangeUtils;
}();
var index = new RangeUtils();

var defaultProps$W = {
  valueMin: 0,
  valueMax: 100,
  valueNow: 0,
  striped: false,
  animated: false
};
var propTypes$Y = {
  className: propTypes.string,
  children: propTypes.node,
  valueMin: propTypes.number,
  valueNow: propTypes.number,
  valueMax: propTypes.number,
  height: propTypes.string,
  striped: propTypes.bool,
  animated: propTypes.bool,
  color: propTypes.oneOf(['success', 'info', 'warning', 'danger', '']),
  cssModule: propTypes.object
};
var ProgressBar =
function (_React$Component) {
  _inherits(ProgressBar, _React$Component);
  function ProgressBar() {
    _classCallCheck(this, ProgressBar);
    return _possibleConstructorReturn(this, _getPrototypeOf(ProgressBar).apply(this, arguments));
  }
  _createClass(ProgressBar, [{
    key: "getWidth",
    value: function getWidth(valueNow, valueMin, valueMax) {
      return "".concat(index.mapBetween(valueNow, valueMin, valueMax), "%");
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          color = _this$props.color,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          valueNow = _this$props.valueNow,
          valueMin = _this$props.valueMin,
          valueMax = _this$props.valueMax,
          height = _this$props.height,
          striped = _this$props.striped,
          animated = _this$props.animated,
          rest = _objectWithoutProperties(_this$props, ["children", "color", "className", "cssModule", "valueNow", "valueMin", "valueMax", "height", "striped", "animated"]);
      var progressBarClasses = mapToCssModules(classnames(className, 'progress-bar', animated ? 'progress-bar-animated' : null, color ? "bg-".concat(color) : null, striped || animated ? 'progress-bar-striped' : null), cssModule);
      return React.createElement("div", _extends({
        className: progressBarClasses,
        style: Object.assign({
          width: this.getWidth(valueNow, valueMin, valueMax)
        }, {
          height: height
        })
      }, rest), children);
    }
  }]);
  return ProgressBar;
}(React.Component);
_defineProperty(ProgressBar, "propTypes", propTypes$Y);
_defineProperty(ProgressBar, "defaultProps", defaultProps$W);
ProgressBar.defaultProps = defaultProps$W;
ProgressBar.propTypes = propTypes$Y;

var defaultProps$X = {
  tag: 'div',
  theme: {
    '$grid-gutter-width': '30px',
    '$enable-grid-classes': true
  }
};
var propTypes$Z = {
  className: propTypes.string,
  tag: propTypes.any,
  noGutters: propTypes.bool,
  theme: propTypes.shape({
    '$grid-gutter-width': propTypes.string,
    '$enable-grid-classes': propTypes.bool
  }),
  cssModule: propTypes.object
};
var RowUnstyled =
function (_React$Component) {
  _inherits(RowUnstyled, _React$Component);
  function RowUnstyled() {
    _classCallCheck(this, RowUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(RowUnstyled).apply(this, arguments));
  }
  _createClass(RowUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          noGutters = _omit.noGutters,
          Tag = _omit.tag,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "noGutters", "tag"]);
      var classes = mapToCssModules(classnames(className, noGutters ? 'no-gutters' : null, 'row'), cssModule);
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
    }
  }]);
  return RowUnstyled;
}(React.Component);
_defineProperty(RowUnstyled, "propTypes", propTypes$Z);
_defineProperty(RowUnstyled, "defaultProps", defaultProps$X);
var Row = styled(RowUnstyled).withConfig({
  displayName: "Row",
  componentId: "sc-2hg243-0"
})(["", ""], function (props) {
  return "\n    &.row {\n      ".concat(grid_3(props.theme['$enable-grid-classes'], props.theme['$grid-gutter-width']), "\n\n      // Remove the negative margin from default .row, then the horizontal padding\n      // from all immediate children columns (to prevent runaway style inheritance).\n\n      &.no-gutters {\n        margin-right: 0;\n        margin-left: 0;\n\n        > .col,\n        > [class*=\"col-\"] {\n          padding-right: 0;\n          padding-left: 0;\n        }\n      }\n      \n      // Fix when not used with a BootstrapProvider, globals are missing (See #74)\n      & *, & ::after, & ::before {\n        box-sizing: border-box;\n      }\n    }\n ");
});
Row.defaultProps = defaultProps$X;
Row.propTypes = propTypes$Z;

var Samp = styled.samp.withConfig({
  displayName: "Samp",
  componentId: "i164o-0"
})(["font-family:monospace;font-size:1em;"]);

var Section = function Section(props) {
  return React.createElement("section", props);
};

var propTypes$_ = {
  className: propTypes.string,
  children: propTypes.node
};
var SelectUnstyled =
function (_React$Component) {
  _inherits(SelectUnstyled, _React$Component);
  function SelectUnstyled() {
    var _getPrototypeOf2;
    var _this;
    _classCallCheck(this, SelectUnstyled);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(SelectUnstyled)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _defineProperty(_assertThisInitialized(_this), "state", {
      className: null
    });
    return _this;
  }
  _createClass(SelectUnstyled, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var nua = navigator.userAgent;
      var isAndroid = nua.indexOf('Mozilla/5.0') > -1 && nua.indexOf('Android ') > -1 && nua.indexOf('AppleWebKit') > -1 && nua.indexOf('Chrome') === -1;
      if (isAndroid) {
        this.setState({
          className: this.props.className.replace(/\bform-control\b/, '')
        });
      } else {
        this.setState({
          className: this.props.className
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['className']),
          children = _omit.children,
          rest = _objectWithoutProperties(_omit, ["children"]);
      return React.createElement("select", _extends({
        className: classnames(this.state.className, 'select')
      }, rest), children);
    }
  }]);
  return SelectUnstyled;
}(React.Component);
_defineProperty(SelectUnstyled, "propTypes", propTypes$_);
var Select = styled(SelectUnstyled).withConfig({
  displayName: "Select",
  componentId: "sc-1xhll55-0"
})(["&.select{touch-action:manipulation;line-height:inherit;}&:disabled{color:graytext;}"]);
Select.propTypes = propTypes$_;

var defaultProps$Y = {
  theme: {
    '$small-font-size': '80%'
  }
};
var propTypes$$ = {
  className: propTypes.string,
  tag: propTypes.any,
  children: propTypes.node,
  theme: propTypes.shape({
    '$small-font-size': propTypes.string
  }),
  color: propTypes.oneOf(['white', 'muted', 'gray-dark', 'primary', 'success', 'info', 'warning', 'danger']),
  cssModule: propTypes.object
};
var SmallUnstyled =
function (_React$Component) {
  _inherits(SmallUnstyled, _React$Component);
  function SmallUnstyled() {
    _classCallCheck(this, SmallUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(SmallUnstyled).apply(this, arguments));
  }
  _createClass(SmallUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          color = _omit.color,
          children = _omit.children,
          cssModule = _omit.cssModule,
          attributes = _objectWithoutProperties(_omit, ["className", "color", "children", "cssModule"]);
      var classes = mapToCssModules(classnames(className, color ? "text-".concat(color) : false), cssModule);
      return React.createElement("small", _extends({
        className: classes
      }, attributes), children);
    }
  }]);
  return SmallUnstyled;
}(React.Component);
_defineProperty(SmallUnstyled, "propTypes", propTypes$$);
_defineProperty(SmallUnstyled, "defaultProps", defaultProps$Y);
var Small = styled(SmallUnstyled).withConfig({
  displayName: "Small",
  componentId: "jvnv75-0"
})(["", ""], function (props) {
  return "\n    /* Reboot Scss */\n    font-size: ".concat(props.theme['$small-font-size'], ";\n    font-weight: normal;\n  ");
});
Small.defaultProps = defaultProps$Y;
Small.propTypes = propTypes$$;

var propTypes$10 = {
  className: propTypes.string,
  children: propTypes.node,
  color: propTypes.oneOf(['white', 'muted', 'gray-dark', 'primary', 'success', 'info', 'warning', 'danger']),
  cssModule: propTypes.object
};
var StrongUnstyled =
function (_React$Component) {
  _inherits(StrongUnstyled, _React$Component);
  function StrongUnstyled() {
    _classCallCheck(this, StrongUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(StrongUnstyled).apply(this, arguments));
  }
  _createClass(StrongUnstyled, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          color = _this$props.color,
          children = _this$props.children,
          cssModule = _this$props.cssModule,
          attributes = _objectWithoutProperties(_this$props, ["className", "color", "children", "cssModule"]);
      var classes = mapToCssModules(classnames(className, color ? "text-".concat(color) : false), cssModule);
      return React.createElement("strong", _extends({
        className: classes
      }, attributes), children);
    }
  }]);
  return StrongUnstyled;
}(React.Component);
_defineProperty(StrongUnstyled, "propTypes", propTypes$10);
var Strong = styled(StrongUnstyled).withConfig({
  displayName: "Strong",
  componentId: "sc-1dhextn-0"
})(["font-weight:bolder;"]);
Strong.propTypes = propTypes$10;

var Summary = styled.summary.withConfig({
  displayName: "Summary",
  componentId: "adf82i-0"
})(["touch-action:manipulation;"]);

var Sub = styled.sub.withConfig({
  displayName: "Sub",
  componentId: "qpjrdn-0"
})(["position:relative;font-size:75%;line-height:0;vertical-align:baseline;bottom:-.25em;"]);

var Sup = styled.sup.withConfig({
  displayName: "Sup",
  componentId: "n597fy-0"
})(["position:relative;font-size:75%;line-height:0;vertical-align:baseline;top:-.5em;"]);

var tableRow = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tableRowVariant = tableRowVariant;
exports.default = void 0;
var _color = _interopRequireDefault(ColorWrapper);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function tableRowVariant(state, background) {
  var hoverBackground = (0, _color.default)(background).darken(0.05).toString();
  return "\n  /* Exact selectors below required to override '.table-striped' and prevent */\n  /* inheritance to nested tables. */\n  & .table-".concat(state, " {\n    &,\n    > th,\n    > td {\n      background-color: ").concat(background, ";\n    }\n  }\n\n  /* Hover states for '.table-hover' */\n  /* Note: this is not available for cells or rows within 'thead' or 'tfoot'. */\n  &.table-hover {\n\n    .table-").concat(state, " {\n      ").concat((0, hover_1.hover)("\n        background-color: ".concat(hoverBackground, ";\n\n        > td,\n        > th {\n          background-color: ").concat(hoverBackground, ";\n        }\n      ")), "\n    }\n  }\n  ");
}
var _default = {
  tableRowVariant: tableRowVariant
};
exports.default = _default;
});
unwrapExports(tableRow);
var tableRow_1 = tableRow.tableRowVariant;

var defaultProps$Z = {
  tag: 'table',
  responsiveTag: 'div',
  theme: {
    '$body-bg': '#fff',
    '$table-cell-padding': '.75rem',
    '$table-sm-cell-padding': '.3rem',
    '$table-bg': 'transparent',
    '$table-inverse-bg': '#292b2c',
    '$table-inverse-bg-accent': 'rgba(255, 255, 255, 0.05)',
    '$table-inverse-bg-hover': 'rgba(0, 0, 0, 0.075)',
    '$table-inverse-color': '#fff',
    '$table-inverse-border': 'hsl(200, 3.5%, 17.9%)',
    '$table-bg-accent': 'rgba(0, 0, 0, 0.05)',
    '$table-bg-hover': 'rgba(0, 0, 0, 0.075)',
    '$table-bg-active': 'rgba(0, 0, 0, 0.075)',
    '$table-head-bg': '#eceeef',
    '$table-head-color': '#464a4c',
    '$table-border-width': '1px',
    '$table-border-color': '#eceeef',
    '$state-success-bg': '#dff0d8',
    '$state-info-bg': '#d9edf7',
    '$state-warning-bg': '#fcf8e3',
    '$state-danger-bg': '#f2dede'
  }
};
var propTypes$11 = {
  className: propTypes.string,
  tag: propTypes.any,
  size: propTypes.string,
  bordered: propTypes.bool,
  striped: propTypes.bool,
  inverse: propTypes.bool,
  hover: propTypes.bool,
  reflow: propTypes.bool,
  responsive: propTypes.bool,
  responsiveTag: propTypes.any,
  theme: propTypes.shape({
    '$body-bg': propTypes.string,
    '$table-cell-padding': propTypes.string,
    '$table-sm-cell-padding': propTypes.string,
    '$table-bg': propTypes.string,
    '$table-inverse-bg': propTypes.string,
    '$table-inverse-bg-accent': propTypes.string,
    '$table-inverse-bg-hover': propTypes.string,
    '$table-inverse-color': propTypes.string,
    '$table-inverse-border': propTypes.string,
    '$table-bg-accent': propTypes.string,
    '$table-bg-hover': propTypes.string,
    '$table-bg-active': propTypes.string,
    '$table-head-bg': propTypes.string,
    '$table-head-color': propTypes.string,
    '$table-border-width': propTypes.string,
    '$table-border-color': propTypes.string,
    '$state-success-bg': propTypes.string,
    '$state-info-bg': propTypes.string,
    '$state-warning-bg': propTypes.string,
    '$state-danger-bg': propTypes.string
  }),
  cssModule: propTypes.object
};
var TableUnstyled =
function (_React$Component) {
  _inherits(TableUnstyled, _React$Component);
  function TableUnstyled() {
    _classCallCheck(this, TableUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(TableUnstyled).apply(this, arguments));
  }
  _createClass(TableUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          size = _omit.size,
          bordered = _omit.bordered,
          striped = _omit.striped,
          inverse = _omit.inverse,
          hover = _omit.hover,
          reflow = _omit.reflow,
          responsive = _omit.responsive,
          Tag = _omit.tag,
          ResponsiveTag = _omit.responsiveTag,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "size", "bordered", "striped", "inverse", "hover", "reflow", "responsive", "tag", "responsiveTag"]);
      var classes = mapToCssModules(classnames(className, 'table', size ? 'table-' + size : false,
      bordered ? 'table-bordered' : false, striped ? 'table-striped' : false, inverse ? 'table-inverse' : false, hover ? 'table-hover' : false, reflow ? 'table-reflow' : false), cssModule);
      var table = React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
      if (responsive) {
        return React.createElement(ResponsiveTag, {
          className: "table-responsive"
        }, table);
      }
      return table;
    }
  }]);
  return TableUnstyled;
}(React.Component);
_defineProperty(TableUnstyled, "propTypes", propTypes$11);
_defineProperty(TableUnstyled, "defaultProps", defaultProps$Z);
var Table = styled(TableUnstyled).withConfig({
  displayName: "Table",
  componentId: "oyilxr-0"
})(["", ""], function (props) {
  return "\n    /*\n     Basic Bootstrap table\n    */\n    &.table {\n      width: 100%;\n      max-width: 100%;\n      margin-bottom: ".concat(props.theme['$spacer'], ";\n      background-color: ").concat(props.theme['$table-bg'], ";\n\n      th,\n      td {\n        padding: ").concat(props.theme['$table-cell-padding'], ";\n        vertical-align: top;\n        border-top: ").concat(props.theme['$table-border-width'], " solid ").concat(props.theme['$table-border-color'], ";\n      }\n    \n      thead th {\n        vertical-align: bottom;\n        border-bottom: ").concat(unitUtils$1.math.multiply(props.theme['$table-border-width'], 2), " solid ").concat(props.theme['$table-border-color'], ";\n      }\n    \n      tbody + tbody {\n        border-top: ").concat(unitUtils$1.math.multiply(props.theme['$table-border-width'], 2), " solid ").concat(props.theme['$table-border-color'], ";\n      }\n    \n      .table {\n        background-color: ").concat(props.theme['$body-bg'], ";\n      }\n    }\n    \n    \n    /*\n     Condensed table w/ half padding\n    */\n    \n    &.table-sm {\n      th,\n      td {\n        padding: ").concat(props.theme['$table-sm-cell-padding'], ";\n      }\n    }\n    \n    \n    /* Bordered version\n     Add borders all around the table and between all the columns.\n    */\n    &.table-bordered {\n      border: ").concat(props.theme['$table-border-width'], " solid ").concat(props.theme['$table-border-color'], ";\n    \n      th,\n      td {\n        border: ").concat(props.theme['$table-border-width'], " solid ").concat(props.theme['$table-border-color'], ";\n      }\n    \n      thead {\n        th,\n        td {\n          border-bottom-width: ").concat(unitUtils$1.math.multiply(2, props.theme['$table-border-width']), ";\n        }\n      }\n    }\n    \n    \n    /* Zebra-striping\n     Default zebra-stripe styles (alternating gray and transparent backgrounds)\n    */\n    \n    &.table-striped {\n      tbody tr:nth-of-type(odd) {\n        background-color: ").concat(props.theme['$table-bg-accent'], ";\n      }\n    }\n    \n    \n    /* \n    Hover effect Placed here since it has to come after the potential zebra striping\n    */\n\n    \n    &.table-hover {\n      tbody tr {\n        ").concat(hover_2("\n          background-color: ".concat(props.theme['$table-bg-hover'], ";\n        ")), "\n      }\n    }\n    \n    /* Table backgrounds\n    Exact selectors below required to override '.table-striped' and prevent\n    inheritance to nested tables.\n    */\n        \n    /* Generate the contextual variants */\n    ").concat(tableRow_1('active', props.theme['$table-bg-active']), "\n    ").concat(tableRow_1('success', props.theme['$state-success-bg']), "\n    ").concat(tableRow_1('info', props.theme['$state-info-bg']), "\n    ").concat(tableRow_1('warning', props.theme['$state-warning-bg']), "\n    ").concat(tableRow_1('danger', props.theme['$state-danger-bg']), "\n     \n    \n    /* Inverse styles\n    Same table markup, but inverted color scheme: dark background and light text.\n    */ \n    \n    & thead.thead-inverse {\n      th {\n        color: ").concat(props.theme['$table-inverse-color'], ";\n        background-color: ").concat(props.theme['$table-inverse-bg'], ";\n      }\n    }\n    \n    \n    & thead.thead-default {\n      th {\n        color: ").concat(props.theme['$table-head-color'], ";\n        background-color: ").concat(props.theme['$table-head-bg'], ";\n      }\n    }\n    \n    &.table-inverse {\n      color: ").concat(props.theme['$table-inverse-color'], ";\n      background-color: ").concat(props.theme['$table-inverse-bg'], ";\n    \n      th,\n      td,\n      thead th {\n        border-color: ").concat(props.theme['$table-inverse-border'], ";\n      }\n    \n      &.table-bordered {\n        border: 0;\n      }\n      \n      &.table-striped {\n        tbody tr:nth-of-type(odd) {\n        background-color: ").concat(props.theme['$table-inverse-bg-accent'], ";\n        }\n      }\n      \n      &.table-hover {\n        tbody tr {\n          ").concat(hover_2("\n            background-color: ".concat(props.theme['$table-inverse-bg-hover'], ";\n          ")), "\n        }\n      }\n    }\n    \n    /* Responsive tables\n     Wrap your tables in '.table-responsive' and we'll make them mobile friendly\n     by enabling horizontal scrolling. Only applies <768px. Everything above that\n     will display normally.\n     */\n    \n    &.table-responsive {\n      display: block;\n      width: 100%;\n      overflow-x: auto;\n      -ms-overflow-style: -ms-autohiding-scrollbar; /* See https://github.com/twbs/bootstrap/pull/10057 */\n      &.table-bordered {\n        border: 0;\n      }\n    }\n    \n    &.table-reflow {\n    \n      /* added bs4 missing tfoot rule */\n      thead, tfoot {\n        float: left;\n      }\n    \n      tbody {\n        display: block;\n        white-space: nowrap;\n      }\n    \n      th,\n      td {\n        border-top: ").concat(props.theme['$table-border-width'], " solid ").concat(props.theme['$table-border-color'], ";\n        border-left: ").concat(props.theme['$table-border-width'], " solid ").concat(props.theme['$table-border-color'], ";\n    \n        &:last-child {\n          border-right: ").concat(props.theme['$table-border-width'], " solid ").concat(props.theme['$table-border-color'], ";\n        }\n      }\n    \n      thead,\n      tbody,\n      tfoot {\n        &:last-child {\n          tr:last-child th,\n          tr:last-child td {\n            border-bottom: ").concat(props.theme['$table-border-width'], " solid ").concat(props.theme['$table-border-color'], ";\n          }\n        }\n      }\n    \n      tr {\n        float: left;\n    \n        th,\n        td {\n          display: block !important;\n          border: ").concat(props.theme['$table-border-width'], " solid ").concat(props.theme['$table-border-color'], ";\n        }\n      }\n    }\n    \n    /* from reboot.scss */\n    th {\n      /* Centered by default, but left-align-ed to match the tds below. */\n      text-align: left;\n    }\n      \n    /* Reboot Scss */\n    /* No longer part of Normalize since v4 */\n    border-collapse: collapse;\n    /*  Reset for nesting within parents with 'background-color'. */\n    background-color: ").concat(props.theme['$table-bg'], ";    \n    \n  ");
});
Table.defaultProps = defaultProps$Z;
Table.propTypes = propTypes$11;

var Tbody = styled.tbody.withConfig({
  displayName: "Tbody",
  componentId: "sc-14l4jy7-0"
})([""]);

var Tfoot = styled.tfoot.withConfig({
  displayName: "Tfoot",
  componentId: "sc-1ghgybq-0"
})([""]);

var propTypes$12 = {
  className: propTypes.string,
  children: propTypes.node,
  inverse: propTypes.bool,
  defaultBg: propTypes.bool
};
var Thead =
function (_React$Component) {
  _inherits(Thead, _React$Component);
  function Thead() {
    _classCallCheck(this, Thead);
    return _possibleConstructorReturn(this, _getPrototypeOf(Thead).apply(this, arguments));
  }
  _createClass(Thead, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          inverse = _this$props.inverse,
          children = _this$props.children,
          defaultBg = _this$props.defaultBg,
          attributes = _objectWithoutProperties(_this$props, ["className", "inverse", "children", "defaultBg"]);
      var classes = classnames(className, inverse ? 'thead-inverse' : false, defaultBg ? 'thead-default' : false);
      return React.createElement("thead", _extends({
        className: classes
      }, attributes), children);
    }
  }]);
  return Thead;
}(React.Component);
_defineProperty(Thead, "propTypes", propTypes$12);
Thead.propTypes = propTypes$12;

var propTypes$13 = {
  className: propTypes.string,
  children: propTypes.node,
  color: propTypes.oneOf(['active', 'success', 'info', 'warning', 'danger', ''])
};
var Td =
function (_React$Component) {
  _inherits(Td, _React$Component);
  function Td() {
    _classCallCheck(this, Td);
    return _possibleConstructorReturn(this, _getPrototypeOf(Td).apply(this, arguments));
  }
  _createClass(Td, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          color = _this$props.color,
          children = _this$props.children,
          attributes = _objectWithoutProperties(_this$props, ["className", "color", "children"]);
      var classes = classnames(className, color ? "table-".concat(color) : false);
      return React.createElement("td", _extends({
        className: classes
      }, attributes), children);
    }
  }]);
  return Td;
}(React.Component);
_defineProperty(Td, "propTypes", propTypes$13);
Td.propTypes = propTypes$13;

var propTypes$14 = {
  className: propTypes.string,
  children: propTypes.node,
  color: propTypes.oneOf(['active', 'success', 'info', 'warning', 'danger', ''])
};
var Th =
function (_React$Component) {
  _inherits(Th, _React$Component);
  function Th() {
    _classCallCheck(this, Th);
    return _possibleConstructorReturn(this, _getPrototypeOf(Th).apply(this, arguments));
  }
  _createClass(Th, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          color = _this$props.color,
          children = _this$props.children,
          attributes = _objectWithoutProperties(_this$props, ["className", "color", "children"]);
      var classes = classnames(className, color ? "table-".concat(color) : false);
      return React.createElement("th", _extends({
        className: classes
      }, attributes), children);
    }
  }]);
  return Th;
}(React.Component);
_defineProperty(Th, "propTypes", propTypes$14);
Th.propTypes = propTypes$14;

var propTypes$15 = {
  className: propTypes.string,
  children: propTypes.node,
  color: propTypes.oneOf(['active', 'success', 'info', 'warning', 'danger', ''])
};
var Tr =
function (_React$Component) {
  _inherits(Tr, _React$Component);
  function Tr() {
    _classCallCheck(this, Tr);
    return _possibleConstructorReturn(this, _getPrototypeOf(Tr).apply(this, arguments));
  }
  _createClass(Tr, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          color = _this$props.color,
          children = _this$props.children,
          attributes = _objectWithoutProperties(_this$props, ["className", "color", "children"]);
      var classes = classnames(className, _defineProperty({}, "table-".concat(color), color));
      return React.createElement("tr", _extends({
        className: classes
      }, attributes), children);
    }
  }]);
  return Tr;
}(React.Component);
_defineProperty(Tr, "propTypes", propTypes$15);
Tr.propTypes = propTypes$15;

var badge = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.badgeVariant = badgeVariant;
exports.default = exports.defaultProps = void 0;
var _color = _interopRequireDefault(ColorWrapper);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var defaultProps = {
  '$enable-hover-mediaQuery': false
};
exports.defaultProps = defaultProps;
function badgeVariant() {
  var enableHoverMediaQuery = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-hover-mediaQuery'];
  var badgeColor = arguments.length > 1 ? arguments[1] : undefined;
  return "\n    background-color: ".concat(badgeColor, ";\n    \n    &[href] {\n      ").concat((0, hover_1.hoverFocus)(enableHoverMediaQuery, "background-color: ".concat((0, _color.default)(badgeColor).darken(0.1).toString(), ";")), "\n    }\n  ");
}
var _default = {
  defaultProps: defaultProps,
  badgeVariant: badgeVariant
};
exports.default = _default;
});
unwrapExports(badge);
var badge_1 = badge.badgeVariant;
var badge_2 = badge.defaultProps;

var defaultProps$_ = {
  color: 'default',
  pill: false,
  tag: 'span',
  theme: {
    '$badge-default-bg': '#636c72',
    '$badge-primary-bg': '#0275d8',
    '$badge-success-bg': '#5cb85c',
    '$badge-info-bg': '#5bc0de',
    '$badge-warning-bg': '#f0ad4e',
    '$badge-danger-bg': '#d9534f',
    '$badge-color': '#fff',
    '$badge-link-hover-color': '#fff',
    '$badge-font-size': '75%',
    '$badge-font-weight': 'bold',
    '$badge-padding-x': '.4em',
    '$badge-padding-y': '.25em',
    '$badge-pill-padding-x': '.6em',
    '$badge-pill-border-radius': '10rem',
    '$enable-rounded': true,
    '$enable-hover-media-query': false
  }
};
var propTypes$16 = {
  className: propTypes.string,
  color: propTypes.oneOf(['default', 'primary', 'success', 'info', 'warning', 'danger']),
  pill: propTypes.bool,
  tag: propTypes.any,
  theme: propTypes.shape({
    '$badge-default-bg': propTypes.string,
    '$badge-primary-bg': propTypes.string,
    '$badge-success-bg': propTypes.string,
    '$badge-info-bg': propTypes.string,
    '$badge-warning-bg': propTypes.string,
    '$badge-danger-bg': propTypes.string,
    '$badge-color': propTypes.string,
    '$badge-link-hover-color': propTypes.string,
    '$badge-font-size': propTypes.string,
    '$badge-font-weight': propTypes.string,
    '$badge-padding-x': propTypes.string,
    '$badge-padding-y': propTypes.string,
    '$badge-pill-padding-x': propTypes.string,
    '$badge-pill-border-radius': propTypes.string,
    '$link-hover-decoration': propTypes.string,
    '$enable-rounded': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool
  }),
  cssModule: propTypes.object
};
var BadgeUnstyled =
function (_React$Component) {
  _inherits(BadgeUnstyled, _React$Component);
  function BadgeUnstyled() {
    _classCallCheck(this, BadgeUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(BadgeUnstyled).apply(this, arguments));
  }
  _createClass(BadgeUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          color = _omit.color,
          pill = _omit.pill,
          Tag = _omit.tag,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "color", "pill", "tag"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'badge', _defineProperty({
          'badge-pill': pill
        }, "badge-".concat(color), color)), cssModule)
      }, attributes));
    }
  }]);
  return BadgeUnstyled;
}(React.Component);
_defineProperty(BadgeUnstyled, "propTypes", propTypes$16);
_defineProperty(BadgeUnstyled, "defaultProps", defaultProps$_);
var Badge = styled(BadgeUnstyled).withConfig({
  displayName: "Badge",
  componentId: "sc-4ja24t-0"
})(["", ""], function (props) {
  return "\n    \n    /* Base class */\n    /* Requires one of the contextual, color modifier classes for 'color' and */\n    /* 'background-color'. */\n    \n    &.badge {\n      display: inline-block;\n      padding: ".concat(props.theme['$badge-padding-y'], " ").concat(props.theme['$badge-padding-x'], ";\n      font-size: ").concat(props.theme['$badge-font-size'], ";\n      font-weight: ").concat(props.theme['$badge-font-weight'], ";\n      line-height: 1;\n      color: ").concat(props.theme['$badge-color'], ";\n      text-align: center;\n      white-space: nowrap;\n      vertical-align: baseline;\n      ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$border-radius']), "\n    \n      /* Empty tags collapse automatically */\n      &:empty {\n        display: none;\n      }\n    }\n    \n    \n    /* scss-lint:disable QualifyingElement */\n    /* Add hover effects, but only for links */\n    &a {\n      ").concat(hover_3(props.theme['$enable-hover-media-query'], "\n        color: ".concat(props.theme['$badge-link-hover-color'], ";\n        text-decoration: none;\n        cursor: pointer;\n      ")), "\n    }\n    /* scss-lint:enable QualifyingElement */\n    \n    /* Pill tags */\n    /* Make them extra rounded with a modifier to replace v3s badges. */\n    \n    &.badge-pill {\n      padding-right: ").concat(props.theme['$badge-pill-padding-x'], ";\n      padding-left: ").concat(props.theme['$badge-pill-padding-x'], ";\n      ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$badge-pill-border-radius']), "\n    }\n    \n    /* Colors */\n    /* Contextual variations (linked tags get darker on :hover). */\n    \n    &.badge-default {\n      ").concat(badge_1(props.theme['$enable-hover-media-query'], props.theme['$badge-default-bg']), "\n    }     \n    \n    &.badge-primary {\n      ").concat(badge_1(props.theme['$enable-hover-media-query'], props.theme['$badge-primary-bg']), "\n    }\n    \n    &.badge-success {\n      ").concat(badge_1(props.theme['$enable-hover-media-query'], props.theme['$badge-success-bg']), "\n    }\n    \n    &.badge-info {\n      ").concat(badge_1(props.theme['$enable-hover-media-query'], props.theme['$badge-info-bg']), "\n    }\n    \n    &.badge-warning {\n      ").concat(badge_1(props.theme['$enable-hover-media-query'], props.theme['$badge-warning-bg']), "\n    }\n    \n    &.badge-danger {\n      ").concat(badge_1(props.theme['$enable-hover-media-query'], props.theme['$badge-danger-bg']), "\n    }\n  ");
});
Badge.defaultProps = defaultProps$_;
Badge.propTypes = propTypes$16;

var Textarea = styled.textarea.withConfig({
  displayName: "Textarea",
  componentId: "sc-1rbvijs-0"
})(["touch-action:manipulation;line-height:inherit;resize:vertical;"]);

var DEFAULT_DELAYS = {
  shape: 0,
  hide: 250
};
var defaultTetherConfig$1 = {
  classPrefix: 'bs-tether',
  classes: {
    element: false,
    enabled: 'show'
  },
  constraints: [{
    to: 'scrollParent',
    attachment: 'together none'
  }, {
    to: 'window',
    attachment: 'together none'
  }]
};
var propTypes$17 = {
  className: propTypes.string,
  placement: propTypes.oneOf(tools_10),
  target: propTypes.oneOfType([propTypes.string, propTypes.object]).isRequired,
  isOpen: propTypes.bool,
  disabled: propTypes.bool,
  tether: propTypes.object,
  tetherRef: propTypes.func,
  toggle: propTypes.func,
  autohide: propTypes.bool,
  delay: propTypes.oneOfType([propTypes.shape({
    show: propTypes.number,
    hide: propTypes.number
  }), propTypes.number]),
  theme: propTypes.shape({
    '$zindex-tooltip': propTypes.string,
    '$tooltip-max-width': propTypes.string,
    '$tooltip-color': propTypes.string,
    '$tooltip-bg': propTypes.string,
    '$tooltip-opacity': propTypes.string,
    '$tooltip-padding-y': propTypes.string,
    '$tooltip-padding-x': propTypes.string,
    '$tooltip-margin': propTypes.string,
    '$tooltip-arrow-width': propTypes.string,
    '$tooltip-arrow-color': propTypes.string,
    '$component-active-color': propTypes.string
  }),
  cssModule: propTypes.object
};
var defaultProps$$ = {
  isOpen: false,
  placement: 'bottom',
  delay: DEFAULT_DELAYS,
  autohide: true,
  toggle: null,
  theme: {
    '$zindex-tooltip': '1070',
    '$tooltip-max-width': '200px',
    '$tooltip-color': '#fff',
    '$tooltip-bg': '#000',
    '$tooltip-opacity': '.9',
    '$tooltip-padding-y': '3px',
    '$tooltip-padding-x': '8px',
    '$tooltip-margin': '3px',
    '$tooltip-arrow-width': '5px',
    '$tooltip-arrow-color': '#000'
  }
};
var TooltipUnstyled =
function (_React$Component) {
  _inherits(TooltipUnstyled, _React$Component);
  function TooltipUnstyled() {
    var _getPrototypeOf2;
    var _this;
    _classCallCheck(this, TooltipUnstyled);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(TooltipUnstyled)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _defineProperty(_assertThisInitialized(_this), "state", {
      focus: false
    });
    _defineProperty(_assertThisInitialized(_this), "componentDidMount", function () {
      _this.target = _this.getTarget();
      _this.addTargetEvents();
    });
    _defineProperty(_assertThisInitialized(_this), "componentWillUnmount", function () {
      _this.removeTargetEvents();
    });
    _defineProperty(_assertThisInitialized(_this), "onMouseOverTooltip", function () {
      if (_this.hideTimeout) {
        _this.clearHideTimeout();
      }
      _this.showTimeout = setTimeout(_this.show, _this.getDelay('show'));
    });
    _defineProperty(_assertThisInitialized(_this), "onMouseLeaveTooltip", function () {
      if (_this.showTimeout) {
        _this.clearShowTimeout();
      }
      _this.hideTimeout = setTimeout(_this.hide, _this.getDelay('hide'));
    });
    _defineProperty(_assertThisInitialized(_this), "onMouseOverTooltipContent", function () {
      if (_this.props.autohide) {
        return;
      }
      if (_this.hideTimeout) {
        _this.clearHideTimeout();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "onMouseLeaveTooltipContent", function () {
      if (_this.props.autohide) {
        return;
      }
      if (_this.showTimeout) {
        _this.clearShowTimeout();
      }
      _this.hideTimeout = setTimeout(_this.hide, _this.getDelay('hide'));
    });
    _defineProperty(_assertThisInitialized(_this), "getDelay", function (key) {
      var delay = _this.props.delay;
      if (_typeof(delay) === 'object') {
        return isNaN(delay[key]) ? DEFAULT_DELAYS[key] : delay[key];
      }
      return delay;
    });
    _defineProperty(_assertThisInitialized(_this), "getTarget", function () {
      var target = _this.props.target;
      if (_typeof(target) === 'object') {
        return target;
      }
      return document.getElementById(target);
    });
    _defineProperty(_assertThisInitialized(_this), "getTetherConfig", function () {
      var attachments = tools_1(_this.props.placement);
      return _objectSpread({}, defaultTetherConfig$1, attachments, {
        target: _this.getTarget
      }, _this.props.tether);
    });
    _defineProperty(_assertThisInitialized(_this), "show", function () {
      if (!_this.props.isOpen) {
        _this.clearShowTimeout();
        _this.toggle();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "hide", function () {
      if (_this.props.isOpen) {
        _this.clearHideTimeout();
        _this.toggle();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "clearShowTimeout", function () {
      clearTimeout(_this.showTimeout);
      _this.showTimeout = undefined;
    });
    _defineProperty(_assertThisInitialized(_this), "clearHideTimeout", function () {
      clearTimeout(_this.hideTimeout);
      _this.hideTimeout = undefined;
    });
    _defineProperty(_assertThisInitialized(_this), "handleDocumentClick", function (e) {
      if (e.target === _this.target || _this.target.contains(e.target)) {
        if (_this.hideTimeout) {
          _this.clearHideTimeout();
        }
        if (!_this.props.isOpen) {
          _this.toggle();
        }
      }
    });
    _defineProperty(_assertThisInitialized(_this), "addTargetEvents", function () {
      if (_this.target) {
        _this.target.addEventListener('mouseover', _this.onMouseOverTooltip, true);
        _this.target.addEventListener('mouseout', _this.onMouseLeaveTooltip, true);
        document.addEventListener('click', _this.handleDocumentClick, true);
      }
    });
    _defineProperty(_assertThisInitialized(_this), "removeTargetEvents", function () {
      if (_this.target) {
        _this.target.removeEventListener('mouseover', _this.onMouseOverTooltip, true);
        _this.target.removeEventListener('mouseout', _this.onMouseLeaveTooltip, true);
        document.removeEventListener('click', _this.handleDocumentClick, true);
      }
    });
    _defineProperty(_assertThisInitialized(_this), "toggle", function (e) {
      if (_this.props.disabled) {
        return e && e.preventDefault();
      }
      if (_this.props.toggle) {
        return _this.props.toggle();
      }
      return null;
    });
    _defineProperty(_assertThisInitialized(_this), "handleFocus", function () {
      _this.setState({
        focus: true
      });
    });
    return _this;
  }
  _createClass(TooltipUnstyled, [{
    key: "render",
    value: function render() {
      if (!this.props.isOpen) {
        return null;
      }
      var attributes = lodash_omit(this.props, Object.keys(propTypes$17));
      var classes = mapToCssModules(classnames('tooltip', this.props.className), this.props.cssModule);
      var tetherConfig = this.getTetherConfig();
      var optional = {};
      if (this.state.focus === true) {
        optional.onFocus = this.handleFocus;
      }
      return React.createElement(TetherContent, {
        className: classes,
        tether: tetherConfig,
        tetherRef: this.props.tetherRef,
        isOpen: this.props.isOpen,
        toggle: this.toggle
      }, React.createElement("div", _extends({}, attributes, {
        className: "tooltip-inner",
        onMouseOver: this.onMouseOverTooltipContent,
        onMouseLeave: this.onMouseLeaveTooltipContent,
        onFocus: this.handleFocus,
        tabIndex: "-1"
      }, optional)));
    }
  }]);
  return TooltipUnstyled;
}(React.Component);
_defineProperty(TooltipUnstyled, "propTypes", propTypes$17);
_defineProperty(TooltipUnstyled, "defaultProps", defaultProps$$);
var Tooltip = styled(TooltipUnstyled).withConfig({
  displayName: "Tooltip",
  componentId: "l83az1-0"
})(["", ""], function (props) {
  return "\n    &.tooltip {\n      position: absolute;\n      z-index: ".concat(props.theme['$zindex-tooltip'], ";\n      display: block;\n      font-family: -apple-system, system-ui, BlinkMacSystemFont, Segoe UI, Roboto, Helvetica Neue, Arial, sans-serif;\n      font-style: normal;\n      font-weight: 400;\n      letter-spacing: normal;\n      line-break: auto;\n      line-height: 1.5;\n      text-align: left;\n      text-align: start;\n      text-decoration: none;\n      text-shadow: none;\n      text-transform: none;\n      white-space: normal;\n      word-break: normal;\n      word-spacing: normal;\n      font-size: .875rem;\n      word-wrap: break-word;\n      opacity: 0\n    }\n    \n    &.tooltip.show {\n      opacity: ").concat(props.theme['$tooltip-opacity'], "\n    }\n    \n    &.tooltip.bs-tether-element-attached-bottom,\n    &.tooltip.tooltip-top {\n      padding: 5px 0;\n      margin-top: -3px\n    }\n    \n    &.tooltip.bs-tether-element-attached-bottom .tooltip-inner:before,\n    &.tooltip.tooltip-top .tooltip-inner:before {\n      bottom: 0;\n      left: 50%;\n      margin-left: -5px;\n      content: \"\";\n      border-width: 5px 5px 0;\n      border-top-color: #000\n    }\n    \n    &.tooltip.bs-tether-element-attached-left,\n    &.tooltip.tooltip-right {\n      padding: 0 5px;\n      margin-left: 3px\n    }\n    \n    &.tooltip.bs-tether-element-attached-left .tooltip-inner:before,\n    &.tooltip.tooltip-right .tooltip-inner:before {\n      top: 50%;\n      left: 0;\n      margin-top: -5px;\n      content: \"\";\n      border-width: 5px 5px 5px 0;\n      border-right-color: #000\n    }\n    \n    &.tooltip.bs-tether-element-attached-top,\n    &.tooltip.tooltip-bottom {\n      padding: 5px 0;\n      margin-top: 3px\n    }\n    \n    &.tooltip.bs-tether-element-attached-top .tooltip-inner:before,\n    &.tooltip.tooltip-bottom .tooltip-inner:before {\n      top: 0;\n      left: 50%;\n      margin-left: -5px;\n      content: \"\";\n      border-width: 0 5px 5px;\n      border-bottom-color: #000\n    }\n    \n    &.tooltip.bs-tether-element-attached-right,\n    &.tooltip.tooltip-left {\n      padding: 0 5px;\n      margin-left: -3px\n    }\n    \n    &.tooltip.bs-tether-element-attached-right .tooltip-inner:before,\n    &.tooltip.tooltip-left .tooltip-inner:before {\n      top: 50%;\n      right: 0;\n      margin-top: -5px;\n      content: \"\";\n      border-width: 5px 0 5px 5px;\n      border-left-color: #000\n    }\n    \n    & .tooltip-inner {\n      max-width: ").concat(props.theme['$tooltip-max-width'], ";\n      padding: ").concat(props.theme['$tooltip-padding-y'], " ").concat(props.theme['$tooltip-padding-x'], ";\n      color: ").concat(props.theme['$tooltip-color'], ";\n      text-align: center;\n      background-color: ").concat(props.theme['$tooltip-bg'], ";\n      border-radius: .25rem\n    }\n    \n    & .tooltip-inner:before {\n      position: absolute;\n      width: 0;\n      height: 0;\n      border-color: transparent;\n      border-style: solid\n    }\n  ");
});
Tooltip.defaultProps = defaultProps$$;
Tooltip.propTypes = propTypes$17;

var cards = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cardVariant = cardVariant;
exports.cardOutlineVariant = cardOutlineVariant;
exports.cardInverse = cardInverse;
exports.card = card;
exports.default = exports.defaultProps = void 0;
var _unitUtils = _interopRequireDefault(unitUtils);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var detectUnit = _unitUtils.default.detectUnit,
    rmUnit = _unitUtils.default.rmUnit;
var defaultProps = {
  '$enable-rounded': true,
  '$enable-hover-media-query': false,
  '$card-spacer-x': '1.25rem',
  '$card-spacer-y': '.75rem',
  '$card-bg': '#fff',
  '$card-border-width': '1px',
  '$card-border-color': 'rgba(0, 0, 0, 0.125)',
  '$card-border-radius': '.25rem',
  '$card-cap-bg': '#f7f7f9',
  '$card-border-radius-inner': 'calc(.25rem - 1px)',
  '$brand-primary': '#0275d8',
  '$brand-success': '#5cb85c',
  '$brand-info': '#5bc0de',
  '$brand-warning': '#f0ad4e',
  '$brand-danger': '#d9534f',
  '$btn-primary-bg': '#0275d8',
  '$btn-secondary-border': '#ccc',
  '$btn-info-bg': '#5bc0de',
  '$btn-success-bg': '#5cb85c',
  '$btn-warning-bg': '#f0ad4e',
  '$btn-danger-bg': '#d9534f',
  '$card-link-hover-color': '#fff',
  '$card-img-overlay-padding': '1.25rem'
};
exports.defaultProps = defaultProps;
function cardVariant(cardBackground, cardBorder) {
  return "\n    background-color: ".concat(cardBackground, ";\n    border-color: ").concat(cardBorder, ";\n  \n    & .card-header,\n    & .card-footer {\n      background-color: transparent;\n    }\n  ");
}
function cardOutlineVariant(cardColor) {
  return "\n    background-color: transparent;\n    border-color: ".concat(cardColor, ";\n  ");
}
function cardInverse() {
  var enableHoverMediaQuery = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-hover-media-query'];
  var cardLinkHoverColor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$card-link-hover-color'];
  return "\n    color: rgba(255,255,255,.65);\n    & .card-header,\n    & .card-footer {\n      background-color: transparent;\n      border-color: rgba(255,255,255,.2);\n    }\n    & .card-header,\n    & .card-footer,\n    & .card-title,\n    & .card-blockquote {\n      color: #fff;\n    }\n    & .card-link,\n    & .card-text,\n    & .card-subtitle,\n    & .card-blockquote .blockquote-footer {\n      color: rgba(255,255,255,.65);\n    }\n    \n    & .card-link {\n      ".concat((0, hover_1.hoverFocus)(enableHoverMediaQuery, "color: ".concat(cardLinkHoverColor, ";")), "\n    }\n  ");
}
function card() {
  var $enableRounded = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-rounded'];
  var $enableHoverMediaQuery = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$enable-hover-media-query'];
  var $cardSpacerY = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$card-spacer-y'];
  var $cardSpacerX = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : defaultProps['$card-spacer-x'];
  var $cardBg = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : defaultProps['$card-bg'];
  var $cardBorderWidth = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : defaultProps['$card-border-width'];
  var $cardBorderColor = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : defaultProps['$card-border-color'];
  var $cardBorderRadius = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : defaultProps['$card-border-radius'];
  var $cardCapBg = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : defaultProps['$card-cap-bg'];
  var $cardBorderRadiusInner = arguments.length > 9 && arguments[9] !== undefined ? arguments[9] : defaultProps['$card-border-radius-inner'];
  var $brandPrimary = arguments.length > 10 && arguments[10] !== undefined ? arguments[10] : defaultProps['$brand-primary'];
  var $brandSuccess = arguments.length > 11 && arguments[11] !== undefined ? arguments[11] : defaultProps['$brand-success'];
  var $brandInfo = arguments.length > 12 && arguments[12] !== undefined ? arguments[12] : defaultProps['$brand-info'];
  var $brandWarning = arguments.length > 13 && arguments[13] !== undefined ? arguments[13] : defaultProps['$brand-warning'];
  var $brandDanger = arguments.length > 14 && arguments[14] !== undefined ? arguments[14] : defaultProps['$brand-danger'];
  var $btnPrimaryBg = arguments.length > 15 && arguments[15] !== undefined ? arguments[15] : defaultProps['$btn-primary-bg'];
  var $btnSecondaryBorder = arguments.length > 16 && arguments[16] !== undefined ? arguments[16] : defaultProps['$btn-secondary-border'];
  var $btnInfoBg = arguments.length > 17 && arguments[17] !== undefined ? arguments[17] : defaultProps['$btn-info-bg'];
  var $btnSuccessBg = arguments.length > 18 && arguments[18] !== undefined ? arguments[18] : defaultProps['$btn-success-bg'];
  var $btnWarningBg = arguments.length > 19 && arguments[19] !== undefined ? arguments[19] : defaultProps['$btn-warning-bg'];
  var $btnDangerBg = arguments.length > 20 && arguments[20] !== undefined ? arguments[20] : defaultProps['$btn-danger-bg'];
  var $cardLinkHoverColor = arguments.length > 21 && arguments[21] !== undefined ? arguments[21] : defaultProps['$card-link-hover-color'];
  var $cardImgOverlayPadding = arguments.length > 22 && arguments[22] !== undefined ? arguments[22] : defaultProps['$card-img-overlay-padding'];
  return "\n    & .card {\n      position: relative;\n      display: flex;\n      flex-direction: column;\n      background-color: ".concat($cardBg, ";\n      border: ").concat($cardBorderWidth, " solid ").concat($cardBorderColor, ";\n      ").concat((0, borderRadius_1.borderRadius)($enableRounded, $cardBorderRadius), "\n    }\n    \n    & .card-block {\n      flex: 1 1 auto;\n\n      padding: ").concat($cardSpacerX, ";\n    }\n    \n    & .card-title {\n      margin-bottom: ").concat($cardSpacerY, ";\n    }\n    \n    & .card-subtitle {\n      margin-top: -").concat(rmUnit($cardSpacerY, detectUnit($cardSpacerY)) / 2 + detectUnit($cardSpacerY), ";\n      margin-bottom: 0;\n    }\n    \n    & .card-text:last-child {\n      margin-bottom: 0;\n    }\n   \n    & .card-link {\n      ").concat((0, hover_1.hover)('text-decoration: none;'), "\n    \n      + .card-link {\n        margin-left: ").concat($cardSpacerX, ";\n      }\n    }\n    \n    & .card{\n      > .list-group:first-child {\n        .list-group-item:first-child {\n          ").concat((0, borderRadius_1.borderTopRadius)($enableRounded, $cardBorderRadius), "\n        }\n      }\n    \n      > .list-group:last-child {\n        .list-group-item:last-child {\n          ").concat((0, borderRadius_1.borderBottomRadius)($enableRounded, $cardBorderRadius), "\n        }\n      }\n    }\n    \n    & .card-header {\n      padding: ").concat($cardSpacerY, " ").concat($cardSpacerX, ";\n      margin-bottom: 0;\n      background-color: ").concat($cardCapBg, ";\n      border-bottom: ").concat($cardBorderWidth, " solid ").concat($cardBorderColor, ";\n    \n      &:first-child {\n        ").concat((0, borderRadius_1.borderRadius)($enableRounded, $cardBorderRadiusInner, $cardBorderRadiusInner, '0', '0'), "\n      }\n    }\n    \n    & .card-footer {\n      padding: ").concat($cardSpacerY, " ").concat($cardSpacerX, ";\n      background-color: ").concat($cardCapBg, ";\n      border-top: ").concat($cardBorderWidth, " solid ").concat($cardBorderColor, ";\n    \n      &:last-child {\n        ").concat((0, borderRadius_1.borderRadius)($enableRounded, '0', '0', $cardBorderRadiusInner, $cardBorderRadiusInner), "\n      }\n    }\n\n    & .card-header-tabs {\n      margin-right: -").concat(rmUnit($cardSpacerX, detectUnit($cardSpacerX)) / 2 + detectUnit($cardSpacerX), ";\n      margin-bottom: -").concat($cardSpacerY, ";\n      margin-left: -").concat(rmUnit($cardSpacerX, detectUnit($cardSpacerX)) / 2 + detectUnit($cardSpacerX), ";\n      border-bottom: 0;\n    }\n    \n    & .card-header-pills {\n      margin-right: -").concat(rmUnit($cardSpacerX, detectUnit($cardSpacerX)) / 2 + detectUnit($cardSpacerX), ";\n      margin-left: -").concat(rmUnit($cardSpacerX, detectUnit($cardSpacerX)) / 2 + detectUnit($cardSpacerX), ";\n    }\n    \n    & .card-primary {\n      ").concat(cardVariant($brandPrimary, $brandPrimary), "\n    }\n    & .card-success {\n      ").concat(cardVariant($brandSuccess, $brandSuccess), "\n    }\n    & .card-info {\n      ").concat(cardVariant($brandInfo, $brandInfo), "\n    }\n    & .card-warning {\n      ").concat(cardVariant($brandWarning, $brandWarning), "\n    }\n    & .card-danger {\n      ").concat(cardVariant($brandDanger, $brandDanger), "\n    }\n    \n    & .card-outline-primary {\n      ").concat(cardOutlineVariant($btnPrimaryBg), "\n    }\n    & .card-outline-secondary {\n      ").concat(cardOutlineVariant($btnSecondaryBorder), "\n    }\n    & .card-outline-info {\n      ").concat(cardOutlineVariant($btnInfoBg), "\n    }\n    & .card-outline-success {\n      ").concat(cardOutlineVariant($btnSuccessBg), "\n    }\n    & .card-outline-warning {\n      ").concat(cardOutlineVariant($btnWarningBg), "\n    }\n    & .card-outline-danger {\n      ").concat(cardOutlineVariant($btnDangerBg), "\n    }\n        \n    & .card-inverse {\n      ").concat(cardInverse($enableHoverMediaQuery, $cardLinkHoverColor), "\n    }\n\n    & .card-blockquote {\n      padding: 0;\n      margin-bottom: 0;\n      border-left: 0;\n    }\n    \n    & .card-img {\n      ").concat((0, borderRadius_1.borderRadius)($enableRounded, $cardBorderRadiusInner), "\n    }\n    \n    & .card-img-overlay {\n      position: absolute;\n      top: 0;\n      right: 0;\n      bottom: 0;\n      left: 0;\n      padding: ").concat($cardImgOverlayPadding, ";\n    }\n\n    & .card-img-top {\n      ").concat((0, borderRadius_1.borderTopRadius)($enableRounded, $cardBorderRadiusInner), "\n    }\n    \n    & .card-img-bottom {\n      ").concat((0, borderRadius_1.borderBottomRadius)($enableRounded, $cardBorderRadiusInner), "\n    }\n  ");
}
var _default = {
  defaultProps: defaultProps,
  cardVariant: cardVariant,
  cardOutlineVariant: cardOutlineVariant,
  cardInverse: cardInverse,
  card: card
};
exports.default = _default;
});
unwrapExports(cards);
var cards_1 = cards.cardVariant;
var cards_2 = cards.cardOutlineVariant;
var cards_3 = cards.cardInverse;
var cards_4 = cards.card;
var cards_5 = cards.defaultProps;

var defaultProps$10 = {
  tag: 'div',
  theme: {
    '$brand-primary': '#0275d8',
    '$brand-success': '#5cb85c',
    '$brand-info': '#5bc0de',
    '$brand-warning': '#f0ad4e',
    '$brand-danger': '#d9534f',
    '$brand-inverse': '#292b2c',
    '$card-spacer-x': '1.25rem',
    '$card-spacer-y': '.75rem',
    '$card-border-width': '1px',
    '$card-border-radius': '.25rem',
    '$card-border-color': 'rgba(0, 0, 0, 0.125)',
    '$card-border-radius-inner': '',
    '$card-cap-bg': '$gray-lightest',
    '$card-bg': '$white',
    '$card-link-hover-color': '$white',
    '$card-img-overlay-padding': '1.25rem',
    '$card-margin-y-halved': '((rmUnit(], UNIT.REM) / 2) + UNIT.REM',
    '$card-margin-x-halved': '((rmUnit(], UNIT.REM) / 2) + UNIT.REM',
    '$card-columns-count-md': '2',
    '$card-columns-gap-md': '1rem',
    '$card-columns-margin-md': '$card-spacer-y',
    '$card-columns-count-lg': '2',
    '$card-columns-gap-lg': '1.15rem',
    '$card-columns-margin-lg': '$card-spacer-y',
    '$card-columns-count-xl': '2',
    '$card-columns-gap-xl': '1.25rem',
    '$card-columns-margin-xl': '$card-spacer-y',
    '$card-columns-count-xxl': '3',
    '$card-columns-gap-xxl': '1.25rem',
    '$card-columns-margin-xxl': '$card-spacer-y',
    '$card-deck-margin': '(r, detectedUnit) / 2) + detectedUni',
    '$btn-primary-bg': '$brand-primary',
    '$btn-secondary-border': '#ccc',
    '$btn-info-bg': '$brand-info',
    '$btn-success-bg': '$brand-success',
    '$btn-warning-bg': '$brand-warning',
    '$btn-danger-bg': '$brand-danger',
    '$enable-rounded': false,
    '$enable-hover-media-query': false
  },
  hover: false,
  focus: false
};
var propTypes$18 = {
  className: propTypes.string,
  tag: propTypes.any,
  theme: propTypes.shape({
    '$brand-primary': propTypes.string,
    '$brand-success': propTypes.string,
    '$brand-info': propTypes.string,
    '$brand-warning': propTypes.string,
    '$brand-danger': propTypes.string,
    '$brand-inverse': propTypes.string,
    '$card-spacer-x': propTypes.string,
    '$card-spacer-y': propTypes.string,
    '$card-border-width': propTypes.string,
    '$card-border-radius': propTypes.string,
    '$card-border-color': propTypes.string,
    '$card-border-radius-inner': propTypes.string,
    '$card-cap-bg': propTypes.string,
    '$card-bg': propTypes.string,
    '$card-link-hover-color': propTypes.string,
    '$card-img-overlay-padding': propTypes.string,
    '$card-margin-y-halved': propTypes.string,
    '$card-margin-x-halved': propTypes.string,
    '$card-columns-count-md': propTypes.string,
    '$card-columns-gap-md': propTypes.string,
    '$card-columns-margin-md': propTypes.string,
    '$card-columns-count-lg': propTypes.string,
    '$card-columns-gap-lg': propTypes.string,
    '$card-columns-margin-lg': propTypes.string,
    '$card-columns-count-xl': propTypes.string,
    '$card-columns-gap-xl': propTypes.string,
    '$card-columns-margin-xl': propTypes.string,
    '$card-columns-count-xxl': propTypes.string,
    '$card-columns-gap-xxl': propTypes.string,
    '$card-columns-margin-xxl': propTypes.string,
    '$card-deck-margin': propTypes.string,
    '$btn-primary-bg': propTypes.string,
    '$btn-secondary-border': propTypes.string,
    '$btn-info-bg': propTypes.string,
    '$btn-success-bg': propTypes.string,
    '$btn-warning-bg': propTypes.string,
    '$btn-danger-bg': propTypes.string,
    '$link-color': propTypes.string,
    '$link-decoration': propTypes.string,
    '$link-hover-color': propTypes.string,
    '$link-hover-decoration': propTypes.string,
    '$enable-rounded': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool
  }),
  color: propTypes.oneOf(['primary', 'success', 'info', 'warning', 'danger', 'white']),
  inverse: propTypes.bool,
  block: propTypes.bool,
  outline: propTypes.bool,
  width: propTypes.string,
  hover: propTypes.bool,
  focus: propTypes.bool,
  backgroundColor: propTypes.string,
  borderColor: propTypes.string,
  cssModule: propTypes.object
};
var CardUnstyled =
function (_React$Component) {
  _inherits(CardUnstyled, _React$Component);
  function CardUnstyled() {
    _classCallCheck(this, CardUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(CardUnstyled).apply(this, arguments));
  }
  _createClass(CardUnstyled, [{
    key: "render",
    value: function render() {
      var _cn;
      var _omit = lodash_omit(this.props, ['theme', 'backgroundColor', 'borderColor', 'width']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          color = _omit.color,
          block = _omit.block,
          inverse = _omit.inverse,
          outline = _omit.outline,
          Tag = _omit.tag,
          hover = _omit.hover,
          focus = _omit.focus,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "color", "block", "inverse", "outline", "tag", "hover", "focus"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'card', (_cn = {
          hover: hover,
          focus: focus,
          inverse: inverse,
          'card-block': block
        }, _defineProperty(_cn, "card-".concat(color), color), _defineProperty(_cn, "card-".concat(outline ? '-outline' : '', "-").concat(color), outline), _cn)), cssModule)
      }, attributes));
    }
  }]);
  return CardUnstyled;
}(React.Component);
_defineProperty(CardUnstyled, "propTypes", propTypes$18);
_defineProperty(CardUnstyled, "defaultProps", defaultProps$10);
var Card = styled(CardUnstyled).withConfig({
  displayName: "Card",
  componentId: "sc-18qyd5o-0"
})(["", ""], function (props) {
  return "\n    \n    /*\n    Base styles\n    */\n    &.card {\n      position: relative;\n      display: flex;\n      flex-direction: column;\n      background-color: ".concat(props.theme['$card-bg'], ";\n      border: ").concat(props.theme['$card-border-width'], " solid ").concat(props.theme['$card-border-color'], ";\n      ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$card-border-radius']), "\n      \n      ").concat(conditional_1(props.width, "width: ".concat(props.width, ";")), "\n      ").concat(conditional_1(props.backgroundColor, "background-color: ".concat(props.backgroundColor, ";")), "\n      ").concat(conditional_1(props.borderColor, "border-color: ".concat(props.borderColor, ";")), "\n    }\n    \n    &.card-block,\n    & .card-block {\n      flex: 1 1 auto;\n      padding: ").concat(props.theme['$card-spacer-x'], ";\n    }\n    \n    & .card-title {\n      margin-bottom: ").concat(props.theme['$card-spacer-y'], ";\n    }\n    \n    & .card-subtitle {\n      margin-top: -").concat(props.theme['$card-margin-y-halved'], ";\n      margin-bottom: 0;\n    }\n    \n    & .card-text:last-child {\n      margin-bottom: 0;\n    }\n   \n    & .card-link {\n      ").concat(hover_2('text-decoration: none;'), "\n    \n      + .card-link {\n        margin-left: ").concat(props.theme['$card-spacer-x'], ";\n      }\n    }\n    \n    &.card {\n      > .list-group:first-child {\n        .list-group-item:first-child {\n          ").concat(borderRadius_3(props.theme['$enable-rounded'], props.theme['$card-border-radius']), "\n        }\n      }\n    \n      > .list-group:last-child {\n        .list-group-item:last-child {\n          ").concat(borderRadius_5(props.theme['$enable-rounded'], props.theme['$card-border-radius']), "\n        }\n      }\n    }\n    \n    \n    /*\n     Optional textual caps\n    */\n    \n    & .card-header {\n      padding: ").concat(props.theme['$card-spacer-y'], " ").concat(props.theme['$card-spacer-x'], ";\n      margin-bottom: 0; /* Removes the default margin-bottom of <hN> */\n      background-color: ").concat(props.theme['$card-cap-bg'], ";\n      border-bottom: ").concat(props.theme['$card-border-width'], " solid ").concat(props.theme['$card-border-color'], ";\n    \n      &:first-child {\n        ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$card-border-radius-inner'], props.theme['$card-border-radius-inner'], '0', '0'), "\n      }\n    }\n    \n    & .card-footer {\n      padding: ").concat(props.theme['$card-spacer-y'], " ").concat(props.theme['$card-spacer-x'], ";\n      background-color: ").concat(props.theme['$card-cap-bg'], ";\n      border-top: ").concat(props.theme['$card-border-width'], " solid ").concat(props.theme['$card-border-color'], ";\n    \n      &:last-child {\n        ").concat(borderRadius_2(props.theme['$enable-rounded'], '0', '0', props.theme['$card-border-radius-inner'], props.theme['$card-border-radius-inner']), "\n      }\n    }\n    \n    \n    /*\n     Header navs\n    */\n    \n    & .card-header-tabs {\n      margin-right: -").concat(props.theme['$card-margin-x-halved'], ";\n      margin-bottom: -").concat(props.theme['$card-spacer-y'], ";\n      margin-left: -").concat(props.theme['$card-margin-x-halved'], ";\n      border-bottom: 0;\n    }\n    \n    & .card-header-pills {\n      margin-right: -").concat(props.theme['$card-margin-x-halved'], ";\n      margin-left: -").concat(props.theme['$card-margin-x-halved'], ";\n    }\n    \n    \n    /*\n     Background variations\n    */\n    \n    &.card-primary {\n      ").concat(cards_1(props.theme['$brand-primary'], props.theme['$brand-primary']), "\n    }\n    &.card-success {\n      ").concat(cards_1(props.theme['$brand-success'], props.theme['$brand-success']), "\n    }\n    &.card-info {\n      ").concat(cards_1(props.theme['$brand-info'], props.theme['$brand-info']), "\n    }\n    &.card-warning {\n      ").concat(cards_1(props.theme['$brand-warning'], props.theme['$brand-warning']), "\n    }\n    &.card-danger {\n      ").concat(cards_1(props.theme['$brand-danger'], props.theme['$brand-danger']), "\n    }\n    \n    /* Remove all backgrounds */\n    &.card-outline-primary {\n      ").concat(cards_2(props.theme['$btn-primary-bg']), "\n    }\n    &.card-outline-secondary {\n      ").concat(cards_2(props.theme['$btn-secondary-border']), "\n    }\n    &.card-outline-info {\n      ").concat(cards_2(props.theme['$btn-info-bg']), "\n    }\n    &.card-outline-success {\n      ").concat(cards_2(props.theme['$btn-success-bg']), "\n    }\n    &.card-outline-warning {\n      ").concat(cards_2(props.theme['$btn-warning-bg']), "\n    }\n    &.card-outline-danger {\n      ").concat(cards_2(props.theme['$btn-danger-bg']), "\n    }\n    \n    /*\n     Inverse text within a card for use with dark backgrounds\n    */\n    \n    &.card-inverse {\n      ").concat(cards_3(props.theme['$enable-hover-media-query'], props.theme['$card-link-hover-color']), "\n    }\n    \n    /*\n     Blockquote\n    */\n    \n    & .card-blockquote {\n      padding: 0;\n      margin-bottom: 0;\n      border-left: 0;\n    }\n    \n    /* Card image */\n    & .card-img {\n      ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$card-border-radius-inner']), "\n    }\n    \n    & .card-img-overlay {\n      position: absolute;\n      top: 0;\n      right: 0;\n      bottom: 0;\n      left: 0;\n      padding: ").concat(props.theme['$card-img-overlay-padding'], ";\n    }\n    \n    \n    \n    /* Card image caps */\n    & .card-img-top {\n      ").concat(borderRadius_3(props.theme['$enable-rounded'], props.theme['$card-border-radius-inner']), "\n    }\n    \n    & .card-img-bottom {\n      ").concat(borderRadius_5(props.theme['$enable-rounded'], props.theme['$card-border-radius-inner']), "\n    }\n  ");
});
Card.defaultProps = defaultProps$10;
Card.propTypes = propTypes$18;

var defaultProps$11 = {
  tag: 'div',
  theme: {
    '$brand-primary': '#0275d8',
    '$brand-success': '#5cb85c',
    '$brand-info': '#5bc0de',
    '$brand-warning': '#f0ad4e',
    '$brand-danger': '#d9534f',
    '$brand-inverse': '#292b2c',
    '$card-spacer-x': '1.25rem',
    '$card-spacer-y': '.75rem',
    '$card-border-width': '1px',
    '$card-border-radius': '.25rem',
    '$card-border-color': 'rgba(0, 0, 0, 0.125)',
    '$card-border-radius-inner': '',
    '$card-cap-bg': '$gray-lightest',
    '$card-bg': '$white',
    '$card-link-hover-color': '$white',
    '$card-img-overlay-padding': '1.25rem',
    '$card-columns-count-md': '2',
    '$card-columns-gap-md': '1rem',
    '$card-columns-margin-md': '$card-spacer-y',
    '$card-columns-count-lg': '2',
    '$card-columns-gap-lg': '1.15rem',
    '$card-columns-margin-lg': '$card-spacer-y',
    '$card-columns-count-xl': '2',
    '$card-columns-gap-xl': '1.25rem',
    '$card-columns-margin-xl': '$card-spacer-y',
    '$card-columns-count-xxl': '3',
    '$card-columns-gap-xxl': '1.25rem',
    '$card-columns-margin-xxl': '$card-spacer-y',
    '$card-deck-margin': '(r, detectedUnit) / 2) + detectedUni',
    '$btn-primary-bg': '$brand-primary',
    '$btn-secondary-border': '#ccc',
    '$btn-info-bg': '$brand-info',
    '$btn-success-bg': '$brand-success',
    '$btn-warning-bg': '$brand-warning',
    '$btn-danger-bg': '$brand-danger',
    '$enable-rounded': false,
    '$enable-hover-media-query': false
  }
};
var propTypes$19 = {
  className: propTypes.string,
  tag: propTypes.any,
  theme: propTypes.shape({
    '$brand-primary': propTypes.string,
    '$brand-success': propTypes.string,
    '$brand-info': propTypes.string,
    '$brand-warning': propTypes.string,
    '$brand-danger': propTypes.string,
    '$brand-inverse': propTypes.string,
    '$card-spacer-x': propTypes.string,
    '$card-spacer-y': propTypes.string,
    '$card-border-width': propTypes.string,
    '$card-border-radius': propTypes.string,
    '$card-border-color': propTypes.string,
    '$card-border-radius-inner': propTypes.string,
    '$card-cap-bg': propTypes.string,
    '$card-bg': propTypes.string,
    '$card-link-hover-color': propTypes.string,
    '$card-img-overlay-padding': propTypes.string,
    '$card-columns-count-md': propTypes.string,
    '$card-columns-gap-md': propTypes.string,
    '$card-columns-margin-md': propTypes.string,
    '$card-columns-count-lg': propTypes.string,
    '$card-columns-gap-lg': propTypes.string,
    '$card-columns-margin-lg': propTypes.string,
    '$card-columns-count-xl': propTypes.string,
    '$card-columns-gap-xl': propTypes.string,
    '$card-columns-margin-xl': propTypes.string,
    '$card-columns-count-xxl': propTypes.string,
    '$card-columns-gap-xxl': propTypes.string,
    '$card-columns-margin-xxl': propTypes.string,
    '$card-deck-margin': propTypes.string,
    '$btn-primary-bg': propTypes.string,
    '$btn-secondary-border': propTypes.string,
    '$btn-info-bg': propTypes.string,
    '$btn-success-bg': propTypes.string,
    '$btn-warning-bg': propTypes.string,
    '$btn-danger-bg': propTypes.string,
    '$link-color': propTypes.string,
    '$link-decoration': propTypes.string,
    '$link-hover-color': propTypes.string,
    '$link-hover-decoration': propTypes.string,
    '$enable-rounded': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool
  }),
  cssModule: propTypes.object
};
var CardColumnsUnstyled =
function (_React$Component) {
  _inherits(CardColumnsUnstyled, _React$Component);
  function CardColumnsUnstyled() {
    _classCallCheck(this, CardColumnsUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(CardColumnsUnstyled).apply(this, arguments));
  }
  _createClass(CardColumnsUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          Tag = _omit.tag,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "tag"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'card-columns'), cssModule)
      }, attributes));
    }
  }]);
  return CardColumnsUnstyled;
}(React.Component);
_defineProperty(CardColumnsUnstyled, "propTypes", propTypes$19);
_defineProperty(CardColumnsUnstyled, "defaultProps", defaultProps$11);
var CardColumns = styled(CardColumnsUnstyled).withConfig({
  displayName: "CardColumns",
  componentId: "r9oeh9-0"
})(["", ""], function (props) {
  return "\n    ".concat(cards_4(props.theme['$enable-rounded'], props.theme['$enable-hover-media-query'], props.theme['$card-spacer-y'], props.theme['$card-spacer-x'], props.theme['$card-bg'], props.theme['$card-border-width'], props.theme['$card-border-color'], props.theme['$card-border-radius'], props.theme['$card-cap-bg'], props.theme['$card-border-radius-inner'], props.theme['$brand-primary'], props.theme['$brand-success'], props.theme['$brand-info'], props.theme['$brand-warning'], props.theme['$brand-danger'], props.theme['$btn-primary-bg'], props.theme['$btn-secondary-border'], props.theme['$btn-info-bg'], props.theme['$btn-success-bg'], props.theme['$btn-warning-bg'], props.theme['$btn-danger-bg'], props.theme['$card-link-hover-color'], props.theme['$card-img-overlay-padding'], props.theme['$card-inverse-bg-color'], props.theme['$card-inverse-border-color']), "\n    ").concat(breakpoints_5('md', props.theme['$grid-breakpoints'], "\n        &.card-columns {\n          column-count: ".concat(props.theme['$card-columns-count-md'], ";\n          column-gap: ").concat(props.theme['$card-columns-gap-md'], ";\n      \n          .card {\n            display: inline-block; /* Don't let them vertically span multiple columns */\n            width: 100%; /* Don't let them exceed the column width */\n            margin-bottom: ").concat(props.theme['$card-columns-margin-md'], ";\n          }\n        }\n      ")), "\n    ").concat(breakpoints_5('lg', props.theme['$grid-breakpoints'], "\n        &.card-columns {\n          column-count: ".concat(props.theme['$card-columns-count-lg'], ";\n          column-gap: ").concat(props.theme['$card-columns-gap-lg'], ";\n      \n          .card {\n            display: inline-block; /* Don't let them vertically span multiple columns */\n            width: 100%; /* Don't let them exceed the column width */\n            margin-bottom: ").concat(props.theme['$card-columns-margin-lg'], ";\n          }\n        }\n      ")), "\n    ").concat(breakpoints_5('xl', props.theme['$grid-breakpoints'], "\n        &.card-columns {\n          column-count: ".concat(props.theme['$card-columns-count-xl'], ";\n          column-gap: ").concat(props.theme['$card-columns-gap-xl'], ";\n      \n          .card {\n            display: inline-block; /* Don't let them vertically span multiple columns */\n            width: 100%; /* Don't let them exceed the column width */\n            margin-bottom: ").concat(props.theme['$card-columns-margin-xl'], ";\n          }\n        }\n      ")), "\n    ").concat(breakpoints_5('xxl', props.theme['$grid-breakpoints'], "\n        &.card-columns {\n          column-count: ".concat(props.theme['$card-columns-count-xxl'], ";\n          column-gap: ").concat(props.theme['$card-columns-gap-xxl'], ";\n      \n          .card {\n            display: inline-block; /* Don't let them vertically span multiple columns */\n            width: 100%; /* Don't let them exceed the column width */\n            margin-bottom: ").concat(props.theme['$card-columns-margin-xxl'], ";\n          }\n        }\n      ")), "\n  ");
});
CardColumns.defaultProps = defaultProps$11;
CardColumns.propTypes = propTypes$19;

var defaultProps$12 = {
  tag: 'div',
  theme: {
    '$brand-primary': '#0275d8',
    '$brand-success': '#5cb85c',
    '$brand-info': '#5bc0de',
    '$brand-warning': '#f0ad4e',
    '$brand-danger': '#d9534f',
    '$brand-inverse': '#292b2c',
    '$card-spacer-x': '1.25rem',
    '$card-spacer-y': '.75rem',
    '$card-border-width': '1px',
    '$card-border-radius': '.25rem',
    '$card-border-color': 'rgba(0, 0, 0, 0.125)',
    '$card-border-radius-inner': '',
    '$card-cap-bg': '$gray-lightest',
    '$card-bg': '$white',
    '$card-link-hover-color': '$white',
    '$card-img-overlay-padding': '1.25rem',
    '$card-columns-count-md': '2',
    '$card-columns-gap-md': '1rem',
    '$card-columns-margin-md': '$card-spacer-y',
    '$card-columns-count-lg': '2',
    '$card-columns-gap-lg': '1.15rem',
    '$card-columns-margin-lg': '$card-spacer-y',
    '$card-columns-count-xl': '2',
    '$card-columns-gap-xl': '1.25rem',
    '$card-columns-margin-xl': '$card-spacer-y',
    '$card-columns-count-xxl': '3',
    '$card-columns-gap-xxl': '1.25rem',
    '$card-columns-margin-xxl': '$card-spacer-y',
    '$card-deck-margin': '(r, detectedUnit) / 2) + detectedUni',
    '$btn-primary-bg': '$brand-primary',
    '$btn-secondary-border': '#ccc',
    '$btn-info-bg': '$brand-info',
    '$btn-success-bg': '$brand-success',
    '$btn-warning-bg': '$brand-warning',
    '$btn-danger-bg': '$brand-danger',
    '$enable-rounded': false,
    '$enable-hover-media-query': false
  }
};
var propTypes$1a = {
  className: propTypes.string,
  tag: propTypes.any,
  theme: propTypes.shape({
    '$brand-primary': propTypes.string,
    '$brand-success': propTypes.string,
    '$brand-info': propTypes.string,
    '$brand-warning': propTypes.string,
    '$brand-danger': propTypes.string,
    '$brand-inverse': propTypes.string,
    '$card-spacer-x': propTypes.string,
    '$card-spacer-y': propTypes.string,
    '$card-border-width': propTypes.string,
    '$card-border-radius': propTypes.string,
    '$card-border-color': propTypes.string,
    '$card-border-radius-inner': propTypes.string,
    '$card-cap-bg': propTypes.string,
    '$card-bg': propTypes.string,
    '$card-link-hover-color': propTypes.string,
    '$card-img-overlay-padding': propTypes.string,
    '$card-columns-count-md': propTypes.string,
    '$card-columns-gap-md': propTypes.string,
    '$card-columns-margin-md': propTypes.string,
    '$card-columns-count-lg': propTypes.string,
    '$card-columns-gap-lg': propTypes.string,
    '$card-columns-margin-lg': propTypes.string,
    '$card-columns-count-xl': propTypes.string,
    '$card-columns-gap-xl': propTypes.string,
    '$card-columns-margin-xl': propTypes.string,
    '$card-columns-count-xxl': propTypes.string,
    '$card-columns-gap-xxl': propTypes.string,
    '$card-columns-margin-xxl': propTypes.string,
    '$card-deck-margin': propTypes.string,
    '$btn-primary-bg': propTypes.string,
    '$btn-secondary-border': propTypes.string,
    '$btn-info-bg': propTypes.string,
    '$btn-success-bg': propTypes.string,
    '$btn-warning-bg': propTypes.string,
    '$btn-danger-bg': propTypes.string,
    '$link-color': propTypes.string,
    '$link-decoration': propTypes.string,
    '$link-hover-color': propTypes.string,
    '$link-hover-decoration': propTypes.string,
    '$enable-rounded': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool
  }),
  cssModule: propTypes.object
};
var CardDeckUnstyled =
function (_React$Component) {
  _inherits(CardDeckUnstyled, _React$Component);
  function CardDeckUnstyled() {
    _classCallCheck(this, CardDeckUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(CardDeckUnstyled).apply(this, arguments));
  }
  _createClass(CardDeckUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          Tag = _omit.tag,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "tag"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'card-deck'), cssModule)
      }, attributes));
    }
  }]);
  return CardDeckUnstyled;
}(React.Component);
_defineProperty(CardDeckUnstyled, "propTypes", propTypes$1a);
_defineProperty(CardDeckUnstyled, "defaultProps", defaultProps$12);
var CardDeck = styled(CardDeckUnstyled).withConfig({
  displayName: "CardDeck",
  componentId: "hiovo2-0"
})(["", ""], function (props) {
  return "\n    ".concat(cards_4(props.theme['$enable-rounded'], props.theme['$enable-hover-media-query'], props.theme['$card-spacer-y'], props.theme['$card-spacer-x'], props.theme['$card-bg'], props.theme['$card-border-width'], props.theme['$card-border-color'], props.theme['$card-border-radius'], props.theme['$card-cap-bg'], props.theme['$card-border-radius-inner'], props.theme['$brand-primary'], props.theme['$brand-success'], props.theme['$brand-info'], props.theme['$brand-warning'], props.theme['$brand-danger'], props.theme['$btn-primary-bg'], props.theme['$btn-secondary-border'], props.theme['$btn-info-bg'], props.theme['$btn-success-bg'], props.theme['$btn-warning-bg'], props.theme['$btn-danger-bg'], props.theme['$card-link-hover-color'], props.theme['$card-img-overlay-padding'], props.theme['$card-inverse-bg-color'], props.theme['$card-inverse-border-color']), "\n    ").concat(breakpoints_5('sm', props.theme['$grid-breakpoints'], "\n        &.card-deck {\n          display: flex;\n          flex-flow: row wrap;\n        \n          .card {\n            display: flex;\n            flex: 1 0 0;\n            flex-direction: column;  \n            &:not(:first-child) { margin-left: ".concat(props.theme['$card-deck-margin'], "; }\n            &:not(:last-child) { margin-right: ").concat(props.theme['$card-deck-margin'], "; }\n          }\n        }\n      ")), "\n  ");
});
CardDeck.defaultProps = defaultProps$12;
CardDeck.propTypes = propTypes$1a;

var defaultProps$13 = {
  tag: 'div',
  theme: {
    '$brand-primary': '#0275d8',
    '$brand-success': '#5cb85c',
    '$brand-info': '#5bc0de',
    '$brand-warning': '#f0ad4e',
    '$brand-danger': '#d9534f',
    '$brand-inverse': '#292b2c',
    '$card-spacer-x': '1.25rem',
    '$card-spacer-y': '.75rem',
    '$card-border-width': '1px',
    '$card-border-radius': '.25rem',
    '$card-border-color': 'rgba(0, 0, 0, 0.125)',
    '$card-border-radius-inner': '',
    '$card-cap-bg': '$gray-lightest',
    '$card-bg': '$white',
    '$card-link-hover-color': '$white',
    '$card-img-overlay-padding': '1.25rem',
    '$card-columns-count-md': '2',
    '$card-columns-gap-md': '1rem',
    '$card-columns-margin-md': '$card-spacer-y',
    '$card-columns-count-lg': '2',
    '$card-columns-gap-lg': '1.15rem',
    '$card-columns-margin-lg': '$card-spacer-y',
    '$card-columns-count-xl': '2',
    '$card-columns-gap-xl': '1.25rem',
    '$card-columns-margin-xl': '$card-spacer-y',
    '$card-columns-count-xxl': '3',
    '$card-columns-gap-xxl': '1.25rem',
    '$card-columns-margin-xxl': '$card-spacer-y',
    '$card-deck-margin': '(r, detectedUnit) / 2) + detectedUni',
    '$btn-primary-bg': '$brand-primary',
    '$btn-secondary-border': '#ccc',
    '$btn-info-bg': '$brand-info',
    '$btn-success-bg': '$brand-success',
    '$btn-warning-bg': '$brand-warning',
    '$btn-danger-bg': '$brand-danger',
    '$enable-rounded': false,
    '$enable-hover-media-query': false
  }
};
var propTypes$1b = {
  className: propTypes.string,
  tag: propTypes.any,
  theme: propTypes.shape({
    '$brand-primary': propTypes.string,
    '$brand-success': propTypes.string,
    '$brand-info': propTypes.string,
    '$brand-warning': propTypes.string,
    '$brand-danger': propTypes.string,
    '$brand-inverse': propTypes.string,
    '$card-spacer-x': propTypes.string,
    '$card-spacer-y': propTypes.string,
    '$card-border-width': propTypes.string,
    '$card-border-radius': propTypes.string,
    '$card-border-color': propTypes.string,
    '$card-border-radius-inner': propTypes.string,
    '$card-cap-bg': propTypes.string,
    '$card-bg': propTypes.string,
    '$card-link-hover-color': propTypes.string,
    '$card-img-overlay-padding': propTypes.string,
    '$card-columns-count-md': propTypes.string,
    '$card-columns-gap-md': propTypes.string,
    '$card-columns-margin-md': propTypes.string,
    '$card-columns-count-lg': propTypes.string,
    '$card-columns-gap-lg': propTypes.string,
    '$card-columns-margin-lg': propTypes.string,
    '$card-columns-count-xl': propTypes.string,
    '$card-columns-gap-xl': propTypes.string,
    '$card-columns-margin-xl': propTypes.string,
    '$card-columns-count-xxl': propTypes.string,
    '$card-columns-gap-xxl': propTypes.string,
    '$card-columns-margin-xxl': propTypes.string,
    '$card-deck-margin': propTypes.string,
    '$btn-primary-bg': propTypes.string,
    '$btn-secondary-border': propTypes.string,
    '$btn-info-bg': propTypes.string,
    '$btn-success-bg': propTypes.string,
    '$btn-warning-bg': propTypes.string,
    '$btn-danger-bg': propTypes.string,
    '$link-color': propTypes.string,
    '$link-decoration': propTypes.string,
    '$link-hover-color': propTypes.string,
    '$link-hover-decoration': propTypes.string,
    '$enable-rounded': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool
  }),
  cssModule: propTypes.object
};
var CardGroupUnstyled =
function (_React$Component) {
  _inherits(CardGroupUnstyled, _React$Component);
  function CardGroupUnstyled() {
    _classCallCheck(this, CardGroupUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(CardGroupUnstyled).apply(this, arguments));
  }
  _createClass(CardGroupUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          Tag = _omit.tag,
          attributes = _objectWithoutProperties(_omit, ["className", "cssModule", "tag"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'card-group'), cssModule)
      }, attributes));
    }
  }]);
  return CardGroupUnstyled;
}(React.Component);
_defineProperty(CardGroupUnstyled, "propTypes", propTypes$1b);
_defineProperty(CardGroupUnstyled, "defaultProps", defaultProps$13);
var CardGroup = styled(CardGroupUnstyled).withConfig({
  displayName: "CardGroup",
  componentId: "ht96b6-0"
})(["", ""], function (props) {
  return "\n    ".concat(cards_4(props.theme['$enable-rounded'], props.theme['$enable-hover-media-query'], props.theme['$card-spacer-y'], props.theme['$card-spacer-x'], props.theme['$card-bg'], props.theme['$card-border-width'], props.theme['$card-border-color'], props.theme['$card-border-radius'], props.theme['$card-cap-bg'], props.theme['$card-border-radius-inner'], props.theme['$brand-primary'], props.theme['$brand-success'], props.theme['$brand-info'], props.theme['$brand-warning'], props.theme['$brand-danger'], props.theme['$btn-primary-bg'], props.theme['$btn-secondary-border'], props.theme['$btn-info-bg'], props.theme['$btn-success-bg'], props.theme['$btn-warning-bg'], props.theme['$btn-danger-bg'], props.theme['$card-link-hover-color'], props.theme['$card-img-overlay-padding'], props.theme['$card-inverse-bg-color'], props.theme['$card-inverse-border-color']), "\n    /*\n      Card group\n    */\n      ").concat(breakpoints_5('sm', props.theme['$grid-breakpoints'], "\n          &.card-group {\n            display: flex;\n            flex-flow: row wrap;\n        \n            .card {\n              flex: 1 0 0;\n        \n              + .card {\n                margin-left: 0;\n                border-left: 0;\n              }\n        \n            ".concat(conditional_1(props.theme['$enable-rounded'], "\n                &:first-child {\n                  ".concat(borderRadius_4(props.theme['$enable-rounded'], '0'), "\n                  .card-img-top {\n                    border-top-right-radius: 0;\n                  }\n                  \n                  .card-img-bottom {\n                    border-bottom-right-radius: 0;\n                  }\n                }\n              \n                &:last-child {\n                  ").concat(borderRadius_6(props.theme['$enable-rounded'], '0'), "\n                  \n                  .card-img-top {\n                    border-top-left-radius: 0;\n                  }\n                  \n                  .card-img-bottom {\n                    border-bottom-left-radius: 0;\n                  }\n                }\n                \n                &:not(:first-child):not(:last-child) {\n                  border-radius: 0;\n        \n                  .card-img-top,\n                  .card-img-bottom {\n                    border-radius: 0;\n                  }\n                }\n              ")), "  \n          }\n        }\n      ")), "\n  ");
});
CardGroup.defaultProps = defaultProps$13;
CardGroup.propTypes = propTypes$1b;

var defaultProps$14 = {
  tag: 'div'
};
var propTypes$1c = {
  className: propTypes.string,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var CardBlock =
function (_React$Component) {
  _inherits(CardBlock, _React$Component);
  function CardBlock() {
    _classCallCheck(this, CardBlock);
    return _possibleConstructorReturn(this, _getPrototypeOf(CardBlock).apply(this, arguments));
  }
  _createClass(CardBlock, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "tag"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'card-block'), cssModule)
      }, attributes));
    }
  }]);
  return CardBlock;
}(React.Component);
_defineProperty(CardBlock, "propTypes", propTypes$1c);
_defineProperty(CardBlock, "defaultProps", defaultProps$14);
CardBlock.defaultProps = defaultProps$14;
CardBlock.propTypes = propTypes$1c;

var defaultProps$15 = {
  tag: 'div'
};
var propTypes$1d = {
  className: propTypes.string,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var CardFooter =
function (_React$Component) {
  _inherits(CardFooter, _React$Component);
  function CardFooter() {
    _classCallCheck(this, CardFooter);
    return _possibleConstructorReturn(this, _getPrototypeOf(CardFooter).apply(this, arguments));
  }
  _createClass(CardFooter, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "tag"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'card-footer'), cssModule)
      }, attributes));
    }
  }]);
  return CardFooter;
}(React.Component);
_defineProperty(CardFooter, "propTypes", propTypes$1d);
_defineProperty(CardFooter, "defaultProps", defaultProps$15);
CardFooter.defaultProps = defaultProps$15;
CardFooter.propTypes = propTypes$1d;

var defaultProps$16 = {
  tag: 'div'
};
var propTypes$1e = {
  className: propTypes.string,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var CardHeader =
function (_React$Component) {
  _inherits(CardHeader, _React$Component);
  function CardHeader() {
    _classCallCheck(this, CardHeader);
    return _possibleConstructorReturn(this, _getPrototypeOf(CardHeader).apply(this, arguments));
  }
  _createClass(CardHeader, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "tag"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'card-header'), cssModule)
      }, attributes));
    }
  }]);
  return CardHeader;
}(React.Component);
_defineProperty(CardHeader, "propTypes", propTypes$1e);
_defineProperty(CardHeader, "defaultProps", defaultProps$16);
CardHeader.defaultProps = defaultProps$16;
CardHeader.propTypes = propTypes$1e;

var defaultProps$17 = {
  tag: 'img'
};
var propTypes$1f = {
  className: propTypes.string,
  tag: propTypes.any,
  top: propTypes.bool,
  bottom: propTypes.bool,
  cssModule: propTypes.object
};
var CardImg =
function (_React$Component) {
  _inherits(CardImg, _React$Component);
  function CardImg() {
    _classCallCheck(this, CardImg);
    return _possibleConstructorReturn(this, _getPrototypeOf(CardImg).apply(this, arguments));
  }
  _createClass(CardImg, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          Tag = _this$props.tag,
          top = _this$props.top,
          bottom = _this$props.bottom,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "tag", "top", "bottom"]);
      var cardImgClassName = 'card-img';
      if (top) {
        cardImgClassName = 'card-img-top';
      } else if (bottom) {
        cardImgClassName = 'card-img-bottom';
      }
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, cardImgClassName), cssModule)
      }, attributes));
    }
  }]);
  return CardImg;
}(React.Component);
_defineProperty(CardImg, "propTypes", propTypes$1f);
_defineProperty(CardImg, "defaultProps", defaultProps$17);
CardImg.defaultProps = defaultProps$17;
CardImg.propTypes = propTypes$1f;

var defaultProps$18 = {
  tag: 'div'
};
var propTypes$1g = {
  className: propTypes.string,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var CardImgOverlay =
function (_React$Component) {
  _inherits(CardImgOverlay, _React$Component);
  function CardImgOverlay() {
    _classCallCheck(this, CardImgOverlay);
    return _possibleConstructorReturn(this, _getPrototypeOf(CardImgOverlay).apply(this, arguments));
  }
  _createClass(CardImgOverlay, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "tag"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'card-img-overlay'), cssModule)
      }, attributes));
    }
  }]);
  return CardImgOverlay;
}(React.Component);
_defineProperty(CardImgOverlay, "propTypes", propTypes$1g);
_defineProperty(CardImgOverlay, "defaultProps", defaultProps$18);
CardImgOverlay.defaultProps = defaultProps$18;
CardImgOverlay.propTypes = propTypes$1g;

var defaultProps$19 = {
  tag: A
};
var propTypes$1h = {
  className: propTypes.string,
  tag: propTypes.any,
  ref: propTypes.func,
  cssModule: propTypes.object
};
var CardLink =
function (_React$Component) {
  _inherits(CardLink, _React$Component);
  function CardLink() {
    _classCallCheck(this, CardLink);
    return _possibleConstructorReturn(this, _getPrototypeOf(CardLink).apply(this, arguments));
  }
  _createClass(CardLink, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          Tag = _this$props.tag,
          ref = _this$props.ref,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "tag", "ref"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'card-link'), cssModule),
        ref: ref
      }, attributes));
    }
  }]);
  return CardLink;
}(React.Component);
_defineProperty(CardLink, "propTypes", propTypes$1h);
_defineProperty(CardLink, "defaultProps", defaultProps$19);
CardLink.defaultProps = defaultProps$19;
CardLink.propTypes = propTypes$1h;

var defaultProps$1a = {
  tag: H6
};
var propTypes$1i = {
  className: propTypes.string,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var CardSubtitle =
function (_React$Component) {
  _inherits(CardSubtitle, _React$Component);
  function CardSubtitle() {
    _classCallCheck(this, CardSubtitle);
    return _possibleConstructorReturn(this, _getPrototypeOf(CardSubtitle).apply(this, arguments));
  }
  _createClass(CardSubtitle, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "tag"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'card-subtitle'), cssModule)
      }, attributes));
    }
  }]);
  return CardSubtitle;
}(React.Component);
_defineProperty(CardSubtitle, "propTypes", propTypes$1i);
_defineProperty(CardSubtitle, "defaultProps", defaultProps$1a);
CardSubtitle.defaultProps = defaultProps$1a;
CardSubtitle.propTypes = propTypes$1i;

var defaultProps$1b = {
  tag: 'p'
};
var propTypes$1j = {
  className: propTypes.string,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var CardText =
function (_React$Component) {
  _inherits(CardText, _React$Component);
  function CardText() {
    _classCallCheck(this, CardText);
    return _possibleConstructorReturn(this, _getPrototypeOf(CardText).apply(this, arguments));
  }
  _createClass(CardText, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "tag"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'card-text'), cssModule)
      }, attributes));
    }
  }]);
  return CardText;
}(React.Component);
_defineProperty(CardText, "propTypes", propTypes$1j);
_defineProperty(CardText, "defaultProps", defaultProps$1b);
CardText.defaultProps = defaultProps$1b;
CardText.propTypes = propTypes$1j;

var defaultProps$1c = {
  tag: H4
};
var propTypes$1k = {
  className: propTypes.string,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var CardTitle =
function (_React$Component) {
  _inherits(CardTitle, _React$Component);
  function CardTitle() {
    _classCallCheck(this, CardTitle);
    return _possibleConstructorReturn(this, _getPrototypeOf(CardTitle).apply(this, arguments));
  }
  _createClass(CardTitle, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "tag"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'card-title'), cssModule)
      }, attributes));
    }
  }]);
  return CardTitle;
}(React.Component);
_defineProperty(CardTitle, "propTypes", propTypes$1k);
_defineProperty(CardTitle, "defaultProps", defaultProps$1c);
CardTitle.defaultProps = defaultProps$1c;
CardTitle.propTypes = propTypes$1k;

var defaultProps$1d = {
  tag: Blockquote
};
var propTypes$1l = {
  className: propTypes.string,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var CardBlockquote =
function (_React$Component) {
  _inherits(CardBlockquote, _React$Component);
  function CardBlockquote() {
    _classCallCheck(this, CardBlockquote);
    return _possibleConstructorReturn(this, _getPrototypeOf(CardBlockquote).apply(this, arguments));
  }
  _createClass(CardBlockquote, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "tag"]);
      return React.createElement(Tag, _extends({
        className: mapToCssModules(classnames(className, 'card-blockquote'), cssModule)
      }, attributes));
    }
  }]);
  return CardBlockquote;
}(React.Component);
_defineProperty(CardBlockquote, "propTypes", propTypes$1l);
_defineProperty(CardBlockquote, "defaultProps", defaultProps$1d);
CardBlockquote.defaultProps = defaultProps$1d;
CardBlockquote.propTypes = propTypes$1l;

var defaultProps$1e = {
  tag: Card,
  delay: 350
};
var propTypes$1m = {
  className: propTypes.string,
  children: propTypes.node,
  tag: propTypes.any,
  delay: propTypes.oneOfType([propTypes.shape({
    show: propTypes.number,
    hide: propTypes.number
  }), propTypes.number]),
  heading: propTypes.oneOfType([propTypes.node, propTypes.string]),
  name: propTypes.string
};
var Accordion =
function (_React$Component) {
  _inherits(Accordion, _React$Component);
  function Accordion() {
    _classCallCheck(this, Accordion);
    return _possibleConstructorReturn(this, _getPrototypeOf(Accordion).apply(this, arguments));
  }
  _createClass(Accordion, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          name = _this$props.name,
          children = _this$props.children,
          heading = _this$props.heading,
          Tag = _this$props.tag,
          delay = _this$props.delay,
          attributes = _objectWithoutProperties(_this$props, ["className", "name", "children", "heading", "tag", "delay"]);
      var _this$context$accordi = this.context.accordionGroup,
          activeAccordionName = _this$context$accordi.activeAccordionName,
          onClick = _this$context$accordi.onClick,
          HeadingComponent = _this$context$accordi['heading-component'];
      var optional = {
        isOpened: false
      };
      if (typeof onClick === 'function') {
        optional.onClick = function () {
          return onClick(name);
        };
      }
      if (activeAccordionName === name) {
        optional.isOpened = true;
      }
      var accordionHeading = HeadingComponent ? React.createElement(HeadingComponent, {
        onClick: optional.onClick
      }, heading)
      : React.createElement(CardHeader, {
        onClick: optional.onClick
      }, React.createElement(H5, null, heading))
      ;
      return React.createElement(Tag, _extends({
        className: className
      }, attributes), accordionHeading, React.createElement(Collapse, {
        delay: delay,
        isOpen: optional.isOpened
      }, children));
    }
  }]);
  return Accordion;
}(React.Component);
_defineProperty(Accordion, "propTypes", propTypes$1m);
_defineProperty(Accordion, "contextTypes", {
  accordionGroup: propTypes.object
});
_defineProperty(Accordion, "defaultProps", defaultProps$1e);
Accordion.defaultProps = defaultProps$1e;
Accordion.propTypes = propTypes$1m;

var propTypes$1n = {
  activeAccordionName: propTypes.oneOfType([propTypes.string, propTypes.number, propTypes.bool]),
  onChange: propTypes.func,
  'heading-component': propTypes.bool
};
var AccordionGroup =
function (_React$Component) {
  _inherits(AccordionGroup, _React$Component);
  function AccordionGroup() {
    _classCallCheck(this, AccordionGroup);
    return _possibleConstructorReturn(this, _getPrototypeOf(AccordionGroup).apply(this, arguments));
  }
  _createClass(AccordionGroup, [{
    key: "getChildContext",
    value: function getChildContext() {
      var _this$props = this.props,
          activeAccordionName = _this$props.activeAccordionName,
          onChange = _this$props.onChange,
          headingComponent = _this$props['heading-component'];
      return {
        accordionGroup: {
          activeAccordionName: activeAccordionName,
          onClick: onChange,
          'heading-component': headingComponent
        }
      };
    }
  }, {
    key: "render",
    value: function render() {
      var attributes = _extends({}, this.props);
      var _omit = lodash_omit(attributes, ['activeAccordionName', 'onClick', 'headingComponent']),
          restAfterChildContext = _extends({}, _omit);
      return React.createElement("div", restAfterChildContext);
    }
  }]);
  return AccordionGroup;
}(React.Component);
_defineProperty(AccordionGroup, "propTypes", propTypes$1n);
_defineProperty(AccordionGroup, "childContextTypes", {
  accordionGroup: propTypes.object
});
AccordionGroup.propTypes = propTypes$1n;

var customForms_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.customForms = customForms;
exports.default = exports.defaultProps = void 0;
var _unitUtils = _interopRequireDefault(unitUtils);
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var defaultProps = {
  '$enable-rounded': true,
  '$enable-shadows': false,
  '$custom-control-checked-indicator-box-shadow': 'none',
  '$custom-control-active-indicator-box-shadow': 'none',
  '$custom-control-indicator-box-shadow': 'inset 0 .25rem .25rem rgba(0, 0, 0, 0.1)',
  '$custom-checkbox-indeterminate-box-shadow': 'none',
  '$custom-select-focus-box-shadow': 'inset 0 1px 2px rgba(0, 0, 0, 0.75), 0 0 5px rgba(hsl(207.79999999999995, 98.2%, 53.4%), .5)',
  '$custom-file-focus-box-shadow': '0 0 0 .075rem #fff, 0 0 0 .2rem #0275d8',
  '$custom-file-box-shadow': 'inset 0 .2rem .4rem rgba(0, 0, 0, 0.05)',
  '$custom-select-border-radius': '.25rem',
  '$custom-file-border-radius': '.25rem',
  '$input-bg': '#fff',
  '$custom-select-line-height': '1.25px',
  '$line-height-base': '1.5',
  '$custom-control-gutter': '1.5rem',
  '$custom-control-spacer-x': '1rem',
  '$custom-control-checked-indicator-color': '#fff',
  '$custom-control-checked-indicator-bg': '#0275d8',
  '$custom-control-focus-indicator-box-shadow': '0 0 0 1px #fff, 0 0 0 3px #0275d8',
  '$custom-control-active-indicator-color': '#fff',
  '$custom-control-active-indicator-bg': 'hsl(207.79999999999995, 98.2%, 57.7%)',
  '$custom-control-disabled-cursor': 'not-allowed',
  '$custom-control-disabled-indicator-bg': '#eceeef',
  '$custom-control-disabled-description-color': '#636c72',
  '$custom-control-indicator-size': '1rem',
  '$custom-control-indicator-bg': '#ddd',
  '$custom-control-indicator-bg-size': '50% 50%',
  '$custom-checkbox-checked-icon': 'url("data:image/svg+xml;charset=utf8,%3Csvg xmlns=\'http://www.w3.org/2000/svg\' viewBox=\'0 0 8 8\'%3E%3Cpath fill=\'#fff\' d=\'M6.564.75l-3.59 3.612-1.538-1.55L0 4.26 2.974 7.25 8 2.193z\'/%3E%3C/svg%3E")',
  '$custom-checkbox-indeterminate-bg': '#0275d8',
  '$custom-checkbox-indeterminate-icon': 'url("data:image/svg+xml;charset=utf8,%3Csvg xmlns=\'http://www.w3.org/2000/svg\' viewBox=\'0 0 4 4\'%3E%3Cpath stroke=\'#fff\' d=\'M0 2h4\'/%3E%3C/svg%3E")',
  '$custom-radio-radius': '50%',
  '$custom-radio-checked-icon': 'url("data:image/svg+xml;charset=utf8,%3Csvg xmlns=\'http://www.w3.org/2000/svg\' viewBox=\'-4 -4 8 8\'%3E%3Ccircle r=\'3\' fill=\'#fff\'/%3E%3C/svg%3E")',
  '$custom-control-spacer-y': '.25rem',
  '$border-width': '1px',
  '$input-height': '2.5rem',
  '$custom-select-padding-y': '.375rem',
  '$custom-select-padding-x': '.75rem ',
  '$custom-select-indicator-padding': '1rem',
  '$custom-select-color': '#464a4c',
  '$custom-select-bg': '#fff',
  '$custom-select-indicator': 'url("data:image/svg+xml;charset=utf8,%3Csvg xmlns=\'http://www.w3.org/2000/svg\' viewBox=\'0 0 4 5\'%3E%3Cpath fill=\'#333\' d=\'M2 0L0 2h4zm0 5L0 3h4z\'/%3E%3C/svg%3E")',
  '$custom-select-bg-size': '8px 10px',
  '$custom-select-border-width': '1px',
  '$custom-select-border-color': 'rgba(0, 0, 0, 0.15)',
  '$custom-select-focus-border-color': 'hsl(207.79999999999995, 98.2%, 53.4%)',
  '$input-color': '#464a4c',
  '$custom-select-disabled-color': '#636c72',
  '$cursor-disabled': 'not-allowed',
  '$custom-select-disabled-bg': '#eceeef',
  '$custom-select-sm-font-size': '75%',
  '$custom-file-width': '14rem',
  '$custom-file-height': '2.5rem',
  '$custom-file-padding-x': '.5rem',
  '$custom-file-padding-y': '1rem',
  '$custom-file-line-height': '1.5',
  '$custom-file-color': '#464a4c',
  '$custom-file-bg': '#fff',
  '$custom-file-border-width': '1px',
  '$custom-file-border-color': 'rgba(0, 0, 0, 0.15)',
  '$custom-file-button-color': '#464a4c',
  '$custom-file-button-bg': '#eceeef',
  '$custom-checkbox-radius': '.25rem',
  '$custom-file-text': {
    'placeholder': {
      'en': 'Choose file...'
    },
    'button-label': {
      'en': 'Browse'
    }
  }
};
exports.defaultProps = defaultProps;
function customForms() {
  var $enableRounded = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$enable-rounded'];
  var $enableShadows = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$enable-shadows'];
  var $customControlCheckedIndicatorBoxShadow = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$custom-control-checked-indicator-box-shadow'];
  var $customControlActiveIndicatorBoxShadow = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : defaultProps['$custom-control-active-indicator-box-shadow'];
  var $customControlIndicatorBoxShadow = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : defaultProps['$custom-control-indicator-box-shadow'];
  var $customCheckboxIndeterminateBoxShadow = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : defaultProps['$custom-checkbox-indeterminate-box-shadow'];
  var $customSelectFocusBoxShadow = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : defaultProps['$custom-select-focus-box-shadow'];
  var $customFileFocusBoxShadow = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : defaultProps['$custom-file-focus-box-shadow'];
  var $customFileBoxShadow = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : defaultProps['$custom-file-box-shadow'];
  var $customSelectBorderRadius = arguments.length > 9 && arguments[9] !== undefined ? arguments[9] : defaultProps['$custom-select-border-radius'];
  var $customFileBorderRadius = arguments.length > 10 && arguments[10] !== undefined ? arguments[10] : defaultProps['$custom-file-border-radius'];
  var $customCheckboxRadius = arguments.length > 11 && arguments[11] !== undefined ? arguments[11] : defaultProps['$custom-checkbox-radius'];
  var $inputBg = arguments.length > 12 && arguments[12] !== undefined ? arguments[12] : defaultProps['$input-bg'];
  var $customSelectLineHeight = arguments.length > 13 && arguments[13] !== undefined ? arguments[13] : defaultProps['$custom-select-line-height'];
  var $lineHeightBase = arguments.length > 14 && arguments[14] !== undefined ? arguments[14] : defaultProps['$line-height-base'];
  var $customControlGutter = arguments.length > 15 && arguments[15] !== undefined ? arguments[15] : defaultProps['$custom-control-gutter'];
  var $customControlSpacerX = arguments.length > 16 && arguments[16] !== undefined ? arguments[16] : defaultProps['$custom-control-spacer-x'];
  var $customControlCheckedIndicatorColor = arguments.length > 17 && arguments[17] !== undefined ? arguments[17] : defaultProps['$custom-control-checked-indicator-color'];
  var $customControlCheckedIndicatorBg = arguments.length > 18 && arguments[18] !== undefined ? arguments[18] : defaultProps['$custom-control-checked-indicator-bg'];
  var $customControlFocusIndicatorBoxShadow = arguments.length > 19 && arguments[19] !== undefined ? arguments[19] : defaultProps['$custom-control-focus-indicator-box-shadow'];
  var $customControlActiveIndicatorColor = arguments.length > 20 && arguments[20] !== undefined ? arguments[20] : defaultProps['$custom-control-active-indicator-color'];
  var $customControlActiveIndicatorBg = arguments.length > 21 && arguments[21] !== undefined ? arguments[21] : defaultProps['$custom-control-active-indicator-bg'];
  var $customControlDisabledCursor = arguments.length > 22 && arguments[22] !== undefined ? arguments[22] : defaultProps['$custom-control-disabled-cursor'];
  var $customControlDisabledIndicatorBg = arguments.length > 23 && arguments[23] !== undefined ? arguments[23] : defaultProps['$custom-control-disabled-indicator-bg'];
  var $customControlDisabledDescriptionColor = arguments.length > 24 && arguments[24] !== undefined ? arguments[24] : defaultProps['$custom-control-disabled-description-color'];
  var $customControlIndicatorSize = arguments.length > 25 && arguments[25] !== undefined ? arguments[25] : defaultProps['$custom-control-indicator-size'];
  var $customControlIndicatorBg = arguments.length > 26 && arguments[26] !== undefined ? arguments[26] : defaultProps['$custom-control-indicator-bg'];
  var $customControlIndicatorBgSize = arguments.length > 27 && arguments[27] !== undefined ? arguments[27] : defaultProps['$custom-control-indicator-bg-size'];
  var $customCheckboxCheckedIcon = arguments.length > 28 && arguments[28] !== undefined ? arguments[28] : defaultProps['$custom-checkbox-checked-icon'];
  var $customCheckboxIndeterminateBg = arguments.length > 29 && arguments[29] !== undefined ? arguments[29] : defaultProps['$custom-checkbox-indeterminate-bg'];
  var $customCheckboxIndeterminateIcon = arguments.length > 30 && arguments[30] !== undefined ? arguments[30] : defaultProps['$custom-checkbox-indeterminate-icon'];
  var $customRadioRadius = arguments.length > 31 && arguments[31] !== undefined ? arguments[31] : defaultProps['$custom-radio-radius'];
  var $customRadioCheckedIcon = arguments.length > 32 && arguments[32] !== undefined ? arguments[32] : defaultProps['$custom-radio-checked-icon'];
  var $customControlSpacerY = arguments.length > 33 && arguments[33] !== undefined ? arguments[33] : defaultProps['$custom-control-spacer-y'];
  var $borderWidth = arguments.length > 34 && arguments[34] !== undefined ? arguments[34] : defaultProps['$border-width'];
  var $inputHeight = arguments.length > 35 && arguments[35] !== undefined ? arguments[35] : defaultProps['$input-height'];
  var $customSelectPaddingY = arguments.length > 36 && arguments[36] !== undefined ? arguments[36] : defaultProps['$custom-select-padding-y'];
  var $customSelectPaddingX = arguments.length > 37 && arguments[37] !== undefined ? arguments[37] : defaultProps['$custom-select-padding-x'];
  var $customSelectIndicatorPadding = arguments.length > 38 && arguments[38] !== undefined ? arguments[38] : defaultProps['$custom-select-indicator-padding'];
  var $customSelectColor = arguments.length > 39 && arguments[39] !== undefined ? arguments[39] : defaultProps['$custom-select-color'];
  var $customSelectBg = arguments.length > 40 && arguments[40] !== undefined ? arguments[40] : defaultProps['$custom-select-bg'];
  var $customSelectIndicator = arguments.length > 41 && arguments[41] !== undefined ? arguments[41] : defaultProps['$custom-select-indicator'];
  var $customSelectBgSize = arguments.length > 42 && arguments[42] !== undefined ? arguments[42] : defaultProps['$custom-select-bg-size'];
  var $customSelectBorderWidth = arguments.length > 43 && arguments[43] !== undefined ? arguments[43] : defaultProps['$custom-select-border-width'];
  var $customSelectBorderColor = arguments.length > 44 && arguments[44] !== undefined ? arguments[44] : defaultProps['$custom-select-border-color'];
  var $customSelectFocusBorderColor = arguments.length > 45 && arguments[45] !== undefined ? arguments[45] : defaultProps['$custom-select-focus-border-color'];
  var $inputColor = arguments.length > 46 && arguments[46] !== undefined ? arguments[46] : defaultProps['$input-color'];
  var $customSelectDisabledColor = arguments.length > 47 && arguments[47] !== undefined ? arguments[47] : defaultProps['$custom-select-disabled-color'];
  var $cursorDisabled = arguments.length > 48 && arguments[48] !== undefined ? arguments[48] : defaultProps['$cursor-disabled'];
  var $customSelectDisabledBg = arguments.length > 49 && arguments[49] !== undefined ? arguments[49] : defaultProps['$custom-select-disabled-bg'];
  var $customSelectSmFontSize = arguments.length > 50 && arguments[50] !== undefined ? arguments[50] : defaultProps['$custom-select-sm-font-size'];
  var $customFileWidth = arguments.length > 51 && arguments[51] !== undefined ? arguments[51] : defaultProps['$custom-file-width'];
  var $customFileHeight = arguments.length > 52 && arguments[52] !== undefined ? arguments[52] : defaultProps['$custom-file-height'];
  var $customFilePaddingX = arguments.length > 53 && arguments[53] !== undefined ? arguments[53] : defaultProps['$custom-file-padding-x'];
  var $customFilePaddingY = arguments.length > 54 && arguments[54] !== undefined ? arguments[54] : defaultProps['$custom-file-padding-y'];
  var $customFileLineHeight = arguments.length > 55 && arguments[55] !== undefined ? arguments[55] : defaultProps['$custom-file-line-height'];
  var $customFileColor = arguments.length > 56 && arguments[56] !== undefined ? arguments[56] : defaultProps['$custom-file-color'];
  var $customFileBg = arguments.length > 57 && arguments[57] !== undefined ? arguments[57] : defaultProps['$custom-file-bg'];
  var $customFileBorderWidth = arguments.length > 58 && arguments[58] !== undefined ? arguments[58] : defaultProps['$custom-file-border-width'];
  var $customFileBorderColor = arguments.length > 59 && arguments[59] !== undefined ? arguments[59] : defaultProps['$custom-file-border-color'];
  var $customFileButtonColor = arguments.length > 60 && arguments[60] !== undefined ? arguments[60] : defaultProps['$custom-file-button-color'];
  var $customFileButtonBg = arguments.length > 61 && arguments[61] !== undefined ? arguments[61] : defaultProps['$custom-file-button-bg'];
  var $customFileText = arguments.length > 62 && arguments[62] !== undefined ? arguments[62] : defaultProps['$custom-file-text'];
  var customFileControlBeforeList = [];
  Object.keys($customFileText.placeholder).forEach(function ($lang) {
    customFileControlBeforeList.push("\n      &:lang(".concat($lang, ")::after {\n        content: \"").concat($customFileText.placeholder[$lang], "\";\n      }   \n    "));
  });
  var customFileControlAfterList = [];
  Object.keys($customFileText['button-label']).forEach(function ($lang) {
    customFileControlAfterList.push("\n      &:lang(".concat($lang, ")::before {\n        content: \"").concat($customFileText['button-label'][$lang], "\";\n      }\n    "));
  });
  var selectBorderWidth = _unitUtils.default.math.multiply($borderWidth, 2);
  var customSelectPaddingRight = _unitUtils.default.math.addition($customSelectPaddingY, $customSelectIndicatorPadding);
  var lineHeightBaseMinusCustomControlIndicatorSize = _unitUtils.default.math.subtract($lineHeightBase, $customControlIndicatorSize);
  return "\n    /* Embedded icons from Open Iconic. */\n    /* Released under MIT and copyright 2014 Waybury. */\n    /* https://useiconic.com/open */\n    \n    \n    /* Checkboxes and radios */\n    /* Base class takes care of all the key behavioral aspects. */\n    \n    & .custom-control {\n      position: relative;\n      display: inline-flex;\n      min-height: calc(1rem * ".concat($lineHeightBase, ");\n      padding-left: ").concat($customControlGutter, ";\n      margin-right: ").concat($customControlSpacerX, ";\n    }\n    \n    & .custom-control-input {\n      position: absolute;\n      z-index: -1; /* Put the input behind the label so it does not overlay text */\n      opacity: 0;\n    \n      &:checked ~ .custom-control-indicator {\n        color: ").concat($customControlCheckedIndicatorColor, ";\n        background-color: ").concat($customControlCheckedIndicatorBg, ";\n        ").concat((0, boxShadow_1.boxShadow)($enableShadows, $customControlCheckedIndicatorBoxShadow), "\n      }\n    \n      &:focus ~ .custom-control-indicator {\n        /* the mixin is not used here to make sure there is feedback */\n        box-shadow: ").concat($customControlFocusIndicatorBoxShadow, ";\n      }\n    \n      &:active ~ .custom-control-indicator {\n        color: ").concat($customControlActiveIndicatorColor, ";\n        background-color: ").concat($customControlActiveIndicatorBg, ";\n        ").concat((0, boxShadow_1.boxShadow)($enableShadows, $customControlActiveIndicatorBoxShadow), "\n      }\n    \n      &:disabled {\n        ~ .custom-control-indicator {\n          cursor: ").concat($customControlDisabledCursor, ";\n          background-color: ").concat($customControlDisabledIndicatorBg, ";\n        }\n    \n        ~ .custom-control-description {\n          color: ").concat($customControlDisabledDescriptionColor, ";\n          cursor: ").concat($customControlDisabledCursor, ";\n        }\n      }\n    }\n    \n    /* Custom indicator */\n    /* Generates a shadow element to create our makeshift checkbox/radio background. */\n    \n    & .custom-control-indicator {\n      position: absolute;\n      top: calc(").concat(lineHeightBaseMinusCustomControlIndicatorSize, " / 2);\n      left: 0;\n      display: block;\n      width: ").concat($customControlIndicatorSize, ";\n      height: ").concat($customControlIndicatorSize, ";\n      pointer-events: none;\n      user-select: none;\n      background-color: ").concat($customControlIndicatorBg, ";\n      background-repeat: no-repeat;\n      background-position: center center;\n      background-size: ").concat($customControlIndicatorBgSize, ";\n      ").concat((0, boxShadow_1.boxShadow)($enableShadows, $customControlIndicatorBoxShadow), "\n    }\n    \n    /* Checkboxes */\n    /* Tweak just a few things for checkboxes.  */\n    \n    & .custom-checkbox {\n      & .custom-control-indicator {\n        ").concat((0, borderRadius_1.borderRadius)($enableRounded, $customCheckboxRadius), "\n      }\n    \n      & .custom-control-input:checked ~ .custom-control-indicator {\n        background-image: ").concat($customCheckboxCheckedIcon, ";\n      }\n    \n      & .custom-control-input.indeterminate ~ .custom-control-indicator {\n        background-color: ").concat($customCheckboxIndeterminateBg, ";\n        background-image: ").concat($customCheckboxIndeterminateIcon, ";\n        ").concat((0, boxShadow_1.boxShadow)($enableShadows, $customCheckboxIndeterminateBoxShadow), "\n      }\n    }\n    \n    /* Radios */\n    /* Tweak just a few things for radios. */\n    \n    & .custom-radio {\n      & .custom-control-indicator {\n        border-radius: ").concat($customRadioRadius, ";\n      }\n    \n      & .custom-control-input:checked ~ .custom-control-indicator {\n        background-image: ").concat($customRadioCheckedIcon, ";\n      }\n    }\n    \n    \n    /* Layout options */\n    /* By default radios and checkboxes are inline-block with no additional spacing */\n    /* set. Use these optional classes to tweak the layout. */\n    \n    & .custom-controls-stacked {\n      display: flex;\n      flex-direction: column;\n    \n      & .custom-control {\n        margin-bottom: ").concat($customControlSpacerY, ";\n    \n        + & .custom-control {\n          margin-left: 0;\n        }\n      }\n    }\n    \n    \n    /* Select */\n    /* Replaces the browser default select with a custom one, mostly pulled from */\n    /* http://primercss.io. */\n    \n    & .custom-select {\n      display: inline-block;\n      max-width: 100%;\n      height: calc(").concat($inputHeight, " + ").concat(selectBorderWidth, ");\n      padding: ").concat($customSelectPaddingY, " ").concat(customSelectPaddingRight, " ").concat($customSelectPaddingY, " ").concat($customSelectPaddingX, ";\n      line-height: ").concat($customSelectLineHeight, ";\n      color: ").concat($customSelectColor, ";\n      vertical-align: middle;\n      background: ").concat($customSelectBg, " ").concat($customSelectIndicator, " no-repeat right ").concat($customSelectPaddingX, " center;\n      background-size: ").concat($customSelectBgSize, ";\n      border: ").concat($customSelectBorderWidth, " solid ").concat($customSelectBorderColor, ";\n      ").concat((0, borderRadius_1.borderRadius)($enableRounded, $customSelectBorderRadius), "\n      /* Use vendor prefixes as appearance is not part of the CSS spec.  */\n      -moz-appearance: none;\n      -webkit-appearance: none;\n    \n      &:focus {\n        border-color: ").concat($customSelectFocusBorderColor, ";\n        outline: none;\n        ").concat((0, boxShadow_1.boxShadow)($enableShadows, $customSelectFocusBoxShadow), "\n    \n        ::-ms-value {\n          /* For visual consistency with other platforms/browsers, */\n          /* supress the default white text on blue background highlight given to */\n          /* the selected option text when the (still closed) <select> receives focus */\n          /* in IE and (under certain conditions) Edge. */\n          /* See https://github.com/twbs/bootstrap/issues/19398. */\n          color: ").concat($inputColor, ";\n          background-color: ").concat($inputBg, ";\n        }\n      }\n    \n      &:disabled {\n        color: ").concat($customSelectDisabledColor, ";\n        cursor: ").concat($cursorDisabled, ";\n        background-color: ").concat($customSelectDisabledBg, ";\n      }\n    \n      /* Hides the default caret in IE11 */\n      ::-ms-expand {\n        opacity: 0;\n      }\n    }\n    \n    & .custom-select-sm {\n      padding-top: ").concat($customSelectPaddingY, ";\n      padding-bottom: ").concat($customSelectPaddingY, ";\n      font-size: ").concat($customSelectSmFontSize, ";\n    \n      /* &:not([multiple]) { */\n      /*   height: 26px; */\n      /*   min-height: 26px; */\n      /* } */\n    }\n    \n    \n    /* File */\n    /* Custom file input. */\n    \n    & .custom-file {\n      position: relative;\n      display: inline-block;\n      max-width: 100%;\n      height: ").concat($customFileHeight, ";\n      margin-bottom: 0;\n    }\n    \n    & .custom-file-input {\n      min-width: ").concat($customFileWidth, ";\n      max-width: 100%;\n      height: ").concat($customFileHeight, ";\n      margin: 0;\n      opacity: 0;\n    \n      &:focus ~ .custom-file-control {\n        ").concat((0, boxShadow_1.boxShadow)($enableShadows, $customFileFocusBoxShadow), "\n      }\n    }\n    \n    & .custom-file-control {\n      position: absolute;\n      top: 0;\n      right: 0;\n      left: 0;\n      z-index: 5;\n      height: ").concat($customFileHeight, ";\n      padding: ").concat($customFilePaddingX, " ").concat($customFilePaddingY, ";\n      line-height: ").concat($customFileLineHeight, ";\n      color: ").concat($customFileColor, ";\n      pointer-events: none;\n      user-select: none;\n      background-color: ").concat($customFileBg, ";\n      border: ").concat($customFileBorderWidth, " solid ").concat($customFileBorderColor, ";\n      ").concat((0, borderRadius_1.borderRadius)($enableRounded, $customFileBorderRadius), "\n      ").concat((0, boxShadow_1.boxShadow)($enableShadows, $customFileBoxShadow), "\n      \n      ").concat(customFileControlBeforeList.join('\n'), "\n    \n      &::before {\n        position: absolute;\n        top: ").concat($customFileBorderWidth, ";\n        right: ").concat($customFileBorderWidth, ";\n        bottom: ").concat($customFileBorderWidth, ";\n        z-index: 6;\n        display: block;\n        height: ").concat($customFileHeight, ";\n        padding: ").concat($customFilePaddingX, " ").concat($customFilePaddingY, ";\n        line-height: ").concat($customFileLineHeight, ";\n        color: ").concat($customFileButtonColor, ";\n        background-color: ").concat($customFileButtonBg, ";\n        border: ").concat($customFileBorderWidth, " solid ").concat($customFileBorderColor, ";\n        ").concat((0, borderRadius_1.borderRadius)(0, $enableRounded, $customFileBorderRadius, $customFileBorderRadius, 0), "\n      }\n\n      ").concat(customFileControlAfterList.join('\n'), "\n    }\n  ");
}
var _default = {
  customForms: customForms
};
exports.default = _default;
});
unwrapExports(customForms_1);
var customForms_2 = customForms_1.customForms;
var customForms_3 = customForms_1.defaultProps;

var defaultProps$1f = {
  tag: 'form',
  theme: {
    '$brand-primary': '#0275d8',
    '$brand-success': '#5cb85c',
    '$brand-info': '#5bc0de',
    '$brand-warning': '#f0ad4e',
    '$brand-danger': '#d9534f',
    '$gray-dark': '#292b2c',
    '$gray': '#464a4c',
    '$gray-light': '#636c72',
    '$gray-lighter': '#eceeef',
    '$gray-lightest': '#f7f7f9',
    '$border-width': '1px',
    '$spacer': '1rem',
    '$spacer-y': '1rem',
    '$grid-breakpoints': {
      xs: '0',
      sm: '576px',
      md: '768px',
      lg: '992px',
      xl: '1200px'
    },
    '$grid-gutter-width': '30px',
    '$font-size-base': '1rem',
    '$font-size-lg': '1.25rem',
    '$font-size-sm': '.875rem',
    '$font-size-xs': '.75rem',
    '$text-muted': '#636c72',
    '$line-height-base': '1.5',
    '$line-height-lg': '1.6',
    '$line-height-sm': '1.3',
    '$border-radius': '.25rem',
    '$border-radius-lg': '.3rem',
    '$border-radius-sm': '.2rem',
    '$input-padding-x': '.75rem',
    '$input-padding-y': '.5rem',
    '$input-line-height': '1.25',
    '$input-bg': '#fff',
    '$input-bg-disabled': '#eceeef',
    '$input-color': '#464a4c',
    '$input-border-color': 'rgba(0, 0, 0, 0.15)',
    '$input-btn-border-width': '1px',
    '$input-box-shadow': 'rgba(0, 0, 0, 0.15)',
    '$input-border-radius': '.25rem',
    '$input-border-radius-lg': '.3rem',
    '$input-border-radius-sm': '.2rem',
    '$input-bg-focus': '#fff',
    '$input-border-focus': 'hsl(207.79999999999995, 98.2%, 53.4%)',
    '$input-box-shadow-focus': 'inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 8px rgba(undefined,.6)',
    '$input-color-focus': '#464a4c',
    '$input-color-placeholder': '#636c72',
    '$input-padding-x-sm': '.5rem',
    '$input-padding-y-sm': '.25rem',
    '$input-padding-x-lg': '1.5rem',
    '$input-padding-y-lg': '.75rem',
    '$input-height': '2.5rem',
    '$input-height-sm': '1.6375rem',
    '$input-height-lg': '3.5rem',
    '$input-transition': '.15s',
    '$form-text-margin-top': '.25rem',
    '$form-feedback-margin-top': '.25rem',
    '$form-check-margin-bottom': '.5rem',
    '$form-check-input-gutter': '1.25rem',
    '$form-check-input-margin-y': '.25rem',
    '$form-check-input-margin-x': '.25rem',
    '$form-check-inline-margin-x': '.75rem',
    '$form-group-margin-bottom': '1rem',
    '$input-group-addon-bg': '#eceeef',
    '$input-group-addon-border-color': 'rgba(0, 0, 0, 0.15)',
    '$cursor-disabled': 'not-allowed',
    '$custom-control-gutter': '1.5rem',
    '$custom-control-spacer-x': '1rem',
    '$custom-control-spacer-y': '.25rem',
    '$custom-control-indicator-size': '1rem',
    '$custom-control-indicator-bg': '#ddd',
    '$custom-control-indicator-bg-size': '50%',
    '$custom-control-indicator-box-shadow': 'inset 0 .25rem .25rem rgba(0, 0, 0, 0.1)',
    '$custom-control-disabled-cursor': 'not-allowed',
    '$custom-control-disabled-indicator-bg': '#eceeef',
    '$custom-control-disabled-description-color': '#636c72',
    '$custom-control-checked-indicator-color': '#fff',
    '$custom-control-checked-indicator-bg': '#0275d8',
    '$custom-control-checked-indicator-box-shadow': 'none',
    '$custom-control-focus-indicator-box-shadow': '0 0 0 1px #fff, 0 0 0 3px #0275d8',
    '$custom-control-active-indicator-color': '#fff',
    '$custom-control-active-indicator-bg': 'hsl(207.79999999999995, 98.2%, 57.7%)',
    '$custom-control-active-indicator-box-shadow': 'none',
    '$custom-checkbox-radius': '.25rem',
    '$custom-checkbox-checked-icon': 'url(\'data:image/svg+xml;charset=utf8,%3Csvg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 8 8"%3E%3Cpath fill="#fff" d="M6.564.75l-3.59 3.612-1.538-1.55L0 4.26 2.974 7.25 8 2.193z"/%3E%3C/svg%3E\')',
    '$custom-checkbox-indeterminate-bg': '#0275d8',
    '$custom-checkbox-indeterminate-indicator-color': '#fff',
    '$custom-checkbox-indeterminate-icon': 'url(\'data:image/svg+xml;charset=utf8,%3Csvg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 4 4"%3E%3Cpath stroke="undefined" d="M0 2h4"/%3E%3C/svg%3E\')',
    '$custom-checkbox-indeterminate-box-shadow': 'none',
    '$custom-radio-radius': '50%',
    '$custom-radio-checked-icon': 'url(\'data:image/svg+xml;charset=utf8,%3Csvg xmlns="http://www.w3.org/2000/svg" viewBox="-4 -4 8 8"%3E%3Ccircle r="3" fill="#fff"/%3E%3C/svg%3E\')',
    '$custom-select-padding-x': '.75rem',
    '$custom-select-padding-y': '.375rem',
    '$custom-select-indicator-padding': '1rem',
    '$custom-select-line-height': '1.25',
    '$custom-select-color': '#464a4c',
    '$custom-select-disabled-color': '#636c72',
    '$custom-select-bg': '#fff',
    '$custom-select-disabled-bg': '#eceeef',
    '$custom-select-bg-size': '8px 10px',
    '$custom-select-indicator-color': '#333',
    '$custom-select-indicator': 'url(\'data:image/svg+xml;charset=utf8,%3Csvg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 4 5"%3E%3Cpath fill="#333" d="M2 0L0 2h4zm0 5L0 3h4z"/%3E%3C/svg%3E\')',
    '$custom-select-border-width': '1px',
    '$custom-select-border-color': 'rgba(0, 0, 0, 0.15)',
    '$custom-select-border-radius': '.25rem',
    '$custom-select-focus-border-color': 'hsl(207.79999999999995, 98.2%, 53.4%)',
    '$custom-select-focus-box-shadow': 'inset 0 1px 2px rgba(0, 0, 0, 0.75), 0 0 5px rgba(hsl(207.79999999999995, 98.2%, 53.4%), .5) ',
    '$custom-select-sm-font-size': '75%',
    '$custom-file-height': '2.5rem',
    '$custom-file-width': '14rem',
    '$custom-file-focus-box-shadow': '0 0 0 .075rem #fff, 0 0 0 .2rem #0275d8',
    '$custom-file-padding-x': '.5rem',
    '$custom-file-padding-y': '1rem',
    '$custom-file-line-height': '1.5',
    '$custom-file-color': '#464a4c',
    '$custom-file-bg': '#fff',
    '$custom-file-border-width': '1px',
    '$custom-file-border-color': 'rgba(0, 0, 0, 0.15)',
    '$custom-file-border-radius': '.25rem',
    '$custom-file-box-shadow': 'inset 0 .2rem .4rem rgba(0, 0, 0, 0.05)',
    '$custom-file-button-color': '#464a4c',
    '$custom-file-button-bg': '#eceeef',
    '$custom-file-text': {
      placeholder: {
        en: 'Choose file...'
      },
      'button-label': {
        en: 'Browse'
      }
    },
    '$form-icon-success-color': '#5cb85c',
    '$form-icon-success': 'url(\'data:image/svg+xml;charset=utf8,%3Csvg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 8 8"%3E%3Cpath fill="undefined" d="M2.3 6.73L.6 4.53c-.4-1.04.46-1.4 1.1-.8l1.1 1.4 3.4-3.8c.6-.63 1.6-.27 1.2.7l-4 4.6c-.43.5-.8.4-1.1.1z"/%3E%3C/svg%3E\')',
    '$form-icon-warning-color': '#f0ad4e',
    '$form-icon-warning': 'url(\'data:image/svg+xml;charset=utf8,%3Csvg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 8 8"%3E%3Cpath fill="undefined" d="M4.4 5.324h-.8v-2.46h.8zm0 1.42h-.8V5.89h.8zM3.76.63L.04 7.075c-.115.2.016.425.26.426h7.397c.242 0 .372-.226.258-.426C6.726 4.924 5.47 2.79 4.253.63c-.113-.174-.39-.174-.494 0z"/%3E%3C/svg%3E\')',
    '$form-icon-danger-color': '#d9534f',
    '$form-icon-danger': 'url(\'data:image/svg+xml;charset=utf8,%3Csvg xmlns="http://www.w3.org/2000/svg" fill="undefined" viewBox="-2 -2 7 7"%3E%3Cpath stroke="%23d9534f" d="M0 0l3 3m0-3L0 3"/%3E%3Ccircle r=".5"/%3E%3Ccircle cx="3" r=".5"/%3E%3Ccircle cy="3" r=".5"/%3E%3Ccircle cx="3" cy="3" r=".5"/%3E%3C/svg%3E\')'
  }
};
var propTypes$1o = {
  className: propTypes.string,
  theme: propTypes.shape({
    '$brand-primary': propTypes.string,
    '$brand-success': propTypes.string,
    '$brand-info': propTypes.string,
    '$brand-warning': propTypes.string,
    '$brand-danger': propTypes.string,
    '$gray-dark': propTypes.string,
    '$gray': propTypes.string,
    '$gray-light': propTypes.string,
    '$gray-lighter': propTypes.string,
    '$gray-lightest': propTypes.string,
    '$border-width': propTypes.string,
    '$spacer': propTypes.string,
    '$spacer-y': propTypes.string,
    '$grid-breakpoints': propTypes.shape({
      'xs': propTypes.string,
      'sm': propTypes.string,
      'md': propTypes.string,
      'lg': propTypes.string,
      'xl': propTypes.string
    }),
    '$grid-gutter-width': propTypes.string,
    '$font-size-base': propTypes.string,
    '$font-size-lg': propTypes.string,
    '$font-size-sm': propTypes.string,
    '$font-size-xs': propTypes.string,
    '$text-muted': propTypes.string,
    '$line-height-base': propTypes.string,
    '$line-height-lg': propTypes.string,
    '$line-height-sm': propTypes.string,
    '$border-radius': propTypes.string,
    '$border-radius-lg': propTypes.string,
    '$border-radius-sm': propTypes.string,
    '$input-padding-x': propTypes.string,
    '$input-padding-y': propTypes.string,
    '$input-line-height': propTypes.string,
    '$input-bg': propTypes.string,
    '$input-bg-disabled': propTypes.string,
    '$input-color': propTypes.string,
    '$input-border-color': propTypes.string,
    '$input-btn-border-width': propTypes.string,
    '$input-box-shadow': propTypes.string,
    '$input-border-radius': propTypes.string,
    '$input-border-radius-lg': propTypes.string,
    '$input-border-radius-sm': propTypes.string,
    '$input-bg-focus': propTypes.string,
    '$input-border-focus': propTypes.string,
    '$input-box-shadow-focus': propTypes.string,
    '$input-color-focus': propTypes.string,
    '$input-color-placeholder': propTypes.string,
    '$input-padding-x-sm': propTypes.string,
    '$input-padding-y-sm': propTypes.string,
    '$input-padding-x-lg': propTypes.string,
    '$input-padding-y-lg': propTypes.string,
    '$input-height': propTypes.string,
    '$input-height-sm': propTypes.string,
    '$input-height-lg': propTypes.string,
    '$input-transition': propTypes.string,
    '$form-text-margin-top': propTypes.string,
    '$form-feedback-margin-top': propTypes.string,
    '$form-check-margin-bottom': propTypes.string,
    '$form-check-input-gutter': propTypes.string,
    '$form-check-input-margin-y': propTypes.string,
    '$form-check-input-margin-x': propTypes.string,
    '$form-check-inline-margin-x': propTypes.string,
    '$form-group-margin-bottom': propTypes.string,
    '$input-group-addon-bg': propTypes.string,
    '$input-group-addon-border-color': propTypes.string,
    '$cursor-disabled': propTypes.string,
    '$custom-control-gutter': propTypes.string,
    '$custom-control-spacer-x': propTypes.string,
    '$custom-control-spacer-y': propTypes.string,
    '$custom-control-indicator-size': propTypes.string,
    '$custom-control-indicator-bg': propTypes.string,
    '$custom-control-indicator-bg-size': propTypes.string,
    '$custom-control-indicator-box-shadow': propTypes.string,
    '$custom-control-disabled-cursor': propTypes.string,
    '$custom-control-disabled-indicator-bg': propTypes.string,
    '$custom-control-disabled-description-color': propTypes.string,
    '$custom-control-checked-indicator-color': propTypes.string,
    '$custom-control-checked-indicator-bg': propTypes.string,
    '$custom-control-checked-indicator-box-shadow': propTypes.string,
    '$custom-control-focus-indicator-box-shadow': propTypes.string,
    '$custom-control-active-indicator-color': propTypes.string,
    '$custom-control-active-indicator-bg': propTypes.string,
    '$custom-control-active-indicator-box-shadow': propTypes.string,
    '$custom-checkbox-radius': propTypes.string,
    '$custom-checkbox-checked-icon': propTypes.string,
    '$custom-checkbox-indeterminate-bg': propTypes.string,
    '$custom-checkbox-indeterminate-indicator-color': propTypes.string,
    '$custom-checkbox-indeterminate-icon': propTypes.string,
    '$custom-checkbox-indeterminate-box-shadow': propTypes.string,
    '$custom-radio-radius': propTypes.string,
    '$custom-radio-checked-icon': propTypes.string,
    '$custom-select-padding-x': propTypes.string,
    '$custom-select-padding-y': propTypes.string,
    '$custom-select-indicator-padding': propTypes.string,
    '$custom-select-line-height': propTypes.string,
    '$custom-select-color': propTypes.string,
    '$custom-select-disabled-color': propTypes.string,
    '$custom-select-bg': propTypes.string,
    '$custom-select-disabled-bg': propTypes.string,
    '$custom-select-bg-size': propTypes.string,
    '$custom-select-indicator-color': propTypes.string,
    '$custom-select-indicator': propTypes.string,
    '$custom-select-border-width': propTypes.string,
    '$custom-select-border-color': propTypes.string,
    '$custom-select-border-radius': propTypes.string,
    '$custom-select-focus-border-color': propTypes.string,
    '$custom-select-focus-box-shadow': propTypes.string,
    '$custom-select-sm-font-size': propTypes.string,
    '$custom-file-height': propTypes.string,
    '$custom-file-width': propTypes.string,
    '$custom-file-focus-box-shadow': propTypes.string,
    '$custom-file-padding-x': propTypes.string,
    '$custom-file-padding-y': propTypes.string,
    '$custom-file-line-height': propTypes.string,
    '$custom-file-color': propTypes.string,
    '$custom-file-bg': propTypes.string,
    '$custom-file-border-width': propTypes.string,
    '$custom-file-border-color': propTypes.string,
    '$custom-file-border-radius': propTypes.string,
    '$custom-file-box-shadow': propTypes.string,
    '$custom-file-button-color': propTypes.string,
    '$custom-file-button-bg': propTypes.string,
    '$custom-file-text': propTypes.object,
    '$form-icon-success-color': propTypes.string,
    '$form-icon-success': propTypes.string,
    '$form-icon-warning-color': propTypes.string,
    '$form-icon-warning': propTypes.string,
    '$form-icon-danger-color': propTypes.string,
    '$form-icon-danger': propTypes.string
  }),
  inline: propTypes.bool,
  ref: propTypes.func,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var FormUnstyled =
function (_React$Component) {
  _inherits(FormUnstyled, _React$Component);
  function FormUnstyled() {
    _classCallCheck(this, FormUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(FormUnstyled).apply(this, arguments));
  }
  _createClass(FormUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          inline = _omit.inline,
          Tag = _omit.tag,
          ref = _omit.ref,
          rest = _objectWithoutProperties(_omit, ["className", "cssModule", "inline", "tag", "ref"]);
      var classes = mapToCssModules(classnames(className, inline ? 'form-inline' : false), cssModule);
      return React.createElement(Tag, _extends({
        ref: ref,
        className: classes
      }, rest));
    }
  }]);
  return FormUnstyled;
}(React.Component);
_defineProperty(FormUnstyled, "propTypes", propTypes$1o);
_defineProperty(FormUnstyled, "defaultProps", defaultProps$1f);
var Form = styled(FormUnstyled).withConfig({
  displayName: "Form",
  componentId: "sc-15bnz0c-0"
})(["  ", ""], function (props) {
  return "\n    /*\n     Textual form controls\n    */\n\n    ".concat(forms_1(props.theme['$enable-rounded'], props.theme['$enable-transitions'], props.theme['$enable-shadows'], props.theme['$input-height'], props.theme['$input-padding-y'], props.theme['$input-padding-x'], props.theme['$font-size-base'], props.theme['$input-line-height'], props.theme['$input-color'], props.theme['$input-bg'], props.theme['$input-border-radius'], props.theme['$input-btn-border-width'], props.theme['$input-border-color'], props.theme['$input-transition'], props.theme['$input-box-shadow'], props.theme['$input-color-focus'], props.theme['$input-bg-focus'], props.theme['$input-border-focus'], props.theme['$input-box-shadow-focus'], props.theme['$input-color-placeholder'], props.theme['$input-bg-disabled'], props.theme['$cursor-disabled']), "\n    \n    select.form-control {\n      &:focus::-ms-value {\n        /* Suppress the nested default white text on blue background highlight given to\n         the selected option text when the (still closed) <select> receives focus\n         in IE and (under certain conditions) Edge, as it looks bad and cannot be made to\n         match the appearance of the native widget.\n         See https://github.com/twbs/bootstrap/issues/19398.\n         */\n        color: ").concat(props.theme['$input-color'], ";\n        background-color: ").concat(props.theme['$input-bg'], ";\n      }\n    }\n\n    /* Make file inputs better match text inputs by forcing them to new lines. */\n    & .form-control-file,\n    .form-control-range {\n      display: block;\n    }\n\n    /*\n     Labels\n    */\n\n    /* For use with horizontal and inline forms, when you need the label text to */\n    /* align with the form controls. */\n    & .col-form-label {\n      padding-top: calc(").concat(props.theme['$input-padding-y'], " - ").concat(props.theme['$input-btn-border-width'], " *2);\n      padding-bottom: calc(").concat(props.theme['$input-padding-y'], " - ").concat(props.theme['$input-btn-border-width'], " *2);\n      margin-bottom: 0; /* Override the '<label>' default */\n    }\n\n    & .col-form-label-lg {\n      padding-top: calc(").concat(props.theme['$input-padding-y-lg'], " - ").concat(props.theme['$input-btn-border-width'], " *2);\n      padding-bottom: calc(").concat(props.theme['$input-padding-y-lg'], " - ").concat(props.theme['$input-btn-border-width'], " *2);\n      font-size: ").concat(props.theme['$font-size-lg'], ";\n    }\n\n    & .col-form-label-sm {\n      padding-top: calc(").concat(props.theme['$input-padding-y-sm'], " - ").concat(props.theme['$input-btn-border-width'], " *2);\n      padding-bottom: calc(").concat(props.theme['$input-padding-y-sm'], " - ").concat(props.theme['$input-btn-border-width'], " *2);\n      font-size: ").concat(props.theme['$font-size-sm'], ";\n    }\n\n    /*\n     Legends\n    */\n\n    /* For use with horizontal and inline forms, when you need the legend text to */\n    /* be the same size as regular labels, and to align with the form controls. */\n    & .col-form-legend {\n      padding-top: ").concat(props.theme['$input-padding-y'], ";\n      padding-bottom: ").concat(props.theme['$input-padding-y'], ";\n      margin-bottom: 0;\n      font-size: ").concat(props.theme['$font-size-base'], ";\n    }\n\n\n    /* Static form control text\n\n     Apply class to an element to make any string of text align with labels in a\n     horizontal form layout.\n    */\n\n    & .form-control-static {\n      padding-top: ").concat(props.theme['$input-padding-y'], ";\n      padding-bottom: ").concat(props.theme['$input-padding-y'], ";\n      margin-bottom: 0; /* match inputs if this class comes on inputs with default margins */\n      line-height: ").concat(props.theme['$input-line-height'], ";\n      border: solid transparent;\n      border-width: ").concat(props.theme['$input-btn-border-width'], " 0;\n\n      &.form-control-sm,\n      &.form-control-lg {\n        padding-right: 0;\n        padding-left: 0;\n      }\n    }\n\n\n    /* Form control sizing\n\n     Build on .form-control with modifier classes to decrease or increase the\n     height and font-size of form controls.\n\n     The .form-group-* form-control variations are sadly duplicated to avoid the\n     issue documented in https://github.com/twbs/bootstrap/issues/15074.\n    */\n\n    & .form-control-sm {\n      padding: ").concat(props.theme['$input-padding-y-sm'], " ").concat(props.theme['$input-padding-x-sm'], ";\n      font-size: ").concat(props.theme['$font-size-sm'], ";\n      ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$input-border-radius-sm']), "\n    }\n\n    select.form-control-sm {\n      &:not([size]):not([multiple]) {\n        height: ").concat(props.theme['$input-height-sm'], ";\n      }\n    }\n\n    & .form-control-lg {\n      padding: ").concat(props.theme['$input-padding-y-lg'], " ").concat(props.theme['$input-padding-x-lg'], ";\n      font-size: ").concat(props.theme['$font-size-lg'], ";\n      ").concat(borderRadius_2(props.theme['$enable-rounded'], props.theme['$input-border-radius-lg']), "\n    }\n\n    select.form-control-lg {\n      &:not([size]):not([multiple]) {\n        height: ").concat(props.theme['$input-height-lg'], ";\n      }\n    }\n\n\n    /* Form groups Designed to help with the organization and spacing of vertical forms. For horizontal forms, use the predefined grid classes. */\n\n    &.form-group,\n     & .form-group {\n      margin-bottom: ").concat(props.theme['$form-group-margin-bottom'], ";\n    }\n\n    & .form-text {\n      display: block;\n      margin-top: ").concat(props.theme['$form-text-margin-top'], "\n    }\n\n\n    /* Checkboxes and radios Indent the labels to position radios/checkboxes as hanging controls. */\n\n    & .form-check {\n      position: relative;\n      display: block;\n      margin-bottom: ").concat(props.theme['$form-check-margin-bottom'], ";\n\n      &.disabled {\n        .form-check-label {\n          color: ").concat(props.theme['$text-muted'], ";\n          cursor: ").concat(props.theme['$cursor-disabled'], ";\n        }\n      }\n    }\n\n    & .form-check-label {\n      padding-left: ").concat(props.theme['$form-check-input-gutter'], ";\n      margin-bottom: 0; /* Override default <label> bottom margin */\n      cursor: pointer;\n    }\n\n    & .form-check-input {\n      position: absolute;\n      margin-top: ").concat(props.theme['$form-check-input-margin-y'], ";\n      margin-left: -").concat(props.theme['$form-check-input-gutter'], ";\n\n      &:only-child {\n        position: static;\n      }\n    }\n\n    /* Radios and checkboxes on same line */\n    & .form-check-inline {\n      display: inline-block;\n      .form-check-label {\n        vertical-align: middle;\n      }\n\n      + .form-check-inline {\n        margin-left: ").concat(props.theme['$form-check-inline-margin-x'], ";\n      }\n\n      &.disabled {\n        color: ").concat(props.theme['$text-muted'], ";\n        cursor: ").concat(props.theme['$cursor-disabled'], ";\n      }\n    }\n\n\n    /* Form control feedback states Apply contextual and semantic states to individual form controls. */\n    & .form-control-feedback {\n      margin-top: ").concat(props.theme['$form-feedback-margin-top'], ";\n    }\n\n    & .form-control-success,\n    & .form-control-warning,\n    & .form-control-danger {\n      padding-right: ").concat(unitUtils$1.math.multiply(props.theme['$input-padding-x'], 3), ";\n      background-repeat: no-repeat;\n      background-position: center right ").concat(unitUtils$1.math.divide(props.theme['$input-height'], 4), ";\n      background-size: ").concat(unitUtils$1.math.divide(props.theme['$input-height'], 2), " ").concat(unitUtils$1.math.divide(props.theme['$input-height'], 2), ";\n    }\n\n    /* Form validation states */\n    & .has-success {\n      ").concat(forms_2(props.theme['$enable-shadows'], props.theme['$brand-success'], props.theme['$box-shadow']), "\n\n      .form-control-success {\n        background-image: ").concat(props.theme['$form-icon-success'], ";\n      }\n    }\n\n    & .has-warning {\n      ").concat(forms_2(props.theme['$enable-shadows'], props.theme['$brand-warning'], props.theme['$box-shadow']), "\n\n      .form-control-warning {\n        background-image: ").concat(props.theme['$form-icon-warning'], ";\n      }\n    }\n\n    & .has-danger {\n      ").concat(forms_2(props.theme['$enable-shadows'], props.theme['$brand-danger'], props.theme['$box-shadow']), "\n\n      .form-control-danger {\n        background-image: ").concat(props.theme['$form-icon-danger'], ";\n      }\n    }\n\n\n    /* Inline forms\n\n     Make forms appear inline(-block) by adding the .form-inline class. Inline\n     forms begin stacked on extra small (mobile) devices and then go inline when\n     viewports reach <768px.\n\n     Requires wrapping inputs and labels with .form-group for proper display of\n     default HTML form controls and our custom form controls (e.g., input groups).\n    */\n\n    &.form-inline {\n      display: flex;\n      flex-flow: row wrap;\n      align-items: center; /* Prevent shorter elements from growing to same height as others (e.g., small buttons growing to normal sized button height) */\n\n      & .form-check {\n         width: 100%;\n      }\n\n      /* Kick in the inline */\n      ").concat(breakpoints_5('sm', props.theme['$grid-breakpoints'], "\n          label {\n            display: flex;\n            align-items: center;\n            justify-content: center;\n            margin-bottom: 0;\n          }\n          \n          /* Inline-block all the things for inline */\n          & .form-group {\n            display: flex;\n            flex: 0 0 auto;\n            flex-flow: row wrap;\n            margin-bottom: 0;\n          }\n      \n          /* Allow folks to *not* use .form-group */\n          & .form-control {\n            display: inline-block;\n            width: auto; /* Prevent labels from stacking above inputs in .form-group */\n            vertical-align: middle;\n          }\n      \n          /* Make static controls behave like regular ones */\n          & .form-control-static {\n            display: inline-block;\n          }\n      \n          & .input-group {\n            width: auto;\n          }\n          \n          & .form-control-label {\n             margin-bottom: 0;\n            vertical-align: middle;\n          }\n      \n          /* Remove default margin on radios/checkboxes that were used for stacking, and */\n          /*  then undo the floating of radios and checkboxes to match. */\n          & .form-check {\n            display: flex;\n            align-items: center;\n            justify-content: center;\n            width: auto;\n            margin-top: 0;\n            margin-bottom: 0;\n          }\n          & .form-check-label {\n            padding-left: 0;\n          }\n          & .form-check-input {\n            position: relative;\n            margin-left: 0;\n            margin-top: 0;\n            margin-right: ".concat(props.theme['$form-check-input-margin-x'], ";\n          }\n          \n          /* Custom form controls */\n          & .custom-control {\n            display: flex;\n            align-items: center;\n            justify-content: center;\n            padding-left: 0;\n          }\n          \n          & .custom-control-indicator {\n            position: static;\n            display: inline-block;\n            margin-right: ").concat(props.theme['$form-check-input-margin-x'], "; /* Flexbox alignment means we lose our HTML space here, so we compensate. */\n            vertical-align: text-bottom;\n          }\n          \n          /* Re-override the feedback icon. */\n          & .has-feedback .form-control-feedback {\n            top: 0;\n          }\n        ")), "\n    }\n    ").concat(customForms_2(props.theme['$enable-rounded'], props.theme['$enable-shadows'], props.theme['$custom-control-checked-indicator-box-shadow'], props.theme['$custom-control-active-indicator-box-shadow'], props.theme['$custom-control-indicator-box-shadow'], props.theme['$custom-checkbox-indeterminate-box-shadow'], props.theme['$custom-select-focus-box-shadow'], props.theme['$custom-file-focus-box-shadow'], props.theme['$custom-file-box-shadow'], props.theme['$custom-select-border-radius'], props.theme['$custom-file-border-radius'], props.theme['$custom-checkbox-radius'], props.theme['$input-bg'], props.theme['$custom-select-line-height'], props.theme['$line-height-base'], props.theme['$custom-control-gutter'], props.theme['$custom-control-spacer-x'], props.theme['$custom-control-checked-indicator-color'], props.theme['$custom-control-checked-indicator-bg'], props.theme['$custom-control-focus-indicator-box-shadow'], props.theme['$custom-control-active-indicator-color'], props.theme['$custom-control-active-indicator-bg'], props.theme['$custom-control-disabled-cursor'], props.theme['$custom-control-disabled-indicator-bg'], props.theme['$custom-control-disabled-description-color'], props.theme['$custom-control-indicator-size'], props.theme['$custom-control-indicator-bg'], props.theme['$custom-control-indicator-bg-size'], props.theme['$custom-checkbox-checked-icon'], props.theme['$custom-checkbox-indeterminate-bg'], props.theme['$custom-checkbox-indeterminate-icon'], props.theme['$custom-radio-radius'], props.theme['$custom-radio-checked-icon'], props.theme['$custom-control-spacer-y'], props.theme['$border-width'], props.theme['$input-height'], props.theme['$custom-select-padding-y'], props.theme['$custom-select-padding-x'], props.theme['$custom-select-indicator-padding'], props.theme['$custom-select-color'], props.theme['$custom-select-bg'], props.theme['$custom-select-indicator'], props.theme['$custom-select-bg-size'], props.theme['$custom-select-border-width'], props.theme['$custom-select-border-color'], props.theme['$custom-select-focus-border-color'], props.theme['$input-color'], props.theme['$custom-select-disabled-color'], props.theme['$cursor-disabled'], props.theme['$custom-select-disabled-bg'], props.theme['$custom-select-sm-font-size'], props.theme['$custom-file-width'], props.theme['$custom-file-height'], props.theme['$custom-file-padding-x'], props.theme['$custom-file-padding-y'], props.theme['$custom-file-line-height'], props.theme['$custom-file-color'], props.theme['$custom-file-bg'], props.theme['$custom-file-border-width'], props.theme['$custom-file-border-color'], props.theme['$custom-file-button-color'], props.theme['$custom-file-button-bg'], props.theme['$custom-file-text']), "\n    & .row {\n      ").concat(grid_3(props.theme['$enable-grid-classes'], props.theme['$grid-gutter-width']), "\n    }\n  ");
});
Form.defaultProps = defaultProps$1f;
Form.propTypes = propTypes$1o;

var defaultProps$1g = {
  tag: 'div'
};
var propTypes$1p = {
  className: propTypes.string,
  children: propTypes.node,
  check: propTypes.bool,
  color: propTypes.oneOf(['success', 'warning', 'danger', '']),
  disabled: propTypes.bool,
  ref: propTypes.func,
  inline: propTypes.bool,
  row: propTypes.bool,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var FormGroup =
function (_React$Component) {
  _inherits(FormGroup, _React$Component);
  function FormGroup() {
    _classCallCheck(this, FormGroup);
    return _possibleConstructorReturn(this, _getPrototypeOf(FormGroup).apply(this, arguments));
  }
  _createClass(FormGroup, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          row = _this$props.row,
          disabled = _this$props.disabled,
          inline = _this$props.inline,
          color = _this$props.color,
          check = _this$props.check,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "row", "disabled", "inline", "color", "check", "tag"]);
      var classes = mapToCssModules(classnames(className, color ? "has-".concat(color) : false, row ? 'row' : false, check ? 'form-check' : 'form-group', check && disabled ? 'disabled' : false, inline ? 'form-check-inline' : false), cssModule);
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
    }
  }]);
  return FormGroup;
}(React.Component);
_defineProperty(FormGroup, "propTypes", propTypes$1p);
_defineProperty(FormGroup, "defaultProps", defaultProps$1g);
FormGroup.defaultProps = defaultProps$1g;
FormGroup.propTypes = propTypes$1p;

var defaultProps$1h = {
  tag: 'small'
};
var propTypes$1q = {
  className: propTypes.string,
  children: propTypes.node,
  color: propTypes.oneOf(['success', 'warning', 'danger', 'muted', '']),
  inline: propTypes.bool,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var FormText =
function (_React$Component) {
  _inherits(FormText, _React$Component);
  function FormText() {
    _classCallCheck(this, FormText);
    return _possibleConstructorReturn(this, _getPrototypeOf(FormText).apply(this, arguments));
  }
  _createClass(FormText, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          inline = _this$props.inline,
          color = _this$props.color,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "inline", "color", "tag"]);
      var classes = mapToCssModules(classnames(className, !inline ? 'form-text' : false, color ? "text-".concat(color) : false), cssModule);
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
    }
  }]);
  return FormText;
}(React.Component);
_defineProperty(FormText, "propTypes", propTypes$1q);
_defineProperty(FormText, "defaultProps", defaultProps$1h);
FormText.defaultProps = defaultProps$1h;
FormText.propTypes = propTypes$1q;

var defaultProps$1i = {
  tag: 'div'
};
var propTypes$1r = {
  className: propTypes.string,
  children: propTypes.node,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var FormFeedback =
function (_React$Component) {
  _inherits(FormFeedback, _React$Component);
  function FormFeedback() {
    _classCallCheck(this, FormFeedback);
    return _possibleConstructorReturn(this, _getPrototypeOf(FormFeedback).apply(this, arguments));
  }
  _createClass(FormFeedback, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          Tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "tag"]);
      var classes = mapToCssModules(classnames(className, 'form-control-feedback'), cssModule);
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
    }
  }]);
  return FormFeedback;
}(React.Component);
_defineProperty(FormFeedback, "propTypes", propTypes$1r);
_defineProperty(FormFeedback, "defaultProps", defaultProps$1i);
FormFeedback.defaultProps = defaultProps$1i;
FormFeedback.propTypes = propTypes$1r;

var propTypes$1s = {
  className: propTypes.string,
  children: propTypes.node,
  radio: propTypes.shape({
    id: propTypes.string,
    name: propTypes.string
  }),
  defaultChecked: propTypes.bool,
  checked: propTypes.bool,
  cssModule: propTypes.object
};
var FormCustom =
function (_React$Component) {
  _inherits(FormCustom, _React$Component);
  function FormCustom() {
    _classCallCheck(this, FormCustom);
    return _possibleConstructorReturn(this, _getPrototypeOf(FormCustom).apply(this, arguments));
  }
  _createClass(FormCustom, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          radio = _this$props.radio,
          children = _this$props.children,
          checked = _this$props.checked,
          defaultChecked = _this$props.defaultChecked,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "radio", "children", "checked", "defaultChecked"]);
      var classes = mapToCssModules(classnames(className, 'custom-control', radio ? 'custom-radio' : 'custom-checkbox'), cssModule);
      var CustomInput = radio ? React.createElement(Input, _extends({
        defaultChecked: defaultChecked,
        checked: checked,
        type: "radio",
        id: radio.id,
        name: radio.name,
        className: "custom-control-input"
      }, attributes)) : React.createElement(Input, _extends({
        defaultChecked: defaultChecked,
        checked: checked,
        type: "checkbox",
        className: "custom-control-input"
      }, attributes));
      return React.createElement(Label, {
        className: classes
      }, CustomInput, React.createElement("span", {
        className: "custom-control-indicator"
      }), React.createElement("span", {
        className: "custom-control-description"
      }, children));
    }
  }]);
  return FormCustom;
}(React.Component);
_defineProperty(FormCustom, "propTypes", propTypes$1s);
FormCustom.propTypes = propTypes$1s;

var defaultProps$1j = {
  tag: 'button'
};
var propTypes$1t = {
  className: propTypes.string,
  children: propTypes.node,
  disabled: propTypes.bool,
  divider: propTypes.bool,
  header: propTypes.bool,
  onClick: propTypes.func,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var DropdownItem =
function (_React$Component) {
  _inherits(DropdownItem, _React$Component);
  function DropdownItem() {
    var _getPrototypeOf2;
    var _this;
    _classCallCheck(this, DropdownItem);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(DropdownItem)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _defineProperty(_assertThisInitialized(_this), "onClick", function (e) {
      if (_this.props.disabled || _this.props.header || _this.props.divider) {
        e.preventDefault();
        return;
      }
      if (_this.props.onClick) {
        _this.props.onClick(e);
      }
      _this.context.toggle();
    });
    _defineProperty(_assertThisInitialized(_this), "getTabIndex", function () {
      if (_this.props.disabled || _this.props.header || _this.props.divider) {
        return '-1';
      }
      return '0';
    });
    return _this;
  }
  _createClass(DropdownItem, [{
    key: "render",
    value: function render() {
      var tabIndex = this.getTabIndex();
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          divider = _this$props.divider,
          disabled = _this$props.disabled,
          Tag = _this$props.tag,
          header = _this$props.header,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "divider", "disabled", "tag", "header"]);
      var classes = mapToCssModules(classnames(className, {
        disabled: disabled,
        'dropdown-item': !divider && !header,
        'dropdown-header': header,
        'dropdown-divider': divider
      }), cssModule);
      if (Tag === 'button') {
        if (header) {
          Tag = H6;
        } else if (divider) {
          Tag = 'div';
        }
      }
      return React.createElement(Tag, _extends({
        tabIndex: tabIndex,
        className: classes,
        onClick: this.onClick
      }, attributes));
    }
  }]);
  return DropdownItem;
}(React.Component);
_defineProperty(DropdownItem, "propTypes", propTypes$1t);
_defineProperty(DropdownItem, "contextTypes", {
  toggle: propTypes.func
});
_defineProperty(DropdownItem, "defaultProps", defaultProps$1j);
DropdownItem.defaultProps = defaultProps$1j;
DropdownItem.propTypes = propTypes$1t;

var defaultProps$1k = {
  'aria-haspopup': true,
  'data-toggle': 'dropdown',
  color: 'primary'
};
var propTypes$1u = {
  className: propTypes.string,
  children: propTypes.node,
  'aria-haspopup': propTypes.bool,
  color: propTypes.oneOf(['white', 'muted', 'gray-dark', 'primary', 'success', 'info', 'warning', 'danger', 'link']),
  caret: propTypes.bool,
  'data-toggle': propTypes.string,
  disabled: propTypes.bool,
  onClick: propTypes.func,
  nav: propTypes.bool,
  split: propTypes.bool,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var DropdownToggle =
function (_React$Component) {
  _inherits(DropdownToggle, _React$Component);
  function DropdownToggle() {
    var _getPrototypeOf2;
    var _this;
    _classCallCheck(this, DropdownToggle);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(DropdownToggle)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _defineProperty(_assertThisInitialized(_this), "onClick", function (e) {
      if (_this.props.disabled) {
        e.preventDefault();
        return;
      }
      if (_this.props.nav && !_this.props.tag) {
        e.preventDefault();
      }
      if (_this.props.onClick) {
        _this.props.onClick(e);
      }
      _this.context.toggle();
    });
    return _this;
  }
  _createClass(DropdownToggle, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          cssModule = _this$props.cssModule,
          caret = _this$props.caret,
          split = _this$props.split,
          nav = _this$props.nav,
          tag = _this$props.tag,
          attributes = _objectWithoutProperties(_this$props, ["className", "cssModule", "caret", "split", "nav", "tag"]);
      var ariaLabel = attributes['aria-label'] || 'Toggle Dropdown';
      var classes = mapToCssModules(classnames(className, {
        'dropdown-toggle': caret || split,
        'dropdown-toggle-split': split,
        active: this.context.isOpen,
        'nav-link': nav
      }), cssModule);
      var children = attributes.children || React.createElement("span", {
        className: "sr-only"
      }, ariaLabel);
      var Tag;
      if (nav && !tag) {
        Tag = A;
        attributes.href = '#';
      } else if (!tag) {
        Tag = Button;
      } else {
        Tag = tag;
      }
      return React.createElement(Tag, _extends({
        className: classes,
        onClick: this.onClick,
        "aria-haspopup": "true",
        "aria-expanded": this.context.isOpen
      }, attributes), children);
    }
  }]);
  return DropdownToggle;
}(React.Component);
_defineProperty(DropdownToggle, "propTypes", propTypes$1u);
_defineProperty(DropdownToggle, "contextTypes", {
  isOpen: propTypes.bool.isRequired,
  toggle: propTypes.func.isRequired
});
_defineProperty(DropdownToggle, "defaultProps", defaultProps$1k);
DropdownToggle.defaultProps = defaultProps$1k;
DropdownToggle.propTypes = propTypes$1u;

var getToggleableClass = function getToggleableClass(toggleable) {
  if (toggleable === false) {
    return '';
  } else if (toggleable === true || toggleable === 'xs') {
    return 'navbar-toggleable';
  }
  return "navbar-toggleable-".concat(toggleable);
};
var defaultProps$1l = {
  tag: 'nav',
  role: 'navigation',
  toggleable: false,
  theme: {
    '$grid-breakpoints': {
      xs: '0',
      sm: '576px',
      md: '768px',
      lg: '992px',
      xl: '1200px'
    },
    '$enable-rounded': true,
    '$enable-hover-media-query': false,
    '$border-width': '1px',
    '$font-size-lg': '1.25rem',
    '$body-bg': '#fff',
    '$component-active-bg': '#0275d8',
    '$component-active-color': '#fff',
    '$border-radius': '.25rem',
    '$navbar-padding-x': '1rem',
    '$navbar-padding-y': '0.5rem',
    '$nav-link-padding': '.5em 1em',
    '$nav-disabled-link-color': '#636c72',
    '$nav-tabs-border-color': '#ddd',
    '$nav-tabs-border-width': '1px',
    '$nav-tabs-border-radius': '.5em 1em',
    '$nav-tabs-link-hover-border-color': '#eceeef',
    '$nav-tabs-active-link-hover-color': '#464a4c',
    '$nav-tabs-active-link-hover-bg': '#fff',
    '$nav-tabs-active-link-hover-border-color': '#ddd',
    '$nav-pills-border-radius': '.25rem',
    '$nav-pills-active-link-color': '#fff',
    '$nav-pills-active-link-bg': '#0275d8',
    '$cursor-disabled': 'not-allowed',
    '$zindex-navbar': '1000',
    '$zindex-navbar-fixed': '1030',
    '$zindex-navbar-sticky': '1030',
    '$navbar-brand-padding-y': '.25rem',
    '$navbar-divider-padding-y': '.425rem',
    '$navbar-toggler-padding-y': '.5rem',
    '$navbar-toggler-padding-x': '.75rem',
    '$navbar-toggler-font-size': '1.25rem',
    '$navbar-toggler-border-radius': '.25rem',
    '$navbar-light-active-color': 'rgba(0,0,0,.9)',
    '$navbar-light-color': 'rgba(0,0,0,.5)',
    '$navbar-light-hover-color': 'rgba(0,0,0,.7)',
    '$navbar-light-toggler-border': 'rgba(0,0,0,.1)',
    '$navbar-light-disabled-color': 'rgba(0, 0, 0, 0.3)',
    '$navbar-light-toggler-bg': 'url(\'data:image/svg+xml;charset=utf8,%3Csvg viewBox="0 0 30 30" xmlns="http://www.w3.org/2000/svg"%3E%3Cpath stroke="rgba(0,0,0,.5)" stroke-width="2" stroke-linecap="round" stroke-miterlimit="10" d="M4 7h22M4 15h22M4 23h22"/%3E%3C/svg%3E\')',
    '$navbar-inverse-active-color': 'rgba(255,255,255,1)',
    '$navbar-inverse-color': 'rgba(255,255,255,.5)',
    '$navbar-inverse-hover-color': 'rgba(255,255,255,.75)',
    '$navbar-inverse-toggler-border': 'rgba(255,255,255,.1)',
    '$navbar-inverse-toggler-bg': 'url(\'data:image/svg+xml;charset=utf8,%3Csvg viewBox="0 0 30 30" xmlns="http://www.w3.org/2000/svg"%3E%3Cpath stroke="rgba(255,255,255,.5)" stroke-width="2" stroke-linecap="round" stroke-miterlimit="10" d="M4 7h22M4 15h22M4 23h22"/%3E%3C/svg%3E\')',
    '$navbar-inverse-disabled-color': 'rgba(255, 255, 255, 0.25)'
  }
};
var propTypes$1v = {
  className: propTypes.string,
  tag: propTypes.any,
  light: propTypes.bool,
  inverse: propTypes.bool,
  full: propTypes.bool,
  fixed: propTypes.string,
  sticky: propTypes.string,
  color: propTypes.oneOf(['primary', 'success', 'info', 'warning', 'danger', 'inverse', 'faded']),
  role: propTypes.string,
  toggleable: propTypes.oneOfType([propTypes.bool, propTypes.string]),
  theme: propTypes.shape({
    '$enable-rounded': propTypes.bool,
    '$enable-hover-media-query': propTypes.bool,
    '$grid-breakpoints': propTypes.object,
    '$border-width': propTypes.string,
    '$font-size-lg': propTypes.string,
    '$body-bg': propTypes.string,
    '$component-active-bg': propTypes.string,
    '$component-active-color': propTypes.string,
    '$border-radius': propTypes.string,
    '$navbar-padding-x': propTypes.string,
    '$navbar-padding-y': propTypes.string,
    '$nav-link-padding': propTypes.string,
    '$nav-disabled-link-color': propTypes.string,
    '$nav-tabs-border-color': propTypes.string,
    '$nav-tabs-border-width': propTypes.string,
    '$nav-tabs-border-radius': propTypes.string,
    '$nav-tabs-link-hover-border-color': propTypes.string,
    '$nav-tabs-active-link-hover-color': propTypes.string,
    '$nav-tabs-active-link-hover-bg': propTypes.string,
    '$nav-tabs-active-link-hover-border-color': propTypes.string,
    '$nav-pills-border-radius': propTypes.string,
    '$nav-pills-active-link-color': propTypes.string,
    '$nav-pills-active-link-bg': propTypes.string,
    '$cursor-disabled': propTypes.string,
    '$zindex-navbar': propTypes.string,
    '$zindex-navbar-fixed': propTypes.string,
    '$zindex-navbar-sticky': propTypes.string,
    '$navbar-brand-padding-y': propTypes.string,
    '$navbar-divider-padding-y': propTypes.string,
    '$navbar-toggler-padding-y': propTypes.string,
    '$navbar-toggler-padding-x': propTypes.string,
    '$navbar-toggler-font-size': propTypes.string,
    '$navbar-toggler-border-radius': propTypes.string,
    '$navbar-light-active-color': propTypes.string,
    '$navbar-light-color': propTypes.string,
    '$navbar-light-hover-color': propTypes.string,
    '$navbar-light-toggler-border': propTypes.string,
    '$navbar-light-disabled-color': propTypes.string,
    '$navbar-light-toggler-bg': propTypes.string,
    '$navbar-inverse-active-color': propTypes.string,
    '$navbar-inverse-color': propTypes.string,
    '$navbar-inverse-hover-color': propTypes.string,
    '$navbar-inverse-toggler-border': propTypes.string,
    '$navbar-inverse-toggler-bg': propTypes.string,
    '$navbar-inverse-disabled-color': propTypes.string
  }),
  cssModule: propTypes.object
};
var NavbarUnstyled =
function (_React$Component) {
  _inherits(NavbarUnstyled, _React$Component);
  function NavbarUnstyled() {
    _classCallCheck(this, NavbarUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(NavbarUnstyled).apply(this, arguments));
  }
  _createClass(NavbarUnstyled, [{
    key: "render",
    value: function render() {
      var _cn;
      var _omit = lodash_omit(this.props, ['theme']),
          toggleable = _omit.toggleable,
          className = _omit.className,
          cssModule = _omit.cssModule,
          light = _omit.light,
          inverse = _omit.inverse,
          full = _omit.full,
          fixed = _omit.fixed,
          sticky = _omit.sticky,
          color = _omit.color,
          Tag = _omit.tag,
          attributes = _objectWithoutProperties(_omit, ["toggleable", "className", "cssModule", "light", "inverse", "full", "fixed", "sticky", "color", "tag"]);
      var classes = mapToCssModules(classnames(className, 'navbar', getToggleableClass(toggleable), (_cn = {
        'navbar-light': light,
        'navbar-inverse': inverse
      }, _defineProperty(_cn, "bg-".concat(color), color), _defineProperty(_cn, 'navbar-full', full), _defineProperty(_cn, "fixed-".concat(fixed), fixed), _defineProperty(_cn, "sticky-".concat(sticky), sticky), _cn)), cssModule);
      return React.createElement(Tag, _extends({}, attributes, {
        className: classes
      }));
    }
  }]);
  return NavbarUnstyled;
}(React.Component);
_defineProperty(NavbarUnstyled, "propTypes", propTypes$1v);
_defineProperty(NavbarUnstyled, "defaultProps", defaultProps$1l);
var Navbar = styled(NavbarUnstyled).withConfig({
  displayName: "Navbar",
  componentId: "sc-1o0l5dr-0"
})(["", ""], function (props) {
  return "\n    ".concat(navbar_2(props.theme['$grid-breakpoints'], props.theme['$enable-rounded'], props.theme['$enable-hover-media-query'], props.theme['$navbar-padding-y'], props.theme['$navbar-padding-x'], props.theme['$zindex-navbar'], props.theme['$zindex-navbar-fixed'], props.theme['$zindex-navbar-sticky'], props.theme['$navbar-brand-padding-y'], props.theme['$font-size-lg'], props.theme['$navbar-divider-padding-y'], props.theme['$navbar-toggler-padding-y'], props.theme['$navbar-toggler-padding-x'], props.theme['$navbar-toggler-font-size'], props.theme['$border-width'], props.theme['$navbar-toggler-border-radius'], props.theme['$navbar-light-active-color'], props.theme['$navbar-light-color'], props.theme['$navbar-light-hover-color'], props.theme['$navbar-light-toggler-border'], props.theme['$navbar-light-disabled-color'], props.theme['$navbar-light-toggler-bg'], props.theme['$navbar-inverse-active-color'], props.theme['$navbar-inverse-color'], props.theme['$navbar-inverse-hover-color'], props.theme['$navbar-inverse-toggler-border'], props.theme['$navbar-inverse-toggler-bg'], props.theme['$navbar-inverse-disabled-color']), "\n    ").concat(nav_2(props.theme['$enable-rounded'], props.theme['$enable-hover-media-query'], props.theme['$nav-link-padding'], props.theme['$nav-disabled-link-color'], props.theme['$cursor-disabled'], props.theme['$nav-tabs-border-width'], props.theme['$nav-tabs-border-color'], props.theme['$nav-tabs-border-radius'], props.theme['$nav-tabs-link-hover-border-color'], props.theme['$nav-tabs-active-link-hover-color'], props.theme['$nav-tabs-active-link-hover-bg'], props.theme['$nav-tabs-active-link-hover-border-color'], props.theme['$nav-pills-border-radius'], props.theme['$nav-pills-active-link-color'], props.theme['$nav-pills-active-link-bg']), "\n  ");
});
Navbar.defaultProps = defaultProps$1l;
Navbar.propTypes = propTypes$1v;

var defaultProps$1m = {
  tag: 'button',
  type: 'button'
};
var propTypes$1w = {
  className: propTypes.string,
  children: propTypes.node,
  type: propTypes.string,
  right: propTypes.bool,
  left: propTypes.bool,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var navbarToggleIcon = React.createElement("span", {
  className: "navbar-toggler-icon"
});
var NavbarToggler = function NavbarToggler(props) {
  var className = props.className,
      cssModule = props.cssModule,
      children = props.children,
      right = props.right,
      left = props.left,
      Tag = props.tag,
      attributes = _objectWithoutProperties(props, ["className", "cssModule", "children", "right", "left", "tag"]);
  var classes = mapToCssModules(classnames(className, 'navbar-toggler', right && 'navbar-toggler-right', left && 'navbar-toggler-left'), cssModule);
  return React.createElement(Tag, _extends({}, attributes, {
    className: classes
  }), children || navbarToggleIcon);
};
NavbarToggler.propTypes = propTypes$1w;
NavbarToggler.defaultProps = defaultProps$1m;

var defaultProps$1n = {
  tag: 'a'
};
var propTypes$1x = {
  className: propTypes.string,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var NavbarBrand = function NavbarBrand(props) {
  var className = props.className,
      cssModule = props.cssModule,
      Tag = props.tag,
      attributes = _objectWithoutProperties(props, ["className", "cssModule", "tag"]);
  var classes = mapToCssModules(classnames(className, 'navbar-brand'), cssModule);
  return React.createElement(Tag, _extends({}, attributes, {
    className: classes
  }));
};
NavbarBrand.propTypes = propTypes$1x;
NavbarBrand.defaultProps = defaultProps$1n;

var propTypes$1y = {
  className: propTypes.string,
  children: propTypes.node,
  toggle: propTypes.func.isRequired,
  isOpen: propTypes.bool.isRequired,
  tag: propTypes.any,
  cssModule: propTypes.object
};
var defaultProps$1o = {
  tag: 'li'
};
var NavDropdown = function NavDropdown(props) {
  var className = props.className,
      cssModule = props.cssModule,
      Tag = props.tag,
      attributes = _objectWithoutProperties(props, ["className", "cssModule", "tag"]);
  var classes = mapToCssModules(classnames(className, 'nav-item'), cssModule);
  return React.createElement(Dropdown, _extends({}, attributes, {
    tag: Tag,
    className: classes
  }));
};
NavDropdown.propTypes = propTypes$1y;
NavDropdown.defaultProps = defaultProps$1o;

var defaultProps$1p = {
  theme: {
    '$grid-gutter-width': '30px',
    '$container-max-widths': {
      sm: '540px',
      md: '720px',
      lg: '960px',
      xl: '1140px'
    },
    '$enable-grid-classes': true
  },
  fluid: false
};
var propTypes$1z = {
  className: propTypes.string,
  theme: propTypes.shape({
    '$grid-gutter-width': propTypes.string,
    '$container-max-widths': propTypes.object,
    '$enable-grid-classes': propTypes.bool
  }),
  fluid: propTypes.bool
};
var ContainerUnstyled =
function (_React$Component) {
  _inherits(ContainerUnstyled, _React$Component);
  function ContainerUnstyled() {
    _classCallCheck(this, ContainerUnstyled);
    return _possibleConstructorReturn(this, _getPrototypeOf(ContainerUnstyled).apply(this, arguments));
  }
  _createClass(ContainerUnstyled, [{
    key: "render",
    value: function render() {
      var _omit = lodash_omit(this.props, ['theme']),
          className = _omit.className,
          fluid = _omit.fluid,
          attributes = _objectWithoutProperties(_omit, ["className", "fluid"]);
      return React.createElement("div", _extends({
        className: classnames(className, {
          container: !fluid,
          'container-fluid': fluid
        })
      }, attributes));
    }
  }]);
  return ContainerUnstyled;
}(React.Component);
_defineProperty(ContainerUnstyled, "propTypes", propTypes$1z);
_defineProperty(ContainerUnstyled, "defaultProps", defaultProps$1p);
var Container = styled(ContainerUnstyled).withConfig({
  displayName: "Container",
  componentId: "u38a83-0"
})(["", ""], function (props) {
  return "\n    ".concat(grid_1(props.theme['$enable-grid-classes'], props.theme['$grid-gutter-width']), "\n    \n  ").concat(!props.fluid ? grid_2(props.theme['$enable-grid-classes'], props.theme['$container-max-widths'], props.theme['$grid-breakpoints']) : '', "\n  ");
});
Container.defaultProps = defaultProps$1p;
Container.propTypes = propTypes$1z;

export { A, composeLink, Abbr, Address, Alert, Area, Article, Blockquote, Breadcrumb, BreadcrumbItem, Button, ButtonDropdown, ButtonGroup, ButtonToolbar, Caption, Close, Code, Col, Collapse, Dd, Dfn, Details, Dl, Drawer, Dt, Fieldset, Footer, H1, H2, H3, H4, H5, H6, Header, Hr, Img, Figure, FigCaption, Input, InputGroup, InputGroupAddon, InputGroupButton, IssueIcon, Kbd, Jumbotron, Label, Legend, Li, ListGroup, ListGroupItem, ListGroupItemHeading, ListGroupItemText, Mapp as Map, Mark, Media, Modal, ModalBody, ModalFooter, ModalHeader, Nav, NavLink, NavItem, Ol, Option, Output, P, Pagination, PaginationItem, PaginationLink, Pre, Progress, ProgressBar, Row, Samp, Section, Select, Small, Strong, Summary, Sub, Sup, Table, Tbody, Tfoot, Thead, Td, Th, Tr, Badge, Textarea, Tooltip, Ul, Card, CardBlock, CardFooter, CardHeader, CardImg, CardImgOverlay, CardLink, CardSubtitle, CardText, CardTitle, CardColumns, CardDeck, CardGroup, CardBlockquote, Accordion, AccordionGroup, Form, FormGroup, FormText, FormFeedback, FormCustom, Dropdown, DropdownItem, DropdownToggle, DropdownMenu, Navbar, NavbarToggler, NavbarBrand, NavDropdown, Container, reboot_1 as getGlobalStyles, reboot_2 as getGlobalStyleNoBootstrapProvider };
//# sourceMappingURL=v4.esm.js.map
